# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['CompleteLifecycleArgs', 'CompleteLifecycle']

@pulumi.input_type
class CompleteLifecycleArgs:
    def __init__(__self__, *,
                 lifecycle_action_result: pulumi.Input[str],
                 lifecycle_hook_id: pulumi.Input[str],
                 instance_id: Optional[pulumi.Input[str]] = None,
                 lifecycle_action_token: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a CompleteLifecycle resource.
        :param pulumi.Input[str] lifecycle_action_result: Result of the lifecycle action. Value range: `CONTINUE`, `ABANDON`.
        :param pulumi.Input[str] lifecycle_hook_id: Lifecycle hook ID.
        :param pulumi.Input[str] instance_id: Instance ID. Either InstanceId or LifecycleActionToken must be specified.
        :param pulumi.Input[str] lifecycle_action_token: Either InstanceId or LifecycleActionToken must be specified.
        """
        pulumi.set(__self__, "lifecycle_action_result", lifecycle_action_result)
        pulumi.set(__self__, "lifecycle_hook_id", lifecycle_hook_id)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if lifecycle_action_token is not None:
            pulumi.set(__self__, "lifecycle_action_token", lifecycle_action_token)

    @property
    @pulumi.getter(name="lifecycleActionResult")
    def lifecycle_action_result(self) -> pulumi.Input[str]:
        """
        Result of the lifecycle action. Value range: `CONTINUE`, `ABANDON`.
        """
        return pulumi.get(self, "lifecycle_action_result")

    @lifecycle_action_result.setter
    def lifecycle_action_result(self, value: pulumi.Input[str]):
        pulumi.set(self, "lifecycle_action_result", value)

    @property
    @pulumi.getter(name="lifecycleHookId")
    def lifecycle_hook_id(self) -> pulumi.Input[str]:
        """
        Lifecycle hook ID.
        """
        return pulumi.get(self, "lifecycle_hook_id")

    @lifecycle_hook_id.setter
    def lifecycle_hook_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "lifecycle_hook_id", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID. Either InstanceId or LifecycleActionToken must be specified.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="lifecycleActionToken")
    def lifecycle_action_token(self) -> Optional[pulumi.Input[str]]:
        """
        Either InstanceId or LifecycleActionToken must be specified.
        """
        return pulumi.get(self, "lifecycle_action_token")

    @lifecycle_action_token.setter
    def lifecycle_action_token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "lifecycle_action_token", value)


@pulumi.input_type
class _CompleteLifecycleState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 lifecycle_action_result: Optional[pulumi.Input[str]] = None,
                 lifecycle_action_token: Optional[pulumi.Input[str]] = None,
                 lifecycle_hook_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CompleteLifecycle resources.
        :param pulumi.Input[str] instance_id: Instance ID. Either InstanceId or LifecycleActionToken must be specified.
        :param pulumi.Input[str] lifecycle_action_result: Result of the lifecycle action. Value range: `CONTINUE`, `ABANDON`.
        :param pulumi.Input[str] lifecycle_action_token: Either InstanceId or LifecycleActionToken must be specified.
        :param pulumi.Input[str] lifecycle_hook_id: Lifecycle hook ID.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if lifecycle_action_result is not None:
            pulumi.set(__self__, "lifecycle_action_result", lifecycle_action_result)
        if lifecycle_action_token is not None:
            pulumi.set(__self__, "lifecycle_action_token", lifecycle_action_token)
        if lifecycle_hook_id is not None:
            pulumi.set(__self__, "lifecycle_hook_id", lifecycle_hook_id)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID. Either InstanceId or LifecycleActionToken must be specified.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="lifecycleActionResult")
    def lifecycle_action_result(self) -> Optional[pulumi.Input[str]]:
        """
        Result of the lifecycle action. Value range: `CONTINUE`, `ABANDON`.
        """
        return pulumi.get(self, "lifecycle_action_result")

    @lifecycle_action_result.setter
    def lifecycle_action_result(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "lifecycle_action_result", value)

    @property
    @pulumi.getter(name="lifecycleActionToken")
    def lifecycle_action_token(self) -> Optional[pulumi.Input[str]]:
        """
        Either InstanceId or LifecycleActionToken must be specified.
        """
        return pulumi.get(self, "lifecycle_action_token")

    @lifecycle_action_token.setter
    def lifecycle_action_token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "lifecycle_action_token", value)

    @property
    @pulumi.getter(name="lifecycleHookId")
    def lifecycle_hook_id(self) -> Optional[pulumi.Input[str]]:
        """
        Lifecycle hook ID.
        """
        return pulumi.get(self, "lifecycle_hook_id")

    @lifecycle_hook_id.setter
    def lifecycle_hook_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "lifecycle_hook_id", value)


class CompleteLifecycle(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 lifecycle_action_result: Optional[pulumi.Input[str]] = None,
                 lifecycle_action_token: Optional[pulumi.Input[str]] = None,
                 lifecycle_hook_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a as complete_lifecycle

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="as")
        image = tencentcloud.Images.get_instance(image_types=["PUBLIC_IMAGE"],
            os_name="TencentOS Server 3.2 (Final)")
        instance_types = tencentcloud.Instance.get_types(filters=[
                tencentcloud.instance.GetTypesFilterArgs(
                    name="zone",
                    values=[zones.zones[0].name],
                ),
                tencentcloud.instance.GetTypesFilterArgs(
                    name="instance-family",
                    values=["S5"],
                ),
            ],
            cpu_core_count=2,
            exclude_sold_out=True)
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            availability_zone=zones.zones[0].name)
        example_scaling_config = tencentcloud.as_.ScalingConfig("exampleScalingConfig",
            configuration_name="tf-example",
            image_id=image.images[0].image_id,
            instance_types=[
                "SA1.SMALL1",
                "SA2.SMALL1",
                "SA2.SMALL2",
                "SA2.SMALL4",
            ],
            instance_name_settings=tencentcloud.as..ScalingConfigInstanceNameSettingsArgs(
                instance_name="test-ins-name",
            ))
        example_scaling_group = tencentcloud.as_.ScalingGroup("exampleScalingGroup",
            scaling_group_name="tf-example",
            configuration_id=example_scaling_config.id,
            max_size=1,
            min_size=0,
            vpc_id=vpc.id,
            subnet_ids=[subnet.id])
        example_lifecycle_hook = tencentcloud.as_.LifecycleHook("exampleLifecycleHook",
            scaling_group_id=example_scaling_group.id,
            lifecycle_hook_name="tf-as-lifecycle-hook",
            lifecycle_transition="INSTANCE_LAUNCHING",
            default_result="CONTINUE",
            heartbeat_timeout=500,
            notification_metadata="tf test")
        example_instance = tencentcloud.instance.Instance("exampleInstance",
            instance_name="tf_example",
            availability_zone=zones.zones[0].name,
            image_id=image.images[0].image_id,
            instance_type=instance_types.instance_types[0].instance_type,
            system_disk_type="CLOUD_PREMIUM",
            system_disk_size=50,
            hostname="user",
            project_id=0,
            vpc_id=vpc.id,
            subnet_id=subnet.id)
        complete_lifecycle = tencentcloud.as_.CompleteLifecycle("completeLifecycle",
            lifecycle_hook_id=example_lifecycle_hook.id,
            instance_id=example_instance.id,
            lifecycle_action_result="CONTINUE")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Instance ID. Either InstanceId or LifecycleActionToken must be specified.
        :param pulumi.Input[str] lifecycle_action_result: Result of the lifecycle action. Value range: `CONTINUE`, `ABANDON`.
        :param pulumi.Input[str] lifecycle_action_token: Either InstanceId or LifecycleActionToken must be specified.
        :param pulumi.Input[str] lifecycle_hook_id: Lifecycle hook ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CompleteLifecycleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a as complete_lifecycle

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="as")
        image = tencentcloud.Images.get_instance(image_types=["PUBLIC_IMAGE"],
            os_name="TencentOS Server 3.2 (Final)")
        instance_types = tencentcloud.Instance.get_types(filters=[
                tencentcloud.instance.GetTypesFilterArgs(
                    name="zone",
                    values=[zones.zones[0].name],
                ),
                tencentcloud.instance.GetTypesFilterArgs(
                    name="instance-family",
                    values=["S5"],
                ),
            ],
            cpu_core_count=2,
            exclude_sold_out=True)
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            availability_zone=zones.zones[0].name)
        example_scaling_config = tencentcloud.as_.ScalingConfig("exampleScalingConfig",
            configuration_name="tf-example",
            image_id=image.images[0].image_id,
            instance_types=[
                "SA1.SMALL1",
                "SA2.SMALL1",
                "SA2.SMALL2",
                "SA2.SMALL4",
            ],
            instance_name_settings=tencentcloud.as..ScalingConfigInstanceNameSettingsArgs(
                instance_name="test-ins-name",
            ))
        example_scaling_group = tencentcloud.as_.ScalingGroup("exampleScalingGroup",
            scaling_group_name="tf-example",
            configuration_id=example_scaling_config.id,
            max_size=1,
            min_size=0,
            vpc_id=vpc.id,
            subnet_ids=[subnet.id])
        example_lifecycle_hook = tencentcloud.as_.LifecycleHook("exampleLifecycleHook",
            scaling_group_id=example_scaling_group.id,
            lifecycle_hook_name="tf-as-lifecycle-hook",
            lifecycle_transition="INSTANCE_LAUNCHING",
            default_result="CONTINUE",
            heartbeat_timeout=500,
            notification_metadata="tf test")
        example_instance = tencentcloud.instance.Instance("exampleInstance",
            instance_name="tf_example",
            availability_zone=zones.zones[0].name,
            image_id=image.images[0].image_id,
            instance_type=instance_types.instance_types[0].instance_type,
            system_disk_type="CLOUD_PREMIUM",
            system_disk_size=50,
            hostname="user",
            project_id=0,
            vpc_id=vpc.id,
            subnet_id=subnet.id)
        complete_lifecycle = tencentcloud.as_.CompleteLifecycle("completeLifecycle",
            lifecycle_hook_id=example_lifecycle_hook.id,
            instance_id=example_instance.id,
            lifecycle_action_result="CONTINUE")
        ```

        :param str resource_name: The name of the resource.
        :param CompleteLifecycleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CompleteLifecycleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 lifecycle_action_result: Optional[pulumi.Input[str]] = None,
                 lifecycle_action_token: Optional[pulumi.Input[str]] = None,
                 lifecycle_hook_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CompleteLifecycleArgs.__new__(CompleteLifecycleArgs)

            __props__.__dict__["instance_id"] = instance_id
            if lifecycle_action_result is None and not opts.urn:
                raise TypeError("Missing required property 'lifecycle_action_result'")
            __props__.__dict__["lifecycle_action_result"] = lifecycle_action_result
            __props__.__dict__["lifecycle_action_token"] = lifecycle_action_token
            if lifecycle_hook_id is None and not opts.urn:
                raise TypeError("Missing required property 'lifecycle_hook_id'")
            __props__.__dict__["lifecycle_hook_id"] = lifecycle_hook_id
        super(CompleteLifecycle, __self__).__init__(
            'tencentcloud:As/completeLifecycle:CompleteLifecycle',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            lifecycle_action_result: Optional[pulumi.Input[str]] = None,
            lifecycle_action_token: Optional[pulumi.Input[str]] = None,
            lifecycle_hook_id: Optional[pulumi.Input[str]] = None) -> 'CompleteLifecycle':
        """
        Get an existing CompleteLifecycle resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Instance ID. Either InstanceId or LifecycleActionToken must be specified.
        :param pulumi.Input[str] lifecycle_action_result: Result of the lifecycle action. Value range: `CONTINUE`, `ABANDON`.
        :param pulumi.Input[str] lifecycle_action_token: Either InstanceId or LifecycleActionToken must be specified.
        :param pulumi.Input[str] lifecycle_hook_id: Lifecycle hook ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CompleteLifecycleState.__new__(_CompleteLifecycleState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["lifecycle_action_result"] = lifecycle_action_result
        __props__.__dict__["lifecycle_action_token"] = lifecycle_action_token
        __props__.__dict__["lifecycle_hook_id"] = lifecycle_hook_id
        return CompleteLifecycle(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[Optional[str]]:
        """
        Instance ID. Either InstanceId or LifecycleActionToken must be specified.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="lifecycleActionResult")
    def lifecycle_action_result(self) -> pulumi.Output[str]:
        """
        Result of the lifecycle action. Value range: `CONTINUE`, `ABANDON`.
        """
        return pulumi.get(self, "lifecycle_action_result")

    @property
    @pulumi.getter(name="lifecycleActionToken")
    def lifecycle_action_token(self) -> pulumi.Output[Optional[str]]:
        """
        Either InstanceId or LifecycleActionToken must be specified.
        """
        return pulumi.get(self, "lifecycle_action_token")

    @property
    @pulumi.getter(name="lifecycleHookId")
    def lifecycle_hook_id(self) -> pulumi.Output[str]:
        """
        Lifecycle hook ID.
        """
        return pulumi.get(self, "lifecycle_hook_id")

