# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ScaleOutInstancesArgs', 'ScaleOutInstances']

@pulumi.input_type
class ScaleOutInstancesArgs:
    def __init__(__self__, *,
                 auto_scaling_group_id: pulumi.Input[str],
                 scale_out_number: pulumi.Input[int]):
        """
        The set of arguments for constructing a ScaleOutInstances resource.
        :param pulumi.Input[str] auto_scaling_group_id: Scaling group ID.
        :param pulumi.Input[int] scale_out_number: Number of instances to be added.
        """
        pulumi.set(__self__, "auto_scaling_group_id", auto_scaling_group_id)
        pulumi.set(__self__, "scale_out_number", scale_out_number)

    @property
    @pulumi.getter(name="autoScalingGroupId")
    def auto_scaling_group_id(self) -> pulumi.Input[str]:
        """
        Scaling group ID.
        """
        return pulumi.get(self, "auto_scaling_group_id")

    @auto_scaling_group_id.setter
    def auto_scaling_group_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "auto_scaling_group_id", value)

    @property
    @pulumi.getter(name="scaleOutNumber")
    def scale_out_number(self) -> pulumi.Input[int]:
        """
        Number of instances to be added.
        """
        return pulumi.get(self, "scale_out_number")

    @scale_out_number.setter
    def scale_out_number(self, value: pulumi.Input[int]):
        pulumi.set(self, "scale_out_number", value)


@pulumi.input_type
class _ScaleOutInstancesState:
    def __init__(__self__, *,
                 auto_scaling_group_id: Optional[pulumi.Input[str]] = None,
                 scale_out_number: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering ScaleOutInstances resources.
        :param pulumi.Input[str] auto_scaling_group_id: Scaling group ID.
        :param pulumi.Input[int] scale_out_number: Number of instances to be added.
        """
        if auto_scaling_group_id is not None:
            pulumi.set(__self__, "auto_scaling_group_id", auto_scaling_group_id)
        if scale_out_number is not None:
            pulumi.set(__self__, "scale_out_number", scale_out_number)

    @property
    @pulumi.getter(name="autoScalingGroupId")
    def auto_scaling_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        Scaling group ID.
        """
        return pulumi.get(self, "auto_scaling_group_id")

    @auto_scaling_group_id.setter
    def auto_scaling_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_scaling_group_id", value)

    @property
    @pulumi.getter(name="scaleOutNumber")
    def scale_out_number(self) -> Optional[pulumi.Input[int]]:
        """
        Number of instances to be added.
        """
        return pulumi.get(self, "scale_out_number")

    @scale_out_number.setter
    def scale_out_number(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "scale_out_number", value)


class ScaleOutInstances(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_scaling_group_id: Optional[pulumi.Input[str]] = None,
                 scale_out_number: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to create a as scale_out_instances

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="as")
        image = tencentcloud.Images.get_instance(image_types=["PUBLIC_IMAGE"],
            os_name="TencentOS Server 3.2 (Final)")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            availability_zone=zones.zones[0].name)
        example_scaling_config = tencentcloud.as_.ScalingConfig("exampleScalingConfig",
            configuration_name="tf-example",
            image_id=image.images[0].image_id,
            instance_types=[
                "SA1.SMALL1",
                "SA2.SMALL1",
                "SA2.SMALL2",
                "SA2.SMALL4",
            ],
            instance_name_settings=tencentcloud.as..ScalingConfigInstanceNameSettingsArgs(
                instance_name="test-ins-name",
            ))
        example_scaling_group = tencentcloud.as_.ScalingGroup("exampleScalingGroup",
            scaling_group_name="tf-example",
            configuration_id=example_scaling_config.id,
            max_size=4,
            min_size=0,
            desired_capacity=2,
            vpc_id=vpc.id,
            subnet_ids=[subnet.id])
        scale_out_instances = tencentcloud.as_.ScaleOutInstances("scaleOutInstances",
            auto_scaling_group_id=example_scaling_group.id,
            scale_out_number=2)
        ```

        ## Import

        as scale_out_instances can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:As/scaleOutInstances:ScaleOutInstances scale_out_instances scale_out_instances_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] auto_scaling_group_id: Scaling group ID.
        :param pulumi.Input[int] scale_out_number: Number of instances to be added.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ScaleOutInstancesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a as scale_out_instances

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="as")
        image = tencentcloud.Images.get_instance(image_types=["PUBLIC_IMAGE"],
            os_name="TencentOS Server 3.2 (Final)")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            availability_zone=zones.zones[0].name)
        example_scaling_config = tencentcloud.as_.ScalingConfig("exampleScalingConfig",
            configuration_name="tf-example",
            image_id=image.images[0].image_id,
            instance_types=[
                "SA1.SMALL1",
                "SA2.SMALL1",
                "SA2.SMALL2",
                "SA2.SMALL4",
            ],
            instance_name_settings=tencentcloud.as..ScalingConfigInstanceNameSettingsArgs(
                instance_name="test-ins-name",
            ))
        example_scaling_group = tencentcloud.as_.ScalingGroup("exampleScalingGroup",
            scaling_group_name="tf-example",
            configuration_id=example_scaling_config.id,
            max_size=4,
            min_size=0,
            desired_capacity=2,
            vpc_id=vpc.id,
            subnet_ids=[subnet.id])
        scale_out_instances = tencentcloud.as_.ScaleOutInstances("scaleOutInstances",
            auto_scaling_group_id=example_scaling_group.id,
            scale_out_number=2)
        ```

        ## Import

        as scale_out_instances can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:As/scaleOutInstances:ScaleOutInstances scale_out_instances scale_out_instances_id
        ```

        :param str resource_name: The name of the resource.
        :param ScaleOutInstancesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ScaleOutInstancesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_scaling_group_id: Optional[pulumi.Input[str]] = None,
                 scale_out_number: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ScaleOutInstancesArgs.__new__(ScaleOutInstancesArgs)

            if auto_scaling_group_id is None and not opts.urn:
                raise TypeError("Missing required property 'auto_scaling_group_id'")
            __props__.__dict__["auto_scaling_group_id"] = auto_scaling_group_id
            if scale_out_number is None and not opts.urn:
                raise TypeError("Missing required property 'scale_out_number'")
            __props__.__dict__["scale_out_number"] = scale_out_number
        super(ScaleOutInstances, __self__).__init__(
            'tencentcloud:As/scaleOutInstances:ScaleOutInstances',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            auto_scaling_group_id: Optional[pulumi.Input[str]] = None,
            scale_out_number: Optional[pulumi.Input[int]] = None) -> 'ScaleOutInstances':
        """
        Get an existing ScaleOutInstances resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] auto_scaling_group_id: Scaling group ID.
        :param pulumi.Input[int] scale_out_number: Number of instances to be added.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ScaleOutInstancesState.__new__(_ScaleOutInstancesState)

        __props__.__dict__["auto_scaling_group_id"] = auto_scaling_group_id
        __props__.__dict__["scale_out_number"] = scale_out_number
        return ScaleOutInstances(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="autoScalingGroupId")
    def auto_scaling_group_id(self) -> pulumi.Output[str]:
        """
        Scaling group ID.
        """
        return pulumi.get(self, "auto_scaling_group_id")

    @property
    @pulumi.getter(name="scaleOutNumber")
    def scale_out_number(self) -> pulumi.Output[int]:
        """
        Number of instances to be added.
        """
        return pulumi.get(self, "scale_out_number")

