# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetRolePolicyAttachmentsResult',
    'AwaitableGetRolePolicyAttachmentsResult',
    'get_role_policy_attachments',
    'get_role_policy_attachments_output',
]

@pulumi.output_type
class GetRolePolicyAttachmentsResult:
    """
    A collection of values returned by getRolePolicyAttachments.
    """
    def __init__(__self__, create_mode=None, id=None, policy_id=None, policy_type=None, result_output_file=None, role_id=None, role_policy_attachment_lists=None):
        if create_mode and not isinstance(create_mode, int):
            raise TypeError("Expected argument 'create_mode' to be a int")
        pulumi.set(__self__, "create_mode", create_mode)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if policy_id and not isinstance(policy_id, str):
            raise TypeError("Expected argument 'policy_id' to be a str")
        pulumi.set(__self__, "policy_id", policy_id)
        if policy_type and not isinstance(policy_type, str):
            raise TypeError("Expected argument 'policy_type' to be a str")
        pulumi.set(__self__, "policy_type", policy_type)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if role_id and not isinstance(role_id, str):
            raise TypeError("Expected argument 'role_id' to be a str")
        pulumi.set(__self__, "role_id", role_id)
        if role_policy_attachment_lists and not isinstance(role_policy_attachment_lists, list):
            raise TypeError("Expected argument 'role_policy_attachment_lists' to be a list")
        pulumi.set(__self__, "role_policy_attachment_lists", role_policy_attachment_lists)

    @property
    @pulumi.getter(name="createMode")
    def create_mode(self) -> Optional[int]:
        """
        Mode of Creation of the CAM role policy attachment. `1` means the cam policy attachment is created by production, and the others indicate syntax strategy ways.
        """
        return pulumi.get(self, "create_mode")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="policyId")
    def policy_id(self) -> Optional[str]:
        """
        Name of CAM role.
        """
        return pulumi.get(self, "policy_id")

    @property
    @pulumi.getter(name="policyType")
    def policy_type(self) -> Optional[str]:
        """
        Type of the policy strategy. 'User' means customer strategy and 'QCS' means preset strategy.
        """
        return pulumi.get(self, "policy_type")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="roleId")
    def role_id(self) -> str:
        """
        ID of CAM role.
        """
        return pulumi.get(self, "role_id")

    @property
    @pulumi.getter(name="rolePolicyAttachmentLists")
    def role_policy_attachment_lists(self) -> Sequence['outputs.GetRolePolicyAttachmentsRolePolicyAttachmentListResult']:
        """
        A list of CAM role policy attachments. Each element contains the following attributes:
        """
        return pulumi.get(self, "role_policy_attachment_lists")


class AwaitableGetRolePolicyAttachmentsResult(GetRolePolicyAttachmentsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRolePolicyAttachmentsResult(
            create_mode=self.create_mode,
            id=self.id,
            policy_id=self.policy_id,
            policy_type=self.policy_type,
            result_output_file=self.result_output_file,
            role_id=self.role_id,
            role_policy_attachment_lists=self.role_policy_attachment_lists)


def get_role_policy_attachments(create_mode: Optional[int] = None,
                                policy_id: Optional[str] = None,
                                policy_type: Optional[str] = None,
                                result_output_file: Optional[str] = None,
                                role_id: Optional[str] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRolePolicyAttachmentsResult:
    """
    Use this data source to query detailed information of CAM role policy attachments

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    foo = tencentcloud.Cam.get_role_policy_attachments(role_id=tencentcloud_cam_role["foo"]["id"])
    bar = tencentcloud.Cam.get_role_policy_attachments(role_id=tencentcloud_cam_role["foo"]["id"],
        policy_id=tencentcloud_cam_policy["foo"]["id"])
    ```


    :param int create_mode: Mode of Creation of the CAM user policy attachment. `1` means the cam policy attachment is created by production, and the others indicate syntax strategy ways.
    :param str policy_id: ID of CAM policy to be queried.
    :param str policy_type: Type of the policy strategy. Valid values are 'User', 'QCS'. 'User' means customer strategy and 'QCS' means preset strategy.
    :param str result_output_file: Used to save results.
    :param str role_id: ID of the attached CAM role to be queried.
    """
    __args__ = dict()
    __args__['createMode'] = create_mode
    __args__['policyId'] = policy_id
    __args__['policyType'] = policy_type
    __args__['resultOutputFile'] = result_output_file
    __args__['roleId'] = role_id
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Cam/getRolePolicyAttachments:getRolePolicyAttachments', __args__, opts=opts, typ=GetRolePolicyAttachmentsResult).value

    return AwaitableGetRolePolicyAttachmentsResult(
        create_mode=__ret__.create_mode,
        id=__ret__.id,
        policy_id=__ret__.policy_id,
        policy_type=__ret__.policy_type,
        result_output_file=__ret__.result_output_file,
        role_id=__ret__.role_id,
        role_policy_attachment_lists=__ret__.role_policy_attachment_lists)


@_utilities.lift_output_func(get_role_policy_attachments)
def get_role_policy_attachments_output(create_mode: Optional[pulumi.Input[Optional[int]]] = None,
                                       policy_id: Optional[pulumi.Input[Optional[str]]] = None,
                                       policy_type: Optional[pulumi.Input[Optional[str]]] = None,
                                       result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                       role_id: Optional[pulumi.Input[str]] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRolePolicyAttachmentsResult]:
    """
    Use this data source to query detailed information of CAM role policy attachments

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    foo = tencentcloud.Cam.get_role_policy_attachments(role_id=tencentcloud_cam_role["foo"]["id"])
    bar = tencentcloud.Cam.get_role_policy_attachments(role_id=tencentcloud_cam_role["foo"]["id"],
        policy_id=tencentcloud_cam_policy["foo"]["id"])
    ```


    :param int create_mode: Mode of Creation of the CAM user policy attachment. `1` means the cam policy attachment is created by production, and the others indicate syntax strategy ways.
    :param str policy_id: ID of CAM policy to be queried.
    :param str policy_type: Type of the policy strategy. Valid values are 'User', 'QCS'. 'User' means customer strategy and 'QCS' means preset strategy.
    :param str result_output_file: Used to save results.
    :param str role_id: ID of the attached CAM role to be queried.
    """
    ...
