# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['DiskBackupRollbackOperationArgs', 'DiskBackupRollbackOperation']

@pulumi.input_type
class DiskBackupRollbackOperationArgs:
    def __init__(__self__, *,
                 disk_backup_id: pulumi.Input[str],
                 disk_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a DiskBackupRollbackOperation resource.
        :param pulumi.Input[str] disk_backup_id: Cloud disk backup point ID.
        :param pulumi.Input[str] disk_id: Cloud disk backup point original cloud disk ID.
        """
        pulumi.set(__self__, "disk_backup_id", disk_backup_id)
        pulumi.set(__self__, "disk_id", disk_id)

    @property
    @pulumi.getter(name="diskBackupId")
    def disk_backup_id(self) -> pulumi.Input[str]:
        """
        Cloud disk backup point ID.
        """
        return pulumi.get(self, "disk_backup_id")

    @disk_backup_id.setter
    def disk_backup_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "disk_backup_id", value)

    @property
    @pulumi.getter(name="diskId")
    def disk_id(self) -> pulumi.Input[str]:
        """
        Cloud disk backup point original cloud disk ID.
        """
        return pulumi.get(self, "disk_id")

    @disk_id.setter
    def disk_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "disk_id", value)


@pulumi.input_type
class _DiskBackupRollbackOperationState:
    def __init__(__self__, *,
                 disk_backup_id: Optional[pulumi.Input[str]] = None,
                 disk_id: Optional[pulumi.Input[str]] = None,
                 is_rollback_completed: Optional[pulumi.Input[bool]] = None):
        """
        Input properties used for looking up and filtering DiskBackupRollbackOperation resources.
        :param pulumi.Input[str] disk_backup_id: Cloud disk backup point ID.
        :param pulumi.Input[str] disk_id: Cloud disk backup point original cloud disk ID.
        :param pulumi.Input[bool] is_rollback_completed: Whether the rollback is completed. `true` meaing rollback completed, `false` meaning still rollbacking.
        """
        if disk_backup_id is not None:
            pulumi.set(__self__, "disk_backup_id", disk_backup_id)
        if disk_id is not None:
            pulumi.set(__self__, "disk_id", disk_id)
        if is_rollback_completed is not None:
            pulumi.set(__self__, "is_rollback_completed", is_rollback_completed)

    @property
    @pulumi.getter(name="diskBackupId")
    def disk_backup_id(self) -> Optional[pulumi.Input[str]]:
        """
        Cloud disk backup point ID.
        """
        return pulumi.get(self, "disk_backup_id")

    @disk_backup_id.setter
    def disk_backup_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "disk_backup_id", value)

    @property
    @pulumi.getter(name="diskId")
    def disk_id(self) -> Optional[pulumi.Input[str]]:
        """
        Cloud disk backup point original cloud disk ID.
        """
        return pulumi.get(self, "disk_id")

    @disk_id.setter
    def disk_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "disk_id", value)

    @property
    @pulumi.getter(name="isRollbackCompleted")
    def is_rollback_completed(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the rollback is completed. `true` meaing rollback completed, `false` meaning still rollbacking.
        """
        return pulumi.get(self, "is_rollback_completed")

    @is_rollback_completed.setter
    def is_rollback_completed(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_rollback_completed", value)


class DiskBackupRollbackOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 disk_backup_id: Optional[pulumi.Input[str]] = None,
                 disk_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to rollback cbs disk backup.

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        operation = tencentcloud.cbs.DiskBackupRollbackOperation("operation",
            disk_backup_id="dbp-xxx",
            disk_id="disk-xxx")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] disk_backup_id: Cloud disk backup point ID.
        :param pulumi.Input[str] disk_id: Cloud disk backup point original cloud disk ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DiskBackupRollbackOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to rollback cbs disk backup.

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        operation = tencentcloud.cbs.DiskBackupRollbackOperation("operation",
            disk_backup_id="dbp-xxx",
            disk_id="disk-xxx")
        ```

        :param str resource_name: The name of the resource.
        :param DiskBackupRollbackOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DiskBackupRollbackOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 disk_backup_id: Optional[pulumi.Input[str]] = None,
                 disk_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DiskBackupRollbackOperationArgs.__new__(DiskBackupRollbackOperationArgs)

            if disk_backup_id is None and not opts.urn:
                raise TypeError("Missing required property 'disk_backup_id'")
            __props__.__dict__["disk_backup_id"] = disk_backup_id
            if disk_id is None and not opts.urn:
                raise TypeError("Missing required property 'disk_id'")
            __props__.__dict__["disk_id"] = disk_id
            __props__.__dict__["is_rollback_completed"] = None
        super(DiskBackupRollbackOperation, __self__).__init__(
            'tencentcloud:Cbs/diskBackupRollbackOperation:DiskBackupRollbackOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            disk_backup_id: Optional[pulumi.Input[str]] = None,
            disk_id: Optional[pulumi.Input[str]] = None,
            is_rollback_completed: Optional[pulumi.Input[bool]] = None) -> 'DiskBackupRollbackOperation':
        """
        Get an existing DiskBackupRollbackOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] disk_backup_id: Cloud disk backup point ID.
        :param pulumi.Input[str] disk_id: Cloud disk backup point original cloud disk ID.
        :param pulumi.Input[bool] is_rollback_completed: Whether the rollback is completed. `true` meaing rollback completed, `false` meaning still rollbacking.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DiskBackupRollbackOperationState.__new__(_DiskBackupRollbackOperationState)

        __props__.__dict__["disk_backup_id"] = disk_backup_id
        __props__.__dict__["disk_id"] = disk_id
        __props__.__dict__["is_rollback_completed"] = is_rollback_completed
        return DiskBackupRollbackOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="diskBackupId")
    def disk_backup_id(self) -> pulumi.Output[str]:
        """
        Cloud disk backup point ID.
        """
        return pulumi.get(self, "disk_backup_id")

    @property
    @pulumi.getter(name="diskId")
    def disk_id(self) -> pulumi.Output[str]:
        """
        Cloud disk backup point original cloud disk ID.
        """
        return pulumi.get(self, "disk_id")

    @property
    @pulumi.getter(name="isRollbackCompleted")
    def is_rollback_completed(self) -> pulumi.Output[bool]:
        """
        Whether the rollback is completed. `true` meaing rollback completed, `false` meaning still rollbacking.
        """
        return pulumi.get(self, "is_rollback_completed")

