# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['InstancesResetAttachArgs', 'InstancesResetAttach']

@pulumi.input_type
class InstancesResetAttachArgs:
    def __init__(__self__, *,
                 ccn_id: pulumi.Input[str],
                 ccn_uin: pulumi.Input[str],
                 instances: pulumi.Input[Sequence[pulumi.Input['InstancesResetAttachInstanceArgs']]]):
        """
        The set of arguments for constructing a InstancesResetAttach resource.
        :param pulumi.Input[str] ccn_id: CCN Instance ID.
        :param pulumi.Input[str] ccn_uin: CCN Uin (root account).
        :param pulumi.Input[Sequence[pulumi.Input['InstancesResetAttachInstanceArgs']]] instances: List Of Attachment Instances.
        """
        pulumi.set(__self__, "ccn_id", ccn_id)
        pulumi.set(__self__, "ccn_uin", ccn_uin)
        pulumi.set(__self__, "instances", instances)

    @property
    @pulumi.getter(name="ccnId")
    def ccn_id(self) -> pulumi.Input[str]:
        """
        CCN Instance ID.
        """
        return pulumi.get(self, "ccn_id")

    @ccn_id.setter
    def ccn_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "ccn_id", value)

    @property
    @pulumi.getter(name="ccnUin")
    def ccn_uin(self) -> pulumi.Input[str]:
        """
        CCN Uin (root account).
        """
        return pulumi.get(self, "ccn_uin")

    @ccn_uin.setter
    def ccn_uin(self, value: pulumi.Input[str]):
        pulumi.set(self, "ccn_uin", value)

    @property
    @pulumi.getter
    def instances(self) -> pulumi.Input[Sequence[pulumi.Input['InstancesResetAttachInstanceArgs']]]:
        """
        List Of Attachment Instances.
        """
        return pulumi.get(self, "instances")

    @instances.setter
    def instances(self, value: pulumi.Input[Sequence[pulumi.Input['InstancesResetAttachInstanceArgs']]]):
        pulumi.set(self, "instances", value)


@pulumi.input_type
class _InstancesResetAttachState:
    def __init__(__self__, *,
                 ccn_id: Optional[pulumi.Input[str]] = None,
                 ccn_uin: Optional[pulumi.Input[str]] = None,
                 instances: Optional[pulumi.Input[Sequence[pulumi.Input['InstancesResetAttachInstanceArgs']]]] = None):
        """
        Input properties used for looking up and filtering InstancesResetAttach resources.
        :param pulumi.Input[str] ccn_id: CCN Instance ID.
        :param pulumi.Input[str] ccn_uin: CCN Uin (root account).
        :param pulumi.Input[Sequence[pulumi.Input['InstancesResetAttachInstanceArgs']]] instances: List Of Attachment Instances.
        """
        if ccn_id is not None:
            pulumi.set(__self__, "ccn_id", ccn_id)
        if ccn_uin is not None:
            pulumi.set(__self__, "ccn_uin", ccn_uin)
        if instances is not None:
            pulumi.set(__self__, "instances", instances)

    @property
    @pulumi.getter(name="ccnId")
    def ccn_id(self) -> Optional[pulumi.Input[str]]:
        """
        CCN Instance ID.
        """
        return pulumi.get(self, "ccn_id")

    @ccn_id.setter
    def ccn_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ccn_id", value)

    @property
    @pulumi.getter(name="ccnUin")
    def ccn_uin(self) -> Optional[pulumi.Input[str]]:
        """
        CCN Uin (root account).
        """
        return pulumi.get(self, "ccn_uin")

    @ccn_uin.setter
    def ccn_uin(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ccn_uin", value)

    @property
    @pulumi.getter
    def instances(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstancesResetAttachInstanceArgs']]]]:
        """
        List Of Attachment Instances.
        """
        return pulumi.get(self, "instances")

    @instances.setter
    def instances(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstancesResetAttachInstanceArgs']]]]):
        pulumi.set(self, "instances", value)


class InstancesResetAttach(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ccn_id: Optional[pulumi.Input[str]] = None,
                 ccn_uin: Optional[pulumi.Input[str]] = None,
                 instances: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstancesResetAttachInstanceArgs']]]]] = None,
                 __props__=None):
        """
        Provides a resource to create a vpc ccn_instances_reset_attach, you can use this resource to reset cross-region attachment.

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        ccn_instances_reset_attach = tencentcloud.ccn.InstancesResetAttach("ccnInstancesResetAttach",
            ccn_id="ccn-39lqkygf",
            ccn_uin="100022975249",
            instances=[tencentcloud.ccn.InstancesResetAttachInstanceArgs(
                instance_id="vpc-j9yhbzpn",
                instance_region="ap-guangzhou",
                instance_type="VPC",
            )])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ccn_id: CCN Instance ID.
        :param pulumi.Input[str] ccn_uin: CCN Uin (root account).
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstancesResetAttachInstanceArgs']]]] instances: List Of Attachment Instances.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InstancesResetAttachArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a vpc ccn_instances_reset_attach, you can use this resource to reset cross-region attachment.

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        ccn_instances_reset_attach = tencentcloud.ccn.InstancesResetAttach("ccnInstancesResetAttach",
            ccn_id="ccn-39lqkygf",
            ccn_uin="100022975249",
            instances=[tencentcloud.ccn.InstancesResetAttachInstanceArgs(
                instance_id="vpc-j9yhbzpn",
                instance_region="ap-guangzhou",
                instance_type="VPC",
            )])
        ```

        :param str resource_name: The name of the resource.
        :param InstancesResetAttachArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InstancesResetAttachArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ccn_id: Optional[pulumi.Input[str]] = None,
                 ccn_uin: Optional[pulumi.Input[str]] = None,
                 instances: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstancesResetAttachInstanceArgs']]]]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InstancesResetAttachArgs.__new__(InstancesResetAttachArgs)

            if ccn_id is None and not opts.urn:
                raise TypeError("Missing required property 'ccn_id'")
            __props__.__dict__["ccn_id"] = ccn_id
            if ccn_uin is None and not opts.urn:
                raise TypeError("Missing required property 'ccn_uin'")
            __props__.__dict__["ccn_uin"] = ccn_uin
            if instances is None and not opts.urn:
                raise TypeError("Missing required property 'instances'")
            __props__.__dict__["instances"] = instances
        super(InstancesResetAttach, __self__).__init__(
            'tencentcloud:Ccn/instancesResetAttach:InstancesResetAttach',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            ccn_id: Optional[pulumi.Input[str]] = None,
            ccn_uin: Optional[pulumi.Input[str]] = None,
            instances: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstancesResetAttachInstanceArgs']]]]] = None) -> 'InstancesResetAttach':
        """
        Get an existing InstancesResetAttach resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ccn_id: CCN Instance ID.
        :param pulumi.Input[str] ccn_uin: CCN Uin (root account).
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstancesResetAttachInstanceArgs']]]] instances: List Of Attachment Instances.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InstancesResetAttachState.__new__(_InstancesResetAttachState)

        __props__.__dict__["ccn_id"] = ccn_id
        __props__.__dict__["ccn_uin"] = ccn_uin
        __props__.__dict__["instances"] = instances
        return InstancesResetAttach(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="ccnId")
    def ccn_id(self) -> pulumi.Output[str]:
        """
        CCN Instance ID.
        """
        return pulumi.get(self, "ccn_id")

    @property
    @pulumi.getter(name="ccnUin")
    def ccn_uin(self) -> pulumi.Output[str]:
        """
        CCN Uin (root account).
        """
        return pulumi.get(self, "ccn_uin")

    @property
    @pulumi.getter
    def instances(self) -> pulumi.Output[Sequence['outputs.InstancesResetAttachInstance']]:
        """
        List Of Attachment Instances.
        """
        return pulumi.get(self, "instances")

