# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetMountTargetsResult',
    'AwaitableGetMountTargetsResult',
    'get_mount_targets',
    'get_mount_targets_output',
]

@pulumi.output_type
class GetMountTargetsResult:
    """
    A collection of values returned by getMountTargets.
    """
    def __init__(__self__, file_system_id=None, id=None, mount_targets=None, result_output_file=None):
        if file_system_id and not isinstance(file_system_id, str):
            raise TypeError("Expected argument 'file_system_id' to be a str")
        pulumi.set(__self__, "file_system_id", file_system_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if mount_targets and not isinstance(mount_targets, list):
            raise TypeError("Expected argument 'mount_targets' to be a list")
        pulumi.set(__self__, "mount_targets", mount_targets)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="fileSystemId")
    def file_system_id(self) -> str:
        """
        File system ID.
        """
        return pulumi.get(self, "file_system_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="mountTargets")
    def mount_targets(self) -> Sequence['outputs.GetMountTargetsMountTargetResult']:
        """
        Mount target details.
        """
        return pulumi.get(self, "mount_targets")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetMountTargetsResult(GetMountTargetsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetMountTargetsResult(
            file_system_id=self.file_system_id,
            id=self.id,
            mount_targets=self.mount_targets,
            result_output_file=self.result_output_file)


def get_mount_targets(file_system_id: Optional[str] = None,
                      result_output_file: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetMountTargetsResult:
    """
    Use this data source to query detailed information of cfs mount_targets

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    mount_targets = tencentcloud.Cfs.get_mount_targets(file_system_id="cfs-iobiaxtj")
    ```


    :param str file_system_id: File system ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['fileSystemId'] = file_system_id
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Cfs/getMountTargets:getMountTargets', __args__, opts=opts, typ=GetMountTargetsResult).value

    return AwaitableGetMountTargetsResult(
        file_system_id=__ret__.file_system_id,
        id=__ret__.id,
        mount_targets=__ret__.mount_targets,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_mount_targets)
def get_mount_targets_output(file_system_id: Optional[pulumi.Input[str]] = None,
                             result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetMountTargetsResult]:
    """
    Use this data source to query detailed information of cfs mount_targets

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    mount_targets = tencentcloud.Cfs.get_mount_targets(file_system_id="cfs-iobiaxtj")
    ```


    :param str file_system_id: File system ID.
    :param str result_output_file: Used to save results.
    """
    ...
