# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['MountPointAttachmentArgs', 'MountPointAttachment']

@pulumi.input_type
class MountPointAttachmentArgs:
    def __init__(__self__, *,
                 access_group_ids: pulumi.Input[Sequence[pulumi.Input[str]]],
                 mount_point_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a MountPointAttachment resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] access_group_ids: associate access group id.
        :param pulumi.Input[str] mount_point_id: associate mount point.
        """
        pulumi.set(__self__, "access_group_ids", access_group_ids)
        pulumi.set(__self__, "mount_point_id", mount_point_id)

    @property
    @pulumi.getter(name="accessGroupIds")
    def access_group_ids(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        associate access group id.
        """
        return pulumi.get(self, "access_group_ids")

    @access_group_ids.setter
    def access_group_ids(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "access_group_ids", value)

    @property
    @pulumi.getter(name="mountPointId")
    def mount_point_id(self) -> pulumi.Input[str]:
        """
        associate mount point.
        """
        return pulumi.get(self, "mount_point_id")

    @mount_point_id.setter
    def mount_point_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "mount_point_id", value)


@pulumi.input_type
class _MountPointAttachmentState:
    def __init__(__self__, *,
                 access_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 mount_point_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering MountPointAttachment resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] access_group_ids: associate access group id.
        :param pulumi.Input[str] mount_point_id: associate mount point.
        """
        if access_group_ids is not None:
            pulumi.set(__self__, "access_group_ids", access_group_ids)
        if mount_point_id is not None:
            pulumi.set(__self__, "mount_point_id", mount_point_id)

    @property
    @pulumi.getter(name="accessGroupIds")
    def access_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        associate access group id.
        """
        return pulumi.get(self, "access_group_ids")

    @access_group_ids.setter
    def access_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "access_group_ids", value)

    @property
    @pulumi.getter(name="mountPointId")
    def mount_point_id(self) -> Optional[pulumi.Input[str]]:
        """
        associate mount point.
        """
        return pulumi.get(self, "mount_point_id")

    @mount_point_id.setter
    def mount_point_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mount_point_id", value)


class MountPointAttachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 mount_point_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a chdfs mount_point_attachment

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        mount_point_attachment = tencentcloud.chdfs.MountPointAttachment("mountPointAttachment",
            access_group_ids=[
                "ag-bvmzrbsm",
                "ag-lairqrgr",
            ],
            mount_point_id="f14mpfy5lh4e-KuiL")
        ```

        ## Import

        chdfs mount_point_attachment can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Chdfs/mountPointAttachment:MountPointAttachment mount_point_attachment mount_point_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] access_group_ids: associate access group id.
        :param pulumi.Input[str] mount_point_id: associate mount point.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MountPointAttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a chdfs mount_point_attachment

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        mount_point_attachment = tencentcloud.chdfs.MountPointAttachment("mountPointAttachment",
            access_group_ids=[
                "ag-bvmzrbsm",
                "ag-lairqrgr",
            ],
            mount_point_id="f14mpfy5lh4e-KuiL")
        ```

        ## Import

        chdfs mount_point_attachment can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Chdfs/mountPointAttachment:MountPointAttachment mount_point_attachment mount_point_id
        ```

        :param str resource_name: The name of the resource.
        :param MountPointAttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MountPointAttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 mount_point_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MountPointAttachmentArgs.__new__(MountPointAttachmentArgs)

            if access_group_ids is None and not opts.urn:
                raise TypeError("Missing required property 'access_group_ids'")
            __props__.__dict__["access_group_ids"] = access_group_ids
            if mount_point_id is None and not opts.urn:
                raise TypeError("Missing required property 'mount_point_id'")
            __props__.__dict__["mount_point_id"] = mount_point_id
        super(MountPointAttachment, __self__).__init__(
            'tencentcloud:Chdfs/mountPointAttachment:MountPointAttachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            access_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            mount_point_id: Optional[pulumi.Input[str]] = None) -> 'MountPointAttachment':
        """
        Get an existing MountPointAttachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] access_group_ids: associate access group id.
        :param pulumi.Input[str] mount_point_id: associate mount point.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MountPointAttachmentState.__new__(_MountPointAttachmentState)

        __props__.__dict__["access_group_ids"] = access_group_ids
        __props__.__dict__["mount_point_id"] = mount_point_id
        return MountPointAttachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessGroupIds")
    def access_group_ids(self) -> pulumi.Output[Sequence[str]]:
        """
        associate access group id.
        """
        return pulumi.get(self, "access_group_ids")

    @property
    @pulumi.getter(name="mountPointId")
    def mount_point_id(self) -> pulumi.Output[str]:
        """
        associate mount point.
        """
        return pulumi.get(self, "mount_point_id")

