# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['BucketAttachmentArgs', 'BucketAttachment']

@pulumi.input_type
class BucketAttachmentArgs:
    def __init__(__self__, *,
                 bucket: pulumi.Input[str]):
        """
        The set of arguments for constructing a BucketAttachment resource.
        :param pulumi.Input[str] bucket: bucket name.
        """
        pulumi.set(__self__, "bucket", bucket)

    @property
    @pulumi.getter
    def bucket(self) -> pulumi.Input[str]:
        """
        bucket name.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: pulumi.Input[str]):
        pulumi.set(self, "bucket", value)


@pulumi.input_type
class _BucketAttachmentState:
    def __init__(__self__, *,
                 bucket: Optional[pulumi.Input[str]] = None,
                 ci_status: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BucketAttachment resources.
        :param pulumi.Input[str] bucket: bucket name.
        :param pulumi.Input[str] ci_status: Binding object storage state, `on`: bound, `off`: unbound, `unbinding`: unbinding.
        """
        if bucket is not None:
            pulumi.set(__self__, "bucket", bucket)
        if ci_status is not None:
            pulumi.set(__self__, "ci_status", ci_status)

    @property
    @pulumi.getter
    def bucket(self) -> Optional[pulumi.Input[str]]:
        """
        bucket name.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bucket", value)

    @property
    @pulumi.getter(name="ciStatus")
    def ci_status(self) -> Optional[pulumi.Input[str]]:
        """
        Binding object storage state, `on`: bound, `off`: unbound, `unbinding`: unbinding.
        """
        return pulumi.get(self, "ci_status")

    @ci_status.setter
    def ci_status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ci_status", value)


class BucketAttachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bucket: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a ci bucket

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        bucket_attachment = tencentcloud.ci.BucketAttachment("bucketAttachment", bucket="terraform-ci-xxxxxx")
        ```

        ## Import

        ci bucket can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Ci/bucketAttachment:BucketAttachment bucket_attachment terraform-ci-xxxxxx
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] bucket: bucket name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BucketAttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a ci bucket

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        bucket_attachment = tencentcloud.ci.BucketAttachment("bucketAttachment", bucket="terraform-ci-xxxxxx")
        ```

        ## Import

        ci bucket can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Ci/bucketAttachment:BucketAttachment bucket_attachment terraform-ci-xxxxxx
        ```

        :param str resource_name: The name of the resource.
        :param BucketAttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BucketAttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bucket: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BucketAttachmentArgs.__new__(BucketAttachmentArgs)

            if bucket is None and not opts.urn:
                raise TypeError("Missing required property 'bucket'")
            __props__.__dict__["bucket"] = bucket
            __props__.__dict__["ci_status"] = None
        super(BucketAttachment, __self__).__init__(
            'tencentcloud:Ci/bucketAttachment:BucketAttachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            bucket: Optional[pulumi.Input[str]] = None,
            ci_status: Optional[pulumi.Input[str]] = None) -> 'BucketAttachment':
        """
        Get an existing BucketAttachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] bucket: bucket name.
        :param pulumi.Input[str] ci_status: Binding object storage state, `on`: bound, `off`: unbound, `unbinding`: unbinding.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BucketAttachmentState.__new__(_BucketAttachmentState)

        __props__.__dict__["bucket"] = bucket
        __props__.__dict__["ci_status"] = ci_status
        return BucketAttachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def bucket(self) -> pulumi.Output[str]:
        """
        bucket name.
        """
        return pulumi.get(self, "bucket")

    @property
    @pulumi.getter(name="ciStatus")
    def ci_status(self) -> pulumi.Output[str]:
        """
        Binding object storage state, `on`: bound, `off`: unbound, `unbinding`: unbinding.
        """
        return pulumi.get(self, "ci_status")

