# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['UserGroupArgs', 'UserGroup']

@pulumi.input_type
class UserGroupArgs:
    def __init__(__self__, *,
                 display_name: pulumi.Input[str],
                 user_store_id: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a UserGroup resource.
        :param pulumi.Input[str] display_name: User Group Name.
        :param pulumi.Input[str] user_store_id: User Store ID.
        :param pulumi.Input[str] description: User Group Description.
        """
        pulumi.set(__self__, "display_name", display_name)
        pulumi.set(__self__, "user_store_id", user_store_id)
        if description is not None:
            pulumi.set(__self__, "description", description)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Input[str]:
        """
        User Group Name.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="userStoreId")
    def user_store_id(self) -> pulumi.Input[str]:
        """
        User Store ID.
        """
        return pulumi.get(self, "user_store_id")

    @user_store_id.setter
    def user_store_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "user_store_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        User Group Description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)


@pulumi.input_type
class _UserGroupState:
    def __init__(__self__, *,
                 description: Optional[pulumi.Input[str]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 user_store_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering UserGroup resources.
        :param pulumi.Input[str] description: User Group Description.
        :param pulumi.Input[str] display_name: User Group Name.
        :param pulumi.Input[str] user_store_id: User Store ID.
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if user_store_id is not None:
            pulumi.set(__self__, "user_store_id", user_store_id)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        User Group Description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[str]]:
        """
        User Group Name.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="userStoreId")
    def user_store_id(self) -> Optional[pulumi.Input[str]]:
        """
        User Store ID.
        """
        return pulumi.get(self, "user_store_id")

    @user_store_id.setter
    def user_store_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_store_id", value)


class UserGroup(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 user_store_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a ciam user group

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        user_store = tencentcloud.ciam.UserStore("userStore",
            user_pool_name="tf_user_store",
            user_pool_desc="for terraform test",
            user_pool_logo="https://ciam-prd-1302490086.cos.ap-guangzhou.myqcloud.com/temporary/92630252a2c5422d9663db5feafd619b.png")
        user_group = tencentcloud.ciam.UserGroup("userGroup",
            display_name="tf_user_group",
            user_store_id=user_store.id,
            description="for terrafrom test")
        ```

        ## Import

        ciam user_group can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Ciam/userGroup:UserGroup user_group userStoreId#userGroupId
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: User Group Description.
        :param pulumi.Input[str] display_name: User Group Name.
        :param pulumi.Input[str] user_store_id: User Store ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: UserGroupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a ciam user group

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        user_store = tencentcloud.ciam.UserStore("userStore",
            user_pool_name="tf_user_store",
            user_pool_desc="for terraform test",
            user_pool_logo="https://ciam-prd-1302490086.cos.ap-guangzhou.myqcloud.com/temporary/92630252a2c5422d9663db5feafd619b.png")
        user_group = tencentcloud.ciam.UserGroup("userGroup",
            display_name="tf_user_group",
            user_store_id=user_store.id,
            description="for terrafrom test")
        ```

        ## Import

        ciam user_group can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Ciam/userGroup:UserGroup user_group userStoreId#userGroupId
        ```

        :param str resource_name: The name of the resource.
        :param UserGroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(UserGroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 user_store_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = UserGroupArgs.__new__(UserGroupArgs)

            __props__.__dict__["description"] = description
            if display_name is None and not opts.urn:
                raise TypeError("Missing required property 'display_name'")
            __props__.__dict__["display_name"] = display_name
            if user_store_id is None and not opts.urn:
                raise TypeError("Missing required property 'user_store_id'")
            __props__.__dict__["user_store_id"] = user_store_id
        super(UserGroup, __self__).__init__(
            'tencentcloud:Ciam/userGroup:UserGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            description: Optional[pulumi.Input[str]] = None,
            display_name: Optional[pulumi.Input[str]] = None,
            user_store_id: Optional[pulumi.Input[str]] = None) -> 'UserGroup':
        """
        Get an existing UserGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: User Group Description.
        :param pulumi.Input[str] display_name: User Group Name.
        :param pulumi.Input[str] user_store_id: User Store ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _UserGroupState.__new__(_UserGroupState)

        __props__.__dict__["description"] = description
        __props__.__dict__["display_name"] = display_name
        __props__.__dict__["user_store_id"] = user_store_id
        return UserGroup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        User Group Description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Output[str]:
        """
        User Group Name.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="userStoreId")
    def user_store_id(self) -> pulumi.Output[str]:
        """
        User Store ID.
        """
        return pulumi.get(self, "user_store_id")

