# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetGroupResult',
    'AwaitableGetGroupResult',
    'get_group',
    'get_group_output',
]

@pulumi.output_type
class GetGroupResult:
    """
    A collection of values returned by getGroup.
    """
    def __init__(__self__, group_lists=None, id=None, instance_id=None, result_output_file=None, search_word=None):
        if group_lists and not isinstance(group_lists, list):
            raise TypeError("Expected argument 'group_lists' to be a list")
        pulumi.set(__self__, "group_lists", group_lists)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if search_word and not isinstance(search_word, str):
            raise TypeError("Expected argument 'search_word' to be a str")
        pulumi.set(__self__, "search_word", search_word)

    @property
    @pulumi.getter(name="groupLists")
    def group_lists(self) -> Sequence['outputs.GetGroupGroupListResult']:
        """
        GroupList.
        """
        return pulumi.get(self, "group_lists")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="searchWord")
    def search_word(self) -> Optional[str]:
        return pulumi.get(self, "search_word")


class AwaitableGetGroupResult(GetGroupResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetGroupResult(
            group_lists=self.group_lists,
            id=self.id,
            instance_id=self.instance_id,
            result_output_file=self.result_output_file,
            search_word=self.search_word)


def get_group(instance_id: Optional[str] = None,
              result_output_file: Optional[str] = None,
              search_word: Optional[str] = None,
              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetGroupResult:
    """
    Use this data source to query detailed information of ckafka group

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    group = tencentcloud.Ckafka.get_group(instance_id="ckafka-xxxxxxx",
        search_word="xxxxxx")
    ```


    :param str instance_id: InstanceId.
    :param str result_output_file: Used to save results.
    :param str search_word: search for the keyword.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    __args__['searchWord'] = search_word
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Ckafka/getGroup:getGroup', __args__, opts=opts, typ=GetGroupResult).value

    return AwaitableGetGroupResult(
        group_lists=__ret__.group_lists,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        result_output_file=__ret__.result_output_file,
        search_word=__ret__.search_word)


@_utilities.lift_output_func(get_group)
def get_group_output(instance_id: Optional[pulumi.Input[str]] = None,
                     result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                     search_word: Optional[pulumi.Input[Optional[str]]] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetGroupResult]:
    """
    Use this data source to query detailed information of ckafka group

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    group = tencentcloud.Ckafka.get_group(instance_id="ckafka-xxxxxxx",
        search_word="xxxxxx")
    ```


    :param str instance_id: InstanceId.
    :param str result_output_file: Used to save results.
    :param str search_word: search for the keyword.
    """
    ...
