# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetGroupOffsetsResult',
    'AwaitableGetGroupOffsetsResult',
    'get_group_offsets',
    'get_group_offsets_output',
]

@pulumi.output_type
class GetGroupOffsetsResult:
    """
    A collection of values returned by getGroupOffsets.
    """
    def __init__(__self__, group=None, id=None, instance_id=None, result_output_file=None, search_word=None, topic_lists=None, topics=None):
        if group and not isinstance(group, str):
            raise TypeError("Expected argument 'group' to be a str")
        pulumi.set(__self__, "group", group)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if search_word and not isinstance(search_word, str):
            raise TypeError("Expected argument 'search_word' to be a str")
        pulumi.set(__self__, "search_word", search_word)
        if topic_lists and not isinstance(topic_lists, list):
            raise TypeError("Expected argument 'topic_lists' to be a list")
        pulumi.set(__self__, "topic_lists", topic_lists)
        if topics and not isinstance(topics, list):
            raise TypeError("Expected argument 'topics' to be a list")
        pulumi.set(__self__, "topics", topics)

    @property
    @pulumi.getter
    def group(self) -> str:
        return pulumi.get(self, "group")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="searchWord")
    def search_word(self) -> Optional[str]:
        return pulumi.get(self, "search_word")

    @property
    @pulumi.getter(name="topicLists")
    def topic_lists(self) -> Sequence['outputs.GetGroupOffsetsTopicListResult']:
        """
        The topic array, where each element is a json object.
        """
        return pulumi.get(self, "topic_lists")

    @property
    @pulumi.getter
    def topics(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "topics")


class AwaitableGetGroupOffsetsResult(GetGroupOffsetsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetGroupOffsetsResult(
            group=self.group,
            id=self.id,
            instance_id=self.instance_id,
            result_output_file=self.result_output_file,
            search_word=self.search_word,
            topic_lists=self.topic_lists,
            topics=self.topics)


def get_group_offsets(group: Optional[str] = None,
                      instance_id: Optional[str] = None,
                      result_output_file: Optional[str] = None,
                      search_word: Optional[str] = None,
                      topics: Optional[Sequence[str]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetGroupOffsetsResult:
    """
    Use this data source to query detailed information of ckafka group_offsets

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    group_offsets = tencentcloud.Ckafka.get_group_offsets(group="xxxxxx",
        instance_id="ckafka-xxxxxx")
    ```


    :param str group: Kafka consumer group name.
    :param str instance_id: InstanceId.
    :param str result_output_file: Used to save results.
    :param str search_word: fuzzy match topicName.
    :param Sequence[str] topics: An array of topic names subscribed by the group, if there is no such array, it means all topic information under the specified group.
    """
    __args__ = dict()
    __args__['group'] = group
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    __args__['searchWord'] = search_word
    __args__['topics'] = topics
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Ckafka/getGroupOffsets:getGroupOffsets', __args__, opts=opts, typ=GetGroupOffsetsResult).value

    return AwaitableGetGroupOffsetsResult(
        group=__ret__.group,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        result_output_file=__ret__.result_output_file,
        search_word=__ret__.search_word,
        topic_lists=__ret__.topic_lists,
        topics=__ret__.topics)


@_utilities.lift_output_func(get_group_offsets)
def get_group_offsets_output(group: Optional[pulumi.Input[str]] = None,
                             instance_id: Optional[pulumi.Input[str]] = None,
                             result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                             search_word: Optional[pulumi.Input[Optional[str]]] = None,
                             topics: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetGroupOffsetsResult]:
    """
    Use this data source to query detailed information of ckafka group_offsets

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    group_offsets = tencentcloud.Ckafka.get_group_offsets(group="xxxxxx",
        instance_id="ckafka-xxxxxx")
    ```


    :param str group: Kafka consumer group name.
    :param str instance_id: InstanceId.
    :param str result_output_file: Used to save results.
    :param str search_word: fuzzy match topicName.
    :param Sequence[str] topics: An array of topic names subscribed by the group, if there is no such array, it means all topic information under the specified group.
    """
    ...
