# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetTopicProduceConnectionResult',
    'AwaitableGetTopicProduceConnectionResult',
    'get_topic_produce_connection',
    'get_topic_produce_connection_output',
]

@pulumi.output_type
class GetTopicProduceConnectionResult:
    """
    A collection of values returned by getTopicProduceConnection.
    """
    def __init__(__self__, id=None, instance_id=None, result_output_file=None, results=None, topic_name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)
        if topic_name and not isinstance(topic_name, str):
            raise TypeError("Expected argument 'topic_name' to be a str")
        pulumi.set(__self__, "topic_name", topic_name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetTopicProduceConnectionResultResult']:
        """
        link information return result set.
        """
        return pulumi.get(self, "results")

    @property
    @pulumi.getter(name="topicName")
    def topic_name(self) -> str:
        return pulumi.get(self, "topic_name")


class AwaitableGetTopicProduceConnectionResult(GetTopicProduceConnectionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTopicProduceConnectionResult(
            id=self.id,
            instance_id=self.instance_id,
            result_output_file=self.result_output_file,
            results=self.results,
            topic_name=self.topic_name)


def get_topic_produce_connection(instance_id: Optional[str] = None,
                                 result_output_file: Optional[str] = None,
                                 topic_name: Optional[str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTopicProduceConnectionResult:
    """
    Use this data source to query detailed information of ckafka topic_produce_connection

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    topic_produce_connection = tencentcloud.Ckafka.get_topic_produce_connection(instance_id="ckafka-xxxxxx",
        topic_name="topic-xxxxxx")
    ```


    :param str instance_id: InstanceId.
    :param str result_output_file: Used to save results.
    :param str topic_name: TopicName.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    __args__['topicName'] = topic_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Ckafka/getTopicProduceConnection:getTopicProduceConnection', __args__, opts=opts, typ=GetTopicProduceConnectionResult).value

    return AwaitableGetTopicProduceConnectionResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        result_output_file=__ret__.result_output_file,
        results=__ret__.results,
        topic_name=__ret__.topic_name)


@_utilities.lift_output_func(get_topic_produce_connection)
def get_topic_produce_connection_output(instance_id: Optional[pulumi.Input[str]] = None,
                                        result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                        topic_name: Optional[pulumi.Input[str]] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetTopicProduceConnectionResult]:
    """
    Use this data source to query detailed information of ckafka topic_produce_connection

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    topic_produce_connection = tencentcloud.Ckafka.get_topic_produce_connection(instance_id="ckafka-xxxxxx",
        topic_name="topic-xxxxxx")
    ```


    :param str instance_id: InstanceId.
    :param str result_output_file: Used to save results.
    :param str topic_name: TopicName.
    """
    ...
