# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetTopicsResult',
    'AwaitableGetTopicsResult',
    'get_topics',
    'get_topics_output',
]

@pulumi.output_type
class GetTopicsResult:
    """
    A collection of values returned by getTopics.
    """
    def __init__(__self__, id=None, instance_id=None, instance_lists=None, result_output_file=None, topic_name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if instance_lists and not isinstance(instance_lists, list):
            raise TypeError("Expected argument 'instance_lists' to be a list")
        pulumi.set(__self__, "instance_lists", instance_lists)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if topic_name and not isinstance(topic_name, str):
            raise TypeError("Expected argument 'topic_name' to be a str")
        pulumi.set(__self__, "topic_name", topic_name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="instanceLists")
    def instance_lists(self) -> Sequence['outputs.GetTopicsInstanceListResult']:
        """
        A list of instances. Each element contains the following attributes.
        """
        return pulumi.get(self, "instance_lists")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="topicName")
    def topic_name(self) -> Optional[str]:
        """
        Name of the CKafka topic.
        """
        return pulumi.get(self, "topic_name")


class AwaitableGetTopicsResult(GetTopicsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTopicsResult(
            id=self.id,
            instance_id=self.instance_id,
            instance_lists=self.instance_lists,
            result_output_file=self.result_output_file,
            topic_name=self.topic_name)


def get_topics(instance_id: Optional[str] = None,
               result_output_file: Optional[str] = None,
               topic_name: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTopicsResult:
    """
    Use this data source to query detailed information of ckafka topic.

    ## Example Usage

    ```python
    import pulumi
    import tencentcloud_iac_pulumi as tencentcloud

    foo = tencentcloud.ckafka.Topic("foo",
        clean_up_policy="delete",
        enable_white_list=True,
        instance_id="ckafka-f9ife4zz",
        ip_white_lists=[
            "ip1",
            "ip2",
        ],
        max_message_bytes=1024,
        note="topic note",
        partition_num=1,
        replica_num=2,
        retention=60000,
        segment=3600000,
        sync_replica_min_num=1,
        topic_name="example",
        unclean_leader_election_enable=False)
    ```


    :param str instance_id: Ckafka instance ID.
    :param str result_output_file: Used to store results.
    :param str topic_name: Name of the CKafka topic. It must start with a letter, the rest can contain letters, numbers and dashes(-). The length range is from 1 to 64.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    __args__['topicName'] = topic_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Ckafka/getTopics:getTopics', __args__, opts=opts, typ=GetTopicsResult).value

    return AwaitableGetTopicsResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        instance_lists=__ret__.instance_lists,
        result_output_file=__ret__.result_output_file,
        topic_name=__ret__.topic_name)


@_utilities.lift_output_func(get_topics)
def get_topics_output(instance_id: Optional[pulumi.Input[str]] = None,
                      result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                      topic_name: Optional[pulumi.Input[Optional[str]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetTopicsResult]:
    """
    Use this data source to query detailed information of ckafka topic.

    ## Example Usage

    ```python
    import pulumi
    import tencentcloud_iac_pulumi as tencentcloud

    foo = tencentcloud.ckafka.Topic("foo",
        clean_up_policy="delete",
        enable_white_list=True,
        instance_id="ckafka-f9ife4zz",
        ip_white_lists=[
            "ip1",
            "ip2",
        ],
        max_message_bytes=1024,
        note="topic note",
        partition_num=1,
        replica_num=2,
        retention=60000,
        segment=3600000,
        sync_replica_min_num=1,
        topic_name="example",
        unclean_leader_election_enable=False)
    ```


    :param str instance_id: Ckafka instance ID.
    :param str result_output_file: Used to store results.
    :param str topic_name: Name of the CKafka topic. It must start with a letter, the rest can contain letters, numbers and dashes(-). The length range is from 1 to 64.
    """
    ...
