# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['InstanceSlaConfigArgs', 'InstanceSlaConfig']

@pulumi.input_type
class InstanceSlaConfigArgs:
    def __init__(__self__, *,
                 load_balancer_id: pulumi.Input[str],
                 sla_type: pulumi.Input[str]):
        """
        The set of arguments for constructing a InstanceSlaConfig resource.
        :param pulumi.Input[str] load_balancer_id: ID of the CLB instance.
        :param pulumi.Input[str] sla_type: To upgrade to LCU-supported CLB instances. It must be SLA.
        """
        pulumi.set(__self__, "load_balancer_id", load_balancer_id)
        pulumi.set(__self__, "sla_type", sla_type)

    @property
    @pulumi.getter(name="loadBalancerId")
    def load_balancer_id(self) -> pulumi.Input[str]:
        """
        ID of the CLB instance.
        """
        return pulumi.get(self, "load_balancer_id")

    @load_balancer_id.setter
    def load_balancer_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "load_balancer_id", value)

    @property
    @pulumi.getter(name="slaType")
    def sla_type(self) -> pulumi.Input[str]:
        """
        To upgrade to LCU-supported CLB instances. It must be SLA.
        """
        return pulumi.get(self, "sla_type")

    @sla_type.setter
    def sla_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "sla_type", value)


@pulumi.input_type
class _InstanceSlaConfigState:
    def __init__(__self__, *,
                 load_balancer_id: Optional[pulumi.Input[str]] = None,
                 sla_type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering InstanceSlaConfig resources.
        :param pulumi.Input[str] load_balancer_id: ID of the CLB instance.
        :param pulumi.Input[str] sla_type: To upgrade to LCU-supported CLB instances. It must be SLA.
        """
        if load_balancer_id is not None:
            pulumi.set(__self__, "load_balancer_id", load_balancer_id)
        if sla_type is not None:
            pulumi.set(__self__, "sla_type", sla_type)

    @property
    @pulumi.getter(name="loadBalancerId")
    def load_balancer_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the CLB instance.
        """
        return pulumi.get(self, "load_balancer_id")

    @load_balancer_id.setter
    def load_balancer_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "load_balancer_id", value)

    @property
    @pulumi.getter(name="slaType")
    def sla_type(self) -> Optional[pulumi.Input[str]]:
        """
        To upgrade to LCU-supported CLB instances. It must be SLA.
        """
        return pulumi.get(self, "sla_type")

    @sla_type.setter
    def sla_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sla_type", value)


class InstanceSlaConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 load_balancer_id: Optional[pulumi.Input[str]] = None,
                 sla_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a clb instance_sla_config

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        instance_sla_config = tencentcloud.clb.InstanceSlaConfig("instanceSlaConfig",
            load_balancer_id="lb-5dnrkgry",
            sla_type="SLA")
        ```

        ## Import

        clb instance_sla_config can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Clb/instanceSlaConfig:InstanceSlaConfig instance_sla_config instance_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] load_balancer_id: ID of the CLB instance.
        :param pulumi.Input[str] sla_type: To upgrade to LCU-supported CLB instances. It must be SLA.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InstanceSlaConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a clb instance_sla_config

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        instance_sla_config = tencentcloud.clb.InstanceSlaConfig("instanceSlaConfig",
            load_balancer_id="lb-5dnrkgry",
            sla_type="SLA")
        ```

        ## Import

        clb instance_sla_config can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Clb/instanceSlaConfig:InstanceSlaConfig instance_sla_config instance_id
        ```

        :param str resource_name: The name of the resource.
        :param InstanceSlaConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InstanceSlaConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 load_balancer_id: Optional[pulumi.Input[str]] = None,
                 sla_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InstanceSlaConfigArgs.__new__(InstanceSlaConfigArgs)

            if load_balancer_id is None and not opts.urn:
                raise TypeError("Missing required property 'load_balancer_id'")
            __props__.__dict__["load_balancer_id"] = load_balancer_id
            if sla_type is None and not opts.urn:
                raise TypeError("Missing required property 'sla_type'")
            __props__.__dict__["sla_type"] = sla_type
        super(InstanceSlaConfig, __self__).__init__(
            'tencentcloud:Clb/instanceSlaConfig:InstanceSlaConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            load_balancer_id: Optional[pulumi.Input[str]] = None,
            sla_type: Optional[pulumi.Input[str]] = None) -> 'InstanceSlaConfig':
        """
        Get an existing InstanceSlaConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] load_balancer_id: ID of the CLB instance.
        :param pulumi.Input[str] sla_type: To upgrade to LCU-supported CLB instances. It must be SLA.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InstanceSlaConfigState.__new__(_InstanceSlaConfigState)

        __props__.__dict__["load_balancer_id"] = load_balancer_id
        __props__.__dict__["sla_type"] = sla_type
        return InstanceSlaConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="loadBalancerId")
    def load_balancer_id(self) -> pulumi.Output[str]:
        """
        ID of the CLB instance.
        """
        return pulumi.get(self, "load_balancer_id")

    @property
    @pulumi.getter(name="slaType")
    def sla_type(self) -> pulumi.Output[str]:
        """
        To upgrade to LCU-supported CLB instances. It must be SLA.
        """
        return pulumi.get(self, "sla_type")

