# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ConfigAttachmentArgs', 'ConfigAttachment']

@pulumi.input_type
class ConfigAttachmentArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[str],
                 group_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a ConfigAttachment resource.
        :param pulumi.Input[str] config_id: Collection configuration id.
        :param pulumi.Input[str] group_id: Machine group id.
        """
        pulumi.set(__self__, "config_id", config_id)
        pulumi.set(__self__, "group_id", group_id)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[str]:
        """
        Collection configuration id.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> pulumi.Input[str]:
        """
        Machine group id.
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_id", value)


@pulumi.input_type
class _ConfigAttachmentState:
    def __init__(__self__, *,
                 config_id: Optional[pulumi.Input[str]] = None,
                 group_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ConfigAttachment resources.
        :param pulumi.Input[str] config_id: Collection configuration id.
        :param pulumi.Input[str] group_id: Machine group id.
        """
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if group_id is not None:
            pulumi.set(__self__, "group_id", group_id)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[str]]:
        """
        Collection configuration id.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> Optional[pulumi.Input[str]]:
        """
        Machine group id.
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "group_id", value)


class ConfigAttachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[str]] = None,
                 group_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a cls config attachment

        ## Import

        cls config_attachment can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Cls/configAttachment:ConfigAttachment attach config_id#group_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] config_id: Collection configuration id.
        :param pulumi.Input[str] group_id: Machine group id.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ConfigAttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a cls config attachment

        ## Import

        cls config_attachment can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Cls/configAttachment:ConfigAttachment attach config_id#group_id
        ```

        :param str resource_name: The name of the resource.
        :param ConfigAttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ConfigAttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[str]] = None,
                 group_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ConfigAttachmentArgs.__new__(ConfigAttachmentArgs)

            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if group_id is None and not opts.urn:
                raise TypeError("Missing required property 'group_id'")
            __props__.__dict__["group_id"] = group_id
        super(ConfigAttachment, __self__).__init__(
            'tencentcloud:Cls/configAttachment:ConfigAttachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config_id: Optional[pulumi.Input[str]] = None,
            group_id: Optional[pulumi.Input[str]] = None) -> 'ConfigAttachment':
        """
        Get an existing ConfigAttachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] config_id: Collection configuration id.
        :param pulumi.Input[str] group_id: Machine group id.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ConfigAttachmentState.__new__(_ConfigAttachmentState)

        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["group_id"] = group_id
        return ConfigAttachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[str]:
        """
        Collection configuration id.
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> pulumi.Output[str]:
        """
        Machine group id.
        """
        return pulumi.get(self, "group_id")

