# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['LogsetArgs', 'Logset']

@pulumi.input_type
class LogsetArgs:
    def __init__(__self__, *,
                 logset_name: pulumi.Input[str],
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None):
        """
        The set of arguments for constructing a Logset resource.
        :param pulumi.Input[str] logset_name: Logset name, which must be unique.
        :param pulumi.Input[Mapping[str, Any]] tags: Tag description list.
        """
        pulumi.set(__self__, "logset_name", logset_name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="logsetName")
    def logset_name(self) -> pulumi.Input[str]:
        """
        Logset name, which must be unique.
        """
        return pulumi.get(self, "logset_name")

    @logset_name.setter
    def logset_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "logset_name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        Tag description list.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _LogsetState:
    def __init__(__self__, *,
                 create_time: Optional[pulumi.Input[str]] = None,
                 logset_name: Optional[pulumi.Input[str]] = None,
                 role_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 topic_count: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering Logset resources.
        :param pulumi.Input[str] create_time: Creation time.
        :param pulumi.Input[str] logset_name: Logset name, which must be unique.
        :param pulumi.Input[str] role_name: If assumer_uin is not empty, it indicates the service provider who creates the logset.
        :param pulumi.Input[Mapping[str, Any]] tags: Tag description list.
        :param pulumi.Input[int] topic_count: Number of log topics in logset.
        """
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if logset_name is not None:
            pulumi.set(__self__, "logset_name", logset_name)
        if role_name is not None:
            pulumi.set(__self__, "role_name", role_name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if topic_count is not None:
            pulumi.set(__self__, "topic_count", topic_count)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        Creation time.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter(name="logsetName")
    def logset_name(self) -> Optional[pulumi.Input[str]]:
        """
        Logset name, which must be unique.
        """
        return pulumi.get(self, "logset_name")

    @logset_name.setter
    def logset_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "logset_name", value)

    @property
    @pulumi.getter(name="roleName")
    def role_name(self) -> Optional[pulumi.Input[str]]:
        """
        If assumer_uin is not empty, it indicates the service provider who creates the logset.
        """
        return pulumi.get(self, "role_name")

    @role_name.setter
    def role_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "role_name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        Tag description list.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="topicCount")
    def topic_count(self) -> Optional[pulumi.Input[int]]:
        """
        Number of log topics in logset.
        """
        return pulumi.get(self, "topic_count")

    @topic_count.setter
    def topic_count(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "topic_count", value)


class Logset(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 logset_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 __props__=None):
        """
        Provides a resource to create a cls logset

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        logset = tencentcloud.cls.Logset("logset",
            logset_name="demo",
            tags={
                "createdBy": "terraform",
            })
        ```

        ## Import

        cls logset can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Cls/logset:Logset logset logset_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] logset_name: Logset name, which must be unique.
        :param pulumi.Input[Mapping[str, Any]] tags: Tag description list.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: LogsetArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a cls logset

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        logset = tencentcloud.cls.Logset("logset",
            logset_name="demo",
            tags={
                "createdBy": "terraform",
            })
        ```

        ## Import

        cls logset can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Cls/logset:Logset logset logset_id
        ```

        :param str resource_name: The name of the resource.
        :param LogsetArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(LogsetArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 logset_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = LogsetArgs.__new__(LogsetArgs)

            if logset_name is None and not opts.urn:
                raise TypeError("Missing required property 'logset_name'")
            __props__.__dict__["logset_name"] = logset_name
            __props__.__dict__["tags"] = tags
            __props__.__dict__["create_time"] = None
            __props__.__dict__["role_name"] = None
            __props__.__dict__["topic_count"] = None
        super(Logset, __self__).__init__(
            'tencentcloud:Cls/logset:Logset',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            logset_name: Optional[pulumi.Input[str]] = None,
            role_name: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            topic_count: Optional[pulumi.Input[int]] = None) -> 'Logset':
        """
        Get an existing Logset resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] create_time: Creation time.
        :param pulumi.Input[str] logset_name: Logset name, which must be unique.
        :param pulumi.Input[str] role_name: If assumer_uin is not empty, it indicates the service provider who creates the logset.
        :param pulumi.Input[Mapping[str, Any]] tags: Tag description list.
        :param pulumi.Input[int] topic_count: Number of log topics in logset.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _LogsetState.__new__(_LogsetState)

        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["logset_name"] = logset_name
        __props__.__dict__["role_name"] = role_name
        __props__.__dict__["tags"] = tags
        __props__.__dict__["topic_count"] = topic_count
        return Logset(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        Creation time.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="logsetName")
    def logset_name(self) -> pulumi.Output[str]:
        """
        Logset name, which must be unique.
        """
        return pulumi.get(self, "logset_name")

    @property
    @pulumi.getter(name="roleName")
    def role_name(self) -> pulumi.Output[str]:
        """
        If assumer_uin is not empty, it indicates the service provider who creates the logset.
        """
        return pulumi.get(self, "role_name")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, Any]]]:
        """
        Tag description list.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="topicCount")
    def topic_count(self) -> pulumi.Output[int]:
        """
        Number of log topics in logset.
        """
        return pulumi.get(self, "topic_count")

