# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetChcHostsResult',
    'AwaitableGetChcHostsResult',
    'get_chc_hosts',
    'get_chc_hosts_output',
]

@pulumi.output_type
class GetChcHostsResult:
    """
    A collection of values returned by getChcHosts.
    """
    def __init__(__self__, chc_host_sets=None, chc_ids=None, filters=None, id=None, result_output_file=None):
        if chc_host_sets and not isinstance(chc_host_sets, list):
            raise TypeError("Expected argument 'chc_host_sets' to be a list")
        pulumi.set(__self__, "chc_host_sets", chc_host_sets)
        if chc_ids and not isinstance(chc_ids, list):
            raise TypeError("Expected argument 'chc_ids' to be a list")
        pulumi.set(__self__, "chc_ids", chc_ids)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="chcHostSets")
    def chc_host_sets(self) -> Sequence['outputs.GetChcHostsChcHostSetResult']:
        """
        List of returned instances.
        """
        return pulumi.get(self, "chc_host_sets")

    @property
    @pulumi.getter(name="chcIds")
    def chc_ids(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "chc_ids")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetChcHostsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetChcHostsResult(GetChcHostsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetChcHostsResult(
            chc_host_sets=self.chc_host_sets,
            chc_ids=self.chc_ids,
            filters=self.filters,
            id=self.id,
            result_output_file=self.result_output_file)


def get_chc_hosts(chc_ids: Optional[Sequence[str]] = None,
                  filters: Optional[Sequence[pulumi.InputType['GetChcHostsFilterArgs']]] = None,
                  result_output_file: Optional[str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetChcHostsResult:
    """
    Use this data source to query detailed information of cvm chc_hosts

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    chc_hosts = tencentcloud.Cvm.get_chc_hosts(chc_ids=["chc-xxxxxx"],
        filters=[tencentcloud.cvm.GetChcHostsFilterArgs(
            name="zone",
            values=["ap-guangzhou-7"],
        )])
    ```


    :param Sequence[str] chc_ids: CHC host ID. Up to 100 instances per request is allowed. ChcIds and Filters cannot be specified at the same time.
    :param Sequence[pulumi.InputType['GetChcHostsFilterArgs']] filters: - `zone` Filter by the availability zone, such as ap-guangzhou-1. Valid values: See [Regions and Availability Zones](https://www.tencentcloud.com/document/product/213/6091?from_cn_redirect=1).
           - `instance-name` Filter by the instance name.
           - `instance-state` Filter by the instance status. For status details, see [InstanceStatus](https://www.tencentcloud.com/document/api/213/15753?from_cn_redirect=1#InstanceStatus).
           - `device-type` Filter by the device type.
           - `vpc-id` Filter by the unique VPC ID.
           - `subnet-id` Filter by the unique VPC subnet ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['chcIds'] = chc_ids
    __args__['filters'] = filters
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Cvm/getChcHosts:getChcHosts', __args__, opts=opts, typ=GetChcHostsResult).value

    return AwaitableGetChcHostsResult(
        chc_host_sets=__ret__.chc_host_sets,
        chc_ids=__ret__.chc_ids,
        filters=__ret__.filters,
        id=__ret__.id,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_chc_hosts)
def get_chc_hosts_output(chc_ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                         filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetChcHostsFilterArgs']]]]] = None,
                         result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetChcHostsResult]:
    """
    Use this data source to query detailed information of cvm chc_hosts

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    chc_hosts = tencentcloud.Cvm.get_chc_hosts(chc_ids=["chc-xxxxxx"],
        filters=[tencentcloud.cvm.GetChcHostsFilterArgs(
            name="zone",
            values=["ap-guangzhou-7"],
        )])
    ```


    :param Sequence[str] chc_ids: CHC host ID. Up to 100 instances per request is allowed. ChcIds and Filters cannot be specified at the same time.
    :param Sequence[pulumi.InputType['GetChcHostsFilterArgs']] filters: - `zone` Filter by the availability zone, such as ap-guangzhou-1. Valid values: See [Regions and Availability Zones](https://www.tencentcloud.com/document/product/213/6091?from_cn_redirect=1).
           - `instance-name` Filter by the instance name.
           - `instance-state` Filter by the instance status. For status details, see [InstanceStatus](https://www.tencentcloud.com/document/api/213/15753?from_cn_redirect=1#InstanceStatus).
           - `device-type` Filter by the device type.
           - `vpc-id` Filter by the unique VPC ID.
           - `subnet-id` Filter by the unique VPC subnet ID.
    :param str result_output_file: Used to save results.
    """
    ...
