# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetRedisTopBigKeysResult',
    'AwaitableGetRedisTopBigKeysResult',
    'get_redis_top_big_keys',
    'get_redis_top_big_keys_output',
]

@pulumi.output_type
class GetRedisTopBigKeysResult:
    """
    A collection of values returned by getRedisTopBigKeys.
    """
    def __init__(__self__, date=None, id=None, instance_id=None, key_type=None, product=None, result_output_file=None, sort_by=None, top_keys=None):
        if date and not isinstance(date, str):
            raise TypeError("Expected argument 'date' to be a str")
        pulumi.set(__self__, "date", date)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if key_type and not isinstance(key_type, str):
            raise TypeError("Expected argument 'key_type' to be a str")
        pulumi.set(__self__, "key_type", key_type)
        if product and not isinstance(product, str):
            raise TypeError("Expected argument 'product' to be a str")
        pulumi.set(__self__, "product", product)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if sort_by and not isinstance(sort_by, str):
            raise TypeError("Expected argument 'sort_by' to be a str")
        pulumi.set(__self__, "sort_by", sort_by)
        if top_keys and not isinstance(top_keys, list):
            raise TypeError("Expected argument 'top_keys' to be a list")
        pulumi.set(__self__, "top_keys", top_keys)

    @property
    @pulumi.getter
    def date(self) -> str:
        return pulumi.get(self, "date")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="keyType")
    def key_type(self) -> Optional[str]:
        return pulumi.get(self, "key_type")

    @property
    @pulumi.getter
    def product(self) -> str:
        return pulumi.get(self, "product")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="sortBy")
    def sort_by(self) -> Optional[str]:
        return pulumi.get(self, "sort_by")

    @property
    @pulumi.getter(name="topKeys")
    def top_keys(self) -> Sequence['outputs.GetRedisTopBigKeysTopKeyResult']:
        """
        list of top keys.
        """
        return pulumi.get(self, "top_keys")


class AwaitableGetRedisTopBigKeysResult(GetRedisTopBigKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRedisTopBigKeysResult(
            date=self.date,
            id=self.id,
            instance_id=self.instance_id,
            key_type=self.key_type,
            product=self.product,
            result_output_file=self.result_output_file,
            sort_by=self.sort_by,
            top_keys=self.top_keys)


def get_redis_top_big_keys(date: Optional[str] = None,
                           instance_id: Optional[str] = None,
                           key_type: Optional[str] = None,
                           product: Optional[str] = None,
                           result_output_file: Optional[str] = None,
                           sort_by: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRedisTopBigKeysResult:
    """
    Use this data source to query detailed information of dbbrain redis_top_big_keys

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    redis_top_big_keys = tencentcloud.Dbbrain.get_redis_top_big_keys(instance_id=local["redis_id"],
        date="%s",
        product="redis",
        sort_by="Capacity",
        key_type="string")
    ```


    :param str date: Query date, such as 2021-05-27, the earliest date can be the previous 30 days.
    :param str instance_id: instance id.
    :param str key_type: Key type filter condition, the default is no filter, the value includes `string`, `list`, `set`, `hash`, `sortedset`, `stream`.
    :param str product: Service product type, supported values include `redis` - cloud database Redis.
    :param str result_output_file: Used to save results.
    :param str sort_by: Sorting field, the value includes `Capacity` - memory, `ItemCount` - number of elements, the default is `Capacity`.
    """
    __args__ = dict()
    __args__['date'] = date
    __args__['instanceId'] = instance_id
    __args__['keyType'] = key_type
    __args__['product'] = product
    __args__['resultOutputFile'] = result_output_file
    __args__['sortBy'] = sort_by
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Dbbrain/getRedisTopBigKeys:getRedisTopBigKeys', __args__, opts=opts, typ=GetRedisTopBigKeysResult).value

    return AwaitableGetRedisTopBigKeysResult(
        date=__ret__.date,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        key_type=__ret__.key_type,
        product=__ret__.product,
        result_output_file=__ret__.result_output_file,
        sort_by=__ret__.sort_by,
        top_keys=__ret__.top_keys)


@_utilities.lift_output_func(get_redis_top_big_keys)
def get_redis_top_big_keys_output(date: Optional[pulumi.Input[str]] = None,
                                  instance_id: Optional[pulumi.Input[str]] = None,
                                  key_type: Optional[pulumi.Input[Optional[str]]] = None,
                                  product: Optional[pulumi.Input[str]] = None,
                                  result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                  sort_by: Optional[pulumi.Input[Optional[str]]] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRedisTopBigKeysResult]:
    """
    Use this data source to query detailed information of dbbrain redis_top_big_keys

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    redis_top_big_keys = tencentcloud.Dbbrain.get_redis_top_big_keys(instance_id=local["redis_id"],
        date="%s",
        product="redis",
        sort_by="Capacity",
        key_type="string")
    ```


    :param str date: Query date, such as 2021-05-27, the earliest date can be the previous 30 days.
    :param str instance_id: instance id.
    :param str key_type: Key type filter condition, the default is no filter, the value includes `string`, `list`, `set`, `hash`, `sortedset`, `stream`.
    :param str product: Service product type, supported values include `redis` - cloud database Redis.
    :param str result_output_file: Used to save results.
    :param str sort_by: Sorting field, the value includes `Capacity` - memory, `ItemCount` - number of elements, the default is `Capacity`.
    """
    ...
