# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetTopSpaceSchemasResult',
    'AwaitableGetTopSpaceSchemasResult',
    'get_top_space_schemas',
    'get_top_space_schemas_output',
]

@pulumi.output_type
class GetTopSpaceSchemasResult:
    """
    A collection of values returned by getTopSpaceSchemas.
    """
    def __init__(__self__, id=None, instance_id=None, limit=None, product=None, result_output_file=None, sort_by=None, timestamp=None, top_space_schemas=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if limit and not isinstance(limit, int):
            raise TypeError("Expected argument 'limit' to be a int")
        pulumi.set(__self__, "limit", limit)
        if product and not isinstance(product, str):
            raise TypeError("Expected argument 'product' to be a str")
        pulumi.set(__self__, "product", product)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if sort_by and not isinstance(sort_by, str):
            raise TypeError("Expected argument 'sort_by' to be a str")
        pulumi.set(__self__, "sort_by", sort_by)
        if timestamp and not isinstance(timestamp, int):
            raise TypeError("Expected argument 'timestamp' to be a int")
        pulumi.set(__self__, "timestamp", timestamp)
        if top_space_schemas and not isinstance(top_space_schemas, list):
            raise TypeError("Expected argument 'top_space_schemas' to be a list")
        pulumi.set(__self__, "top_space_schemas", top_space_schemas)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def limit(self) -> Optional[int]:
        return pulumi.get(self, "limit")

    @property
    @pulumi.getter
    def product(self) -> Optional[str]:
        return pulumi.get(self, "product")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="sortBy")
    def sort_by(self) -> Optional[str]:
        return pulumi.get(self, "sort_by")

    @property
    @pulumi.getter
    def timestamp(self) -> int:
        """
        Timestamp (in seconds) when library space data is collected.
        """
        return pulumi.get(self, "timestamp")

    @property
    @pulumi.getter(name="topSpaceSchemas")
    def top_space_schemas(self) -> Sequence['outputs.GetTopSpaceSchemasTopSpaceSchemaResult']:
        """
        The returned list of top library space statistics.
        """
        return pulumi.get(self, "top_space_schemas")


class AwaitableGetTopSpaceSchemasResult(GetTopSpaceSchemasResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTopSpaceSchemasResult(
            id=self.id,
            instance_id=self.instance_id,
            limit=self.limit,
            product=self.product,
            result_output_file=self.result_output_file,
            sort_by=self.sort_by,
            timestamp=self.timestamp,
            top_space_schemas=self.top_space_schemas)


def get_top_space_schemas(instance_id: Optional[str] = None,
                          limit: Optional[int] = None,
                          product: Optional[str] = None,
                          result_output_file: Optional[str] = None,
                          sort_by: Optional[str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTopSpaceSchemasResult:
    """
    Use this data source to query detailed information of dbbrain top_space_schemas

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    top_space_schemas = tencentcloud.Dbbrain.get_top_space_schemas(instance_id="%s",
        product="mysql",
        sort_by="DataLength")
    ```


    :param str instance_id: instance id.
    :param int limit: The number of Top libraries to return, the maximum value is 100, and the default is 20.
    :param str product: Service product type, supported values include: mysql - cloud database MySQL, cynosdb - cloud database CynosDB for MySQL, the default is mysql.
    :param str result_output_file: Used to save results.
    :param str sort_by: The sorting field used to filter the Top library. The optional fields include DataLength, IndexLength, TotalLength, DataFree, FragRatio, TableRows, and PhysicalFileSize (only supported by ApsaraDB for MySQL instances). The default for ApsaraDB for MySQL instances is PhysicalFileSize, and the default for other product instances is TotalLength.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['limit'] = limit
    __args__['product'] = product
    __args__['resultOutputFile'] = result_output_file
    __args__['sortBy'] = sort_by
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Dbbrain/getTopSpaceSchemas:getTopSpaceSchemas', __args__, opts=opts, typ=GetTopSpaceSchemasResult).value

    return AwaitableGetTopSpaceSchemasResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        limit=__ret__.limit,
        product=__ret__.product,
        result_output_file=__ret__.result_output_file,
        sort_by=__ret__.sort_by,
        timestamp=__ret__.timestamp,
        top_space_schemas=__ret__.top_space_schemas)


@_utilities.lift_output_func(get_top_space_schemas)
def get_top_space_schemas_output(instance_id: Optional[pulumi.Input[str]] = None,
                                 limit: Optional[pulumi.Input[Optional[int]]] = None,
                                 product: Optional[pulumi.Input[Optional[str]]] = None,
                                 result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                 sort_by: Optional[pulumi.Input[Optional[str]]] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetTopSpaceSchemasResult]:
    """
    Use this data source to query detailed information of dbbrain top_space_schemas

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    top_space_schemas = tencentcloud.Dbbrain.get_top_space_schemas(instance_id="%s",
        product="mysql",
        sort_by="DataLength")
    ```


    :param str instance_id: instance id.
    :param int limit: The number of Top libraries to return, the maximum value is 100, and the default is 20.
    :param str product: Service product type, supported values include: mysql - cloud database MySQL, cynosdb - cloud database CynosDB for MySQL, the default is mysql.
    :param str result_output_file: Used to save results.
    :param str sort_by: The sorting field used to filter the Top library. The optional fields include DataLength, IndexLength, TotalLength, DataFree, FragRatio, TableRows, and PhysicalFileSize (only supported by ApsaraDB for MySQL instances). The default for ApsaraDB for MySQL instances is PhysicalFileSize, and the default for other product instances is TotalLength.
    """
    ...
