# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInternetAddressStatisticsResult',
    'AwaitableGetInternetAddressStatisticsResult',
    'get_internet_address_statistics',
    'get_internet_address_statistics_output',
]

@pulumi.output_type
class GetInternetAddressStatisticsResult:
    """
    A collection of values returned by getInternetAddressStatistics.
    """
    def __init__(__self__, id=None, internet_address_statistics=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if internet_address_statistics and not isinstance(internet_address_statistics, list):
            raise TypeError("Expected argument 'internet_address_statistics' to be a list")
        pulumi.set(__self__, "internet_address_statistics", internet_address_statistics)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="internetAddressStatistics")
    def internet_address_statistics(self) -> Sequence['outputs.GetInternetAddressStatisticsInternetAddressStatisticResult']:
        """
        Statistical Information List of Internet Public Network Addresses.
        """
        return pulumi.get(self, "internet_address_statistics")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetInternetAddressStatisticsResult(GetInternetAddressStatisticsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInternetAddressStatisticsResult(
            id=self.id,
            internet_address_statistics=self.internet_address_statistics,
            result_output_file=self.result_output_file)


def get_internet_address_statistics(result_output_file: Optional[str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInternetAddressStatisticsResult:
    """
    Use this data source to query detailed information of dc internet_address_statistics

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    internet_address_statistics = tencentcloud.Dc.get_internet_address_statistics()
    ```


    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Dc/getInternetAddressStatistics:getInternetAddressStatistics', __args__, opts=opts, typ=GetInternetAddressStatisticsResult).value

    return AwaitableGetInternetAddressStatisticsResult(
        id=__ret__.id,
        internet_address_statistics=__ret__.internet_address_statistics,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_internet_address_statistics)
def get_internet_address_statistics_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInternetAddressStatisticsResult]:
    """
    Use this data source to query detailed information of dc internet_address_statistics

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    internet_address_statistics = tencentcloud.Dc.get_internet_address_statistics()
    ```


    :param str result_output_file: Used to save results.
    """
    ...
