# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DbParametersArgs', 'DbParameters']

@pulumi.input_type
class DbParametersArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 params: pulumi.Input['DbParametersParamsArgs']):
        """
        The set of arguments for constructing a DbParameters resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input['DbParametersParamsArgs'] params: Parameter list, each element is a combination of Param and Value.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "params", params)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def params(self) -> pulumi.Input['DbParametersParamsArgs']:
        """
        Parameter list, each element is a combination of Param and Value.
        """
        return pulumi.get(self, "params")

    @params.setter
    def params(self, value: pulumi.Input['DbParametersParamsArgs']):
        pulumi.set(self, "params", value)


@pulumi.input_type
class _DbParametersState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 params: Optional[pulumi.Input['DbParametersParamsArgs']] = None):
        """
        Input properties used for looking up and filtering DbParameters resources.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input['DbParametersParamsArgs'] params: Parameter list, each element is a combination of Param and Value.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if params is not None:
            pulumi.set(__self__, "params", params)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def params(self) -> Optional[pulumi.Input['DbParametersParamsArgs']]:
        """
        Parameter list, each element is a combination of Param and Value.
        """
        return pulumi.get(self, "params")

    @params.setter
    def params(self, value: Optional[pulumi.Input['DbParametersParamsArgs']]):
        pulumi.set(self, "params", value)


class DbParameters(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 params: Optional[pulumi.Input[pulumi.InputType['DbParametersParamsArgs']]] = None,
                 __props__=None):
        """
        Provides a resource to create a dcdb db_parameters

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        db_parameters = tencentcloud.dcdb.DbParameters("dbParameters",
            instance_id="%s",
            params=tencentcloud.dcdb.DbParametersParamsArgs(
                param="max_connections",
                value="9999",
            ))
        ```

        ## Import

        dcdb db_parameters can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Dcdb/dbParameters:DbParameters db_parameters instanceId#paramName
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[pulumi.InputType['DbParametersParamsArgs']] params: Parameter list, each element is a combination of Param and Value.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DbParametersArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a dcdb db_parameters

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        db_parameters = tencentcloud.dcdb.DbParameters("dbParameters",
            instance_id="%s",
            params=tencentcloud.dcdb.DbParametersParamsArgs(
                param="max_connections",
                value="9999",
            ))
        ```

        ## Import

        dcdb db_parameters can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Dcdb/dbParameters:DbParameters db_parameters instanceId#paramName
        ```

        :param str resource_name: The name of the resource.
        :param DbParametersArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DbParametersArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 params: Optional[pulumi.Input[pulumi.InputType['DbParametersParamsArgs']]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DbParametersArgs.__new__(DbParametersArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if params is None and not opts.urn:
                raise TypeError("Missing required property 'params'")
            __props__.__dict__["params"] = params
        super(DbParameters, __self__).__init__(
            'tencentcloud:Dcdb/dbParameters:DbParameters',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            params: Optional[pulumi.Input[pulumi.InputType['DbParametersParamsArgs']]] = None) -> 'DbParameters':
        """
        Get an existing DbParameters resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[pulumi.InputType['DbParametersParamsArgs']] params: Parameter list, each element is a combination of Param and Value.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DbParametersState.__new__(_DbParametersState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["params"] = params
        return DbParameters(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def params(self) -> pulumi.Output['outputs.DbParametersParams']:
        """
        Parameter list, each element is a combination of Param and Value.
        """
        return pulumi.get(self, "params")

