# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['DbSyncModeConfigArgs', 'DbSyncModeConfig']

@pulumi.input_type
class DbSyncModeConfigArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 sync_mode: pulumi.Input[int]):
        """
        The set of arguments for constructing a DbSyncModeConfig resource.
        :param pulumi.Input[str] instance_id: ID of the instance for which to modify the sync mode. The ID is in the format of `tdsql-ow728lmc`.
        :param pulumi.Input[int] sync_mode: Sync mode. Valid values: `0` (async), `1` (strong sync), `2` (downgradable strong sync).
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "sync_mode", sync_mode)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        ID of the instance for which to modify the sync mode. The ID is in the format of `tdsql-ow728lmc`.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="syncMode")
    def sync_mode(self) -> pulumi.Input[int]:
        """
        Sync mode. Valid values: `0` (async), `1` (strong sync), `2` (downgradable strong sync).
        """
        return pulumi.get(self, "sync_mode")

    @sync_mode.setter
    def sync_mode(self, value: pulumi.Input[int]):
        pulumi.set(self, "sync_mode", value)


@pulumi.input_type
class _DbSyncModeConfigState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 sync_mode: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering DbSyncModeConfig resources.
        :param pulumi.Input[str] instance_id: ID of the instance for which to modify the sync mode. The ID is in the format of `tdsql-ow728lmc`.
        :param pulumi.Input[int] sync_mode: Sync mode. Valid values: `0` (async), `1` (strong sync), `2` (downgradable strong sync).
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if sync_mode is not None:
            pulumi.set(__self__, "sync_mode", sync_mode)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the instance for which to modify the sync mode. The ID is in the format of `tdsql-ow728lmc`.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="syncMode")
    def sync_mode(self) -> Optional[pulumi.Input[int]]:
        """
        Sync mode. Valid values: `0` (async), `1` (strong sync), `2` (downgradable strong sync).
        """
        return pulumi.get(self, "sync_mode")

    @sync_mode.setter
    def sync_mode(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "sync_mode", value)


class DbSyncModeConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 sync_mode: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to create a dcdb db_sync_mode_config

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        config = tencentcloud.dcdb.DbSyncModeConfig("config",
            instance_id="%s",
            sync_mode=2)
        ```

        ## Import

        dcdb db_sync_mode_config can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Dcdb/dbSyncModeConfig:DbSyncModeConfig db_sync_mode_config db_sync_mode_config_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: ID of the instance for which to modify the sync mode. The ID is in the format of `tdsql-ow728lmc`.
        :param pulumi.Input[int] sync_mode: Sync mode. Valid values: `0` (async), `1` (strong sync), `2` (downgradable strong sync).
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DbSyncModeConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a dcdb db_sync_mode_config

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        config = tencentcloud.dcdb.DbSyncModeConfig("config",
            instance_id="%s",
            sync_mode=2)
        ```

        ## Import

        dcdb db_sync_mode_config can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Dcdb/dbSyncModeConfig:DbSyncModeConfig db_sync_mode_config db_sync_mode_config_id
        ```

        :param str resource_name: The name of the resource.
        :param DbSyncModeConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DbSyncModeConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 sync_mode: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DbSyncModeConfigArgs.__new__(DbSyncModeConfigArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if sync_mode is None and not opts.urn:
                raise TypeError("Missing required property 'sync_mode'")
            __props__.__dict__["sync_mode"] = sync_mode
        super(DbSyncModeConfig, __self__).__init__(
            'tencentcloud:Dcdb/dbSyncModeConfig:DbSyncModeConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            sync_mode: Optional[pulumi.Input[int]] = None) -> 'DbSyncModeConfig':
        """
        Get an existing DbSyncModeConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: ID of the instance for which to modify the sync mode. The ID is in the format of `tdsql-ow728lmc`.
        :param pulumi.Input[int] sync_mode: Sync mode. Valid values: `0` (async), `1` (strong sync), `2` (downgradable strong sync).
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DbSyncModeConfigState.__new__(_DbSyncModeConfigState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["sync_mode"] = sync_mode
        return DbSyncModeConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        ID of the instance for which to modify the sync mode. The ID is in the format of `tdsql-ow728lmc`.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="syncMode")
    def sync_mode(self) -> pulumi.Output[int]:
        """
        Sync mode. Valid values: `0` (async), `1` (strong sync), `2` (downgradable strong sync).
        """
        return pulumi.get(self, "sync_mode")

