# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetShardsResult',
    'AwaitableGetShardsResult',
    'get_shards',
    'get_shards_output',
]

@pulumi.output_type
class GetShardsResult:
    """
    A collection of values returned by getShards.
    """
    def __init__(__self__, id=None, instance_id=None, lists=None, result_output_file=None, shard_instance_ids=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if lists and not isinstance(lists, list):
            raise TypeError("Expected argument 'lists' to be a list")
        pulumi.set(__self__, "lists", lists)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if shard_instance_ids and not isinstance(shard_instance_ids, list):
            raise TypeError("Expected argument 'shard_instance_ids' to be a list")
        pulumi.set(__self__, "shard_instance_ids", shard_instance_ids)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def lists(self) -> Sequence['outputs.GetShardsListResult']:
        """
        shard list.
        """
        return pulumi.get(self, "lists")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="shardInstanceIds")
    def shard_instance_ids(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "shard_instance_ids")


class AwaitableGetShardsResult(GetShardsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetShardsResult(
            id=self.id,
            instance_id=self.instance_id,
            lists=self.lists,
            result_output_file=self.result_output_file,
            shard_instance_ids=self.shard_instance_ids)


def get_shards(instance_id: Optional[str] = None,
               result_output_file: Optional[str] = None,
               shard_instance_ids: Optional[Sequence[str]] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetShardsResult:
    """
    Use this data source to query detailed information of dcdb shards

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    shards = tencentcloud.Dcdb.get_shards(instance_id="your_instance_id",
        shard_instance_ids=["shard1_id"])
    ```


    :param str instance_id: instance id.
    :param str result_output_file: Used to save results.
    :param Sequence[str] shard_instance_ids: shard instance ids.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    __args__['shardInstanceIds'] = shard_instance_ids
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Dcdb/getShards:getShards', __args__, opts=opts, typ=GetShardsResult).value

    return AwaitableGetShardsResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        lists=__ret__.lists,
        result_output_file=__ret__.result_output_file,
        shard_instance_ids=__ret__.shard_instance_ids)


@_utilities.lift_output_func(get_shards)
def get_shards_output(instance_id: Optional[pulumi.Input[str]] = None,
                      result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                      shard_instance_ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetShardsResult]:
    """
    Use this data source to query detailed information of dcdb shards

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    shards = tencentcloud.Dcdb.get_shards(instance_id="your_instance_id",
        shard_instance_ids=["shard1_id"])
    ```


    :param str instance_id: instance id.
    :param str result_output_file: Used to save results.
    :param Sequence[str] shard_instance_ids: shard instance ids.
    """
    ...
