# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetCompareTasksResult',
    'AwaitableGetCompareTasksResult',
    'get_compare_tasks',
    'get_compare_tasks_output',
]

@pulumi.output_type
class GetCompareTasksResult:
    """
    A collection of values returned by getCompareTasks.
    """
    def __init__(__self__, id=None, job_id=None, lists=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if job_id and not isinstance(job_id, str):
            raise TypeError("Expected argument 'job_id' to be a str")
        pulumi.set(__self__, "job_id", job_id)
        if lists and not isinstance(lists, list):
            raise TypeError("Expected argument 'lists' to be a list")
        pulumi.set(__self__, "lists", lists)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="jobId")
    def job_id(self) -> str:
        """
        job id.
        """
        return pulumi.get(self, "job_id")

    @property
    @pulumi.getter
    def lists(self) -> Sequence['outputs.GetCompareTasksListResult']:
        """
        compare task list.
        """
        return pulumi.get(self, "lists")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetCompareTasksResult(GetCompareTasksResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCompareTasksResult(
            id=self.id,
            job_id=self.job_id,
            lists=self.lists,
            result_output_file=self.result_output_file)


def get_compare_tasks(job_id: Optional[str] = None,
                      result_output_file: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCompareTasksResult:
    """
    Use this data source to query detailed information of dts compareTasks

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    compare_tasks = tencentcloud.Dts.get_compare_tasks(job_id="")
    ```


    :param str job_id: job id.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['jobId'] = job_id
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Dts/getCompareTasks:getCompareTasks', __args__, opts=opts, typ=GetCompareTasksResult).value

    return AwaitableGetCompareTasksResult(
        id=__ret__.id,
        job_id=__ret__.job_id,
        lists=__ret__.lists,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_compare_tasks)
def get_compare_tasks_output(job_id: Optional[pulumi.Input[str]] = None,
                             result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCompareTasksResult]:
    """
    Use this data source to query detailed information of dts compareTasks

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    compare_tasks = tencentcloud.Dts.get_compare_tasks(job_id="")
    ```


    :param str job_id: job id.
    :param str result_output_file: Used to save results.
    """
    ...
