# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['MigrateJobArgs', 'MigrateJob']

@pulumi.input_type
class MigrateJobArgs:
    def __init__(__self__, *,
                 dst_info: pulumi.Input['MigrateJobDstInfoArgs'],
                 migrate_option: pulumi.Input['MigrateJobMigrateOptionArgs'],
                 run_mode: pulumi.Input[str],
                 service_id: pulumi.Input[str],
                 src_info: pulumi.Input['MigrateJobSrcInfoArgs'],
                 auto_retry_time_range_minutes: Optional[pulumi.Input[int]] = None,
                 expect_run_time: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a MigrateJob resource.
        :param pulumi.Input['MigrateJobDstInfoArgs'] dst_info: DstInfo.
        :param pulumi.Input['MigrateJobMigrateOptionArgs'] migrate_option: Migration job configuration options, used to describe how the task performs migration.
        :param pulumi.Input[str] run_mode: Run Mode. eg:immediate,timed.
        :param pulumi.Input[str] service_id: Migrate service Id from `Dts.MigrateService`.
        :param pulumi.Input['MigrateJobSrcInfoArgs'] src_info: SrcInfo.
        :param pulumi.Input[int] auto_retry_time_range_minutes: AutoRetryTimeRangeMinutes.
        :param pulumi.Input[str] expect_run_time: ExpectRunTime.
        """
        pulumi.set(__self__, "dst_info", dst_info)
        pulumi.set(__self__, "migrate_option", migrate_option)
        pulumi.set(__self__, "run_mode", run_mode)
        pulumi.set(__self__, "service_id", service_id)
        pulumi.set(__self__, "src_info", src_info)
        if auto_retry_time_range_minutes is not None:
            pulumi.set(__self__, "auto_retry_time_range_minutes", auto_retry_time_range_minutes)
        if expect_run_time is not None:
            pulumi.set(__self__, "expect_run_time", expect_run_time)

    @property
    @pulumi.getter(name="dstInfo")
    def dst_info(self) -> pulumi.Input['MigrateJobDstInfoArgs']:
        """
        DstInfo.
        """
        return pulumi.get(self, "dst_info")

    @dst_info.setter
    def dst_info(self, value: pulumi.Input['MigrateJobDstInfoArgs']):
        pulumi.set(self, "dst_info", value)

    @property
    @pulumi.getter(name="migrateOption")
    def migrate_option(self) -> pulumi.Input['MigrateJobMigrateOptionArgs']:
        """
        Migration job configuration options, used to describe how the task performs migration.
        """
        return pulumi.get(self, "migrate_option")

    @migrate_option.setter
    def migrate_option(self, value: pulumi.Input['MigrateJobMigrateOptionArgs']):
        pulumi.set(self, "migrate_option", value)

    @property
    @pulumi.getter(name="runMode")
    def run_mode(self) -> pulumi.Input[str]:
        """
        Run Mode. eg:immediate,timed.
        """
        return pulumi.get(self, "run_mode")

    @run_mode.setter
    def run_mode(self, value: pulumi.Input[str]):
        pulumi.set(self, "run_mode", value)

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> pulumi.Input[str]:
        """
        Migrate service Id from `Dts.MigrateService`.
        """
        return pulumi.get(self, "service_id")

    @service_id.setter
    def service_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "service_id", value)

    @property
    @pulumi.getter(name="srcInfo")
    def src_info(self) -> pulumi.Input['MigrateJobSrcInfoArgs']:
        """
        SrcInfo.
        """
        return pulumi.get(self, "src_info")

    @src_info.setter
    def src_info(self, value: pulumi.Input['MigrateJobSrcInfoArgs']):
        pulumi.set(self, "src_info", value)

    @property
    @pulumi.getter(name="autoRetryTimeRangeMinutes")
    def auto_retry_time_range_minutes(self) -> Optional[pulumi.Input[int]]:
        """
        AutoRetryTimeRangeMinutes.
        """
        return pulumi.get(self, "auto_retry_time_range_minutes")

    @auto_retry_time_range_minutes.setter
    def auto_retry_time_range_minutes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "auto_retry_time_range_minutes", value)

    @property
    @pulumi.getter(name="expectRunTime")
    def expect_run_time(self) -> Optional[pulumi.Input[str]]:
        """
        ExpectRunTime.
        """
        return pulumi.get(self, "expect_run_time")

    @expect_run_time.setter
    def expect_run_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "expect_run_time", value)


@pulumi.input_type
class _MigrateJobState:
    def __init__(__self__, *,
                 auto_retry_time_range_minutes: Optional[pulumi.Input[int]] = None,
                 dst_info: Optional[pulumi.Input['MigrateJobDstInfoArgs']] = None,
                 expect_run_time: Optional[pulumi.Input[str]] = None,
                 migrate_option: Optional[pulumi.Input['MigrateJobMigrateOptionArgs']] = None,
                 run_mode: Optional[pulumi.Input[str]] = None,
                 service_id: Optional[pulumi.Input[str]] = None,
                 src_info: Optional[pulumi.Input['MigrateJobSrcInfoArgs']] = None,
                 status: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering MigrateJob resources.
        :param pulumi.Input[int] auto_retry_time_range_minutes: AutoRetryTimeRangeMinutes.
        :param pulumi.Input['MigrateJobDstInfoArgs'] dst_info: DstInfo.
        :param pulumi.Input[str] expect_run_time: ExpectRunTime.
        :param pulumi.Input['MigrateJobMigrateOptionArgs'] migrate_option: Migration job configuration options, used to describe how the task performs migration.
        :param pulumi.Input[str] run_mode: Run Mode. eg:immediate,timed.
        :param pulumi.Input[str] service_id: Migrate service Id from `Dts.MigrateService`.
        :param pulumi.Input['MigrateJobSrcInfoArgs'] src_info: SrcInfo.
        :param pulumi.Input[str] status: Migrate job status.
        """
        if auto_retry_time_range_minutes is not None:
            pulumi.set(__self__, "auto_retry_time_range_minutes", auto_retry_time_range_minutes)
        if dst_info is not None:
            pulumi.set(__self__, "dst_info", dst_info)
        if expect_run_time is not None:
            pulumi.set(__self__, "expect_run_time", expect_run_time)
        if migrate_option is not None:
            pulumi.set(__self__, "migrate_option", migrate_option)
        if run_mode is not None:
            pulumi.set(__self__, "run_mode", run_mode)
        if service_id is not None:
            pulumi.set(__self__, "service_id", service_id)
        if src_info is not None:
            pulumi.set(__self__, "src_info", src_info)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="autoRetryTimeRangeMinutes")
    def auto_retry_time_range_minutes(self) -> Optional[pulumi.Input[int]]:
        """
        AutoRetryTimeRangeMinutes.
        """
        return pulumi.get(self, "auto_retry_time_range_minutes")

    @auto_retry_time_range_minutes.setter
    def auto_retry_time_range_minutes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "auto_retry_time_range_minutes", value)

    @property
    @pulumi.getter(name="dstInfo")
    def dst_info(self) -> Optional[pulumi.Input['MigrateJobDstInfoArgs']]:
        """
        DstInfo.
        """
        return pulumi.get(self, "dst_info")

    @dst_info.setter
    def dst_info(self, value: Optional[pulumi.Input['MigrateJobDstInfoArgs']]):
        pulumi.set(self, "dst_info", value)

    @property
    @pulumi.getter(name="expectRunTime")
    def expect_run_time(self) -> Optional[pulumi.Input[str]]:
        """
        ExpectRunTime.
        """
        return pulumi.get(self, "expect_run_time")

    @expect_run_time.setter
    def expect_run_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "expect_run_time", value)

    @property
    @pulumi.getter(name="migrateOption")
    def migrate_option(self) -> Optional[pulumi.Input['MigrateJobMigrateOptionArgs']]:
        """
        Migration job configuration options, used to describe how the task performs migration.
        """
        return pulumi.get(self, "migrate_option")

    @migrate_option.setter
    def migrate_option(self, value: Optional[pulumi.Input['MigrateJobMigrateOptionArgs']]):
        pulumi.set(self, "migrate_option", value)

    @property
    @pulumi.getter(name="runMode")
    def run_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Run Mode. eg:immediate,timed.
        """
        return pulumi.get(self, "run_mode")

    @run_mode.setter
    def run_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "run_mode", value)

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> Optional[pulumi.Input[str]]:
        """
        Migrate service Id from `Dts.MigrateService`.
        """
        return pulumi.get(self, "service_id")

    @service_id.setter
    def service_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_id", value)

    @property
    @pulumi.getter(name="srcInfo")
    def src_info(self) -> Optional[pulumi.Input['MigrateJobSrcInfoArgs']]:
        """
        SrcInfo.
        """
        return pulumi.get(self, "src_info")

    @src_info.setter
    def src_info(self, value: Optional[pulumi.Input['MigrateJobSrcInfoArgs']]):
        pulumi.set(self, "src_info", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Migrate job status.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)


class MigrateJob(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_retry_time_range_minutes: Optional[pulumi.Input[int]] = None,
                 dst_info: Optional[pulumi.Input[pulumi.InputType['MigrateJobDstInfoArgs']]] = None,
                 expect_run_time: Optional[pulumi.Input[str]] = None,
                 migrate_option: Optional[pulumi.Input[pulumi.InputType['MigrateJobMigrateOptionArgs']]] = None,
                 run_mode: Optional[pulumi.Input[str]] = None,
                 service_id: Optional[pulumi.Input[str]] = None,
                 src_info: Optional[pulumi.Input[pulumi.InputType['MigrateJobSrcInfoArgs']]] = None,
                 __props__=None):
        """
        Provides a resource to create a dts migrate_job

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.cynosdb.Cluster("foo",
            available_zone=var["availability_zone"],
            vpc_id=local["vpc_id"],
            subnet_id=local["subnet_id"],
            db_type="MYSQL",
            db_version="5.7",
            storage_limit=1000,
            cluster_name="tf-cynosdb-mysql",
            password="cynos@123",
            instance_maintain_duration=3600,
            instance_maintain_start_time=10800,
            instance_maintain_weekdays=[
                "Fri",
                "Mon",
                "Sat",
                "Sun",
                "Thu",
                "Wed",
                "Tue",
            ],
            instance_cpu_core=1,
            instance_memory_size=2,
            param_items=[
                tencentcloud.cynosdb.ClusterParamItemArgs(
                    name="character_set_server",
                    current_value="utf8",
                ),
                tencentcloud.cynosdb.ClusterParamItemArgs(
                    name="time_zone",
                    current_value="+09:00",
                ),
                tencentcloud.cynosdb.ClusterParamItemArgs(
                    name="lower_case_table_names",
                    current_value="1",
                ),
            ],
            force_delete=True,
            rw_group_sgs=[local["sg_id"]],
            ro_group_sgs=[local["sg_id"]],
            prarm_template_id=var["my_param_template"])
        service = tencentcloud.dts.MigrateService("service",
            src_database_type="mysql",
            dst_database_type="cynosdbmysql",
            src_region="ap-guangzhou",
            dst_region="ap-guangzhou",
            instance_class="small",
            job_name="tf_test_migration_service_1",
            tags=[tencentcloud.dts.MigrateServiceTagArgs(
                tag_key="aaa",
                tag_value="bbb",
            )])
        job = tencentcloud.dts.MigrateJob("job",
            service_id=service.id,
            run_mode="immediate",
            migrate_option=tencentcloud.dts.MigrateJobMigrateOptionArgs(
                database_table=tencentcloud.dts.MigrateJobMigrateOptionDatabaseTableArgs(
                    object_mode="partial",
                    databases=[tencentcloud.dts.MigrateJobMigrateOptionDatabaseTableDatabaseArgs(
                        db_name="tf_ci_test",
                        db_mode="partial",
                        table_mode="partial",
                        tables=[tencentcloud.dts.MigrateJobMigrateOptionDatabaseTableDatabaseTableArgs(
                            table_name="test",
                            new_table_name="test_%s",
                            table_edit_mode="rename",
                        )],
                    )],
                ),
            ),
            src_info=tencentcloud.dts.MigrateJobSrcInfoArgs(
                region="ap-guangzhou",
                access_type="cdb",
                database_type="mysql",
                node_type="simple",
                infos=[tencentcloud.dts.MigrateJobSrcInfoInfoArgs(
                    user="user_name",
                    password="your_pw",
                    instance_id="cdb-fitq5t9h",
                )],
            ),
            dst_info=tencentcloud.dts.MigrateJobDstInfoArgs(
                region="ap-guangzhou",
                access_type="cdb",
                database_type="cynosdbmysql",
                node_type="simple",
                infos=[tencentcloud.dts.MigrateJobDstInfoInfoArgs(
                    user="user_name",
                    password="your_pw",
                    instance_id=foo.id,
                )],
            ),
            auto_retry_time_range_minutes=0)
        start = tencentcloud.dts.MigrateJobStartOperation("start", job_id=job.id)
        ```

        ## Import

        dts migrate_job can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Dts/migrateJob:MigrateJob migrate_job migrate_config_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] auto_retry_time_range_minutes: AutoRetryTimeRangeMinutes.
        :param pulumi.Input[pulumi.InputType['MigrateJobDstInfoArgs']] dst_info: DstInfo.
        :param pulumi.Input[str] expect_run_time: ExpectRunTime.
        :param pulumi.Input[pulumi.InputType['MigrateJobMigrateOptionArgs']] migrate_option: Migration job configuration options, used to describe how the task performs migration.
        :param pulumi.Input[str] run_mode: Run Mode. eg:immediate,timed.
        :param pulumi.Input[str] service_id: Migrate service Id from `Dts.MigrateService`.
        :param pulumi.Input[pulumi.InputType['MigrateJobSrcInfoArgs']] src_info: SrcInfo.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MigrateJobArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a dts migrate_job

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.cynosdb.Cluster("foo",
            available_zone=var["availability_zone"],
            vpc_id=local["vpc_id"],
            subnet_id=local["subnet_id"],
            db_type="MYSQL",
            db_version="5.7",
            storage_limit=1000,
            cluster_name="tf-cynosdb-mysql",
            password="cynos@123",
            instance_maintain_duration=3600,
            instance_maintain_start_time=10800,
            instance_maintain_weekdays=[
                "Fri",
                "Mon",
                "Sat",
                "Sun",
                "Thu",
                "Wed",
                "Tue",
            ],
            instance_cpu_core=1,
            instance_memory_size=2,
            param_items=[
                tencentcloud.cynosdb.ClusterParamItemArgs(
                    name="character_set_server",
                    current_value="utf8",
                ),
                tencentcloud.cynosdb.ClusterParamItemArgs(
                    name="time_zone",
                    current_value="+09:00",
                ),
                tencentcloud.cynosdb.ClusterParamItemArgs(
                    name="lower_case_table_names",
                    current_value="1",
                ),
            ],
            force_delete=True,
            rw_group_sgs=[local["sg_id"]],
            ro_group_sgs=[local["sg_id"]],
            prarm_template_id=var["my_param_template"])
        service = tencentcloud.dts.MigrateService("service",
            src_database_type="mysql",
            dst_database_type="cynosdbmysql",
            src_region="ap-guangzhou",
            dst_region="ap-guangzhou",
            instance_class="small",
            job_name="tf_test_migration_service_1",
            tags=[tencentcloud.dts.MigrateServiceTagArgs(
                tag_key="aaa",
                tag_value="bbb",
            )])
        job = tencentcloud.dts.MigrateJob("job",
            service_id=service.id,
            run_mode="immediate",
            migrate_option=tencentcloud.dts.MigrateJobMigrateOptionArgs(
                database_table=tencentcloud.dts.MigrateJobMigrateOptionDatabaseTableArgs(
                    object_mode="partial",
                    databases=[tencentcloud.dts.MigrateJobMigrateOptionDatabaseTableDatabaseArgs(
                        db_name="tf_ci_test",
                        db_mode="partial",
                        table_mode="partial",
                        tables=[tencentcloud.dts.MigrateJobMigrateOptionDatabaseTableDatabaseTableArgs(
                            table_name="test",
                            new_table_name="test_%s",
                            table_edit_mode="rename",
                        )],
                    )],
                ),
            ),
            src_info=tencentcloud.dts.MigrateJobSrcInfoArgs(
                region="ap-guangzhou",
                access_type="cdb",
                database_type="mysql",
                node_type="simple",
                infos=[tencentcloud.dts.MigrateJobSrcInfoInfoArgs(
                    user="user_name",
                    password="your_pw",
                    instance_id="cdb-fitq5t9h",
                )],
            ),
            dst_info=tencentcloud.dts.MigrateJobDstInfoArgs(
                region="ap-guangzhou",
                access_type="cdb",
                database_type="cynosdbmysql",
                node_type="simple",
                infos=[tencentcloud.dts.MigrateJobDstInfoInfoArgs(
                    user="user_name",
                    password="your_pw",
                    instance_id=foo.id,
                )],
            ),
            auto_retry_time_range_minutes=0)
        start = tencentcloud.dts.MigrateJobStartOperation("start", job_id=job.id)
        ```

        ## Import

        dts migrate_job can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Dts/migrateJob:MigrateJob migrate_job migrate_config_id
        ```

        :param str resource_name: The name of the resource.
        :param MigrateJobArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MigrateJobArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_retry_time_range_minutes: Optional[pulumi.Input[int]] = None,
                 dst_info: Optional[pulumi.Input[pulumi.InputType['MigrateJobDstInfoArgs']]] = None,
                 expect_run_time: Optional[pulumi.Input[str]] = None,
                 migrate_option: Optional[pulumi.Input[pulumi.InputType['MigrateJobMigrateOptionArgs']]] = None,
                 run_mode: Optional[pulumi.Input[str]] = None,
                 service_id: Optional[pulumi.Input[str]] = None,
                 src_info: Optional[pulumi.Input[pulumi.InputType['MigrateJobSrcInfoArgs']]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MigrateJobArgs.__new__(MigrateJobArgs)

            __props__.__dict__["auto_retry_time_range_minutes"] = auto_retry_time_range_minutes
            if dst_info is None and not opts.urn:
                raise TypeError("Missing required property 'dst_info'")
            __props__.__dict__["dst_info"] = dst_info
            __props__.__dict__["expect_run_time"] = expect_run_time
            if migrate_option is None and not opts.urn:
                raise TypeError("Missing required property 'migrate_option'")
            __props__.__dict__["migrate_option"] = migrate_option
            if run_mode is None and not opts.urn:
                raise TypeError("Missing required property 'run_mode'")
            __props__.__dict__["run_mode"] = run_mode
            if service_id is None and not opts.urn:
                raise TypeError("Missing required property 'service_id'")
            __props__.__dict__["service_id"] = service_id
            if src_info is None and not opts.urn:
                raise TypeError("Missing required property 'src_info'")
            __props__.__dict__["src_info"] = src_info
            __props__.__dict__["status"] = None
        super(MigrateJob, __self__).__init__(
            'tencentcloud:Dts/migrateJob:MigrateJob',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            auto_retry_time_range_minutes: Optional[pulumi.Input[int]] = None,
            dst_info: Optional[pulumi.Input[pulumi.InputType['MigrateJobDstInfoArgs']]] = None,
            expect_run_time: Optional[pulumi.Input[str]] = None,
            migrate_option: Optional[pulumi.Input[pulumi.InputType['MigrateJobMigrateOptionArgs']]] = None,
            run_mode: Optional[pulumi.Input[str]] = None,
            service_id: Optional[pulumi.Input[str]] = None,
            src_info: Optional[pulumi.Input[pulumi.InputType['MigrateJobSrcInfoArgs']]] = None,
            status: Optional[pulumi.Input[str]] = None) -> 'MigrateJob':
        """
        Get an existing MigrateJob resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] auto_retry_time_range_minutes: AutoRetryTimeRangeMinutes.
        :param pulumi.Input[pulumi.InputType['MigrateJobDstInfoArgs']] dst_info: DstInfo.
        :param pulumi.Input[str] expect_run_time: ExpectRunTime.
        :param pulumi.Input[pulumi.InputType['MigrateJobMigrateOptionArgs']] migrate_option: Migration job configuration options, used to describe how the task performs migration.
        :param pulumi.Input[str] run_mode: Run Mode. eg:immediate,timed.
        :param pulumi.Input[str] service_id: Migrate service Id from `Dts.MigrateService`.
        :param pulumi.Input[pulumi.InputType['MigrateJobSrcInfoArgs']] src_info: SrcInfo.
        :param pulumi.Input[str] status: Migrate job status.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MigrateJobState.__new__(_MigrateJobState)

        __props__.__dict__["auto_retry_time_range_minutes"] = auto_retry_time_range_minutes
        __props__.__dict__["dst_info"] = dst_info
        __props__.__dict__["expect_run_time"] = expect_run_time
        __props__.__dict__["migrate_option"] = migrate_option
        __props__.__dict__["run_mode"] = run_mode
        __props__.__dict__["service_id"] = service_id
        __props__.__dict__["src_info"] = src_info
        __props__.__dict__["status"] = status
        return MigrateJob(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="autoRetryTimeRangeMinutes")
    def auto_retry_time_range_minutes(self) -> pulumi.Output[Optional[int]]:
        """
        AutoRetryTimeRangeMinutes.
        """
        return pulumi.get(self, "auto_retry_time_range_minutes")

    @property
    @pulumi.getter(name="dstInfo")
    def dst_info(self) -> pulumi.Output['outputs.MigrateJobDstInfo']:
        """
        DstInfo.
        """
        return pulumi.get(self, "dst_info")

    @property
    @pulumi.getter(name="expectRunTime")
    def expect_run_time(self) -> pulumi.Output[str]:
        """
        ExpectRunTime.
        """
        return pulumi.get(self, "expect_run_time")

    @property
    @pulumi.getter(name="migrateOption")
    def migrate_option(self) -> pulumi.Output['outputs.MigrateJobMigrateOption']:
        """
        Migration job configuration options, used to describe how the task performs migration.
        """
        return pulumi.get(self, "migrate_option")

    @property
    @pulumi.getter(name="runMode")
    def run_mode(self) -> pulumi.Output[str]:
        """
        Run Mode. eg:immediate,timed.
        """
        return pulumi.get(self, "run_mode")

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> pulumi.Output[str]:
        """
        Migrate service Id from `Dts.MigrateService`.
        """
        return pulumi.get(self, "service_id")

    @property
    @pulumi.getter(name="srcInfo")
    def src_info(self) -> pulumi.Output['outputs.MigrateJobSrcInfo']:
        """
        SrcInfo.
        """
        return pulumi.get(self, "src_info")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Migrate job status.
        """
        return pulumi.get(self, "status")

