# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['SyncJobResizeOperationArgs', 'SyncJobResizeOperation']

@pulumi.input_type
class SyncJobResizeOperationArgs:
    def __init__(__self__, *,
                 job_id: pulumi.Input[str],
                 new_instance_class: pulumi.Input[str]):
        """
        The set of arguments for constructing a SyncJobResizeOperation resource.
        :param pulumi.Input[str] job_id: Synchronization instance id (i.e. identifies a synchronization job).
        :param pulumi.Input[str] new_instance_class: Task specification.
        """
        pulumi.set(__self__, "job_id", job_id)
        pulumi.set(__self__, "new_instance_class", new_instance_class)

    @property
    @pulumi.getter(name="jobId")
    def job_id(self) -> pulumi.Input[str]:
        """
        Synchronization instance id (i.e. identifies a synchronization job).
        """
        return pulumi.get(self, "job_id")

    @job_id.setter
    def job_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "job_id", value)

    @property
    @pulumi.getter(name="newInstanceClass")
    def new_instance_class(self) -> pulumi.Input[str]:
        """
        Task specification.
        """
        return pulumi.get(self, "new_instance_class")

    @new_instance_class.setter
    def new_instance_class(self, value: pulumi.Input[str]):
        pulumi.set(self, "new_instance_class", value)


@pulumi.input_type
class _SyncJobResizeOperationState:
    def __init__(__self__, *,
                 job_id: Optional[pulumi.Input[str]] = None,
                 new_instance_class: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SyncJobResizeOperation resources.
        :param pulumi.Input[str] job_id: Synchronization instance id (i.e. identifies a synchronization job).
        :param pulumi.Input[str] new_instance_class: Task specification.
        """
        if job_id is not None:
            pulumi.set(__self__, "job_id", job_id)
        if new_instance_class is not None:
            pulumi.set(__self__, "new_instance_class", new_instance_class)

    @property
    @pulumi.getter(name="jobId")
    def job_id(self) -> Optional[pulumi.Input[str]]:
        """
        Synchronization instance id (i.e. identifies a synchronization job).
        """
        return pulumi.get(self, "job_id")

    @job_id.setter
    def job_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "job_id", value)

    @property
    @pulumi.getter(name="newInstanceClass")
    def new_instance_class(self) -> Optional[pulumi.Input[str]]:
        """
        Task specification.
        """
        return pulumi.get(self, "new_instance_class")

    @new_instance_class.setter
    def new_instance_class(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "new_instance_class", value)


class SyncJobResizeOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 job_id: Optional[pulumi.Input[str]] = None,
                 new_instance_class: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a dts sync_job_resize_operation

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        sync_job_resize_operation = tencentcloud.dts.SyncJobResizeOperation("syncJobResizeOperation",
            job_id="sync-werwfs23",
            new_instance_class="large")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] job_id: Synchronization instance id (i.e. identifies a synchronization job).
        :param pulumi.Input[str] new_instance_class: Task specification.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SyncJobResizeOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a dts sync_job_resize_operation

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        sync_job_resize_operation = tencentcloud.dts.SyncJobResizeOperation("syncJobResizeOperation",
            job_id="sync-werwfs23",
            new_instance_class="large")
        ```

        :param str resource_name: The name of the resource.
        :param SyncJobResizeOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SyncJobResizeOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 job_id: Optional[pulumi.Input[str]] = None,
                 new_instance_class: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SyncJobResizeOperationArgs.__new__(SyncJobResizeOperationArgs)

            if job_id is None and not opts.urn:
                raise TypeError("Missing required property 'job_id'")
            __props__.__dict__["job_id"] = job_id
            if new_instance_class is None and not opts.urn:
                raise TypeError("Missing required property 'new_instance_class'")
            __props__.__dict__["new_instance_class"] = new_instance_class
        super(SyncJobResizeOperation, __self__).__init__(
            'tencentcloud:Dts/syncJobResizeOperation:SyncJobResizeOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            job_id: Optional[pulumi.Input[str]] = None,
            new_instance_class: Optional[pulumi.Input[str]] = None) -> 'SyncJobResizeOperation':
        """
        Get an existing SyncJobResizeOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] job_id: Synchronization instance id (i.e. identifies a synchronization job).
        :param pulumi.Input[str] new_instance_class: Task specification.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SyncJobResizeOperationState.__new__(_SyncJobResizeOperationState)

        __props__.__dict__["job_id"] = job_id
        __props__.__dict__["new_instance_class"] = new_instance_class
        return SyncJobResizeOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="jobId")
    def job_id(self) -> pulumi.Output[str]:
        """
        Synchronization instance id (i.e. identifies a synchronization job).
        """
        return pulumi.get(self, "job_id")

    @property
    @pulumi.getter(name="newInstanceClass")
    def new_instance_class(self) -> pulumi.Output[str]:
        """
        Task specification.
        """
        return pulumi.get(self, "new_instance_class")

