# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetModifyInstanceBundleResult',
    'AwaitableGetModifyInstanceBundleResult',
    'get_modify_instance_bundle',
    'get_modify_instance_bundle_output',
]

@pulumi.output_type
class GetModifyInstanceBundleResult:
    """
    A collection of values returned by getModifyInstanceBundle.
    """
    def __init__(__self__, filters=None, id=None, instance_id=None, modify_bundle_sets=None, result_output_file=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if modify_bundle_sets and not isinstance(modify_bundle_sets, list):
            raise TypeError("Expected argument 'modify_bundle_sets' to be a list")
        pulumi.set(__self__, "modify_bundle_sets", modify_bundle_sets)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetModifyInstanceBundleFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="modifyBundleSets")
    def modify_bundle_sets(self) -> Sequence['outputs.GetModifyInstanceBundleModifyBundleSetResult']:
        """
        Change package details.
        """
        return pulumi.get(self, "modify_bundle_sets")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetModifyInstanceBundleResult(GetModifyInstanceBundleResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetModifyInstanceBundleResult(
            filters=self.filters,
            id=self.id,
            instance_id=self.instance_id,
            modify_bundle_sets=self.modify_bundle_sets,
            result_output_file=self.result_output_file)


def get_modify_instance_bundle(filters: Optional[Sequence[pulumi.InputType['GetModifyInstanceBundleFilterArgs']]] = None,
                               instance_id: Optional[str] = None,
                               result_output_file: Optional[str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetModifyInstanceBundleResult:
    """
    Use this data source to query detailed information of lighthouse modify_instance_bundle

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    modify_instance_bundle = tencentcloud.Lighthouse.get_modify_instance_bundle(filters=[tencentcloud.lighthouse.GetModifyInstanceBundleFilterArgs(
            name="bundle-id",
            values=["bundle_gen_mc_med2_02"],
        )],
        instance_id="lhins-xxxxxx")
    ```


    :param Sequence[pulumi.InputType['GetModifyInstanceBundleFilterArgs']] filters: Filter list.
           - `bundle-id`: filter by the bundle ID.
           - `support-platform-type`: filter by system type, valid values: `LINUX_UNIX`, `WINDOWS`.
           - `bundle-type`: filter according to package type, valid values: `GENERAL_BUNDLE`, `STORAGE_BUNDLE`, `ENTERPRISE_BUNDLE`, `EXCLUSIVE_BUNDLE`, `BEFAST_BUNDLE`.
           - `bundle-state`: filter according to package status, valid values: `ONLINE`, `OFFLINE`.
           NOTE: The upper limit of Filters per request is 10. The upper limit of Filter.Values is 5. Parameter does not support specifying both BundleIds and Filters.
    :param str instance_id: Instance ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Lighthouse/getModifyInstanceBundle:getModifyInstanceBundle', __args__, opts=opts, typ=GetModifyInstanceBundleResult).value

    return AwaitableGetModifyInstanceBundleResult(
        filters=__ret__.filters,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        modify_bundle_sets=__ret__.modify_bundle_sets,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_modify_instance_bundle)
def get_modify_instance_bundle_output(filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetModifyInstanceBundleFilterArgs']]]]] = None,
                                      instance_id: Optional[pulumi.Input[str]] = None,
                                      result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetModifyInstanceBundleResult]:
    """
    Use this data source to query detailed information of lighthouse modify_instance_bundle

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    modify_instance_bundle = tencentcloud.Lighthouse.get_modify_instance_bundle(filters=[tencentcloud.lighthouse.GetModifyInstanceBundleFilterArgs(
            name="bundle-id",
            values=["bundle_gen_mc_med2_02"],
        )],
        instance_id="lhins-xxxxxx")
    ```


    :param Sequence[pulumi.InputType['GetModifyInstanceBundleFilterArgs']] filters: Filter list.
           - `bundle-id`: filter by the bundle ID.
           - `support-platform-type`: filter by system type, valid values: `LINUX_UNIX`, `WINDOWS`.
           - `bundle-type`: filter according to package type, valid values: `GENERAL_BUNDLE`, `STORAGE_BUNDLE`, `ENTERPRISE_BUNDLE`, `EXCLUSIVE_BUNDLE`, `BEFAST_BUNDLE`.
           - `bundle-state`: filter according to package status, valid values: `ONLINE`, `OFFLINE`.
           NOTE: The upper limit of Filters per request is 10. The upper limit of Filter.Values is 5. Parameter does not support specifying both BundleIds and Filters.
    :param str instance_id: Instance ID.
    :param str result_output_file: Used to save results.
    """
    ...
