# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetOrdersResult',
    'AwaitableGetOrdersResult',
    'get_orders',
    'get_orders_output',
]

@pulumi.output_type
class GetOrdersResult:
    """
    A collection of values returned by getOrders.
    """
    def __init__(__self__, deal_name=None, deals=None, id=None, result_output_file=None):
        if deal_name and not isinstance(deal_name, str):
            raise TypeError("Expected argument 'deal_name' to be a str")
        pulumi.set(__self__, "deal_name", deal_name)
        if deals and not isinstance(deals, list):
            raise TypeError("Expected argument 'deals' to be a list")
        pulumi.set(__self__, "deals", deals)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="dealName")
    def deal_name(self) -> str:
        """
        Order number.
        """
        return pulumi.get(self, "deal_name")

    @property
    @pulumi.getter
    def deals(self) -> Sequence['outputs.GetOrdersDealResult']:
        """
        Order information list.
        """
        return pulumi.get(self, "deals")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetOrdersResult(GetOrdersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrdersResult(
            deal_name=self.deal_name,
            deals=self.deals,
            id=self.id,
            result_output_file=self.result_output_file)


def get_orders(deal_name: Optional[str] = None,
               result_output_file: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrdersResult:
    """
    Use this data source to query detailed information of mariadb orders

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    orders = tencentcloud.Mariadb.get_orders(deal_name="20230607164033835942781")
    ```


    :param str deal_name: List of long order numbers to be queried, which are returned for the APIs for creating, renewing, or scaling instances.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['dealName'] = deal_name
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Mariadb/getOrders:getOrders', __args__, opts=opts, typ=GetOrdersResult).value

    return AwaitableGetOrdersResult(
        deal_name=__ret__.deal_name,
        deals=__ret__.deals,
        id=__ret__.id,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_orders)
def get_orders_output(deal_name: Optional[pulumi.Input[str]] = None,
                      result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetOrdersResult]:
    """
    Use this data source to query detailed information of mariadb orders

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    orders = tencentcloud.Mariadb.get_orders(deal_name="20230607164033835942781")
    ```


    :param str deal_name: List of long order numbers to be queried, which are returned for the APIs for creating, renewing, or scaling instances.
    :param str result_output_file: Used to save results.
    """
    ...
