# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetPriceResult',
    'AwaitableGetPriceResult',
    'get_price',
    'get_price_output',
]

@pulumi.output_type
class GetPriceResult:
    """
    A collection of values returned by getPrice.
    """
    def __init__(__self__, amount_unit=None, buy_count=None, id=None, memory=None, node_count=None, original_price=None, paymode=None, period=None, price=None, result_output_file=None, storage=None, zone=None):
        if amount_unit and not isinstance(amount_unit, str):
            raise TypeError("Expected argument 'amount_unit' to be a str")
        pulumi.set(__self__, "amount_unit", amount_unit)
        if buy_count and not isinstance(buy_count, int):
            raise TypeError("Expected argument 'buy_count' to be a int")
        pulumi.set(__self__, "buy_count", buy_count)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if memory and not isinstance(memory, int):
            raise TypeError("Expected argument 'memory' to be a int")
        pulumi.set(__self__, "memory", memory)
        if node_count and not isinstance(node_count, int):
            raise TypeError("Expected argument 'node_count' to be a int")
        pulumi.set(__self__, "node_count", node_count)
        if original_price and not isinstance(original_price, int):
            raise TypeError("Expected argument 'original_price' to be a int")
        pulumi.set(__self__, "original_price", original_price)
        if paymode and not isinstance(paymode, str):
            raise TypeError("Expected argument 'paymode' to be a str")
        pulumi.set(__self__, "paymode", paymode)
        if period and not isinstance(period, int):
            raise TypeError("Expected argument 'period' to be a int")
        pulumi.set(__self__, "period", period)
        if price and not isinstance(price, int):
            raise TypeError("Expected argument 'price' to be a int")
        pulumi.set(__self__, "price", price)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if storage and not isinstance(storage, int):
            raise TypeError("Expected argument 'storage' to be a int")
        pulumi.set(__self__, "storage", storage)
        if zone and not isinstance(zone, str):
            raise TypeError("Expected argument 'zone' to be a str")
        pulumi.set(__self__, "zone", zone)

    @property
    @pulumi.getter(name="amountUnit")
    def amount_unit(self) -> Optional[str]:
        return pulumi.get(self, "amount_unit")

    @property
    @pulumi.getter(name="buyCount")
    def buy_count(self) -> int:
        return pulumi.get(self, "buy_count")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def memory(self) -> int:
        return pulumi.get(self, "memory")

    @property
    @pulumi.getter(name="nodeCount")
    def node_count(self) -> int:
        return pulumi.get(self, "node_count")

    @property
    @pulumi.getter(name="originalPrice")
    def original_price(self) -> int:
        """
        Original price * Unit: Cent (default). If the request parameter contains `AmountUnit`, see `AmountUnit` description. * Currency: CNY (Chinese site), USD (international site).
        """
        return pulumi.get(self, "original_price")

    @property
    @pulumi.getter
    def paymode(self) -> Optional[str]:
        return pulumi.get(self, "paymode")

    @property
    @pulumi.getter
    def period(self) -> Optional[int]:
        return pulumi.get(self, "period")

    @property
    @pulumi.getter
    def price(self) -> int:
        """
        The actual price may be different from the original price due to discounts. * Unit: Cent (default). If the request parameter contains `AmountUnit`, see `AmountUnit` description. * Currency: CNY (Chinese site), USD (international site).
        """
        return pulumi.get(self, "price")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def storage(self) -> int:
        return pulumi.get(self, "storage")

    @property
    @pulumi.getter
    def zone(self) -> str:
        return pulumi.get(self, "zone")


class AwaitableGetPriceResult(GetPriceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPriceResult(
            amount_unit=self.amount_unit,
            buy_count=self.buy_count,
            id=self.id,
            memory=self.memory,
            node_count=self.node_count,
            original_price=self.original_price,
            paymode=self.paymode,
            period=self.period,
            price=self.price,
            result_output_file=self.result_output_file,
            storage=self.storage,
            zone=self.zone)


def get_price(amount_unit: Optional[str] = None,
              buy_count: Optional[int] = None,
              memory: Optional[int] = None,
              node_count: Optional[int] = None,
              paymode: Optional[str] = None,
              period: Optional[int] = None,
              result_output_file: Optional[str] = None,
              storage: Optional[int] = None,
              zone: Optional[str] = None,
              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPriceResult:
    """
    Use this data source to query detailed information of mariadb price

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    price = tencentcloud.Mariadb.get_price(buy_count=1,
        memory=2,
        node_count=2,
        paymode="prepaid",
        period=1,
        storage=20,
        zone="ap-guangzhou-3")
    ```


    :param str amount_unit: Price unit. Valid values: `* pent` (cent), `* microPent` (microcent).
    :param int buy_count: The quantity you want to purchase is queried by default for the price of purchasing 1 instance.
    :param int memory: Memory size in GB, which can be obtained by querying the instance specification through the `DescribeDBInstanceSpecs` API.
    :param int node_count: Number of instance nodes, which can be obtained by querying the instance specification through the `DescribeDBInstanceSpecs` API.
    :param str paymode: Billing type. Valid values: `postpaid` (pay-as-you-go), `prepaid` (monthly subscription).
    :param int period: Purchase period in months.
    :param str result_output_file: Used to save results.
    :param int storage: Storage capacity in GB. The maximum and minimum storage space can be obtained by querying instance specification through the `DescribeDBInstanceSpecs` API.
    :param str zone: AZ ID of the purchased instance.
    """
    __args__ = dict()
    __args__['amountUnit'] = amount_unit
    __args__['buyCount'] = buy_count
    __args__['memory'] = memory
    __args__['nodeCount'] = node_count
    __args__['paymode'] = paymode
    __args__['period'] = period
    __args__['resultOutputFile'] = result_output_file
    __args__['storage'] = storage
    __args__['zone'] = zone
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Mariadb/getPrice:getPrice', __args__, opts=opts, typ=GetPriceResult).value

    return AwaitableGetPriceResult(
        amount_unit=__ret__.amount_unit,
        buy_count=__ret__.buy_count,
        id=__ret__.id,
        memory=__ret__.memory,
        node_count=__ret__.node_count,
        original_price=__ret__.original_price,
        paymode=__ret__.paymode,
        period=__ret__.period,
        price=__ret__.price,
        result_output_file=__ret__.result_output_file,
        storage=__ret__.storage,
        zone=__ret__.zone)


@_utilities.lift_output_func(get_price)
def get_price_output(amount_unit: Optional[pulumi.Input[Optional[str]]] = None,
                     buy_count: Optional[pulumi.Input[int]] = None,
                     memory: Optional[pulumi.Input[int]] = None,
                     node_count: Optional[pulumi.Input[int]] = None,
                     paymode: Optional[pulumi.Input[Optional[str]]] = None,
                     period: Optional[pulumi.Input[Optional[int]]] = None,
                     result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                     storage: Optional[pulumi.Input[int]] = None,
                     zone: Optional[pulumi.Input[str]] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPriceResult]:
    """
    Use this data source to query detailed information of mariadb price

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    price = tencentcloud.Mariadb.get_price(buy_count=1,
        memory=2,
        node_count=2,
        paymode="prepaid",
        period=1,
        storage=20,
        zone="ap-guangzhou-3")
    ```


    :param str amount_unit: Price unit. Valid values: `* pent` (cent), `* microPent` (microcent).
    :param int buy_count: The quantity you want to purchase is queried by default for the price of purchasing 1 instance.
    :param int memory: Memory size in GB, which can be obtained by querying the instance specification through the `DescribeDBInstanceSpecs` API.
    :param int node_count: Number of instance nodes, which can be obtained by querying the instance specification through the `DescribeDBInstanceSpecs` API.
    :param str paymode: Billing type. Valid values: `postpaid` (pay-as-you-go), `prepaid` (monthly subscription).
    :param int period: Purchase period in months.
    :param str result_output_file: Used to save results.
    :param int storage: Storage capacity in GB. The maximum and minimum storage space can be obtained by querying instance specification through the `DescribeDBInstanceSpecs` API.
    :param str zone: AZ ID of the purchased instance.
    """
    ...
