# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['InstanceConfigArgs', 'InstanceConfig']

@pulumi.input_type
class InstanceConfigArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 extranet_access: Optional[pulumi.Input[int]] = None,
                 rs_access_strategy: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a InstanceConfig resource.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[int] extranet_access: External network status, 0-closed; 1- Opening; Default not enabled.
        :param pulumi.Input[int] rs_access_strategy: RS proximity mode, 0- no strategy, 1- access to the nearest available zone.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        if extranet_access is not None:
            pulumi.set(__self__, "extranet_access", extranet_access)
        if rs_access_strategy is not None:
            pulumi.set(__self__, "rs_access_strategy", rs_access_strategy)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="extranetAccess")
    def extranet_access(self) -> Optional[pulumi.Input[int]]:
        """
        External network status, 0-closed; 1- Opening; Default not enabled.
        """
        return pulumi.get(self, "extranet_access")

    @extranet_access.setter
    def extranet_access(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "extranet_access", value)

    @property
    @pulumi.getter(name="rsAccessStrategy")
    def rs_access_strategy(self) -> Optional[pulumi.Input[int]]:
        """
        RS proximity mode, 0- no strategy, 1- access to the nearest available zone.
        """
        return pulumi.get(self, "rs_access_strategy")

    @rs_access_strategy.setter
    def rs_access_strategy(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "rs_access_strategy", value)


@pulumi.input_type
class _InstanceConfigState:
    def __init__(__self__, *,
                 extranet_access: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 rs_access_strategy: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering InstanceConfig resources.
        :param pulumi.Input[int] extranet_access: External network status, 0-closed; 1- Opening; Default not enabled.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[int] rs_access_strategy: RS proximity mode, 0- no strategy, 1- access to the nearest available zone.
        """
        if extranet_access is not None:
            pulumi.set(__self__, "extranet_access", extranet_access)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if rs_access_strategy is not None:
            pulumi.set(__self__, "rs_access_strategy", rs_access_strategy)

    @property
    @pulumi.getter(name="extranetAccess")
    def extranet_access(self) -> Optional[pulumi.Input[int]]:
        """
        External network status, 0-closed; 1- Opening; Default not enabled.
        """
        return pulumi.get(self, "extranet_access")

    @extranet_access.setter
    def extranet_access(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "extranet_access", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="rsAccessStrategy")
    def rs_access_strategy(self) -> Optional[pulumi.Input[int]]:
        """
        RS proximity mode, 0- no strategy, 1- access to the nearest available zone.
        """
        return pulumi.get(self, "rs_access_strategy")

    @rs_access_strategy.setter
    def rs_access_strategy(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "rs_access_strategy", value)


class InstanceConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 extranet_access: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 rs_access_strategy: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to create a mariadb instance_config

        ## Import

        mariadb instance_config can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Mariadb/instanceConfig:InstanceConfig test id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] extranet_access: External network status, 0-closed; 1- Opening; Default not enabled.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[int] rs_access_strategy: RS proximity mode, 0- no strategy, 1- access to the nearest available zone.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InstanceConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a mariadb instance_config

        ## Import

        mariadb instance_config can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Mariadb/instanceConfig:InstanceConfig test id
        ```

        :param str resource_name: The name of the resource.
        :param InstanceConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InstanceConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 extranet_access: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 rs_access_strategy: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InstanceConfigArgs.__new__(InstanceConfigArgs)

            __props__.__dict__["extranet_access"] = extranet_access
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["rs_access_strategy"] = rs_access_strategy
        super(InstanceConfig, __self__).__init__(
            'tencentcloud:Mariadb/instanceConfig:InstanceConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            extranet_access: Optional[pulumi.Input[int]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            rs_access_strategy: Optional[pulumi.Input[int]] = None) -> 'InstanceConfig':
        """
        Get an existing InstanceConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] extranet_access: External network status, 0-closed; 1- Opening; Default not enabled.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[int] rs_access_strategy: RS proximity mode, 0- no strategy, 1- access to the nearest available zone.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InstanceConfigState.__new__(_InstanceConfigState)

        __props__.__dict__["extranet_access"] = extranet_access
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["rs_access_strategy"] = rs_access_strategy
        return InstanceConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="extranetAccess")
    def extranet_access(self) -> pulumi.Output[int]:
        """
        External network status, 0-closed; 1- Opening; Default not enabled.
        """
        return pulumi.get(self, "extranet_access")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="rsAccessStrategy")
    def rs_access_strategy(self) -> pulumi.Output[int]:
        """
        RS proximity mode, 0- no strategy, 1- access to the nearest available zone.
        """
        return pulumi.get(self, "rs_access_strategy")

