# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['OperateHourDbInstanceArgs', 'OperateHourDbInstance']

@pulumi.input_type
class OperateHourDbInstanceArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 operate: pulumi.Input[str]):
        """
        The set of arguments for constructing a OperateHourDbInstance resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] operate: Operation, `activate`- activate the hour db instance, `isolate`- isolate the hour db instance.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "operate", operate)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def operate(self) -> pulumi.Input[str]:
        """
        Operation, `activate`- activate the hour db instance, `isolate`- isolate the hour db instance.
        """
        return pulumi.get(self, "operate")

    @operate.setter
    def operate(self, value: pulumi.Input[str]):
        pulumi.set(self, "operate", value)


@pulumi.input_type
class _OperateHourDbInstanceState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 operate: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering OperateHourDbInstance resources.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] operate: Operation, `activate`- activate the hour db instance, `isolate`- isolate the hour db instance.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if operate is not None:
            pulumi.set(__self__, "operate", operate)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def operate(self) -> Optional[pulumi.Input[str]]:
        """
        Operation, `activate`- activate the hour db instance, `isolate`- isolate the hour db instance.
        """
        return pulumi.get(self, "operate")

    @operate.setter
    def operate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "operate", value)


class OperateHourDbInstance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 operate: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a mariadb activate_hour_db_instance

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        activate_hour_db_instance = tencentcloud.mariadb.OperateHourDbInstance("activateHourDbInstance",
            instance_id="tdsql-9vqvls95",
            operate="activate")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] operate: Operation, `activate`- activate the hour db instance, `isolate`- isolate the hour db instance.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: OperateHourDbInstanceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a mariadb activate_hour_db_instance

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        activate_hour_db_instance = tencentcloud.mariadb.OperateHourDbInstance("activateHourDbInstance",
            instance_id="tdsql-9vqvls95",
            operate="activate")
        ```

        :param str resource_name: The name of the resource.
        :param OperateHourDbInstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(OperateHourDbInstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 operate: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = OperateHourDbInstanceArgs.__new__(OperateHourDbInstanceArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if operate is None and not opts.urn:
                raise TypeError("Missing required property 'operate'")
            __props__.__dict__["operate"] = operate
        super(OperateHourDbInstance, __self__).__init__(
            'tencentcloud:Mariadb/operateHourDbInstance:OperateHourDbInstance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            operate: Optional[pulumi.Input[str]] = None) -> 'OperateHourDbInstance':
        """
        Get an existing OperateHourDbInstance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] operate: Operation, `activate`- activate the hour db instance, `isolate`- isolate the hour db instance.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _OperateHourDbInstanceState.__new__(_OperateHourDbInstanceState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["operate"] = operate
        return OperateHourDbInstance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def operate(self) -> pulumi.Output[str]:
        """
        Operation, `activate`- activate the hour db instance, `isolate`- isolate the hour db instance.
        """
        return pulumi.get(self, "operate")

