# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['TmpTkeConfigArgs', 'TmpTkeConfig']

@pulumi.input_type
class TmpTkeConfigArgs:
    def __init__(__self__, *,
                 cluster_id: pulumi.Input[str],
                 cluster_type: pulumi.Input[str],
                 instance_id: pulumi.Input[str],
                 pod_monitors: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigPodMonitorArgs']]]] = None,
                 raw_jobs: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigRawJobArgs']]]] = None,
                 service_monitors: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigServiceMonitorArgs']]]] = None):
        """
        The set of arguments for constructing a TmpTkeConfig resource.
        :param pulumi.Input[str] cluster_id: ID of cluster.
        :param pulumi.Input[str] cluster_type: Type of cluster.
        :param pulumi.Input[str] instance_id: ID of instance.
        :param pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigPodMonitorArgs']]] pod_monitors: Configuration of the pod monitors.
        :param pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigRawJobArgs']]] raw_jobs: Configuration of the native prometheus job.
        :param pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigServiceMonitorArgs']]] service_monitors: Configuration of the service monitors.
        """
        pulumi.set(__self__, "cluster_id", cluster_id)
        pulumi.set(__self__, "cluster_type", cluster_type)
        pulumi.set(__self__, "instance_id", instance_id)
        if pod_monitors is not None:
            pulumi.set(__self__, "pod_monitors", pod_monitors)
        if raw_jobs is not None:
            pulumi.set(__self__, "raw_jobs", raw_jobs)
        if service_monitors is not None:
            pulumi.set(__self__, "service_monitors", service_monitors)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Input[str]:
        """
        ID of cluster.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="clusterType")
    def cluster_type(self) -> pulumi.Input[str]:
        """
        Type of cluster.
        """
        return pulumi.get(self, "cluster_type")

    @cluster_type.setter
    def cluster_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_type", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="podMonitors")
    def pod_monitors(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigPodMonitorArgs']]]]:
        """
        Configuration of the pod monitors.
        """
        return pulumi.get(self, "pod_monitors")

    @pod_monitors.setter
    def pod_monitors(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigPodMonitorArgs']]]]):
        pulumi.set(self, "pod_monitors", value)

    @property
    @pulumi.getter(name="rawJobs")
    def raw_jobs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigRawJobArgs']]]]:
        """
        Configuration of the native prometheus job.
        """
        return pulumi.get(self, "raw_jobs")

    @raw_jobs.setter
    def raw_jobs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigRawJobArgs']]]]):
        pulumi.set(self, "raw_jobs", value)

    @property
    @pulumi.getter(name="serviceMonitors")
    def service_monitors(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigServiceMonitorArgs']]]]:
        """
        Configuration of the service monitors.
        """
        return pulumi.get(self, "service_monitors")

    @service_monitors.setter
    def service_monitors(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigServiceMonitorArgs']]]]):
        pulumi.set(self, "service_monitors", value)


@pulumi.input_type
class _TmpTkeConfigState:
    def __init__(__self__, *,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 cluster_type: Optional[pulumi.Input[str]] = None,
                 config: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 pod_monitors: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigPodMonitorArgs']]]] = None,
                 raw_jobs: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigRawJobArgs']]]] = None,
                 service_monitors: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigServiceMonitorArgs']]]] = None):
        """
        Input properties used for looking up and filtering TmpTkeConfig resources.
        :param pulumi.Input[str] cluster_id: ID of cluster.
        :param pulumi.Input[str] cluster_type: Type of cluster.
        :param pulumi.Input[str] config: Config.
        :param pulumi.Input[str] instance_id: ID of instance.
        :param pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigPodMonitorArgs']]] pod_monitors: Configuration of the pod monitors.
        :param pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigRawJobArgs']]] raw_jobs: Configuration of the native prometheus job.
        :param pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigServiceMonitorArgs']]] service_monitors: Configuration of the service monitors.
        """
        if cluster_id is not None:
            pulumi.set(__self__, "cluster_id", cluster_id)
        if cluster_type is not None:
            pulumi.set(__self__, "cluster_type", cluster_type)
        if config is not None:
            pulumi.set(__self__, "config", config)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if pod_monitors is not None:
            pulumi.set(__self__, "pod_monitors", pod_monitors)
        if raw_jobs is not None:
            pulumi.set(__self__, "raw_jobs", raw_jobs)
        if service_monitors is not None:
            pulumi.set(__self__, "service_monitors", service_monitors)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of cluster.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="clusterType")
    def cluster_type(self) -> Optional[pulumi.Input[str]]:
        """
        Type of cluster.
        """
        return pulumi.get(self, "cluster_type")

    @cluster_type.setter
    def cluster_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_type", value)

    @property
    @pulumi.getter
    def config(self) -> Optional[pulumi.Input[str]]:
        """
        Config.
        """
        return pulumi.get(self, "config")

    @config.setter
    def config(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="podMonitors")
    def pod_monitors(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigPodMonitorArgs']]]]:
        """
        Configuration of the pod monitors.
        """
        return pulumi.get(self, "pod_monitors")

    @pod_monitors.setter
    def pod_monitors(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigPodMonitorArgs']]]]):
        pulumi.set(self, "pod_monitors", value)

    @property
    @pulumi.getter(name="rawJobs")
    def raw_jobs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigRawJobArgs']]]]:
        """
        Configuration of the native prometheus job.
        """
        return pulumi.get(self, "raw_jobs")

    @raw_jobs.setter
    def raw_jobs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigRawJobArgs']]]]):
        pulumi.set(self, "raw_jobs", value)

    @property
    @pulumi.getter(name="serviceMonitors")
    def service_monitors(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigServiceMonitorArgs']]]]:
        """
        Configuration of the service monitors.
        """
        return pulumi.get(self, "service_monitors")

    @service_monitors.setter
    def service_monitors(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TmpTkeConfigServiceMonitorArgs']]]]):
        pulumi.set(self, "service_monitors", value)


class TmpTkeConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 cluster_type: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 pod_monitors: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigPodMonitorArgs']]]]] = None,
                 raw_jobs: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigRawJobArgs']]]]] = None,
                 service_monitors: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigServiceMonitorArgs']]]]] = None,
                 __props__=None):
        """
        Provides a resource to create a tke tmpPrometheusConfig

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        config = pulumi.Config()
        default_instance_type = config.get("defaultInstanceType")
        if default_instance_type is None:
            default_instance_type = "SA1.MEDIUM2"
        availability_zone_first = config.get("availabilityZoneFirst")
        if availability_zone_first is None:
            availability_zone_first = "ap-guangzhou-3"
        availability_zone_second = config.get("availabilityZoneSecond")
        if availability_zone_second is None:
            availability_zone_second = "ap-guangzhou-4"
        example_cluster_cidr = config.get("exampleClusterCidr")
        if example_cluster_cidr is None:
            example_cluster_cidr = "10.31.0.0/16"
        vpc_one = tencentcloud.Vpc.get_subnets(is_default=True,
            availability_zone=availability_zone_first)
        first_vpc_id = vpc_one.instance_lists[0].vpc_id
        first_subnet_id = vpc_one.instance_lists[0].subnet_id
        vpc_two = tencentcloud.Vpc.get_subnets(is_default=True,
            availability_zone=availability_zone_second)
        second_vpc_id = vpc_two.instance_lists[0].vpc_id
        second_subnet_id = vpc_two.instance_lists[0].subnet_id
        sg = tencentcloud.security.Group("sg")
        sg_id = sg.id
        default = tencentcloud.Images.get_instance(image_types=["PUBLIC_IMAGE"],
            image_name_regex="Final")
        image_id = default.image_id
        sg_rule = tencentcloud.security.GroupLiteRule("sgRule",
            security_group_id=sg.id,
            ingresses=[
                "ACCEPT#10.0.0.0/16#ALL#ALL",
                "ACCEPT#172.16.0.0/22#ALL#ALL",
                "DROP#0.0.0.0/0#ALL#ALL",
            ],
            egresses=["ACCEPT#172.16.0.0/22#ALL#ALL"])
        example = tencentcloud.kubernetes.Cluster("example",
            vpc_id=first_vpc_id,
            cluster_cidr=example_cluster_cidr,
            cluster_max_pod_num=32,
            cluster_name="tf_example_cluster",
            cluster_desc="example for tke cluster",
            cluster_max_service_num=32,
            cluster_internet=False,
            cluster_internet_security_group=sg_id,
            cluster_version="1.22.5",
            cluster_deploy_type="MANAGED_CLUSTER",
            worker_configs=[
                tencentcloud.kubernetes.ClusterWorkerConfigArgs(
                    count=1,
                    availability_zone=availability_zone_first,
                    instance_type=default_instance_type,
                    system_disk_type="CLOUD_SSD",
                    system_disk_size=60,
                    internet_charge_type="TRAFFIC_POSTPAID_BY_HOUR",
                    internet_max_bandwidth_out=100,
                    public_ip_assigned=True,
                    subnet_id=first_subnet_id,
                    img_id=image_id,
                    data_disks=[tencentcloud.kubernetes.ClusterWorkerConfigDataDiskArgs(
                        disk_type="CLOUD_PREMIUM",
                        disk_size=50,
                    )],
                    enhanced_security_service=False,
                    enhanced_monitor_service=False,
                    user_data="dGVzdA==",
                    password="ZZXXccvv1212",
                ),
                tencentcloud.kubernetes.ClusterWorkerConfigArgs(
                    count=1,
                    availability_zone=availability_zone_second,
                    instance_type=default_instance_type,
                    system_disk_type="CLOUD_SSD",
                    system_disk_size=60,
                    internet_charge_type="TRAFFIC_POSTPAID_BY_HOUR",
                    internet_max_bandwidth_out=100,
                    public_ip_assigned=True,
                    subnet_id=second_subnet_id,
                    data_disks=[tencentcloud.kubernetes.ClusterWorkerConfigDataDiskArgs(
                        disk_type="CLOUD_PREMIUM",
                        disk_size=50,
                    )],
                    enhanced_security_service=False,
                    enhanced_monitor_service=False,
                    user_data="dGVzdA==",
                    cam_role_name="CVM_QcsRole",
                    password="ZZXXccvv1212",
                ),
            ],
            labels={
                "test1": "test1",
                "test2": "test2",
            })
        zone = config.get("zone")
        if zone is None:
            zone = "ap-guangzhou"
        cluster_type = config.get("clusterType")
        if cluster_type is None:
            cluster_type = "tke"
        foo_tmp_instance = tencentcloud.monitor.TmpInstance("fooTmpInstance",
            instance_name="tf-tmp-instance",
            vpc_id=first_vpc_id,
            subnet_id=first_subnet_id,
            data_retention_time=30,
            zone=availability_zone_second,
            tags={
                "createdBy": "terraform",
            })
        # tmp tke bind
        foo_tmp_tke_cluster_agent = tencentcloud.monitor.TmpTkeClusterAgent("fooTmpTkeClusterAgent",
            instance_id=foo_tmp_instance.id,
            agents=tencentcloud.monitor.TmpTkeClusterAgentAgentsArgs(
                region=zone,
                cluster_type=cluster_type,
                cluster_id=example.id,
                enable_external=False,
            ))
        foo_tmp_tke_config = tencentcloud.monitor.TmpTkeConfig("fooTmpTkeConfig",
            instance_id=foo_tmp_instance.id,
            cluster_type=cluster_type,
            cluster_id=example.id,
            raw_jobs=[tencentcloud.monitor.TmpTkeConfigRawJobArgs(
                name="raw_jobs_001",
                config="your config for raw_jobs_001\n",
            )],
            service_monitors=[tencentcloud.monitor.TmpTkeConfigServiceMonitorArgs(
                name="kube-system/service-monitor-001",
                config=\"\"\"apiVersion: monitoring.coreos.com/v1
        kind: ServiceMonitor
        metadata:
          name: service-monitor-001
          namespace: kube-system
        \"\"\",
            )],
            pod_monitors=[tencentcloud.monitor.TmpTkeConfigPodMonitorArgs(
                name="mynamespace/pod-monitor-001",
                config=\"\"\"apiVersion: monitoring.coreos.com/v1
        kind: PodMonitor
        metadata:
          name: pod-monitor-001
          namespace: mynamespace
        \"\"\",
            )])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_id: ID of cluster.
        :param pulumi.Input[str] cluster_type: Type of cluster.
        :param pulumi.Input[str] instance_id: ID of instance.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigPodMonitorArgs']]]] pod_monitors: Configuration of the pod monitors.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigRawJobArgs']]]] raw_jobs: Configuration of the native prometheus job.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigServiceMonitorArgs']]]] service_monitors: Configuration of the service monitors.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TmpTkeConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a tke tmpPrometheusConfig

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        config = pulumi.Config()
        default_instance_type = config.get("defaultInstanceType")
        if default_instance_type is None:
            default_instance_type = "SA1.MEDIUM2"
        availability_zone_first = config.get("availabilityZoneFirst")
        if availability_zone_first is None:
            availability_zone_first = "ap-guangzhou-3"
        availability_zone_second = config.get("availabilityZoneSecond")
        if availability_zone_second is None:
            availability_zone_second = "ap-guangzhou-4"
        example_cluster_cidr = config.get("exampleClusterCidr")
        if example_cluster_cidr is None:
            example_cluster_cidr = "10.31.0.0/16"
        vpc_one = tencentcloud.Vpc.get_subnets(is_default=True,
            availability_zone=availability_zone_first)
        first_vpc_id = vpc_one.instance_lists[0].vpc_id
        first_subnet_id = vpc_one.instance_lists[0].subnet_id
        vpc_two = tencentcloud.Vpc.get_subnets(is_default=True,
            availability_zone=availability_zone_second)
        second_vpc_id = vpc_two.instance_lists[0].vpc_id
        second_subnet_id = vpc_two.instance_lists[0].subnet_id
        sg = tencentcloud.security.Group("sg")
        sg_id = sg.id
        default = tencentcloud.Images.get_instance(image_types=["PUBLIC_IMAGE"],
            image_name_regex="Final")
        image_id = default.image_id
        sg_rule = tencentcloud.security.GroupLiteRule("sgRule",
            security_group_id=sg.id,
            ingresses=[
                "ACCEPT#10.0.0.0/16#ALL#ALL",
                "ACCEPT#172.16.0.0/22#ALL#ALL",
                "DROP#0.0.0.0/0#ALL#ALL",
            ],
            egresses=["ACCEPT#172.16.0.0/22#ALL#ALL"])
        example = tencentcloud.kubernetes.Cluster("example",
            vpc_id=first_vpc_id,
            cluster_cidr=example_cluster_cidr,
            cluster_max_pod_num=32,
            cluster_name="tf_example_cluster",
            cluster_desc="example for tke cluster",
            cluster_max_service_num=32,
            cluster_internet=False,
            cluster_internet_security_group=sg_id,
            cluster_version="1.22.5",
            cluster_deploy_type="MANAGED_CLUSTER",
            worker_configs=[
                tencentcloud.kubernetes.ClusterWorkerConfigArgs(
                    count=1,
                    availability_zone=availability_zone_first,
                    instance_type=default_instance_type,
                    system_disk_type="CLOUD_SSD",
                    system_disk_size=60,
                    internet_charge_type="TRAFFIC_POSTPAID_BY_HOUR",
                    internet_max_bandwidth_out=100,
                    public_ip_assigned=True,
                    subnet_id=first_subnet_id,
                    img_id=image_id,
                    data_disks=[tencentcloud.kubernetes.ClusterWorkerConfigDataDiskArgs(
                        disk_type="CLOUD_PREMIUM",
                        disk_size=50,
                    )],
                    enhanced_security_service=False,
                    enhanced_monitor_service=False,
                    user_data="dGVzdA==",
                    password="ZZXXccvv1212",
                ),
                tencentcloud.kubernetes.ClusterWorkerConfigArgs(
                    count=1,
                    availability_zone=availability_zone_second,
                    instance_type=default_instance_type,
                    system_disk_type="CLOUD_SSD",
                    system_disk_size=60,
                    internet_charge_type="TRAFFIC_POSTPAID_BY_HOUR",
                    internet_max_bandwidth_out=100,
                    public_ip_assigned=True,
                    subnet_id=second_subnet_id,
                    data_disks=[tencentcloud.kubernetes.ClusterWorkerConfigDataDiskArgs(
                        disk_type="CLOUD_PREMIUM",
                        disk_size=50,
                    )],
                    enhanced_security_service=False,
                    enhanced_monitor_service=False,
                    user_data="dGVzdA==",
                    cam_role_name="CVM_QcsRole",
                    password="ZZXXccvv1212",
                ),
            ],
            labels={
                "test1": "test1",
                "test2": "test2",
            })
        zone = config.get("zone")
        if zone is None:
            zone = "ap-guangzhou"
        cluster_type = config.get("clusterType")
        if cluster_type is None:
            cluster_type = "tke"
        foo_tmp_instance = tencentcloud.monitor.TmpInstance("fooTmpInstance",
            instance_name="tf-tmp-instance",
            vpc_id=first_vpc_id,
            subnet_id=first_subnet_id,
            data_retention_time=30,
            zone=availability_zone_second,
            tags={
                "createdBy": "terraform",
            })
        # tmp tke bind
        foo_tmp_tke_cluster_agent = tencentcloud.monitor.TmpTkeClusterAgent("fooTmpTkeClusterAgent",
            instance_id=foo_tmp_instance.id,
            agents=tencentcloud.monitor.TmpTkeClusterAgentAgentsArgs(
                region=zone,
                cluster_type=cluster_type,
                cluster_id=example.id,
                enable_external=False,
            ))
        foo_tmp_tke_config = tencentcloud.monitor.TmpTkeConfig("fooTmpTkeConfig",
            instance_id=foo_tmp_instance.id,
            cluster_type=cluster_type,
            cluster_id=example.id,
            raw_jobs=[tencentcloud.monitor.TmpTkeConfigRawJobArgs(
                name="raw_jobs_001",
                config="your config for raw_jobs_001\n",
            )],
            service_monitors=[tencentcloud.monitor.TmpTkeConfigServiceMonitorArgs(
                name="kube-system/service-monitor-001",
                config=\"\"\"apiVersion: monitoring.coreos.com/v1
        kind: ServiceMonitor
        metadata:
          name: service-monitor-001
          namespace: kube-system
        \"\"\",
            )],
            pod_monitors=[tencentcloud.monitor.TmpTkeConfigPodMonitorArgs(
                name="mynamespace/pod-monitor-001",
                config=\"\"\"apiVersion: monitoring.coreos.com/v1
        kind: PodMonitor
        metadata:
          name: pod-monitor-001
          namespace: mynamespace
        \"\"\",
            )])
        ```

        :param str resource_name: The name of the resource.
        :param TmpTkeConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TmpTkeConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 cluster_type: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 pod_monitors: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigPodMonitorArgs']]]]] = None,
                 raw_jobs: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigRawJobArgs']]]]] = None,
                 service_monitors: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigServiceMonitorArgs']]]]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TmpTkeConfigArgs.__new__(TmpTkeConfigArgs)

            if cluster_id is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_id'")
            __props__.__dict__["cluster_id"] = cluster_id
            if cluster_type is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_type'")
            __props__.__dict__["cluster_type"] = cluster_type
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["pod_monitors"] = pod_monitors
            __props__.__dict__["raw_jobs"] = raw_jobs
            __props__.__dict__["service_monitors"] = service_monitors
            __props__.__dict__["config"] = None
        super(TmpTkeConfig, __self__).__init__(
            'tencentcloud:Monitor/tmpTkeConfig:TmpTkeConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cluster_id: Optional[pulumi.Input[str]] = None,
            cluster_type: Optional[pulumi.Input[str]] = None,
            config: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            pod_monitors: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigPodMonitorArgs']]]]] = None,
            raw_jobs: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigRawJobArgs']]]]] = None,
            service_monitors: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigServiceMonitorArgs']]]]] = None) -> 'TmpTkeConfig':
        """
        Get an existing TmpTkeConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_id: ID of cluster.
        :param pulumi.Input[str] cluster_type: Type of cluster.
        :param pulumi.Input[str] config: Config.
        :param pulumi.Input[str] instance_id: ID of instance.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigPodMonitorArgs']]]] pod_monitors: Configuration of the pod monitors.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigRawJobArgs']]]] raw_jobs: Configuration of the native prometheus job.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TmpTkeConfigServiceMonitorArgs']]]] service_monitors: Configuration of the service monitors.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TmpTkeConfigState.__new__(_TmpTkeConfigState)

        __props__.__dict__["cluster_id"] = cluster_id
        __props__.__dict__["cluster_type"] = cluster_type
        __props__.__dict__["config"] = config
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["pod_monitors"] = pod_monitors
        __props__.__dict__["raw_jobs"] = raw_jobs
        __props__.__dict__["service_monitors"] = service_monitors
        return TmpTkeConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Output[str]:
        """
        ID of cluster.
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter(name="clusterType")
    def cluster_type(self) -> pulumi.Output[str]:
        """
        Type of cluster.
        """
        return pulumi.get(self, "cluster_type")

    @property
    @pulumi.getter
    def config(self) -> pulumi.Output[str]:
        """
        Config.
        """
        return pulumi.get(self, "config")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="podMonitors")
    def pod_monitors(self) -> pulumi.Output[Optional[Sequence['outputs.TmpTkeConfigPodMonitor']]]:
        """
        Configuration of the pod monitors.
        """
        return pulumi.get(self, "pod_monitors")

    @property
    @pulumi.getter(name="rawJobs")
    def raw_jobs(self) -> pulumi.Output[Optional[Sequence['outputs.TmpTkeConfigRawJob']]]:
        """
        Configuration of the native prometheus job.
        """
        return pulumi.get(self, "raw_jobs")

    @property
    @pulumi.getter(name="serviceMonitors")
    def service_monitors(self) -> pulumi.Output[Optional[Sequence['outputs.TmpTkeConfigServiceMonitor']]]:
        """
        Configuration of the service monitors.
        """
        return pulumi.get(self, "service_monitors")

