# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['TmpTkeTemplateAttachmentArgs', 'TmpTkeTemplateAttachment']

@pulumi.input_type
class TmpTkeTemplateAttachmentArgs:
    def __init__(__self__, *,
                 targets: pulumi.Input['TmpTkeTemplateAttachmentTargetsArgs'],
                 template_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a TmpTkeTemplateAttachment resource.
        :param pulumi.Input['TmpTkeTemplateAttachmentTargetsArgs'] targets: Sync target details.
        :param pulumi.Input[str] template_id: The ID of the template, which is used for the outgoing reference.
        """
        pulumi.set(__self__, "targets", targets)
        pulumi.set(__self__, "template_id", template_id)

    @property
    @pulumi.getter
    def targets(self) -> pulumi.Input['TmpTkeTemplateAttachmentTargetsArgs']:
        """
        Sync target details.
        """
        return pulumi.get(self, "targets")

    @targets.setter
    def targets(self, value: pulumi.Input['TmpTkeTemplateAttachmentTargetsArgs']):
        pulumi.set(self, "targets", value)

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> pulumi.Input[str]:
        """
        The ID of the template, which is used for the outgoing reference.
        """
        return pulumi.get(self, "template_id")

    @template_id.setter
    def template_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "template_id", value)


@pulumi.input_type
class _TmpTkeTemplateAttachmentState:
    def __init__(__self__, *,
                 targets: Optional[pulumi.Input['TmpTkeTemplateAttachmentTargetsArgs']] = None,
                 template_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering TmpTkeTemplateAttachment resources.
        :param pulumi.Input['TmpTkeTemplateAttachmentTargetsArgs'] targets: Sync target details.
        :param pulumi.Input[str] template_id: The ID of the template, which is used for the outgoing reference.
        """
        if targets is not None:
            pulumi.set(__self__, "targets", targets)
        if template_id is not None:
            pulumi.set(__self__, "template_id", template_id)

    @property
    @pulumi.getter
    def targets(self) -> Optional[pulumi.Input['TmpTkeTemplateAttachmentTargetsArgs']]:
        """
        Sync target details.
        """
        return pulumi.get(self, "targets")

    @targets.setter
    def targets(self, value: Optional[pulumi.Input['TmpTkeTemplateAttachmentTargetsArgs']]):
        pulumi.set(self, "targets", value)

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the template, which is used for the outgoing reference.
        """
        return pulumi.get(self, "template_id")

    @template_id.setter
    def template_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "template_id", value)


class TmpTkeTemplateAttachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 targets: Optional[pulumi.Input[pulumi.InputType['TmpTkeTemplateAttachmentTargetsArgs']]] = None,
                 template_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a tmp tke template attachment

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        config = pulumi.Config()
        default_instance_type = config.get("defaultInstanceType")
        if default_instance_type is None:
            default_instance_type = "SA1.MEDIUM2"
        availability_zone_first = config.get("availabilityZoneFirst")
        if availability_zone_first is None:
            availability_zone_first = "ap-guangzhou-3"
        availability_zone_second = config.get("availabilityZoneSecond")
        if availability_zone_second is None:
            availability_zone_second = "ap-guangzhou-4"
        example_cluster_cidr = config.get("exampleClusterCidr")
        if example_cluster_cidr is None:
            example_cluster_cidr = "10.31.0.0/16"
        vpc_one = tencentcloud.Vpc.get_subnets(is_default=True,
            availability_zone=availability_zone_first)
        first_vpc_id = vpc_one.instance_lists[0].vpc_id
        first_subnet_id = vpc_one.instance_lists[0].subnet_id
        vpc_two = tencentcloud.Vpc.get_subnets(is_default=True,
            availability_zone=availability_zone_second)
        second_vpc_id = vpc_two.instance_lists[0].vpc_id
        second_subnet_id = vpc_two.instance_lists[0].subnet_id
        sg = tencentcloud.security.Group("sg")
        sg_id = sg.id
        default = tencentcloud.Images.get_instance(image_types=["PUBLIC_IMAGE"],
            image_name_regex="Final")
        image_id = default.image_id
        sg_rule = tencentcloud.security.GroupLiteRule("sgRule",
            security_group_id=sg.id,
            ingresses=[
                "ACCEPT#10.0.0.0/16#ALL#ALL",
                "ACCEPT#172.16.0.0/22#ALL#ALL",
                "DROP#0.0.0.0/0#ALL#ALL",
            ],
            egresses=["ACCEPT#172.16.0.0/22#ALL#ALL"])
        example = tencentcloud.kubernetes.Cluster("example",
            vpc_id=first_vpc_id,
            cluster_cidr=example_cluster_cidr,
            cluster_max_pod_num=32,
            cluster_name="tf_example_cluster",
            cluster_desc="example for tke cluster",
            cluster_max_service_num=32,
            cluster_internet=False,
            cluster_internet_security_group=sg_id,
            cluster_version="1.22.5",
            cluster_deploy_type="MANAGED_CLUSTER",
            worker_configs=[
                tencentcloud.kubernetes.ClusterWorkerConfigArgs(
                    count=1,
                    availability_zone=availability_zone_first,
                    instance_type=default_instance_type,
                    system_disk_type="CLOUD_SSD",
                    system_disk_size=60,
                    internet_charge_type="TRAFFIC_POSTPAID_BY_HOUR",
                    internet_max_bandwidth_out=100,
                    public_ip_assigned=True,
                    subnet_id=first_subnet_id,
                    img_id=image_id,
                    data_disks=[tencentcloud.kubernetes.ClusterWorkerConfigDataDiskArgs(
                        disk_type="CLOUD_PREMIUM",
                        disk_size=50,
                    )],
                    enhanced_security_service=False,
                    enhanced_monitor_service=False,
                    user_data="dGVzdA==",
                    password="ZZXXccvv1212",
                ),
                tencentcloud.kubernetes.ClusterWorkerConfigArgs(
                    count=1,
                    availability_zone=availability_zone_second,
                    instance_type=default_instance_type,
                    system_disk_type="CLOUD_SSD",
                    system_disk_size=60,
                    internet_charge_type="TRAFFIC_POSTPAID_BY_HOUR",
                    internet_max_bandwidth_out=100,
                    public_ip_assigned=True,
                    subnet_id=second_subnet_id,
                    data_disks=[tencentcloud.kubernetes.ClusterWorkerConfigDataDiskArgs(
                        disk_type="CLOUD_PREMIUM",
                        disk_size=50,
                    )],
                    enhanced_security_service=False,
                    enhanced_monitor_service=False,
                    user_data="dGVzdA==",
                    cam_role_name="CVM_QcsRole",
                    password="ZZXXccvv1212",
                ),
            ],
            labels={
                "test1": "test1",
                "test2": "test2",
            })
        zone = config.get("zone")
        if zone is None:
            zone = "ap-guangzhou"
        cluster_type = config.get("clusterType")
        if cluster_type is None:
            cluster_type = "tke"
        foo_tmp_instance = tencentcloud.monitor.TmpInstance("fooTmpInstance",
            instance_name="tf-tmp-instance",
            vpc_id=first_vpc_id,
            subnet_id=first_subnet_id,
            data_retention_time=30,
            zone=availability_zone_second,
            tags={
                "createdBy": "terraform",
            })
        # tmp tke bind
        foo_tmp_tke_cluster_agent = tencentcloud.monitor.TmpTkeClusterAgent("fooTmpTkeClusterAgent",
            instance_id=foo_tmp_instance.id,
            agents=tencentcloud.monitor.TmpTkeClusterAgentAgentsArgs(
                region=zone,
                cluster_type=cluster_type,
                cluster_id=example.id,
                enable_external=False,
            ))
        # create monitor template
        foo_tmp_tke_template = tencentcloud.monitor.TmpTkeTemplate("fooTmpTkeTemplate", template=tencentcloud.monitor.TmpTkeTemplateTemplateArgs(
            name="tf-template",
            level="cluster",
            describe="template",
            service_monitors=[tencentcloud.monitor.TmpTkeTemplateTemplateServiceMonitorArgs(
                name="tf-ServiceMonitor",
                config=\"\"\"apiVersion: monitoring.coreos.com/v1
        kind: ServiceMonitor
        metadata:
          name: example-service-monitor
          namespace: monitoring
          labels:
            k8s-app: example-service
        spec:
          selector:
            matchLabels:
              k8s-app: example-service
          namespaceSelector:
            matchNames:
              - default
          endpoints:
          - port: http-metrics
            interval: 30s
            path: /metrics
            scheme: http
            bearerTokenFile: /var/run/secrets/kubernetes.io/serviceaccount/token
            tlsConfig:
              insecureSkipVerify: true
        \"\"\",
            )],
            pod_monitors=[
                tencentcloud.monitor.TmpTkeTemplateTemplatePodMonitorArgs(
                    name="tf-PodMonitors",
                    config=\"\"\"apiVersion: monitoring.coreos.com/v1
        kind: PodMonitor
        metadata:
          name: example-pod-monitor
          namespace: monitoring
          labels:
            k8s-app: example-pod
        spec:
          selector:
            matchLabels:
              k8s-app: example-pod
          namespaceSelector:
            matchNames:
              - default
          podMetricsEndpoints:
          - port: http-metrics
            interval: 30s
            path: /metrics
            scheme: http
            bearerTokenFile: /var/run/secrets/kubernetes.io/serviceaccount/token
            tlsConfig:
              insecureSkipVerify: true
        \"\"\",
                ),
                tencentcloud.monitor.TmpTkeTemplateTemplatePodMonitorArgs(
                    name="tf-RawJobs",
                    config=\"\"\"scrape_configs:
          - job_name: 'example-job'
            scrape_interval: 30s
            static_configs:
              - targets: ['example-service.default.svc.cluster.local:8080']
            metrics_path: /metrics
            scheme: http
            bearer_token_file: /var/run/secrets/kubernetes.io/serviceaccount/token
            tls_config:
              insecure_skip_verify: true
        \"\"\",
                ),
            ],
        ))
        temp_attachment = tencentcloud.monitor.TmpTkeTemplateAttachment("tempAttachment",
            template_id=foo_tmp_tke_template.id,
            targets=tencentcloud.monitor.TmpTkeTemplateAttachmentTargetsArgs(
                cluster_type=cluster_type,
                cluster_id=example.id,
                region=zone,
                instance_id=foo_tmp_instance.id,
            ),
            opts=pulumi.ResourceOptions(depends_on=[foo_tmp_tke_cluster_agent]))
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['TmpTkeTemplateAttachmentTargetsArgs']] targets: Sync target details.
        :param pulumi.Input[str] template_id: The ID of the template, which is used for the outgoing reference.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TmpTkeTemplateAttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a tmp tke template attachment

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        config = pulumi.Config()
        default_instance_type = config.get("defaultInstanceType")
        if default_instance_type is None:
            default_instance_type = "SA1.MEDIUM2"
        availability_zone_first = config.get("availabilityZoneFirst")
        if availability_zone_first is None:
            availability_zone_first = "ap-guangzhou-3"
        availability_zone_second = config.get("availabilityZoneSecond")
        if availability_zone_second is None:
            availability_zone_second = "ap-guangzhou-4"
        example_cluster_cidr = config.get("exampleClusterCidr")
        if example_cluster_cidr is None:
            example_cluster_cidr = "10.31.0.0/16"
        vpc_one = tencentcloud.Vpc.get_subnets(is_default=True,
            availability_zone=availability_zone_first)
        first_vpc_id = vpc_one.instance_lists[0].vpc_id
        first_subnet_id = vpc_one.instance_lists[0].subnet_id
        vpc_two = tencentcloud.Vpc.get_subnets(is_default=True,
            availability_zone=availability_zone_second)
        second_vpc_id = vpc_two.instance_lists[0].vpc_id
        second_subnet_id = vpc_two.instance_lists[0].subnet_id
        sg = tencentcloud.security.Group("sg")
        sg_id = sg.id
        default = tencentcloud.Images.get_instance(image_types=["PUBLIC_IMAGE"],
            image_name_regex="Final")
        image_id = default.image_id
        sg_rule = tencentcloud.security.GroupLiteRule("sgRule",
            security_group_id=sg.id,
            ingresses=[
                "ACCEPT#10.0.0.0/16#ALL#ALL",
                "ACCEPT#172.16.0.0/22#ALL#ALL",
                "DROP#0.0.0.0/0#ALL#ALL",
            ],
            egresses=["ACCEPT#172.16.0.0/22#ALL#ALL"])
        example = tencentcloud.kubernetes.Cluster("example",
            vpc_id=first_vpc_id,
            cluster_cidr=example_cluster_cidr,
            cluster_max_pod_num=32,
            cluster_name="tf_example_cluster",
            cluster_desc="example for tke cluster",
            cluster_max_service_num=32,
            cluster_internet=False,
            cluster_internet_security_group=sg_id,
            cluster_version="1.22.5",
            cluster_deploy_type="MANAGED_CLUSTER",
            worker_configs=[
                tencentcloud.kubernetes.ClusterWorkerConfigArgs(
                    count=1,
                    availability_zone=availability_zone_first,
                    instance_type=default_instance_type,
                    system_disk_type="CLOUD_SSD",
                    system_disk_size=60,
                    internet_charge_type="TRAFFIC_POSTPAID_BY_HOUR",
                    internet_max_bandwidth_out=100,
                    public_ip_assigned=True,
                    subnet_id=first_subnet_id,
                    img_id=image_id,
                    data_disks=[tencentcloud.kubernetes.ClusterWorkerConfigDataDiskArgs(
                        disk_type="CLOUD_PREMIUM",
                        disk_size=50,
                    )],
                    enhanced_security_service=False,
                    enhanced_monitor_service=False,
                    user_data="dGVzdA==",
                    password="ZZXXccvv1212",
                ),
                tencentcloud.kubernetes.ClusterWorkerConfigArgs(
                    count=1,
                    availability_zone=availability_zone_second,
                    instance_type=default_instance_type,
                    system_disk_type="CLOUD_SSD",
                    system_disk_size=60,
                    internet_charge_type="TRAFFIC_POSTPAID_BY_HOUR",
                    internet_max_bandwidth_out=100,
                    public_ip_assigned=True,
                    subnet_id=second_subnet_id,
                    data_disks=[tencentcloud.kubernetes.ClusterWorkerConfigDataDiskArgs(
                        disk_type="CLOUD_PREMIUM",
                        disk_size=50,
                    )],
                    enhanced_security_service=False,
                    enhanced_monitor_service=False,
                    user_data="dGVzdA==",
                    cam_role_name="CVM_QcsRole",
                    password="ZZXXccvv1212",
                ),
            ],
            labels={
                "test1": "test1",
                "test2": "test2",
            })
        zone = config.get("zone")
        if zone is None:
            zone = "ap-guangzhou"
        cluster_type = config.get("clusterType")
        if cluster_type is None:
            cluster_type = "tke"
        foo_tmp_instance = tencentcloud.monitor.TmpInstance("fooTmpInstance",
            instance_name="tf-tmp-instance",
            vpc_id=first_vpc_id,
            subnet_id=first_subnet_id,
            data_retention_time=30,
            zone=availability_zone_second,
            tags={
                "createdBy": "terraform",
            })
        # tmp tke bind
        foo_tmp_tke_cluster_agent = tencentcloud.monitor.TmpTkeClusterAgent("fooTmpTkeClusterAgent",
            instance_id=foo_tmp_instance.id,
            agents=tencentcloud.monitor.TmpTkeClusterAgentAgentsArgs(
                region=zone,
                cluster_type=cluster_type,
                cluster_id=example.id,
                enable_external=False,
            ))
        # create monitor template
        foo_tmp_tke_template = tencentcloud.monitor.TmpTkeTemplate("fooTmpTkeTemplate", template=tencentcloud.monitor.TmpTkeTemplateTemplateArgs(
            name="tf-template",
            level="cluster",
            describe="template",
            service_monitors=[tencentcloud.monitor.TmpTkeTemplateTemplateServiceMonitorArgs(
                name="tf-ServiceMonitor",
                config=\"\"\"apiVersion: monitoring.coreos.com/v1
        kind: ServiceMonitor
        metadata:
          name: example-service-monitor
          namespace: monitoring
          labels:
            k8s-app: example-service
        spec:
          selector:
            matchLabels:
              k8s-app: example-service
          namespaceSelector:
            matchNames:
              - default
          endpoints:
          - port: http-metrics
            interval: 30s
            path: /metrics
            scheme: http
            bearerTokenFile: /var/run/secrets/kubernetes.io/serviceaccount/token
            tlsConfig:
              insecureSkipVerify: true
        \"\"\",
            )],
            pod_monitors=[
                tencentcloud.monitor.TmpTkeTemplateTemplatePodMonitorArgs(
                    name="tf-PodMonitors",
                    config=\"\"\"apiVersion: monitoring.coreos.com/v1
        kind: PodMonitor
        metadata:
          name: example-pod-monitor
          namespace: monitoring
          labels:
            k8s-app: example-pod
        spec:
          selector:
            matchLabels:
              k8s-app: example-pod
          namespaceSelector:
            matchNames:
              - default
          podMetricsEndpoints:
          - port: http-metrics
            interval: 30s
            path: /metrics
            scheme: http
            bearerTokenFile: /var/run/secrets/kubernetes.io/serviceaccount/token
            tlsConfig:
              insecureSkipVerify: true
        \"\"\",
                ),
                tencentcloud.monitor.TmpTkeTemplateTemplatePodMonitorArgs(
                    name="tf-RawJobs",
                    config=\"\"\"scrape_configs:
          - job_name: 'example-job'
            scrape_interval: 30s
            static_configs:
              - targets: ['example-service.default.svc.cluster.local:8080']
            metrics_path: /metrics
            scheme: http
            bearer_token_file: /var/run/secrets/kubernetes.io/serviceaccount/token
            tls_config:
              insecure_skip_verify: true
        \"\"\",
                ),
            ],
        ))
        temp_attachment = tencentcloud.monitor.TmpTkeTemplateAttachment("tempAttachment",
            template_id=foo_tmp_tke_template.id,
            targets=tencentcloud.monitor.TmpTkeTemplateAttachmentTargetsArgs(
                cluster_type=cluster_type,
                cluster_id=example.id,
                region=zone,
                instance_id=foo_tmp_instance.id,
            ),
            opts=pulumi.ResourceOptions(depends_on=[foo_tmp_tke_cluster_agent]))
        ```

        :param str resource_name: The name of the resource.
        :param TmpTkeTemplateAttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TmpTkeTemplateAttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 targets: Optional[pulumi.Input[pulumi.InputType['TmpTkeTemplateAttachmentTargetsArgs']]] = None,
                 template_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TmpTkeTemplateAttachmentArgs.__new__(TmpTkeTemplateAttachmentArgs)

            if targets is None and not opts.urn:
                raise TypeError("Missing required property 'targets'")
            __props__.__dict__["targets"] = targets
            if template_id is None and not opts.urn:
                raise TypeError("Missing required property 'template_id'")
            __props__.__dict__["template_id"] = template_id
        super(TmpTkeTemplateAttachment, __self__).__init__(
            'tencentcloud:Monitor/tmpTkeTemplateAttachment:TmpTkeTemplateAttachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            targets: Optional[pulumi.Input[pulumi.InputType['TmpTkeTemplateAttachmentTargetsArgs']]] = None,
            template_id: Optional[pulumi.Input[str]] = None) -> 'TmpTkeTemplateAttachment':
        """
        Get an existing TmpTkeTemplateAttachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['TmpTkeTemplateAttachmentTargetsArgs']] targets: Sync target details.
        :param pulumi.Input[str] template_id: The ID of the template, which is used for the outgoing reference.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TmpTkeTemplateAttachmentState.__new__(_TmpTkeTemplateAttachmentState)

        __props__.__dict__["targets"] = targets
        __props__.__dict__["template_id"] = template_id
        return TmpTkeTemplateAttachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def targets(self) -> pulumi.Output['outputs.TmpTkeTemplateAttachmentTargets']:
        """
        Sync target details.
        """
        return pulumi.get(self, "targets")

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> pulumi.Output[str]:
        """
        The ID of the template, which is used for the outgoing reference.
        """
        return pulumi.get(self, "template_id")

