# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['TranscodeTemplateArgs', 'TranscodeTemplate']

@pulumi.input_type
class TranscodeTemplateArgs:
    def __init__(__self__, *,
                 container: pulumi.Input[str],
                 audio_template: Optional[pulumi.Input['TranscodeTemplateAudioTemplateArgs']] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 enhance_config: Optional[pulumi.Input['TranscodeTemplateEnhanceConfigArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 remove_audio: Optional[pulumi.Input[int]] = None,
                 remove_video: Optional[pulumi.Input[int]] = None,
                 tehd_config: Optional[pulumi.Input['TranscodeTemplateTehdConfigArgs']] = None,
                 video_template: Optional[pulumi.Input['TranscodeTemplateVideoTemplateArgs']] = None):
        """
        The set of arguments for constructing a TranscodeTemplate resource.
        :param pulumi.Input[str] container: Encapsulation format, optional values: mp4, flv, hls, mp3, flac, ogg, m4a. Among them, mp3, flac, ogg, m4a are pure audio files.
        :param pulumi.Input['TranscodeTemplateAudioTemplateArgs'] audio_template: Audio stream configuration parameters, when RemoveAudio is 0, this field is required.
        :param pulumi.Input[str] comment: Template description information, length limit: 256 characters.
        :param pulumi.Input['TranscodeTemplateEnhanceConfigArgs'] enhance_config: Audio and video enhancement configuration.
        :param pulumi.Input[str] name: Transcoding template name, length limit: 64 characters.
        :param pulumi.Input[int] remove_audio: Whether to remove audio data, value:0: reserved.1: remove.Default: 0.
        :param pulumi.Input[int] remove_video: Whether to remove video data, value:0: reserved.1: remove.Default: 0.
        :param pulumi.Input['TranscodeTemplateTehdConfigArgs'] tehd_config: Ultra-fast HD transcoding parameters.
        :param pulumi.Input['TranscodeTemplateVideoTemplateArgs'] video_template: Video stream configuration parameters, when RemoveVideo is 0, this field is required.
        """
        pulumi.set(__self__, "container", container)
        if audio_template is not None:
            pulumi.set(__self__, "audio_template", audio_template)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if enhance_config is not None:
            pulumi.set(__self__, "enhance_config", enhance_config)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if remove_audio is not None:
            pulumi.set(__self__, "remove_audio", remove_audio)
        if remove_video is not None:
            pulumi.set(__self__, "remove_video", remove_video)
        if tehd_config is not None:
            pulumi.set(__self__, "tehd_config", tehd_config)
        if video_template is not None:
            pulumi.set(__self__, "video_template", video_template)

    @property
    @pulumi.getter
    def container(self) -> pulumi.Input[str]:
        """
        Encapsulation format, optional values: mp4, flv, hls, mp3, flac, ogg, m4a. Among them, mp3, flac, ogg, m4a are pure audio files.
        """
        return pulumi.get(self, "container")

    @container.setter
    def container(self, value: pulumi.Input[str]):
        pulumi.set(self, "container", value)

    @property
    @pulumi.getter(name="audioTemplate")
    def audio_template(self) -> Optional[pulumi.Input['TranscodeTemplateAudioTemplateArgs']]:
        """
        Audio stream configuration parameters, when RemoveAudio is 0, this field is required.
        """
        return pulumi.get(self, "audio_template")

    @audio_template.setter
    def audio_template(self, value: Optional[pulumi.Input['TranscodeTemplateAudioTemplateArgs']]):
        pulumi.set(self, "audio_template", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Template description information, length limit: 256 characters.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter(name="enhanceConfig")
    def enhance_config(self) -> Optional[pulumi.Input['TranscodeTemplateEnhanceConfigArgs']]:
        """
        Audio and video enhancement configuration.
        """
        return pulumi.get(self, "enhance_config")

    @enhance_config.setter
    def enhance_config(self, value: Optional[pulumi.Input['TranscodeTemplateEnhanceConfigArgs']]):
        pulumi.set(self, "enhance_config", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Transcoding template name, length limit: 64 characters.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="removeAudio")
    def remove_audio(self) -> Optional[pulumi.Input[int]]:
        """
        Whether to remove audio data, value:0: reserved.1: remove.Default: 0.
        """
        return pulumi.get(self, "remove_audio")

    @remove_audio.setter
    def remove_audio(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "remove_audio", value)

    @property
    @pulumi.getter(name="removeVideo")
    def remove_video(self) -> Optional[pulumi.Input[int]]:
        """
        Whether to remove video data, value:0: reserved.1: remove.Default: 0.
        """
        return pulumi.get(self, "remove_video")

    @remove_video.setter
    def remove_video(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "remove_video", value)

    @property
    @pulumi.getter(name="tehdConfig")
    def tehd_config(self) -> Optional[pulumi.Input['TranscodeTemplateTehdConfigArgs']]:
        """
        Ultra-fast HD transcoding parameters.
        """
        return pulumi.get(self, "tehd_config")

    @tehd_config.setter
    def tehd_config(self, value: Optional[pulumi.Input['TranscodeTemplateTehdConfigArgs']]):
        pulumi.set(self, "tehd_config", value)

    @property
    @pulumi.getter(name="videoTemplate")
    def video_template(self) -> Optional[pulumi.Input['TranscodeTemplateVideoTemplateArgs']]:
        """
        Video stream configuration parameters, when RemoveVideo is 0, this field is required.
        """
        return pulumi.get(self, "video_template")

    @video_template.setter
    def video_template(self, value: Optional[pulumi.Input['TranscodeTemplateVideoTemplateArgs']]):
        pulumi.set(self, "video_template", value)


@pulumi.input_type
class _TranscodeTemplateState:
    def __init__(__self__, *,
                 audio_template: Optional[pulumi.Input['TranscodeTemplateAudioTemplateArgs']] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 container: Optional[pulumi.Input[str]] = None,
                 enhance_config: Optional[pulumi.Input['TranscodeTemplateEnhanceConfigArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 remove_audio: Optional[pulumi.Input[int]] = None,
                 remove_video: Optional[pulumi.Input[int]] = None,
                 tehd_config: Optional[pulumi.Input['TranscodeTemplateTehdConfigArgs']] = None,
                 video_template: Optional[pulumi.Input['TranscodeTemplateVideoTemplateArgs']] = None):
        """
        Input properties used for looking up and filtering TranscodeTemplate resources.
        :param pulumi.Input['TranscodeTemplateAudioTemplateArgs'] audio_template: Audio stream configuration parameters, when RemoveAudio is 0, this field is required.
        :param pulumi.Input[str] comment: Template description information, length limit: 256 characters.
        :param pulumi.Input[str] container: Encapsulation format, optional values: mp4, flv, hls, mp3, flac, ogg, m4a. Among them, mp3, flac, ogg, m4a are pure audio files.
        :param pulumi.Input['TranscodeTemplateEnhanceConfigArgs'] enhance_config: Audio and video enhancement configuration.
        :param pulumi.Input[str] name: Transcoding template name, length limit: 64 characters.
        :param pulumi.Input[int] remove_audio: Whether to remove audio data, value:0: reserved.1: remove.Default: 0.
        :param pulumi.Input[int] remove_video: Whether to remove video data, value:0: reserved.1: remove.Default: 0.
        :param pulumi.Input['TranscodeTemplateTehdConfigArgs'] tehd_config: Ultra-fast HD transcoding parameters.
        :param pulumi.Input['TranscodeTemplateVideoTemplateArgs'] video_template: Video stream configuration parameters, when RemoveVideo is 0, this field is required.
        """
        if audio_template is not None:
            pulumi.set(__self__, "audio_template", audio_template)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if container is not None:
            pulumi.set(__self__, "container", container)
        if enhance_config is not None:
            pulumi.set(__self__, "enhance_config", enhance_config)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if remove_audio is not None:
            pulumi.set(__self__, "remove_audio", remove_audio)
        if remove_video is not None:
            pulumi.set(__self__, "remove_video", remove_video)
        if tehd_config is not None:
            pulumi.set(__self__, "tehd_config", tehd_config)
        if video_template is not None:
            pulumi.set(__self__, "video_template", video_template)

    @property
    @pulumi.getter(name="audioTemplate")
    def audio_template(self) -> Optional[pulumi.Input['TranscodeTemplateAudioTemplateArgs']]:
        """
        Audio stream configuration parameters, when RemoveAudio is 0, this field is required.
        """
        return pulumi.get(self, "audio_template")

    @audio_template.setter
    def audio_template(self, value: Optional[pulumi.Input['TranscodeTemplateAudioTemplateArgs']]):
        pulumi.set(self, "audio_template", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Template description information, length limit: 256 characters.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def container(self) -> Optional[pulumi.Input[str]]:
        """
        Encapsulation format, optional values: mp4, flv, hls, mp3, flac, ogg, m4a. Among them, mp3, flac, ogg, m4a are pure audio files.
        """
        return pulumi.get(self, "container")

    @container.setter
    def container(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "container", value)

    @property
    @pulumi.getter(name="enhanceConfig")
    def enhance_config(self) -> Optional[pulumi.Input['TranscodeTemplateEnhanceConfigArgs']]:
        """
        Audio and video enhancement configuration.
        """
        return pulumi.get(self, "enhance_config")

    @enhance_config.setter
    def enhance_config(self, value: Optional[pulumi.Input['TranscodeTemplateEnhanceConfigArgs']]):
        pulumi.set(self, "enhance_config", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Transcoding template name, length limit: 64 characters.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="removeAudio")
    def remove_audio(self) -> Optional[pulumi.Input[int]]:
        """
        Whether to remove audio data, value:0: reserved.1: remove.Default: 0.
        """
        return pulumi.get(self, "remove_audio")

    @remove_audio.setter
    def remove_audio(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "remove_audio", value)

    @property
    @pulumi.getter(name="removeVideo")
    def remove_video(self) -> Optional[pulumi.Input[int]]:
        """
        Whether to remove video data, value:0: reserved.1: remove.Default: 0.
        """
        return pulumi.get(self, "remove_video")

    @remove_video.setter
    def remove_video(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "remove_video", value)

    @property
    @pulumi.getter(name="tehdConfig")
    def tehd_config(self) -> Optional[pulumi.Input['TranscodeTemplateTehdConfigArgs']]:
        """
        Ultra-fast HD transcoding parameters.
        """
        return pulumi.get(self, "tehd_config")

    @tehd_config.setter
    def tehd_config(self, value: Optional[pulumi.Input['TranscodeTemplateTehdConfigArgs']]):
        pulumi.set(self, "tehd_config", value)

    @property
    @pulumi.getter(name="videoTemplate")
    def video_template(self) -> Optional[pulumi.Input['TranscodeTemplateVideoTemplateArgs']]:
        """
        Video stream configuration parameters, when RemoveVideo is 0, this field is required.
        """
        return pulumi.get(self, "video_template")

    @video_template.setter
    def video_template(self, value: Optional[pulumi.Input['TranscodeTemplateVideoTemplateArgs']]):
        pulumi.set(self, "video_template", value)


class TranscodeTemplate(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 audio_template: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateAudioTemplateArgs']]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 container: Optional[pulumi.Input[str]] = None,
                 enhance_config: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateEnhanceConfigArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 remove_audio: Optional[pulumi.Input[int]] = None,
                 remove_video: Optional[pulumi.Input[int]] = None,
                 tehd_config: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateTehdConfigArgs']]] = None,
                 video_template: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateVideoTemplateArgs']]] = None,
                 __props__=None):
        """
        Provides a resource to create a mps transcode_template

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        transcode_template = tencentcloud.mps.TranscodeTemplate("transcodeTemplate",
            audio_template=tencentcloud.mps.TranscodeTemplateAudioTemplateArgs(
                audio_channel=2,
                bitrate=27,
                codec="libfdk_aac",
                sample_rate=32000,
            ),
            container="mp4",
            remove_audio=0,
            remove_video=0,
            video_template=tencentcloud.mps.TranscodeTemplateVideoTemplateArgs(
                bitrate=130,
                codec="libx264",
                fill_type="black",
                fps=20,
                gop=0,
                height=4096,
                resolution_adaptive="close",
                vcrf=0,
                width=128,
            ))
        ```

        ## Import

        mps transcode_template can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Mps/transcodeTemplate:TranscodeTemplate transcode_template transcode_template_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['TranscodeTemplateAudioTemplateArgs']] audio_template: Audio stream configuration parameters, when RemoveAudio is 0, this field is required.
        :param pulumi.Input[str] comment: Template description information, length limit: 256 characters.
        :param pulumi.Input[str] container: Encapsulation format, optional values: mp4, flv, hls, mp3, flac, ogg, m4a. Among them, mp3, flac, ogg, m4a are pure audio files.
        :param pulumi.Input[pulumi.InputType['TranscodeTemplateEnhanceConfigArgs']] enhance_config: Audio and video enhancement configuration.
        :param pulumi.Input[str] name: Transcoding template name, length limit: 64 characters.
        :param pulumi.Input[int] remove_audio: Whether to remove audio data, value:0: reserved.1: remove.Default: 0.
        :param pulumi.Input[int] remove_video: Whether to remove video data, value:0: reserved.1: remove.Default: 0.
        :param pulumi.Input[pulumi.InputType['TranscodeTemplateTehdConfigArgs']] tehd_config: Ultra-fast HD transcoding parameters.
        :param pulumi.Input[pulumi.InputType['TranscodeTemplateVideoTemplateArgs']] video_template: Video stream configuration parameters, when RemoveVideo is 0, this field is required.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TranscodeTemplateArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a mps transcode_template

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        transcode_template = tencentcloud.mps.TranscodeTemplate("transcodeTemplate",
            audio_template=tencentcloud.mps.TranscodeTemplateAudioTemplateArgs(
                audio_channel=2,
                bitrate=27,
                codec="libfdk_aac",
                sample_rate=32000,
            ),
            container="mp4",
            remove_audio=0,
            remove_video=0,
            video_template=tencentcloud.mps.TranscodeTemplateVideoTemplateArgs(
                bitrate=130,
                codec="libx264",
                fill_type="black",
                fps=20,
                gop=0,
                height=4096,
                resolution_adaptive="close",
                vcrf=0,
                width=128,
            ))
        ```

        ## Import

        mps transcode_template can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Mps/transcodeTemplate:TranscodeTemplate transcode_template transcode_template_id
        ```

        :param str resource_name: The name of the resource.
        :param TranscodeTemplateArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TranscodeTemplateArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 audio_template: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateAudioTemplateArgs']]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 container: Optional[pulumi.Input[str]] = None,
                 enhance_config: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateEnhanceConfigArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 remove_audio: Optional[pulumi.Input[int]] = None,
                 remove_video: Optional[pulumi.Input[int]] = None,
                 tehd_config: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateTehdConfigArgs']]] = None,
                 video_template: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateVideoTemplateArgs']]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TranscodeTemplateArgs.__new__(TranscodeTemplateArgs)

            __props__.__dict__["audio_template"] = audio_template
            __props__.__dict__["comment"] = comment
            if container is None and not opts.urn:
                raise TypeError("Missing required property 'container'")
            __props__.__dict__["container"] = container
            __props__.__dict__["enhance_config"] = enhance_config
            __props__.__dict__["name"] = name
            __props__.__dict__["remove_audio"] = remove_audio
            __props__.__dict__["remove_video"] = remove_video
            __props__.__dict__["tehd_config"] = tehd_config
            __props__.__dict__["video_template"] = video_template
        super(TranscodeTemplate, __self__).__init__(
            'tencentcloud:Mps/transcodeTemplate:TranscodeTemplate',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            audio_template: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateAudioTemplateArgs']]] = None,
            comment: Optional[pulumi.Input[str]] = None,
            container: Optional[pulumi.Input[str]] = None,
            enhance_config: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateEnhanceConfigArgs']]] = None,
            name: Optional[pulumi.Input[str]] = None,
            remove_audio: Optional[pulumi.Input[int]] = None,
            remove_video: Optional[pulumi.Input[int]] = None,
            tehd_config: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateTehdConfigArgs']]] = None,
            video_template: Optional[pulumi.Input[pulumi.InputType['TranscodeTemplateVideoTemplateArgs']]] = None) -> 'TranscodeTemplate':
        """
        Get an existing TranscodeTemplate resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['TranscodeTemplateAudioTemplateArgs']] audio_template: Audio stream configuration parameters, when RemoveAudio is 0, this field is required.
        :param pulumi.Input[str] comment: Template description information, length limit: 256 characters.
        :param pulumi.Input[str] container: Encapsulation format, optional values: mp4, flv, hls, mp3, flac, ogg, m4a. Among them, mp3, flac, ogg, m4a are pure audio files.
        :param pulumi.Input[pulumi.InputType['TranscodeTemplateEnhanceConfigArgs']] enhance_config: Audio and video enhancement configuration.
        :param pulumi.Input[str] name: Transcoding template name, length limit: 64 characters.
        :param pulumi.Input[int] remove_audio: Whether to remove audio data, value:0: reserved.1: remove.Default: 0.
        :param pulumi.Input[int] remove_video: Whether to remove video data, value:0: reserved.1: remove.Default: 0.
        :param pulumi.Input[pulumi.InputType['TranscodeTemplateTehdConfigArgs']] tehd_config: Ultra-fast HD transcoding parameters.
        :param pulumi.Input[pulumi.InputType['TranscodeTemplateVideoTemplateArgs']] video_template: Video stream configuration parameters, when RemoveVideo is 0, this field is required.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TranscodeTemplateState.__new__(_TranscodeTemplateState)

        __props__.__dict__["audio_template"] = audio_template
        __props__.__dict__["comment"] = comment
        __props__.__dict__["container"] = container
        __props__.__dict__["enhance_config"] = enhance_config
        __props__.__dict__["name"] = name
        __props__.__dict__["remove_audio"] = remove_audio
        __props__.__dict__["remove_video"] = remove_video
        __props__.__dict__["tehd_config"] = tehd_config
        __props__.__dict__["video_template"] = video_template
        return TranscodeTemplate(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="audioTemplate")
    def audio_template(self) -> pulumi.Output[Optional['outputs.TranscodeTemplateAudioTemplate']]:
        """
        Audio stream configuration parameters, when RemoveAudio is 0, this field is required.
        """
        return pulumi.get(self, "audio_template")

    @property
    @pulumi.getter
    def comment(self) -> pulumi.Output[Optional[str]]:
        """
        Template description information, length limit: 256 characters.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def container(self) -> pulumi.Output[str]:
        """
        Encapsulation format, optional values: mp4, flv, hls, mp3, flac, ogg, m4a. Among them, mp3, flac, ogg, m4a are pure audio files.
        """
        return pulumi.get(self, "container")

    @property
    @pulumi.getter(name="enhanceConfig")
    def enhance_config(self) -> pulumi.Output[Optional['outputs.TranscodeTemplateEnhanceConfig']]:
        """
        Audio and video enhancement configuration.
        """
        return pulumi.get(self, "enhance_config")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Transcoding template name, length limit: 64 characters.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="removeAudio")
    def remove_audio(self) -> pulumi.Output[Optional[int]]:
        """
        Whether to remove audio data, value:0: reserved.1: remove.Default: 0.
        """
        return pulumi.get(self, "remove_audio")

    @property
    @pulumi.getter(name="removeVideo")
    def remove_video(self) -> pulumi.Output[Optional[int]]:
        """
        Whether to remove video data, value:0: reserved.1: remove.Default: 0.
        """
        return pulumi.get(self, "remove_video")

    @property
    @pulumi.getter(name="tehdConfig")
    def tehd_config(self) -> pulumi.Output[Optional['outputs.TranscodeTemplateTehdConfig']]:
        """
        Ultra-fast HD transcoding parameters.
        """
        return pulumi.get(self, "tehd_config")

    @property
    @pulumi.getter(name="videoTemplate")
    def video_template(self) -> pulumi.Output[Optional['outputs.TranscodeTemplateVideoTemplate']]:
        """
        Video stream configuration parameters, when RemoveVideo is 0, this field is required.
        """
        return pulumi.get(self, "video_template")

