# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetBinlogBackupOverviewResult',
    'AwaitableGetBinlogBackupOverviewResult',
    'get_binlog_backup_overview',
    'get_binlog_backup_overview_output',
]

@pulumi.output_type
class GetBinlogBackupOverviewResult:
    """
    A collection of values returned by getBinlogBackupOverview.
    """
    def __init__(__self__, binlog_archive_count=None, binlog_archive_volume=None, binlog_backup_count=None, binlog_backup_volume=None, binlog_standby_count=None, binlog_standby_volume=None, id=None, product=None, remote_binlog_count=None, remote_binlog_volume=None, result_output_file=None):
        if binlog_archive_count and not isinstance(binlog_archive_count, int):
            raise TypeError("Expected argument 'binlog_archive_count' to be a int")
        pulumi.set(__self__, "binlog_archive_count", binlog_archive_count)
        if binlog_archive_volume and not isinstance(binlog_archive_volume, int):
            raise TypeError("Expected argument 'binlog_archive_volume' to be a int")
        pulumi.set(__self__, "binlog_archive_volume", binlog_archive_volume)
        if binlog_backup_count and not isinstance(binlog_backup_count, int):
            raise TypeError("Expected argument 'binlog_backup_count' to be a int")
        pulumi.set(__self__, "binlog_backup_count", binlog_backup_count)
        if binlog_backup_volume and not isinstance(binlog_backup_volume, int):
            raise TypeError("Expected argument 'binlog_backup_volume' to be a int")
        pulumi.set(__self__, "binlog_backup_volume", binlog_backup_volume)
        if binlog_standby_count and not isinstance(binlog_standby_count, int):
            raise TypeError("Expected argument 'binlog_standby_count' to be a int")
        pulumi.set(__self__, "binlog_standby_count", binlog_standby_count)
        if binlog_standby_volume and not isinstance(binlog_standby_volume, int):
            raise TypeError("Expected argument 'binlog_standby_volume' to be a int")
        pulumi.set(__self__, "binlog_standby_volume", binlog_standby_volume)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if product and not isinstance(product, str):
            raise TypeError("Expected argument 'product' to be a str")
        pulumi.set(__self__, "product", product)
        if remote_binlog_count and not isinstance(remote_binlog_count, int):
            raise TypeError("Expected argument 'remote_binlog_count' to be a int")
        pulumi.set(__self__, "remote_binlog_count", remote_binlog_count)
        if remote_binlog_volume and not isinstance(remote_binlog_volume, int):
            raise TypeError("Expected argument 'remote_binlog_volume' to be a int")
        pulumi.set(__self__, "remote_binlog_volume", remote_binlog_volume)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="binlogArchiveCount")
    def binlog_archive_count(self) -> int:
        """
        The number of archived log backups.
        """
        return pulumi.get(self, "binlog_archive_count")

    @property
    @pulumi.getter(name="binlogArchiveVolume")
    def binlog_archive_volume(self) -> int:
        """
        Archived log backup capacity (in bytes).
        """
        return pulumi.get(self, "binlog_archive_volume")

    @property
    @pulumi.getter(name="binlogBackupCount")
    def binlog_backup_count(self) -> int:
        """
        The total number of log backups, including remote log backups.
        """
        return pulumi.get(self, "binlog_backup_count")

    @property
    @pulumi.getter(name="binlogBackupVolume")
    def binlog_backup_volume(self) -> int:
        """
        Total log backup capacity, including off-site log backup (unit is byte).
        """
        return pulumi.get(self, "binlog_backup_volume")

    @property
    @pulumi.getter(name="binlogStandbyCount")
    def binlog_standby_count(self) -> int:
        """
        The number of standard storage log backups.
        """
        return pulumi.get(self, "binlog_standby_count")

    @property
    @pulumi.getter(name="binlogStandbyVolume")
    def binlog_standby_volume(self) -> int:
        """
        Standard storage log backup capacity (in bytes).
        """
        return pulumi.get(self, "binlog_standby_volume")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def product(self) -> str:
        return pulumi.get(self, "product")

    @property
    @pulumi.getter(name="remoteBinlogCount")
    def remote_binlog_count(self) -> int:
        """
        The number of remote log backups.
        """
        return pulumi.get(self, "remote_binlog_count")

    @property
    @pulumi.getter(name="remoteBinlogVolume")
    def remote_binlog_volume(self) -> int:
        """
        Remote log backup capacity (in bytes).
        """
        return pulumi.get(self, "remote_binlog_volume")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetBinlogBackupOverviewResult(GetBinlogBackupOverviewResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBinlogBackupOverviewResult(
            binlog_archive_count=self.binlog_archive_count,
            binlog_archive_volume=self.binlog_archive_volume,
            binlog_backup_count=self.binlog_backup_count,
            binlog_backup_volume=self.binlog_backup_volume,
            binlog_standby_count=self.binlog_standby_count,
            binlog_standby_volume=self.binlog_standby_volume,
            id=self.id,
            product=self.product,
            remote_binlog_count=self.remote_binlog_count,
            remote_binlog_volume=self.remote_binlog_volume,
            result_output_file=self.result_output_file)


def get_binlog_backup_overview(product: Optional[str] = None,
                               result_output_file: Optional[str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBinlogBackupOverviewResult:
    """
    Use this data source to query detailed information of mysql binlog_backup_overview

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    binlog_backup_overview = tencentcloud.Mysql.get_binlog_backup_overview(product="mysql")
    ```


    :param str product: The type of cloud database product to be queried, currently only supports `mysql`.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['product'] = product
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Mysql/getBinlogBackupOverview:getBinlogBackupOverview', __args__, opts=opts, typ=GetBinlogBackupOverviewResult).value

    return AwaitableGetBinlogBackupOverviewResult(
        binlog_archive_count=__ret__.binlog_archive_count,
        binlog_archive_volume=__ret__.binlog_archive_volume,
        binlog_backup_count=__ret__.binlog_backup_count,
        binlog_backup_volume=__ret__.binlog_backup_volume,
        binlog_standby_count=__ret__.binlog_standby_count,
        binlog_standby_volume=__ret__.binlog_standby_volume,
        id=__ret__.id,
        product=__ret__.product,
        remote_binlog_count=__ret__.remote_binlog_count,
        remote_binlog_volume=__ret__.remote_binlog_volume,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_binlog_backup_overview)
def get_binlog_backup_overview_output(product: Optional[pulumi.Input[str]] = None,
                                      result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetBinlogBackupOverviewResult]:
    """
    Use this data source to query detailed information of mysql binlog_backup_overview

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    binlog_backup_overview = tencentcloud.Mysql.get_binlog_backup_overview(product="mysql")
    ```


    :param str product: The type of cloud database product to be queried, currently only supports `mysql`.
    :param str result_output_file: Used to save results.
    """
    ...
