# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDatabasesResult',
    'AwaitableGetDatabasesResult',
    'get_databases',
    'get_databases_output',
]

@pulumi.output_type
class GetDatabasesResult:
    """
    A collection of values returned by getDatabases.
    """
    def __init__(__self__, database_lists=None, database_regexp=None, id=None, instance_id=None, items=None, limit=None, offset=None, result_output_file=None):
        if database_lists and not isinstance(database_lists, list):
            raise TypeError("Expected argument 'database_lists' to be a list")
        pulumi.set(__self__, "database_lists", database_lists)
        if database_regexp and not isinstance(database_regexp, str):
            raise TypeError("Expected argument 'database_regexp' to be a str")
        pulumi.set(__self__, "database_regexp", database_regexp)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if limit and not isinstance(limit, int):
            raise TypeError("Expected argument 'limit' to be a int")
        pulumi.set(__self__, "limit", limit)
        if offset and not isinstance(offset, int):
            raise TypeError("Expected argument 'offset' to be a int")
        pulumi.set(__self__, "offset", offset)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="databaseLists")
    def database_lists(self) -> Sequence['outputs.GetDatabasesDatabaseListResult']:
        """
        Database name and character set.
        """
        return pulumi.get(self, "database_lists")

    @property
    @pulumi.getter(name="databaseRegexp")
    def database_regexp(self) -> Optional[str]:
        return pulumi.get(self, "database_regexp")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def items(self) -> Sequence[str]:
        """
        Returned instance information.
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter
    def limit(self) -> Optional[int]:
        return pulumi.get(self, "limit")

    @property
    @pulumi.getter
    def offset(self) -> Optional[int]:
        return pulumi.get(self, "offset")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetDatabasesResult(GetDatabasesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDatabasesResult(
            database_lists=self.database_lists,
            database_regexp=self.database_regexp,
            id=self.id,
            instance_id=self.instance_id,
            items=self.items,
            limit=self.limit,
            offset=self.offset,
            result_output_file=self.result_output_file)


def get_databases(database_regexp: Optional[str] = None,
                  instance_id: Optional[str] = None,
                  limit: Optional[int] = None,
                  offset: Optional[int] = None,
                  result_output_file: Optional[str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDatabasesResult:
    """
    Use this data source to query detailed information of mysql databases

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    databases = tencentcloud.Mysql.get_databases(database_regexp="",
        instance_id="cdb-c1nl9rpv")
    ```


    :param str database_regexp: Regular expression to match database library names.
    :param str instance_id: The ID of instance.
    :param int limit: The number of single requests, the default value is 20, the minimum value is 1, and the maximum value is 100.
    :param int offset: Page offset.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['databaseRegexp'] = database_regexp
    __args__['instanceId'] = instance_id
    __args__['limit'] = limit
    __args__['offset'] = offset
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Mysql/getDatabases:getDatabases', __args__, opts=opts, typ=GetDatabasesResult).value

    return AwaitableGetDatabasesResult(
        database_lists=__ret__.database_lists,
        database_regexp=__ret__.database_regexp,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        items=__ret__.items,
        limit=__ret__.limit,
        offset=__ret__.offset,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_databases)
def get_databases_output(database_regexp: Optional[pulumi.Input[Optional[str]]] = None,
                         instance_id: Optional[pulumi.Input[str]] = None,
                         limit: Optional[pulumi.Input[Optional[int]]] = None,
                         offset: Optional[pulumi.Input[Optional[int]]] = None,
                         result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDatabasesResult]:
    """
    Use this data source to query detailed information of mysql databases

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    databases = tencentcloud.Mysql.get_databases(database_regexp="",
        instance_id="cdb-c1nl9rpv")
    ```


    :param str database_regexp: Regular expression to match database library names.
    :param str instance_id: The ID of instance.
    :param int limit: The number of single requests, the default value is 20, the minimum value is 1, and the maximum value is 100.
    :param int offset: Page offset.
    :param str result_output_file: Used to save results.
    """
    ...
