# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInstanceParamRecordResult',
    'AwaitableGetInstanceParamRecordResult',
    'get_instance_param_record',
    'get_instance_param_record_output',
]

@pulumi.output_type
class GetInstanceParamRecordResult:
    """
    A collection of values returned by getInstanceParamRecord.
    """
    def __init__(__self__, id=None, instance_id=None, items=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetInstanceParamRecordItemResult']:
        """
        Parameter modification record.
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetInstanceParamRecordResult(GetInstanceParamRecordResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInstanceParamRecordResult(
            id=self.id,
            instance_id=self.instance_id,
            items=self.items,
            result_output_file=self.result_output_file)


def get_instance_param_record(instance_id: Optional[str] = None,
                              result_output_file: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInstanceParamRecordResult:
    """
    Use this data source to query detailed information of mysql instance_param_record

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    instance_param_record = tencentcloud.Mysql.get_instance_param_record(instance_id="")
    ```


    :param str instance_id: Instance ID, the format is: cdb-c1nl9rpv, which is the same as the instance ID displayed on the cloud database console page, and you can use the [query instance list] (https://cloud.tencent.com/document/api/236/15872) interface Gets the value of the field InstanceId in the output parameter.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Mysql/getInstanceParamRecord:getInstanceParamRecord', __args__, opts=opts, typ=GetInstanceParamRecordResult).value

    return AwaitableGetInstanceParamRecordResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        items=__ret__.items,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_instance_param_record)
def get_instance_param_record_output(instance_id: Optional[pulumi.Input[str]] = None,
                                     result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInstanceParamRecordResult]:
    """
    Use this data source to query detailed information of mysql instance_param_record

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    instance_param_record = tencentcloud.Mysql.get_instance_param_record(instance_id="")
    ```


    :param str instance_id: Instance ID, the format is: cdb-c1nl9rpv, which is the same as the instance ID displayed on the cloud database console page, and you can use the [query instance list] (https://cloud.tencent.com/document/api/236/15872) interface Gets the value of the field InstanceId in the output parameter.
    :param str result_output_file: Used to save results.
    """
    ...
