# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetBackupDownloadUrlsResult',
    'AwaitableGetBackupDownloadUrlsResult',
    'get_backup_download_urls',
    'get_backup_download_urls_output',
]

@pulumi.output_type
class GetBackupDownloadUrlsResult:
    """
    A collection of values returned by getBackupDownloadUrls.
    """
    def __init__(__self__, backup_download_restriction=None, backup_download_url=None, backup_id=None, backup_type=None, db_instance_id=None, id=None, result_output_file=None, url_expire_time=None):
        if backup_download_restriction and not isinstance(backup_download_restriction, dict):
            raise TypeError("Expected argument 'backup_download_restriction' to be a dict")
        pulumi.set(__self__, "backup_download_restriction", backup_download_restriction)
        if backup_download_url and not isinstance(backup_download_url, str):
            raise TypeError("Expected argument 'backup_download_url' to be a str")
        pulumi.set(__self__, "backup_download_url", backup_download_url)
        if backup_id and not isinstance(backup_id, str):
            raise TypeError("Expected argument 'backup_id' to be a str")
        pulumi.set(__self__, "backup_id", backup_id)
        if backup_type and not isinstance(backup_type, str):
            raise TypeError("Expected argument 'backup_type' to be a str")
        pulumi.set(__self__, "backup_type", backup_type)
        if db_instance_id and not isinstance(db_instance_id, str):
            raise TypeError("Expected argument 'db_instance_id' to be a str")
        pulumi.set(__self__, "db_instance_id", db_instance_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if url_expire_time and not isinstance(url_expire_time, int):
            raise TypeError("Expected argument 'url_expire_time' to be a int")
        pulumi.set(__self__, "url_expire_time", url_expire_time)

    @property
    @pulumi.getter(name="backupDownloadRestriction")
    def backup_download_restriction(self) -> Optional['outputs.GetBackupDownloadUrlsBackupDownloadRestrictionResult']:
        return pulumi.get(self, "backup_download_restriction")

    @property
    @pulumi.getter(name="backupDownloadUrl")
    def backup_download_url(self) -> str:
        """
        Backup download URL.
        """
        return pulumi.get(self, "backup_download_url")

    @property
    @pulumi.getter(name="backupId")
    def backup_id(self) -> str:
        return pulumi.get(self, "backup_id")

    @property
    @pulumi.getter(name="backupType")
    def backup_type(self) -> str:
        return pulumi.get(self, "backup_type")

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> str:
        return pulumi.get(self, "db_instance_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="urlExpireTime")
    def url_expire_time(self) -> Optional[int]:
        return pulumi.get(self, "url_expire_time")


class AwaitableGetBackupDownloadUrlsResult(GetBackupDownloadUrlsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBackupDownloadUrlsResult(
            backup_download_restriction=self.backup_download_restriction,
            backup_download_url=self.backup_download_url,
            backup_id=self.backup_id,
            backup_type=self.backup_type,
            db_instance_id=self.db_instance_id,
            id=self.id,
            result_output_file=self.result_output_file,
            url_expire_time=self.url_expire_time)


def get_backup_download_urls(backup_download_restriction: Optional[pulumi.InputType['GetBackupDownloadUrlsBackupDownloadRestrictionArgs']] = None,
                             backup_id: Optional[str] = None,
                             backup_type: Optional[str] = None,
                             db_instance_id: Optional[str] = None,
                             result_output_file: Optional[str] = None,
                             url_expire_time: Optional[int] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBackupDownloadUrlsResult:
    """
    Use this data source to query detailed information of postgresql backup_download_urls

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    log_backups = tencentcloud.Postgresql.get_log_backups(min_finish_time="%s",
        max_finish_time="%s",
        filters=[tencentcloud.postgresql.GetLogBackupsFilterArgs(
            name="db-instance-id",
            values=[local["pgsql_id"]],
        )],
        order_by="StartTime",
        order_by_type="desc")
    backup_download_urls = tencentcloud.Postgresql.get_backup_download_urls(db_instance_id=local["pgsql_id"],
        backup_type="LogBackup",
        backup_id=log_backups.log_backup_sets[0].id,
        url_expire_time=12,
        backup_download_restriction=tencentcloud.postgresql.GetBackupDownloadUrlsBackupDownloadRestrictionArgs(
            restriction_type="NONE",
            vpc_restriction_effect="ALLOW",
            vpc_id_sets=[local["vpc_id"]],
            ip_restriction_effect="ALLOW",
            ip_sets=["0.0.0.0"],
        ))
    ```


    :param pulumi.InputType['GetBackupDownloadUrlsBackupDownloadRestrictionArgs'] backup_download_restriction: Backup download restriction.
    :param str backup_id: Unique backup ID.
    :param str backup_type: Backup type. Valid values: `LogBackup`, `BaseBackup`.
    :param str db_instance_id: Instance ID.
    :param str result_output_file: Used to save results.
    :param int url_expire_time: Validity period of a URL, which is 12 hours by default.
    """
    __args__ = dict()
    __args__['backupDownloadRestriction'] = backup_download_restriction
    __args__['backupId'] = backup_id
    __args__['backupType'] = backup_type
    __args__['dbInstanceId'] = db_instance_id
    __args__['resultOutputFile'] = result_output_file
    __args__['urlExpireTime'] = url_expire_time
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Postgresql/getBackupDownloadUrls:getBackupDownloadUrls', __args__, opts=opts, typ=GetBackupDownloadUrlsResult).value

    return AwaitableGetBackupDownloadUrlsResult(
        backup_download_restriction=__ret__.backup_download_restriction,
        backup_download_url=__ret__.backup_download_url,
        backup_id=__ret__.backup_id,
        backup_type=__ret__.backup_type,
        db_instance_id=__ret__.db_instance_id,
        id=__ret__.id,
        result_output_file=__ret__.result_output_file,
        url_expire_time=__ret__.url_expire_time)


@_utilities.lift_output_func(get_backup_download_urls)
def get_backup_download_urls_output(backup_download_restriction: Optional[pulumi.Input[Optional[pulumi.InputType['GetBackupDownloadUrlsBackupDownloadRestrictionArgs']]]] = None,
                                    backup_id: Optional[pulumi.Input[str]] = None,
                                    backup_type: Optional[pulumi.Input[str]] = None,
                                    db_instance_id: Optional[pulumi.Input[str]] = None,
                                    result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                    url_expire_time: Optional[pulumi.Input[Optional[int]]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetBackupDownloadUrlsResult]:
    """
    Use this data source to query detailed information of postgresql backup_download_urls

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    log_backups = tencentcloud.Postgresql.get_log_backups(min_finish_time="%s",
        max_finish_time="%s",
        filters=[tencentcloud.postgresql.GetLogBackupsFilterArgs(
            name="db-instance-id",
            values=[local["pgsql_id"]],
        )],
        order_by="StartTime",
        order_by_type="desc")
    backup_download_urls = tencentcloud.Postgresql.get_backup_download_urls(db_instance_id=local["pgsql_id"],
        backup_type="LogBackup",
        backup_id=log_backups.log_backup_sets[0].id,
        url_expire_time=12,
        backup_download_restriction=tencentcloud.postgresql.GetBackupDownloadUrlsBackupDownloadRestrictionArgs(
            restriction_type="NONE",
            vpc_restriction_effect="ALLOW",
            vpc_id_sets=[local["vpc_id"]],
            ip_restriction_effect="ALLOW",
            ip_sets=["0.0.0.0"],
        ))
    ```


    :param pulumi.InputType['GetBackupDownloadUrlsBackupDownloadRestrictionArgs'] backup_download_restriction: Backup download restriction.
    :param str backup_id: Unique backup ID.
    :param str backup_type: Backup type. Valid values: `LogBackup`, `BaseBackup`.
    :param str db_instance_id: Instance ID.
    :param str result_output_file: Used to save results.
    :param int url_expire_time: Validity period of a URL, which is 12 hours by default.
    """
    ...
