# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetBaseBackupsResult',
    'AwaitableGetBaseBackupsResult',
    'get_base_backups',
    'get_base_backups_output',
]

@pulumi.output_type
class GetBaseBackupsResult:
    """
    A collection of values returned by getBaseBackups.
    """
    def __init__(__self__, base_backup_sets=None, filters=None, id=None, max_finish_time=None, min_finish_time=None, order_by=None, order_by_type=None, result_output_file=None):
        if base_backup_sets and not isinstance(base_backup_sets, list):
            raise TypeError("Expected argument 'base_backup_sets' to be a list")
        pulumi.set(__self__, "base_backup_sets", base_backup_sets)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if max_finish_time and not isinstance(max_finish_time, str):
            raise TypeError("Expected argument 'max_finish_time' to be a str")
        pulumi.set(__self__, "max_finish_time", max_finish_time)
        if min_finish_time and not isinstance(min_finish_time, str):
            raise TypeError("Expected argument 'min_finish_time' to be a str")
        pulumi.set(__self__, "min_finish_time", min_finish_time)
        if order_by and not isinstance(order_by, str):
            raise TypeError("Expected argument 'order_by' to be a str")
        pulumi.set(__self__, "order_by", order_by)
        if order_by_type and not isinstance(order_by_type, str):
            raise TypeError("Expected argument 'order_by_type' to be a str")
        pulumi.set(__self__, "order_by_type", order_by_type)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="baseBackupSets")
    def base_backup_sets(self) -> Sequence['outputs.GetBaseBackupsBaseBackupSetResult']:
        """
        List of full backup details.
        """
        return pulumi.get(self, "base_backup_sets")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetBaseBackupsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="maxFinishTime")
    def max_finish_time(self) -> Optional[str]:
        return pulumi.get(self, "max_finish_time")

    @property
    @pulumi.getter(name="minFinishTime")
    def min_finish_time(self) -> Optional[str]:
        return pulumi.get(self, "min_finish_time")

    @property
    @pulumi.getter(name="orderBy")
    def order_by(self) -> Optional[str]:
        return pulumi.get(self, "order_by")

    @property
    @pulumi.getter(name="orderByType")
    def order_by_type(self) -> Optional[str]:
        return pulumi.get(self, "order_by_type")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetBaseBackupsResult(GetBaseBackupsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBaseBackupsResult(
            base_backup_sets=self.base_backup_sets,
            filters=self.filters,
            id=self.id,
            max_finish_time=self.max_finish_time,
            min_finish_time=self.min_finish_time,
            order_by=self.order_by,
            order_by_type=self.order_by_type,
            result_output_file=self.result_output_file)


def get_base_backups(filters: Optional[Sequence[pulumi.InputType['GetBaseBackupsFilterArgs']]] = None,
                     max_finish_time: Optional[str] = None,
                     min_finish_time: Optional[str] = None,
                     order_by: Optional[str] = None,
                     order_by_type: Optional[str] = None,
                     result_output_file: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBaseBackupsResult:
    """
    Use this data source to query detailed information of postgresql base_backups


    :param Sequence[pulumi.InputType['GetBaseBackupsFilterArgs']] filters: Filter instances using one or more criteria. Valid filter names: `db-instance-id`: Filter by instance ID (in string format). `db-instance-name`: Filter by instance name (in string format). `db-instance-ip`: Filter by instance VPC IP (in string format). `base-backup-id`: Filter by base backup ID (in string format).
    :param str max_finish_time: Maximum end time of a backup in the format of `2018-01-01 00:00:00`. It is the current time by default.
    :param str min_finish_time: Minimum end time of a backup in the format of `2018-01-01 00:00:00`. It is 7 days ago by default.
    :param str order_by: Sorting field. Valid values: `StartTime`, `FinishTime`, `Size`.
    :param str order_by_type: Sorting order. Valid values: `asc` (ascending), `desc` (descending).
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['maxFinishTime'] = max_finish_time
    __args__['minFinishTime'] = min_finish_time
    __args__['orderBy'] = order_by
    __args__['orderByType'] = order_by_type
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Postgresql/getBaseBackups:getBaseBackups', __args__, opts=opts, typ=GetBaseBackupsResult).value

    return AwaitableGetBaseBackupsResult(
        base_backup_sets=__ret__.base_backup_sets,
        filters=__ret__.filters,
        id=__ret__.id,
        max_finish_time=__ret__.max_finish_time,
        min_finish_time=__ret__.min_finish_time,
        order_by=__ret__.order_by,
        order_by_type=__ret__.order_by_type,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_base_backups)
def get_base_backups_output(filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetBaseBackupsFilterArgs']]]]] = None,
                            max_finish_time: Optional[pulumi.Input[Optional[str]]] = None,
                            min_finish_time: Optional[pulumi.Input[Optional[str]]] = None,
                            order_by: Optional[pulumi.Input[Optional[str]]] = None,
                            order_by_type: Optional[pulumi.Input[Optional[str]]] = None,
                            result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetBaseBackupsResult]:
    """
    Use this data source to query detailed information of postgresql base_backups


    :param Sequence[pulumi.InputType['GetBaseBackupsFilterArgs']] filters: Filter instances using one or more criteria. Valid filter names: `db-instance-id`: Filter by instance ID (in string format). `db-instance-name`: Filter by instance name (in string format). `db-instance-ip`: Filter by instance VPC IP (in string format). `base-backup-id`: Filter by base backup ID (in string format).
    :param str max_finish_time: Maximum end time of a backup in the format of `2018-01-01 00:00:00`. It is the current time by default.
    :param str min_finish_time: Minimum end time of a backup in the format of `2018-01-01 00:00:00`. It is 7 days ago by default.
    :param str order_by: Sorting field. Valid values: `StartTime`, `FinishTime`, `Size`.
    :param str order_by_type: Sorting order. Valid values: `asc` (ascending), `desc` (descending).
    :param str result_output_file: Used to save results.
    """
    ...
