# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ModifySwitchTimePeriodOperationArgs', 'ModifySwitchTimePeriodOperation']

@pulumi.input_type
class ModifySwitchTimePeriodOperationArgs:
    def __init__(__self__, *,
                 db_instance_id: pulumi.Input[str],
                 switch_tag: pulumi.Input[int]):
        """
        The set of arguments for constructing a ModifySwitchTimePeriodOperation resource.
        :param pulumi.Input[str] db_instance_id: The ID of the instance waiting for a switch.
        :param pulumi.Input[int] switch_tag: Valid value: `0` (switch immediately).
        """
        pulumi.set(__self__, "db_instance_id", db_instance_id)
        pulumi.set(__self__, "switch_tag", switch_tag)

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> pulumi.Input[str]:
        """
        The ID of the instance waiting for a switch.
        """
        return pulumi.get(self, "db_instance_id")

    @db_instance_id.setter
    def db_instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "db_instance_id", value)

    @property
    @pulumi.getter(name="switchTag")
    def switch_tag(self) -> pulumi.Input[int]:
        """
        Valid value: `0` (switch immediately).
        """
        return pulumi.get(self, "switch_tag")

    @switch_tag.setter
    def switch_tag(self, value: pulumi.Input[int]):
        pulumi.set(self, "switch_tag", value)


@pulumi.input_type
class _ModifySwitchTimePeriodOperationState:
    def __init__(__self__, *,
                 db_instance_id: Optional[pulumi.Input[str]] = None,
                 switch_tag: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering ModifySwitchTimePeriodOperation resources.
        :param pulumi.Input[str] db_instance_id: The ID of the instance waiting for a switch.
        :param pulumi.Input[int] switch_tag: Valid value: `0` (switch immediately).
        """
        if db_instance_id is not None:
            pulumi.set(__self__, "db_instance_id", db_instance_id)
        if switch_tag is not None:
            pulumi.set(__self__, "switch_tag", switch_tag)

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the instance waiting for a switch.
        """
        return pulumi.get(self, "db_instance_id")

    @db_instance_id.setter
    def db_instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "db_instance_id", value)

    @property
    @pulumi.getter(name="switchTag")
    def switch_tag(self) -> Optional[pulumi.Input[int]]:
        """
        Valid value: `0` (switch immediately).
        """
        return pulumi.get(self, "switch_tag")

    @switch_tag.setter
    def switch_tag(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "switch_tag", value)


class ModifySwitchTimePeriodOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_instance_id: Optional[pulumi.Input[str]] = None,
                 switch_tag: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to create a postgresql modify_switch_time_period_operation

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        modify_switch_time_period_operation = tencentcloud.postgresql.ModifySwitchTimePeriodOperation("modifySwitchTimePeriodOperation",
            db_instance_id=local["pgsql_id"],
            switch_tag=0)
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] db_instance_id: The ID of the instance waiting for a switch.
        :param pulumi.Input[int] switch_tag: Valid value: `0` (switch immediately).
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ModifySwitchTimePeriodOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a postgresql modify_switch_time_period_operation

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        modify_switch_time_period_operation = tencentcloud.postgresql.ModifySwitchTimePeriodOperation("modifySwitchTimePeriodOperation",
            db_instance_id=local["pgsql_id"],
            switch_tag=0)
        ```

        :param str resource_name: The name of the resource.
        :param ModifySwitchTimePeriodOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ModifySwitchTimePeriodOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_instance_id: Optional[pulumi.Input[str]] = None,
                 switch_tag: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ModifySwitchTimePeriodOperationArgs.__new__(ModifySwitchTimePeriodOperationArgs)

            if db_instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'db_instance_id'")
            __props__.__dict__["db_instance_id"] = db_instance_id
            if switch_tag is None and not opts.urn:
                raise TypeError("Missing required property 'switch_tag'")
            __props__.__dict__["switch_tag"] = switch_tag
        super(ModifySwitchTimePeriodOperation, __self__).__init__(
            'tencentcloud:Postgresql/modifySwitchTimePeriodOperation:ModifySwitchTimePeriodOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            db_instance_id: Optional[pulumi.Input[str]] = None,
            switch_tag: Optional[pulumi.Input[int]] = None) -> 'ModifySwitchTimePeriodOperation':
        """
        Get an existing ModifySwitchTimePeriodOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] db_instance_id: The ID of the instance waiting for a switch.
        :param pulumi.Input[int] switch_tag: Valid value: `0` (switch immediately).
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ModifySwitchTimePeriodOperationState.__new__(_ModifySwitchTimePeriodOperationState)

        __props__.__dict__["db_instance_id"] = db_instance_id
        __props__.__dict__["switch_tag"] = switch_tag
        return ModifySwitchTimePeriodOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> pulumi.Output[str]:
        """
        The ID of the instance waiting for a switch.
        """
        return pulumi.get(self, "db_instance_id")

    @property
    @pulumi.getter(name="switchTag")
    def switch_tag(self) -> pulumi.Output[int]:
        """
        Valid value: `0` (switch immediately).
        """
        return pulumi.get(self, "switch_tag")

