# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInstanceResult',
    'AwaitableGetInstanceResult',
    'get_instance',
    'get_instance_output',
]

@pulumi.output_type
class GetInstanceResult:
    """
    A collection of values returned by getInstance.
    """
    def __init__(__self__, all_list=None, id=None, projects=None, result_output_file=None):
        if all_list and not isinstance(all_list, int):
            raise TypeError("Expected argument 'all_list' to be a int")
        pulumi.set(__self__, "all_list", all_list)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if projects and not isinstance(projects, list):
            raise TypeError("Expected argument 'projects' to be a list")
        pulumi.set(__self__, "projects", projects)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="allList")
    def all_list(self) -> int:
        return pulumi.get(self, "all_list")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def projects(self) -> Sequence['outputs.GetInstanceProjectResult']:
        """
        List of projects.
        """
        return pulumi.get(self, "projects")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetInstanceResult(GetInstanceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInstanceResult(
            all_list=self.all_list,
            id=self.id,
            projects=self.projects,
            result_output_file=self.result_output_file)


def get_instance(all_list: Optional[int] = None,
                 result_output_file: Optional[str] = None,
                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInstanceResult:
    """
    Use this data source to query detailed information of tag project

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    project = tencentcloud.Projects.get_instance(all_list=1)
    ```


    :param int all_list: 1 means to list all project, 0 means to list visible project.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['allList'] = all_list
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Projects/getInstance:getInstance', __args__, opts=opts, typ=GetInstanceResult).value

    return AwaitableGetInstanceResult(
        all_list=__ret__.all_list,
        id=__ret__.id,
        projects=__ret__.projects,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_instance)
def get_instance_output(all_list: Optional[pulumi.Input[int]] = None,
                        result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInstanceResult]:
    """
    Use this data source to query detailed information of tag project

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    project = tencentcloud.Projects.get_instance(all_list=1)
    ```


    :param int all_list: 1 means to list all project, 0 means to list visible project.
    :param str result_output_file: Used to save results.
    """
    ...
