# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['BackupOperationArgs', 'BackupOperation']

@pulumi.input_type
class BackupOperationArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 remark: Optional[pulumi.Input[str]] = None,
                 storage_days: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a BackupOperation resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] remark: Notes information for the backup.
        :param pulumi.Input[int] storage_days: Number of days to store.0 specifies the default retention time.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        if remark is not None:
            pulumi.set(__self__, "remark", remark)
        if storage_days is not None:
            pulumi.set(__self__, "storage_days", storage_days)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def remark(self) -> Optional[pulumi.Input[str]]:
        """
        Notes information for the backup.
        """
        return pulumi.get(self, "remark")

    @remark.setter
    def remark(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "remark", value)

    @property
    @pulumi.getter(name="storageDays")
    def storage_days(self) -> Optional[pulumi.Input[int]]:
        """
        Number of days to store.0 specifies the default retention time.
        """
        return pulumi.get(self, "storage_days")

    @storage_days.setter
    def storage_days(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "storage_days", value)


@pulumi.input_type
class _BackupOperationState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 remark: Optional[pulumi.Input[str]] = None,
                 storage_days: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering BackupOperation resources.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] remark: Notes information for the backup.
        :param pulumi.Input[int] storage_days: Number of days to store.0 specifies the default retention time.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if remark is not None:
            pulumi.set(__self__, "remark", remark)
        if storage_days is not None:
            pulumi.set(__self__, "storage_days", storage_days)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def remark(self) -> Optional[pulumi.Input[str]]:
        """
        Notes information for the backup.
        """
        return pulumi.get(self, "remark")

    @remark.setter
    def remark(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "remark", value)

    @property
    @pulumi.getter(name="storageDays")
    def storage_days(self) -> Optional[pulumi.Input[int]]:
        """
        Number of days to store.0 specifies the default retention time.
        """
        return pulumi.get(self, "storage_days")

    @storage_days.setter
    def storage_days(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "storage_days", value)


class BackupOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 remark: Optional[pulumi.Input[str]] = None,
                 storage_days: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to create a redis backup_operation

        ## Example Usage
        ### Manually back up the Redis instance, and the backup data is kept for 7 days

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.Mysql.get_instance()
        backup_operation = tencentcloud.redis.BackupOperation("backupOperation",
            instance_id=foo.instance_lists[0].mysql_id,
            remark="manually back",
            storage_days=7)
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] remark: Notes information for the backup.
        :param pulumi.Input[int] storage_days: Number of days to store.0 specifies the default retention time.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BackupOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a redis backup_operation

        ## Example Usage
        ### Manually back up the Redis instance, and the backup data is kept for 7 days

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.Mysql.get_instance()
        backup_operation = tencentcloud.redis.BackupOperation("backupOperation",
            instance_id=foo.instance_lists[0].mysql_id,
            remark="manually back",
            storage_days=7)
        ```

        :param str resource_name: The name of the resource.
        :param BackupOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BackupOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 remark: Optional[pulumi.Input[str]] = None,
                 storage_days: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BackupOperationArgs.__new__(BackupOperationArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["remark"] = remark
            __props__.__dict__["storage_days"] = storage_days
        super(BackupOperation, __self__).__init__(
            'tencentcloud:Redis/backupOperation:BackupOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            remark: Optional[pulumi.Input[str]] = None,
            storage_days: Optional[pulumi.Input[int]] = None) -> 'BackupOperation':
        """
        Get an existing BackupOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] remark: Notes information for the backup.
        :param pulumi.Input[int] storage_days: Number of days to store.0 specifies the default retention time.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BackupOperationState.__new__(_BackupOperationState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["remark"] = remark
        __props__.__dict__["storage_days"] = storage_days
        return BackupOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def remark(self) -> pulumi.Output[Optional[str]]:
        """
        Notes information for the backup.
        """
        return pulumi.get(self, "remark")

    @property
    @pulumi.getter(name="storageDays")
    def storage_days(self) -> pulumi.Output[Optional[int]]:
        """
        Number of days to store.0 specifies the default retention time.
        """
        return pulumi.get(self, "storage_days")

