# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInstanceNodeInfoResult',
    'AwaitableGetInstanceNodeInfoResult',
    'get_instance_node_info',
    'get_instance_node_info_output',
]

@pulumi.output_type
class GetInstanceNodeInfoResult:
    """
    A collection of values returned by getInstanceNodeInfo.
    """
    def __init__(__self__, id=None, instance_id=None, proxies=None, proxy_count=None, redis=None, redis_count=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if proxies and not isinstance(proxies, list):
            raise TypeError("Expected argument 'proxies' to be a list")
        pulumi.set(__self__, "proxies", proxies)
        if proxy_count and not isinstance(proxy_count, int):
            raise TypeError("Expected argument 'proxy_count' to be a int")
        pulumi.set(__self__, "proxy_count", proxy_count)
        if redis and not isinstance(redis, list):
            raise TypeError("Expected argument 'redis' to be a list")
        pulumi.set(__self__, "redis", redis)
        if redis_count and not isinstance(redis_count, int):
            raise TypeError("Expected argument 'redis_count' to be a int")
        pulumi.set(__self__, "redis_count", redis_count)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def proxies(self) -> Sequence['outputs.GetInstanceNodeInfoProxyResult']:
        """
        Proxy node information.
        """
        return pulumi.get(self, "proxies")

    @property
    @pulumi.getter(name="proxyCount")
    def proxy_count(self) -> int:
        """
        Number of proxy nodes.
        """
        return pulumi.get(self, "proxy_count")

    @property
    @pulumi.getter
    def redis(self) -> Sequence['outputs.GetInstanceNodeInfoRediResult']:
        """
        Redis node information.
        """
        return pulumi.get(self, "redis")

    @property
    @pulumi.getter(name="redisCount")
    def redis_count(self) -> int:
        """
        Number of redis nodes.
        """
        return pulumi.get(self, "redis_count")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetInstanceNodeInfoResult(GetInstanceNodeInfoResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInstanceNodeInfoResult(
            id=self.id,
            instance_id=self.instance_id,
            proxies=self.proxies,
            proxy_count=self.proxy_count,
            redis=self.redis,
            redis_count=self.redis_count,
            result_output_file=self.result_output_file)


def get_instance_node_info(instance_id: Optional[str] = None,
                           result_output_file: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInstanceNodeInfoResult:
    """
    Use this data source to query detailed information of redis instance_node_info

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    instance_node_info = tencentcloud.Redis.get_instance_node_info(instance_id="crs-c1nl9rpv")
    ```


    :param str instance_id: The ID of instance.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Redis/getInstanceNodeInfo:getInstanceNodeInfo', __args__, opts=opts, typ=GetInstanceNodeInfoResult).value

    return AwaitableGetInstanceNodeInfoResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        proxies=__ret__.proxies,
        proxy_count=__ret__.proxy_count,
        redis=__ret__.redis,
        redis_count=__ret__.redis_count,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_instance_node_info)
def get_instance_node_info_output(instance_id: Optional[pulumi.Input[str]] = None,
                                  result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInstanceNodeInfoResult]:
    """
    Use this data source to query detailed information of redis instance_node_info

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    instance_node_info = tencentcloud.Redis.get_instance_node_info(instance_id="crs-c1nl9rpv")
    ```


    :param str instance_id: The ID of instance.
    :param str result_output_file: Used to save results.
    """
    ...
