# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['SecurityGroupAttachmentArgs', 'SecurityGroupAttachment']

@pulumi.input_type
class SecurityGroupAttachmentArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 security_group_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a SecurityGroupAttachment resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] security_group_id: Security group ID.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "security_group_id", security_group_id)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="securityGroupId")
    def security_group_id(self) -> pulumi.Input[str]:
        """
        Security group ID.
        """
        return pulumi.get(self, "security_group_id")

    @security_group_id.setter
    def security_group_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "security_group_id", value)


@pulumi.input_type
class _SecurityGroupAttachmentState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 security_group_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SecurityGroupAttachment resources.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] security_group_id: Security group ID.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if security_group_id is not None:
            pulumi.set(__self__, "security_group_id", security_group_id)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="securityGroupId")
    def security_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        Security group ID.
        """
        return pulumi.get(self, "security_group_id")

    @security_group_id.setter
    def security_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_group_id", value)


class SecurityGroupAttachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 security_group_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a redis security_group_attachment

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zone = tencentcloud.Redis.get_zone_config(type_id=7,
            region="ap-guangzhou")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            vpc_id=vpc.id,
            availability_zone=zone.lists[2].zone,
            cidr_block="10.0.1.0/24")
        foo_group = tencentcloud.security.Group("fooGroup")
        foo_group_lite_rule = tencentcloud.security.GroupLiteRule("fooGroupLiteRule",
            security_group_id=foo_group.id,
            ingresses=[
                "ACCEPT#192.168.1.0/24#80#TCP",
                "DROP#8.8.8.8#80,90#UDP",
                "DROP#0.0.0.0/0#80-90#TCP",
            ],
            egresses=[
                "ACCEPT#192.168.0.0/16#ALL#TCP",
                "ACCEPT#10.0.0.0/8#ALL#ICMP",
                "DROP#0.0.0.0/0#ALL#ALL",
            ])
        foo_instance = tencentcloud.redis.Instance("fooInstance",
            availability_zone=zone.lists[2].zone,
            type_id=zone.lists[2].type_id,
            password="test12345789",
            mem_size=8192,
            redis_shard_num=zone.lists[2].redis_shard_nums[0],
            redis_replicas_num=zone.lists[2].redis_replicas_nums[0],
            port=6379,
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            security_groups=[foo_group.id])
        instance = tencentcloud.redis.Instance("instance",
            availability_zone=zone.lists[2].zone,
            type_id=zone.lists[2].type_id,
            password="test12345789",
            mem_size=8192,
            redis_shard_num=zone.lists[2].redis_shard_nums[0],
            redis_replicas_num=zone.lists[2].redis_replicas_nums[0],
            port=6379,
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            security_groups=[foo_group.id])
        replicate_attachment = tencentcloud.redis.ReplicateAttachment("replicateAttachment",
            group_id="crs-rpl-orfiwmn5",
            master_instance_id=foo_instance.id,
            instance_ids=[instance.id])
        ```

        ## Import

        redis security_group_attachment can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Redis/securityGroupAttachment:SecurityGroupAttachment security_group_attachment instance_id#security_group_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] security_group_id: Security group ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SecurityGroupAttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a redis security_group_attachment

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zone = tencentcloud.Redis.get_zone_config(type_id=7,
            region="ap-guangzhou")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            vpc_id=vpc.id,
            availability_zone=zone.lists[2].zone,
            cidr_block="10.0.1.0/24")
        foo_group = tencentcloud.security.Group("fooGroup")
        foo_group_lite_rule = tencentcloud.security.GroupLiteRule("fooGroupLiteRule",
            security_group_id=foo_group.id,
            ingresses=[
                "ACCEPT#192.168.1.0/24#80#TCP",
                "DROP#8.8.8.8#80,90#UDP",
                "DROP#0.0.0.0/0#80-90#TCP",
            ],
            egresses=[
                "ACCEPT#192.168.0.0/16#ALL#TCP",
                "ACCEPT#10.0.0.0/8#ALL#ICMP",
                "DROP#0.0.0.0/0#ALL#ALL",
            ])
        foo_instance = tencentcloud.redis.Instance("fooInstance",
            availability_zone=zone.lists[2].zone,
            type_id=zone.lists[2].type_id,
            password="test12345789",
            mem_size=8192,
            redis_shard_num=zone.lists[2].redis_shard_nums[0],
            redis_replicas_num=zone.lists[2].redis_replicas_nums[0],
            port=6379,
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            security_groups=[foo_group.id])
        instance = tencentcloud.redis.Instance("instance",
            availability_zone=zone.lists[2].zone,
            type_id=zone.lists[2].type_id,
            password="test12345789",
            mem_size=8192,
            redis_shard_num=zone.lists[2].redis_shard_nums[0],
            redis_replicas_num=zone.lists[2].redis_replicas_nums[0],
            port=6379,
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            security_groups=[foo_group.id])
        replicate_attachment = tencentcloud.redis.ReplicateAttachment("replicateAttachment",
            group_id="crs-rpl-orfiwmn5",
            master_instance_id=foo_instance.id,
            instance_ids=[instance.id])
        ```

        ## Import

        redis security_group_attachment can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Redis/securityGroupAttachment:SecurityGroupAttachment security_group_attachment instance_id#security_group_id
        ```

        :param str resource_name: The name of the resource.
        :param SecurityGroupAttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SecurityGroupAttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 security_group_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SecurityGroupAttachmentArgs.__new__(SecurityGroupAttachmentArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if security_group_id is None and not opts.urn:
                raise TypeError("Missing required property 'security_group_id'")
            __props__.__dict__["security_group_id"] = security_group_id
        super(SecurityGroupAttachment, __self__).__init__(
            'tencentcloud:Redis/securityGroupAttachment:SecurityGroupAttachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            security_group_id: Optional[pulumi.Input[str]] = None) -> 'SecurityGroupAttachment':
        """
        Get an existing SecurityGroupAttachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] security_group_id: Security group ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SecurityGroupAttachmentState.__new__(_SecurityGroupAttachmentState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["security_group_id"] = security_group_id
        return SecurityGroupAttachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="securityGroupId")
    def security_group_id(self) -> pulumi.Output[str]:
        """
        Security group ID.
        """
        return pulumi.get(self, "security_group_id")

