# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['SwitchMasterArgs', 'SwitchMaster']

@pulumi.input_type
class SwitchMasterArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 group_id: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a SwitchMaster resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[int] group_id: Replication group ID, required for multi-AZ instances.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        if group_id is not None:
            pulumi.set(__self__, "group_id", group_id)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> Optional[pulumi.Input[int]]:
        """
        Replication group ID, required for multi-AZ instances.
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "group_id", value)


@pulumi.input_type
class _SwitchMasterState:
    def __init__(__self__, *,
                 group_id: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SwitchMaster resources.
        :param pulumi.Input[int] group_id: Replication group ID, required for multi-AZ instances.
        :param pulumi.Input[str] instance_id: The ID of instance.
        """
        if group_id is not None:
            pulumi.set(__self__, "group_id", group_id)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> Optional[pulumi.Input[int]]:
        """
        Replication group ID, required for multi-AZ instances.
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "group_id", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)


class SwitchMaster(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 group_id: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a redis switch_master

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zone = tencentcloud.Redis.get_zone_config(type_id=7,
            region="ap-guangzhou")
        config = pulumi.Config()
        replica_zone_ids = config.get_object("replicaZoneIds")
        if replica_zone_ids is None:
            replica_zone_ids = [
                100004,
                100006,
            ]
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            vpc_id=vpc.id,
            availability_zone=zone.lists[2].zone,
            cidr_block="10.0.1.0/24")
        foo_group = tencentcloud.security.Group("fooGroup")
        foo_group_lite_rule = tencentcloud.security.GroupLiteRule("fooGroupLiteRule",
            security_group_id=foo_group.id,
            ingresses=[
                "ACCEPT#192.168.1.0/24#80#TCP",
                "DROP#8.8.8.8#80,90#UDP",
                "DROP#0.0.0.0/0#80-90#TCP",
            ],
            egresses=[
                "ACCEPT#192.168.0.0/16#ALL#TCP",
                "ACCEPT#10.0.0.0/8#ALL#ICMP",
                "DROP#0.0.0.0/0#ALL#ALL",
            ])
        foo_instance = tencentcloud.redis.Instance("fooInstance",
            availability_zone=zone.lists[2].zone,
            type_id=zone.lists[2].type_id,
            password="test12345789",
            mem_size=8192,
            redis_shard_num=zone.lists[2].redis_shard_nums[0],
            redis_replicas_num=2,
            replica_zone_ids=replica_zone_ids,
            port=6379,
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            security_groups=[foo_group.id])
        foo_instance_zone_info = tencentcloud.Redis.get_instance_zone_info_output(instance_id=foo_instance.id)
        switch_master = tencentcloud.redis.SwitchMaster("switchMaster",
            instance_id=foo_instance.id,
            group_id=foo_instance_zone_info.replica_groups[1].group_id)
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] group_id: Replication group ID, required for multi-AZ instances.
        :param pulumi.Input[str] instance_id: The ID of instance.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SwitchMasterArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a redis switch_master

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zone = tencentcloud.Redis.get_zone_config(type_id=7,
            region="ap-guangzhou")
        config = pulumi.Config()
        replica_zone_ids = config.get_object("replicaZoneIds")
        if replica_zone_ids is None:
            replica_zone_ids = [
                100004,
                100006,
            ]
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            vpc_id=vpc.id,
            availability_zone=zone.lists[2].zone,
            cidr_block="10.0.1.0/24")
        foo_group = tencentcloud.security.Group("fooGroup")
        foo_group_lite_rule = tencentcloud.security.GroupLiteRule("fooGroupLiteRule",
            security_group_id=foo_group.id,
            ingresses=[
                "ACCEPT#192.168.1.0/24#80#TCP",
                "DROP#8.8.8.8#80,90#UDP",
                "DROP#0.0.0.0/0#80-90#TCP",
            ],
            egresses=[
                "ACCEPT#192.168.0.0/16#ALL#TCP",
                "ACCEPT#10.0.0.0/8#ALL#ICMP",
                "DROP#0.0.0.0/0#ALL#ALL",
            ])
        foo_instance = tencentcloud.redis.Instance("fooInstance",
            availability_zone=zone.lists[2].zone,
            type_id=zone.lists[2].type_id,
            password="test12345789",
            mem_size=8192,
            redis_shard_num=zone.lists[2].redis_shard_nums[0],
            redis_replicas_num=2,
            replica_zone_ids=replica_zone_ids,
            port=6379,
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            security_groups=[foo_group.id])
        foo_instance_zone_info = tencentcloud.Redis.get_instance_zone_info_output(instance_id=foo_instance.id)
        switch_master = tencentcloud.redis.SwitchMaster("switchMaster",
            instance_id=foo_instance.id,
            group_id=foo_instance_zone_info.replica_groups[1].group_id)
        ```

        :param str resource_name: The name of the resource.
        :param SwitchMasterArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SwitchMasterArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 group_id: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SwitchMasterArgs.__new__(SwitchMasterArgs)

            __props__.__dict__["group_id"] = group_id
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
        super(SwitchMaster, __self__).__init__(
            'tencentcloud:Redis/switchMaster:SwitchMaster',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            group_id: Optional[pulumi.Input[int]] = None,
            instance_id: Optional[pulumi.Input[str]] = None) -> 'SwitchMaster':
        """
        Get an existing SwitchMaster resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] group_id: Replication group ID, required for multi-AZ instances.
        :param pulumi.Input[str] instance_id: The ID of instance.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SwitchMasterState.__new__(_SwitchMasterState)

        __props__.__dict__["group_id"] = group_id
        __props__.__dict__["instance_id"] = instance_id
        return SwitchMaster(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> pulumi.Output[Optional[int]]:
        """
        Replication group ID, required for multi-AZ instances.
        """
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

