# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['UpgradeCacheVersionOperationArgs', 'UpgradeCacheVersionOperation']

@pulumi.input_type
class UpgradeCacheVersionOperationArgs:
    def __init__(__self__, *,
                 current_redis_version: pulumi.Input[str],
                 instance_id: pulumi.Input[str],
                 instance_type_upgrade_now: pulumi.Input[int],
                 upgrade_redis_version: pulumi.Input[str]):
        """
        The set of arguments for constructing a UpgradeCacheVersionOperation resource.
        :param pulumi.Input[str] current_redis_version: Current redis version.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[int] instance_type_upgrade_now: Switch mode:1 - Upgrade now0 - Maintenance window upgrade.
        :param pulumi.Input[str] upgrade_redis_version: Upgradeable redis version.
        """
        pulumi.set(__self__, "current_redis_version", current_redis_version)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "instance_type_upgrade_now", instance_type_upgrade_now)
        pulumi.set(__self__, "upgrade_redis_version", upgrade_redis_version)

    @property
    @pulumi.getter(name="currentRedisVersion")
    def current_redis_version(self) -> pulumi.Input[str]:
        """
        Current redis version.
        """
        return pulumi.get(self, "current_redis_version")

    @current_redis_version.setter
    def current_redis_version(self, value: pulumi.Input[str]):
        pulumi.set(self, "current_redis_version", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="instanceTypeUpgradeNow")
    def instance_type_upgrade_now(self) -> pulumi.Input[int]:
        """
        Switch mode:1 - Upgrade now0 - Maintenance window upgrade.
        """
        return pulumi.get(self, "instance_type_upgrade_now")

    @instance_type_upgrade_now.setter
    def instance_type_upgrade_now(self, value: pulumi.Input[int]):
        pulumi.set(self, "instance_type_upgrade_now", value)

    @property
    @pulumi.getter(name="upgradeRedisVersion")
    def upgrade_redis_version(self) -> pulumi.Input[str]:
        """
        Upgradeable redis version.
        """
        return pulumi.get(self, "upgrade_redis_version")

    @upgrade_redis_version.setter
    def upgrade_redis_version(self, value: pulumi.Input[str]):
        pulumi.set(self, "upgrade_redis_version", value)


@pulumi.input_type
class _UpgradeCacheVersionOperationState:
    def __init__(__self__, *,
                 current_redis_version: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 instance_type_upgrade_now: Optional[pulumi.Input[int]] = None,
                 upgrade_redis_version: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering UpgradeCacheVersionOperation resources.
        :param pulumi.Input[str] current_redis_version: Current redis version.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[int] instance_type_upgrade_now: Switch mode:1 - Upgrade now0 - Maintenance window upgrade.
        :param pulumi.Input[str] upgrade_redis_version: Upgradeable redis version.
        """
        if current_redis_version is not None:
            pulumi.set(__self__, "current_redis_version", current_redis_version)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if instance_type_upgrade_now is not None:
            pulumi.set(__self__, "instance_type_upgrade_now", instance_type_upgrade_now)
        if upgrade_redis_version is not None:
            pulumi.set(__self__, "upgrade_redis_version", upgrade_redis_version)

    @property
    @pulumi.getter(name="currentRedisVersion")
    def current_redis_version(self) -> Optional[pulumi.Input[str]]:
        """
        Current redis version.
        """
        return pulumi.get(self, "current_redis_version")

    @current_redis_version.setter
    def current_redis_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "current_redis_version", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="instanceTypeUpgradeNow")
    def instance_type_upgrade_now(self) -> Optional[pulumi.Input[int]]:
        """
        Switch mode:1 - Upgrade now0 - Maintenance window upgrade.
        """
        return pulumi.get(self, "instance_type_upgrade_now")

    @instance_type_upgrade_now.setter
    def instance_type_upgrade_now(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "instance_type_upgrade_now", value)

    @property
    @pulumi.getter(name="upgradeRedisVersion")
    def upgrade_redis_version(self) -> Optional[pulumi.Input[str]]:
        """
        Upgradeable redis version.
        """
        return pulumi.get(self, "upgrade_redis_version")

    @upgrade_redis_version.setter
    def upgrade_redis_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "upgrade_redis_version", value)


class UpgradeCacheVersionOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 current_redis_version: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 instance_type_upgrade_now: Optional[pulumi.Input[int]] = None,
                 upgrade_redis_version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a redis upgrade_cache_version_operation

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        upgrade_cache_version_operation = tencentcloud.redis.UpgradeCacheVersionOperation("upgradeCacheVersionOperation",
            current_redis_version="5.0.0",
            instance_id="crs-c1nl9rpv",
            instance_type_upgrade_now=1,
            upgrade_redis_version="5.0.0")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] current_redis_version: Current redis version.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[int] instance_type_upgrade_now: Switch mode:1 - Upgrade now0 - Maintenance window upgrade.
        :param pulumi.Input[str] upgrade_redis_version: Upgradeable redis version.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: UpgradeCacheVersionOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a redis upgrade_cache_version_operation

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        upgrade_cache_version_operation = tencentcloud.redis.UpgradeCacheVersionOperation("upgradeCacheVersionOperation",
            current_redis_version="5.0.0",
            instance_id="crs-c1nl9rpv",
            instance_type_upgrade_now=1,
            upgrade_redis_version="5.0.0")
        ```

        :param str resource_name: The name of the resource.
        :param UpgradeCacheVersionOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(UpgradeCacheVersionOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 current_redis_version: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 instance_type_upgrade_now: Optional[pulumi.Input[int]] = None,
                 upgrade_redis_version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = UpgradeCacheVersionOperationArgs.__new__(UpgradeCacheVersionOperationArgs)

            if current_redis_version is None and not opts.urn:
                raise TypeError("Missing required property 'current_redis_version'")
            __props__.__dict__["current_redis_version"] = current_redis_version
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if instance_type_upgrade_now is None and not opts.urn:
                raise TypeError("Missing required property 'instance_type_upgrade_now'")
            __props__.__dict__["instance_type_upgrade_now"] = instance_type_upgrade_now
            if upgrade_redis_version is None and not opts.urn:
                raise TypeError("Missing required property 'upgrade_redis_version'")
            __props__.__dict__["upgrade_redis_version"] = upgrade_redis_version
        super(UpgradeCacheVersionOperation, __self__).__init__(
            'tencentcloud:Redis/upgradeCacheVersionOperation:UpgradeCacheVersionOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            current_redis_version: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            instance_type_upgrade_now: Optional[pulumi.Input[int]] = None,
            upgrade_redis_version: Optional[pulumi.Input[str]] = None) -> 'UpgradeCacheVersionOperation':
        """
        Get an existing UpgradeCacheVersionOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] current_redis_version: Current redis version.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[int] instance_type_upgrade_now: Switch mode:1 - Upgrade now0 - Maintenance window upgrade.
        :param pulumi.Input[str] upgrade_redis_version: Upgradeable redis version.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _UpgradeCacheVersionOperationState.__new__(_UpgradeCacheVersionOperationState)

        __props__.__dict__["current_redis_version"] = current_redis_version
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["instance_type_upgrade_now"] = instance_type_upgrade_now
        __props__.__dict__["upgrade_redis_version"] = upgrade_redis_version
        return UpgradeCacheVersionOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="currentRedisVersion")
    def current_redis_version(self) -> pulumi.Output[str]:
        """
        Current redis version.
        """
        return pulumi.get(self, "current_redis_version")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="instanceTypeUpgradeNow")
    def instance_type_upgrade_now(self) -> pulumi.Output[int]:
        """
        Switch mode:1 - Upgrade now0 - Maintenance window upgrade.
        """
        return pulumi.get(self, "instance_type_upgrade_now")

    @property
    @pulumi.getter(name="upgradeRedisVersion")
    def upgrade_redis_version(self) -> pulumi.Output[str]:
        """
        Upgradeable redis version.
        """
        return pulumi.get(self, "upgrade_redis_version")

