# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetAsyncEventStatusResult',
    'AwaitableGetAsyncEventStatusResult',
    'get_async_event_status',
    'get_async_event_status_output',
]

@pulumi.output_type
class GetAsyncEventStatusResult:
    """
    A collection of values returned by getAsyncEventStatus.
    """
    def __init__(__self__, id=None, invoke_request_id=None, result_output_file=None, results=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if invoke_request_id and not isinstance(invoke_request_id, str):
            raise TypeError("Expected argument 'invoke_request_id' to be a str")
        pulumi.set(__self__, "invoke_request_id", invoke_request_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="invokeRequestId")
    def invoke_request_id(self) -> str:
        """
        Async execution request ID.
        """
        return pulumi.get(self, "invoke_request_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetAsyncEventStatusResultResult']:
        """
        Async event status.
        """
        return pulumi.get(self, "results")


class AwaitableGetAsyncEventStatusResult(GetAsyncEventStatusResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAsyncEventStatusResult(
            id=self.id,
            invoke_request_id=self.invoke_request_id,
            result_output_file=self.result_output_file,
            results=self.results)


def get_async_event_status(invoke_request_id: Optional[str] = None,
                           result_output_file: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAsyncEventStatusResult:
    """
    Use this data source to query detailed information of scf async_event_status

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    async_event_status = tencentcloud.Scf.get_async_event_status(invoke_request_id="9de9405a-e33a-498d-bb59-e80b7bed1191")
    ```


    :param str invoke_request_id: ID of the async execution request.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['invokeRequestId'] = invoke_request_id
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Scf/getAsyncEventStatus:getAsyncEventStatus', __args__, opts=opts, typ=GetAsyncEventStatusResult).value

    return AwaitableGetAsyncEventStatusResult(
        id=__ret__.id,
        invoke_request_id=__ret__.invoke_request_id,
        result_output_file=__ret__.result_output_file,
        results=__ret__.results)


@_utilities.lift_output_func(get_async_event_status)
def get_async_event_status_output(invoke_request_id: Optional[pulumi.Input[str]] = None,
                                  result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAsyncEventStatusResult]:
    """
    Use this data source to query detailed information of scf async_event_status

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    async_event_status = tencentcloud.Scf.get_async_event_status(invoke_request_id="9de9405a-e33a-498d-bb59-e80b7bed1191")
    ```


    :param str invoke_request_id: ID of the async execution request.
    :param str result_output_file: Used to save results.
    """
    ...
