# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetLayersResult',
    'AwaitableGetLayersResult',
    'get_layers',
    'get_layers_output',
]

@pulumi.output_type
class GetLayersResult:
    """
    A collection of values returned by getLayers.
    """
    def __init__(__self__, compatible_runtime=None, id=None, layers=None, result_output_file=None, search_key=None):
        if compatible_runtime and not isinstance(compatible_runtime, str):
            raise TypeError("Expected argument 'compatible_runtime' to be a str")
        pulumi.set(__self__, "compatible_runtime", compatible_runtime)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if layers and not isinstance(layers, list):
            raise TypeError("Expected argument 'layers' to be a list")
        pulumi.set(__self__, "layers", layers)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if search_key and not isinstance(search_key, str):
            raise TypeError("Expected argument 'search_key' to be a str")
        pulumi.set(__self__, "search_key", search_key)

    @property
    @pulumi.getter(name="compatibleRuntime")
    def compatible_runtime(self) -> Optional[str]:
        return pulumi.get(self, "compatible_runtime")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def layers(self) -> Sequence['outputs.GetLayersLayerResult']:
        """
        Layer list.
        """
        return pulumi.get(self, "layers")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="searchKey")
    def search_key(self) -> Optional[str]:
        return pulumi.get(self, "search_key")


class AwaitableGetLayersResult(GetLayersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetLayersResult(
            compatible_runtime=self.compatible_runtime,
            id=self.id,
            layers=self.layers,
            result_output_file=self.result_output_file,
            search_key=self.search_key)


def get_layers(compatible_runtime: Optional[str] = None,
               result_output_file: Optional[str] = None,
               search_key: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetLayersResult:
    """
    Use this data source to query detailed information of scf layers

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    layers = tencentcloud.Scf.get_layers()
    ```


    :param str compatible_runtime: Compatible runtimes.
    :param str result_output_file: Used to save results.
    :param str search_key: Query key, which fuzzily matches the name.
    """
    __args__ = dict()
    __args__['compatibleRuntime'] = compatible_runtime
    __args__['resultOutputFile'] = result_output_file
    __args__['searchKey'] = search_key
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Scf/getLayers:getLayers', __args__, opts=opts, typ=GetLayersResult).value

    return AwaitableGetLayersResult(
        compatible_runtime=__ret__.compatible_runtime,
        id=__ret__.id,
        layers=__ret__.layers,
        result_output_file=__ret__.result_output_file,
        search_key=__ret__.search_key)


@_utilities.lift_output_func(get_layers)
def get_layers_output(compatible_runtime: Optional[pulumi.Input[Optional[str]]] = None,
                      result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                      search_key: Optional[pulumi.Input[Optional[str]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetLayersResult]:
    """
    Use this data source to query detailed information of scf layers

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    layers = tencentcloud.Scf.get_layers()
    ```


    :param str compatible_runtime: Compatible runtimes.
    :param str result_output_file: Used to save results.
    :param str search_key: Query key, which fuzzily matches the name.
    """
    ...
