# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ConfigDatabaseCtArgs', 'ConfigDatabaseCt']

@pulumi.input_type
class ConfigDatabaseCtArgs:
    def __init__(__self__, *,
                 db_name: pulumi.Input[str],
                 instance_id: pulumi.Input[str],
                 modify_type: pulumi.Input[str],
                 change_retention_day: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a ConfigDatabaseCt resource.
        :param pulumi.Input[str] db_name: database name.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] modify_type: Enable or disable CT. Valid values: enable, disable.
        :param pulumi.Input[int] change_retention_day: Retention period (in days) of change tracking information when CT is enabled. Value range: 3-30. Default value: 3.
        """
        pulumi.set(__self__, "db_name", db_name)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "modify_type", modify_type)
        if change_retention_day is not None:
            pulumi.set(__self__, "change_retention_day", change_retention_day)

    @property
    @pulumi.getter(name="dbName")
    def db_name(self) -> pulumi.Input[str]:
        """
        database name.
        """
        return pulumi.get(self, "db_name")

    @db_name.setter
    def db_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "db_name", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="modifyType")
    def modify_type(self) -> pulumi.Input[str]:
        """
        Enable or disable CT. Valid values: enable, disable.
        """
        return pulumi.get(self, "modify_type")

    @modify_type.setter
    def modify_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "modify_type", value)

    @property
    @pulumi.getter(name="changeRetentionDay")
    def change_retention_day(self) -> Optional[pulumi.Input[int]]:
        """
        Retention period (in days) of change tracking information when CT is enabled. Value range: 3-30. Default value: 3.
        """
        return pulumi.get(self, "change_retention_day")

    @change_retention_day.setter
    def change_retention_day(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "change_retention_day", value)


@pulumi.input_type
class _ConfigDatabaseCtState:
    def __init__(__self__, *,
                 change_retention_day: Optional[pulumi.Input[int]] = None,
                 db_name: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 modify_type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ConfigDatabaseCt resources.
        :param pulumi.Input[int] change_retention_day: Retention period (in days) of change tracking information when CT is enabled. Value range: 3-30. Default value: 3.
        :param pulumi.Input[str] db_name: database name.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] modify_type: Enable or disable CT. Valid values: enable, disable.
        """
        if change_retention_day is not None:
            pulumi.set(__self__, "change_retention_day", change_retention_day)
        if db_name is not None:
            pulumi.set(__self__, "db_name", db_name)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if modify_type is not None:
            pulumi.set(__self__, "modify_type", modify_type)

    @property
    @pulumi.getter(name="changeRetentionDay")
    def change_retention_day(self) -> Optional[pulumi.Input[int]]:
        """
        Retention period (in days) of change tracking information when CT is enabled. Value range: 3-30. Default value: 3.
        """
        return pulumi.get(self, "change_retention_day")

    @change_retention_day.setter
    def change_retention_day(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "change_retention_day", value)

    @property
    @pulumi.getter(name="dbName")
    def db_name(self) -> Optional[pulumi.Input[str]]:
        """
        database name.
        """
        return pulumi.get(self, "db_name")

    @db_name.setter
    def db_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "db_name", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="modifyType")
    def modify_type(self) -> Optional[pulumi.Input[str]]:
        """
        Enable or disable CT. Valid values: enable, disable.
        """
        return pulumi.get(self, "modify_type")

    @modify_type.setter
    def modify_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "modify_type", value)


class ConfigDatabaseCt(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 change_retention_day: Optional[pulumi.Input[int]] = None,
                 db_name: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 modify_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a sqlserver config_database_ct

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="sqlserver")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=zones.zones[4].name,
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            is_multicast=False)
        security_group = tencentcloud.security.Group("securityGroup", description="desc.")
        example_basic_instance = tencentcloud.sqlserver.BasicInstance("exampleBasicInstance",
            availability_zone=zones.zones[4].name,
            charge_type="POSTPAID_BY_HOUR",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            project_id=0,
            memory=4,
            storage=100,
            cpu=2,
            machine_type="CLOUD_PREMIUM",
            maintenance_week_sets=[
                1,
                2,
                3,
            ],
            maintenance_start_time="09:00",
            maintenance_time_span=3,
            security_groups=[security_group.id],
            tags={
                "test": "test",
            })
        example_db = tencentcloud.sqlserver.Db("exampleDb",
            instance_id=example_basic_instance.id,
            charset="Chinese_PRC_BIN",
            remark="test-remark")
        example_config_database_ct = tencentcloud.sqlserver.ConfigDatabaseCt("exampleConfigDatabaseCt",
            instance_id=example_basic_instance.id,
            db_name=example_db.name,
            modify_type="disable",
            change_retention_day=7)
        ```

        ## Import

        sqlserver tencentcloud_sqlserver_config_database_ct can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Sqlserver/configDatabaseCt:ConfigDatabaseCt example mssql-i9ma6oy7#tf_example_db
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] change_retention_day: Retention period (in days) of change tracking information when CT is enabled. Value range: 3-30. Default value: 3.
        :param pulumi.Input[str] db_name: database name.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] modify_type: Enable or disable CT. Valid values: enable, disable.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ConfigDatabaseCtArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a sqlserver config_database_ct

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="sqlserver")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=zones.zones[4].name,
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            is_multicast=False)
        security_group = tencentcloud.security.Group("securityGroup", description="desc.")
        example_basic_instance = tencentcloud.sqlserver.BasicInstance("exampleBasicInstance",
            availability_zone=zones.zones[4].name,
            charge_type="POSTPAID_BY_HOUR",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            project_id=0,
            memory=4,
            storage=100,
            cpu=2,
            machine_type="CLOUD_PREMIUM",
            maintenance_week_sets=[
                1,
                2,
                3,
            ],
            maintenance_start_time="09:00",
            maintenance_time_span=3,
            security_groups=[security_group.id],
            tags={
                "test": "test",
            })
        example_db = tencentcloud.sqlserver.Db("exampleDb",
            instance_id=example_basic_instance.id,
            charset="Chinese_PRC_BIN",
            remark="test-remark")
        example_config_database_ct = tencentcloud.sqlserver.ConfigDatabaseCt("exampleConfigDatabaseCt",
            instance_id=example_basic_instance.id,
            db_name=example_db.name,
            modify_type="disable",
            change_retention_day=7)
        ```

        ## Import

        sqlserver tencentcloud_sqlserver_config_database_ct can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Sqlserver/configDatabaseCt:ConfigDatabaseCt example mssql-i9ma6oy7#tf_example_db
        ```

        :param str resource_name: The name of the resource.
        :param ConfigDatabaseCtArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ConfigDatabaseCtArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 change_retention_day: Optional[pulumi.Input[int]] = None,
                 db_name: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 modify_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ConfigDatabaseCtArgs.__new__(ConfigDatabaseCtArgs)

            __props__.__dict__["change_retention_day"] = change_retention_day
            if db_name is None and not opts.urn:
                raise TypeError("Missing required property 'db_name'")
            __props__.__dict__["db_name"] = db_name
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if modify_type is None and not opts.urn:
                raise TypeError("Missing required property 'modify_type'")
            __props__.__dict__["modify_type"] = modify_type
        super(ConfigDatabaseCt, __self__).__init__(
            'tencentcloud:Sqlserver/configDatabaseCt:ConfigDatabaseCt',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            change_retention_day: Optional[pulumi.Input[int]] = None,
            db_name: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            modify_type: Optional[pulumi.Input[str]] = None) -> 'ConfigDatabaseCt':
        """
        Get an existing ConfigDatabaseCt resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] change_retention_day: Retention period (in days) of change tracking information when CT is enabled. Value range: 3-30. Default value: 3.
        :param pulumi.Input[str] db_name: database name.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] modify_type: Enable or disable CT. Valid values: enable, disable.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ConfigDatabaseCtState.__new__(_ConfigDatabaseCtState)

        __props__.__dict__["change_retention_day"] = change_retention_day
        __props__.__dict__["db_name"] = db_name
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["modify_type"] = modify_type
        return ConfigDatabaseCt(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="changeRetentionDay")
    def change_retention_day(self) -> pulumi.Output[int]:
        """
        Retention period (in days) of change tracking information when CT is enabled. Value range: 3-30. Default value: 3.
        """
        return pulumi.get(self, "change_retention_day")

    @property
    @pulumi.getter(name="dbName")
    def db_name(self) -> pulumi.Output[str]:
        """
        database name.
        """
        return pulumi.get(self, "db_name")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="modifyType")
    def modify_type(self) -> pulumi.Output[str]:
        """
        Enable or disable CT. Valid values: enable, disable.
        """
        return pulumi.get(self, "modify_type")

