# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['GeneralBackupArgs', 'GeneralBackup']

@pulumi.input_type
class GeneralBackupArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 backup_name: Optional[pulumi.Input[str]] = None,
                 db_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 strategy: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a GeneralBackup resource.
        :param pulumi.Input[str] instance_id: Instance ID in the format of mssql-i1z41iwd.
        :param pulumi.Input[str] backup_name: Backup name. If this parameter is left empty, a backup name in the format of [Instance ID]_[Backup start timestamp] will be automatically generated.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] db_names: List of names of databases to be backed up (required only for multi-database backup).
        :param pulumi.Input[int] strategy: Backup policy (0: instance backup, 1: multi-database backup).
        """
        pulumi.set(__self__, "instance_id", instance_id)
        if backup_name is not None:
            pulumi.set(__self__, "backup_name", backup_name)
        if db_names is not None:
            pulumi.set(__self__, "db_names", db_names)
        if strategy is not None:
            pulumi.set(__self__, "strategy", strategy)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Instance ID in the format of mssql-i1z41iwd.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="backupName")
    def backup_name(self) -> Optional[pulumi.Input[str]]:
        """
        Backup name. If this parameter is left empty, a backup name in the format of [Instance ID]_[Backup start timestamp] will be automatically generated.
        """
        return pulumi.get(self, "backup_name")

    @backup_name.setter
    def backup_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "backup_name", value)

    @property
    @pulumi.getter(name="dbNames")
    def db_names(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of names of databases to be backed up (required only for multi-database backup).
        """
        return pulumi.get(self, "db_names")

    @db_names.setter
    def db_names(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "db_names", value)

    @property
    @pulumi.getter
    def strategy(self) -> Optional[pulumi.Input[int]]:
        """
        Backup policy (0: instance backup, 1: multi-database backup).
        """
        return pulumi.get(self, "strategy")

    @strategy.setter
    def strategy(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "strategy", value)


@pulumi.input_type
class _GeneralBackupState:
    def __init__(__self__, *,
                 backup_name: Optional[pulumi.Input[str]] = None,
                 db_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 flow_id: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 strategy: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering GeneralBackup resources.
        :param pulumi.Input[str] backup_name: Backup name. If this parameter is left empty, a backup name in the format of [Instance ID]_[Backup start timestamp] will be automatically generated.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] db_names: List of names of databases to be backed up (required only for multi-database backup).
        :param pulumi.Input[str] flow_id: flow id.
        :param pulumi.Input[str] instance_id: Instance ID in the format of mssql-i1z41iwd.
        :param pulumi.Input[int] strategy: Backup policy (0: instance backup, 1: multi-database backup).
        """
        if backup_name is not None:
            pulumi.set(__self__, "backup_name", backup_name)
        if db_names is not None:
            pulumi.set(__self__, "db_names", db_names)
        if flow_id is not None:
            pulumi.set(__self__, "flow_id", flow_id)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if strategy is not None:
            pulumi.set(__self__, "strategy", strategy)

    @property
    @pulumi.getter(name="backupName")
    def backup_name(self) -> Optional[pulumi.Input[str]]:
        """
        Backup name. If this parameter is left empty, a backup name in the format of [Instance ID]_[Backup start timestamp] will be automatically generated.
        """
        return pulumi.get(self, "backup_name")

    @backup_name.setter
    def backup_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "backup_name", value)

    @property
    @pulumi.getter(name="dbNames")
    def db_names(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of names of databases to be backed up (required only for multi-database backup).
        """
        return pulumi.get(self, "db_names")

    @db_names.setter
    def db_names(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "db_names", value)

    @property
    @pulumi.getter(name="flowId")
    def flow_id(self) -> Optional[pulumi.Input[str]]:
        """
        flow id.
        """
        return pulumi.get(self, "flow_id")

    @flow_id.setter
    def flow_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "flow_id", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID in the format of mssql-i1z41iwd.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def strategy(self) -> Optional[pulumi.Input[int]]:
        """
        Backup policy (0: instance backup, 1: multi-database backup).
        """
        return pulumi.get(self, "strategy")

    @strategy.setter
    def strategy(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "strategy", value)


class GeneralBackup(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 backup_name: Optional[pulumi.Input[str]] = None,
                 db_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 strategy: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to create a sqlserver general_backup

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="sqlserver")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=zones.zones[4].name,
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            is_multicast=False)
        security_group = tencentcloud.security.Group("securityGroup", description="desc.")
        example_basic_instance = tencentcloud.sqlserver.BasicInstance("exampleBasicInstance",
            availability_zone=zones.zones[4].name,
            charge_type="POSTPAID_BY_HOUR",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            project_id=0,
            memory=4,
            storage=100,
            cpu=2,
            machine_type="CLOUD_PREMIUM",
            maintenance_week_sets=[
                1,
                2,
                3,
            ],
            maintenance_start_time="09:00",
            maintenance_time_span=3,
            security_groups=[security_group.id],
            tags={
                "test": "test",
            })
        example_db = tencentcloud.sqlserver.Db("exampleDb",
            instance_id=example_basic_instance.id,
            charset="Chinese_PRC_BIN",
            remark="test-remark")
        example_general_backup = tencentcloud.sqlserver.GeneralBackup("exampleGeneralBackup",
            instance_id=example_db.instance_id,
            backup_name="tf_example_backup",
            strategy=0)
        ```

        ## Import

        sqlserver general_backups can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Sqlserver/generalBackup:GeneralBackup example mssql-qelbzgwf#3512621#5293#2020-07-31 14:28:51#2020-07-31 15:10:27#autoed_instance_58037_20200728011545.bak.tar
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] backup_name: Backup name. If this parameter is left empty, a backup name in the format of [Instance ID]_[Backup start timestamp] will be automatically generated.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] db_names: List of names of databases to be backed up (required only for multi-database backup).
        :param pulumi.Input[str] instance_id: Instance ID in the format of mssql-i1z41iwd.
        :param pulumi.Input[int] strategy: Backup policy (0: instance backup, 1: multi-database backup).
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GeneralBackupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a sqlserver general_backup

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="sqlserver")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=zones.zones[4].name,
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            is_multicast=False)
        security_group = tencentcloud.security.Group("securityGroup", description="desc.")
        example_basic_instance = tencentcloud.sqlserver.BasicInstance("exampleBasicInstance",
            availability_zone=zones.zones[4].name,
            charge_type="POSTPAID_BY_HOUR",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            project_id=0,
            memory=4,
            storage=100,
            cpu=2,
            machine_type="CLOUD_PREMIUM",
            maintenance_week_sets=[
                1,
                2,
                3,
            ],
            maintenance_start_time="09:00",
            maintenance_time_span=3,
            security_groups=[security_group.id],
            tags={
                "test": "test",
            })
        example_db = tencentcloud.sqlserver.Db("exampleDb",
            instance_id=example_basic_instance.id,
            charset="Chinese_PRC_BIN",
            remark="test-remark")
        example_general_backup = tencentcloud.sqlserver.GeneralBackup("exampleGeneralBackup",
            instance_id=example_db.instance_id,
            backup_name="tf_example_backup",
            strategy=0)
        ```

        ## Import

        sqlserver general_backups can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Sqlserver/generalBackup:GeneralBackup example mssql-qelbzgwf#3512621#5293#2020-07-31 14:28:51#2020-07-31 15:10:27#autoed_instance_58037_20200728011545.bak.tar
        ```

        :param str resource_name: The name of the resource.
        :param GeneralBackupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GeneralBackupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 backup_name: Optional[pulumi.Input[str]] = None,
                 db_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 strategy: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GeneralBackupArgs.__new__(GeneralBackupArgs)

            __props__.__dict__["backup_name"] = backup_name
            __props__.__dict__["db_names"] = db_names
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["strategy"] = strategy
            __props__.__dict__["flow_id"] = None
        super(GeneralBackup, __self__).__init__(
            'tencentcloud:Sqlserver/generalBackup:GeneralBackup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            backup_name: Optional[pulumi.Input[str]] = None,
            db_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            flow_id: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            strategy: Optional[pulumi.Input[int]] = None) -> 'GeneralBackup':
        """
        Get an existing GeneralBackup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] backup_name: Backup name. If this parameter is left empty, a backup name in the format of [Instance ID]_[Backup start timestamp] will be automatically generated.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] db_names: List of names of databases to be backed up (required only for multi-database backup).
        :param pulumi.Input[str] flow_id: flow id.
        :param pulumi.Input[str] instance_id: Instance ID in the format of mssql-i1z41iwd.
        :param pulumi.Input[int] strategy: Backup policy (0: instance backup, 1: multi-database backup).
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GeneralBackupState.__new__(_GeneralBackupState)

        __props__.__dict__["backup_name"] = backup_name
        __props__.__dict__["db_names"] = db_names
        __props__.__dict__["flow_id"] = flow_id
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["strategy"] = strategy
        return GeneralBackup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="backupName")
    def backup_name(self) -> pulumi.Output[str]:
        """
        Backup name. If this parameter is left empty, a backup name in the format of [Instance ID]_[Backup start timestamp] will be automatically generated.
        """
        return pulumi.get(self, "backup_name")

    @property
    @pulumi.getter(name="dbNames")
    def db_names(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        List of names of databases to be backed up (required only for multi-database backup).
        """
        return pulumi.get(self, "db_names")

    @property
    @pulumi.getter(name="flowId")
    def flow_id(self) -> pulumi.Output[str]:
        """
        flow id.
        """
        return pulumi.get(self, "flow_id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Instance ID in the format of mssql-i1z41iwd.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def strategy(self) -> pulumi.Output[int]:
        """
        Backup policy (0: instance backup, 1: multi-database backup).
        """
        return pulumi.get(self, "strategy")

