# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetZoneConfigResult',
    'AwaitableGetZoneConfigResult',
    'get_zone_config',
    'get_zone_config_output',
]

@pulumi.output_type
class GetZoneConfigResult:
    """
    A collection of values returned by getZoneConfig.
    """
    def __init__(__self__, id=None, result_output_file=None, zone_lists=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if zone_lists and not isinstance(zone_lists, list):
            raise TypeError("Expected argument 'zone_lists' to be a list")
        pulumi.set(__self__, "zone_lists", zone_lists)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="zoneLists")
    def zone_lists(self) -> Sequence['outputs.GetZoneConfigZoneListResult']:
        """
        A list of availability zones. Each element contains the following attributes:
        """
        return pulumi.get(self, "zone_lists")


class AwaitableGetZoneConfigResult(GetZoneConfigResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZoneConfigResult(
            id=self.id,
            result_output_file=self.result_output_file,
            zone_lists=self.zone_lists)


def get_zone_config(result_output_file: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZoneConfigResult:
    """
    Use this data source to query purchasable specification configuration for each availability zone in this specific region.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Sqlserver.get_zone_config()
    ```


    :param str result_output_file: Used to store results.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Sqlserver/getZoneConfig:getZoneConfig', __args__, opts=opts, typ=GetZoneConfigResult).value

    return AwaitableGetZoneConfigResult(
        id=__ret__.id,
        result_output_file=__ret__.result_output_file,
        zone_lists=__ret__.zone_lists)


@_utilities.lift_output_func(get_zone_config)
def get_zone_config_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetZoneConfigResult]:
    """
    Use this data source to query purchasable specification configuration for each availability zone in this specific region.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Sqlserver.get_zone_config()
    ```


    :param str result_output_file: Used to store results.
    """
    ...
