# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ReadonlyInstanceArgs', 'ReadonlyInstance']

@pulumi.input_type
class ReadonlyInstanceArgs:
    def __init__(__self__, *,
                 master_instance_id: pulumi.Input[str],
                 memory: pulumi.Input[int],
                 readonly_group_type: pulumi.Input[int],
                 storage: pulumi.Input[int],
                 auto_voucher: Optional[pulumi.Input[int]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 charge_type: Optional[pulumi.Input[str]] = None,
                 force_upgrade: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 readonly_group_id: Optional[pulumi.Input[str]] = None,
                 readonly_group_name: Optional[pulumi.Input[str]] = None,
                 readonly_groups_is_offline_delay: Optional[pulumi.Input[int]] = None,
                 readonly_groups_max_delay_time: Optional[pulumi.Input[int]] = None,
                 readonly_groups_min_in_group: Optional[pulumi.Input[int]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 voucher_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 wait_switch: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a ReadonlyInstance resource.
        :param pulumi.Input[str] master_instance_id: Indicates the master instance ID of recovery instances.
        :param pulumi.Input[int] memory: Memory size (in GB). Allowed value must be larger than `memory` that data source `tencentcloud_sqlserver_specinfos` provides.
        :param pulumi.Input[int] readonly_group_type: Type of readonly group. Valid values: `1`, `3`. `1` for one auto-assigned readonly instance per one readonly group, `2` for creating new readonly group, `3` for all exist readonly instances stay in the exist readonly group. For now, only `1` and `3` are supported.
        :param pulumi.Input[int] storage: Disk size (in GB). Allowed value must be a multiple of 10. The storage must be set with the limit of `storage_min` and `storage_max` which data source `tencentcloud_sqlserver_specinfos` provides.
        :param pulumi.Input[int] auto_voucher: Whether to use the voucher automatically; 1 for yes, 0 for no, the default is 0.
        :param pulumi.Input[str] availability_zone: Availability zone.
        :param pulumi.Input[str] charge_type: Pay type of the SQL Server instance. Available values `PREPAID`, `POSTPAID_BY_HOUR`.
        :param pulumi.Input[bool] force_upgrade: Indicate that the master instance upgrade or not. `true` for upgrading the master SQL Server instance to cluster type by force. Default is false. Note: this is not supported with `DUAL`(ha_type), `2017`(engine_version) master SQL Server instance, for it will cause ha_type of the master SQL Server instance change.
        :param pulumi.Input[str] name: Name of the SQL Server instance.
        :param pulumi.Input[int] period: Purchase instance period in month. The value does not exceed 48.
        :param pulumi.Input[str] readonly_group_id: ID of the readonly group that this instance belongs to. When `readonly_group_type` set value `3`, it must be set with valid value.
        :param pulumi.Input[str] readonly_group_name: Required when `readonly_group_type`=2, the name of the newly created read-only group.
        :param pulumi.Input[int] readonly_groups_is_offline_delay: Required when `readonly_group_type`=2, whether the newly created read-only group has delay elimination enabled, 1-enabled, 0-disabled. When the delay between the read-only copy and the primary instance exceeds the threshold, it is automatically removed.
        :param pulumi.Input[int] readonly_groups_max_delay_time: Required when `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, the threshold for delayed elimination of newly created read-only groups.
        :param pulumi.Input[int] readonly_groups_min_in_group: When `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, it is required. After the newly created read-only group is delayed and removed, at least the number of read-only copies should be retained.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: Security group bound to the instance.
        :param pulumi.Input[str] subnet_id: ID of subnet.
        :param pulumi.Input[Mapping[str, Any]] tags: The tags of the SQL Server.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] voucher_ids: An array of voucher IDs, currently only one can be used for a single order.
        :param pulumi.Input[str] vpc_id: ID of VPC.
        :param pulumi.Input[int] wait_switch: It has been deprecated from version 1.81.2. The way to execute the allocation. Supported values include: 0 - execute immediately, 1 - execute in maintenance window.
        """
        pulumi.set(__self__, "master_instance_id", master_instance_id)
        pulumi.set(__self__, "memory", memory)
        pulumi.set(__self__, "readonly_group_type", readonly_group_type)
        pulumi.set(__self__, "storage", storage)
        if auto_voucher is not None:
            pulumi.set(__self__, "auto_voucher", auto_voucher)
        if availability_zone is not None:
            pulumi.set(__self__, "availability_zone", availability_zone)
        if charge_type is not None:
            pulumi.set(__self__, "charge_type", charge_type)
        if force_upgrade is not None:
            pulumi.set(__self__, "force_upgrade", force_upgrade)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if period is not None:
            pulumi.set(__self__, "period", period)
        if readonly_group_id is not None:
            pulumi.set(__self__, "readonly_group_id", readonly_group_id)
        if readonly_group_name is not None:
            pulumi.set(__self__, "readonly_group_name", readonly_group_name)
        if readonly_groups_is_offline_delay is not None:
            pulumi.set(__self__, "readonly_groups_is_offline_delay", readonly_groups_is_offline_delay)
        if readonly_groups_max_delay_time is not None:
            pulumi.set(__self__, "readonly_groups_max_delay_time", readonly_groups_max_delay_time)
        if readonly_groups_min_in_group is not None:
            pulumi.set(__self__, "readonly_groups_min_in_group", readonly_groups_min_in_group)
        if security_groups is not None:
            pulumi.set(__self__, "security_groups", security_groups)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if voucher_ids is not None:
            pulumi.set(__self__, "voucher_ids", voucher_ids)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)
        if wait_switch is not None:
            warnings.warn("""It has been deprecated from version 1.81.2.""", DeprecationWarning)
            pulumi.log.warn("""wait_switch is deprecated: It has been deprecated from version 1.81.2.""")
        if wait_switch is not None:
            pulumi.set(__self__, "wait_switch", wait_switch)

    @property
    @pulumi.getter(name="masterInstanceId")
    def master_instance_id(self) -> pulumi.Input[str]:
        """
        Indicates the master instance ID of recovery instances.
        """
        return pulumi.get(self, "master_instance_id")

    @master_instance_id.setter
    def master_instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "master_instance_id", value)

    @property
    @pulumi.getter
    def memory(self) -> pulumi.Input[int]:
        """
        Memory size (in GB). Allowed value must be larger than `memory` that data source `tencentcloud_sqlserver_specinfos` provides.
        """
        return pulumi.get(self, "memory")

    @memory.setter
    def memory(self, value: pulumi.Input[int]):
        pulumi.set(self, "memory", value)

    @property
    @pulumi.getter(name="readonlyGroupType")
    def readonly_group_type(self) -> pulumi.Input[int]:
        """
        Type of readonly group. Valid values: `1`, `3`. `1` for one auto-assigned readonly instance per one readonly group, `2` for creating new readonly group, `3` for all exist readonly instances stay in the exist readonly group. For now, only `1` and `3` are supported.
        """
        return pulumi.get(self, "readonly_group_type")

    @readonly_group_type.setter
    def readonly_group_type(self, value: pulumi.Input[int]):
        pulumi.set(self, "readonly_group_type", value)

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Input[int]:
        """
        Disk size (in GB). Allowed value must be a multiple of 10. The storage must be set with the limit of `storage_min` and `storage_max` which data source `tencentcloud_sqlserver_specinfos` provides.
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: pulumi.Input[int]):
        pulumi.set(self, "storage", value)

    @property
    @pulumi.getter(name="autoVoucher")
    def auto_voucher(self) -> Optional[pulumi.Input[int]]:
        """
        Whether to use the voucher automatically; 1 for yes, 0 for no, the default is 0.
        """
        return pulumi.get(self, "auto_voucher")

    @auto_voucher.setter
    def auto_voucher(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "auto_voucher", value)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[pulumi.Input[str]]:
        """
        Availability zone.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter(name="chargeType")
    def charge_type(self) -> Optional[pulumi.Input[str]]:
        """
        Pay type of the SQL Server instance. Available values `PREPAID`, `POSTPAID_BY_HOUR`.
        """
        return pulumi.get(self, "charge_type")

    @charge_type.setter
    def charge_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "charge_type", value)

    @property
    @pulumi.getter(name="forceUpgrade")
    def force_upgrade(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicate that the master instance upgrade or not. `true` for upgrading the master SQL Server instance to cluster type by force. Default is false. Note: this is not supported with `DUAL`(ha_type), `2017`(engine_version) master SQL Server instance, for it will cause ha_type of the master SQL Server instance change.
        """
        return pulumi.get(self, "force_upgrade")

    @force_upgrade.setter
    def force_upgrade(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "force_upgrade", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the SQL Server instance.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def period(self) -> Optional[pulumi.Input[int]]:
        """
        Purchase instance period in month. The value does not exceed 48.
        """
        return pulumi.get(self, "period")

    @period.setter
    def period(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "period", value)

    @property
    @pulumi.getter(name="readonlyGroupId")
    def readonly_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the readonly group that this instance belongs to. When `readonly_group_type` set value `3`, it must be set with valid value.
        """
        return pulumi.get(self, "readonly_group_id")

    @readonly_group_id.setter
    def readonly_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "readonly_group_id", value)

    @property
    @pulumi.getter(name="readonlyGroupName")
    def readonly_group_name(self) -> Optional[pulumi.Input[str]]:
        """
        Required when `readonly_group_type`=2, the name of the newly created read-only group.
        """
        return pulumi.get(self, "readonly_group_name")

    @readonly_group_name.setter
    def readonly_group_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "readonly_group_name", value)

    @property
    @pulumi.getter(name="readonlyGroupsIsOfflineDelay")
    def readonly_groups_is_offline_delay(self) -> Optional[pulumi.Input[int]]:
        """
        Required when `readonly_group_type`=2, whether the newly created read-only group has delay elimination enabled, 1-enabled, 0-disabled. When the delay between the read-only copy and the primary instance exceeds the threshold, it is automatically removed.
        """
        return pulumi.get(self, "readonly_groups_is_offline_delay")

    @readonly_groups_is_offline_delay.setter
    def readonly_groups_is_offline_delay(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "readonly_groups_is_offline_delay", value)

    @property
    @pulumi.getter(name="readonlyGroupsMaxDelayTime")
    def readonly_groups_max_delay_time(self) -> Optional[pulumi.Input[int]]:
        """
        Required when `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, the threshold for delayed elimination of newly created read-only groups.
        """
        return pulumi.get(self, "readonly_groups_max_delay_time")

    @readonly_groups_max_delay_time.setter
    def readonly_groups_max_delay_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "readonly_groups_max_delay_time", value)

    @property
    @pulumi.getter(name="readonlyGroupsMinInGroup")
    def readonly_groups_min_in_group(self) -> Optional[pulumi.Input[int]]:
        """
        When `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, it is required. After the newly created read-only group is delayed and removed, at least the number of read-only copies should be retained.
        """
        return pulumi.get(self, "readonly_groups_min_in_group")

    @readonly_groups_min_in_group.setter
    def readonly_groups_min_in_group(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "readonly_groups_min_in_group", value)

    @property
    @pulumi.getter(name="securityGroups")
    def security_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Security group bound to the instance.
        """
        return pulumi.get(self, "security_groups")

    @security_groups.setter
    def security_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_groups", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of subnet.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        The tags of the SQL Server.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="voucherIds")
    def voucher_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        An array of voucher IDs, currently only one can be used for a single order.
        """
        return pulumi.get(self, "voucher_ids")

    @voucher_ids.setter
    def voucher_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "voucher_ids", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of VPC.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_id", value)

    @property
    @pulumi.getter(name="waitSwitch")
    def wait_switch(self) -> Optional[pulumi.Input[int]]:
        """
        It has been deprecated from version 1.81.2. The way to execute the allocation. Supported values include: 0 - execute immediately, 1 - execute in maintenance window.
        """
        return pulumi.get(self, "wait_switch")

    @wait_switch.setter
    def wait_switch(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "wait_switch", value)


@pulumi.input_type
class _ReadonlyInstanceState:
    def __init__(__self__, *,
                 auto_voucher: Optional[pulumi.Input[int]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 charge_type: Optional[pulumi.Input[str]] = None,
                 create_time: Optional[pulumi.Input[str]] = None,
                 force_upgrade: Optional[pulumi.Input[bool]] = None,
                 master_instance_id: Optional[pulumi.Input[str]] = None,
                 memory: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 readonly_group_id: Optional[pulumi.Input[str]] = None,
                 readonly_group_name: Optional[pulumi.Input[str]] = None,
                 readonly_group_type: Optional[pulumi.Input[int]] = None,
                 readonly_groups_is_offline_delay: Optional[pulumi.Input[int]] = None,
                 readonly_groups_max_delay_time: Optional[pulumi.Input[int]] = None,
                 readonly_groups_min_in_group: Optional[pulumi.Input[int]] = None,
                 ro_flag: Optional[pulumi.Input[str]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 status: Optional[pulumi.Input[int]] = None,
                 storage: Optional[pulumi.Input[int]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 vip: Optional[pulumi.Input[str]] = None,
                 voucher_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 vport: Optional[pulumi.Input[int]] = None,
                 wait_switch: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering ReadonlyInstance resources.
        :param pulumi.Input[int] auto_voucher: Whether to use the voucher automatically; 1 for yes, 0 for no, the default is 0.
        :param pulumi.Input[str] availability_zone: Availability zone.
        :param pulumi.Input[str] charge_type: Pay type of the SQL Server instance. Available values `PREPAID`, `POSTPAID_BY_HOUR`.
        :param pulumi.Input[str] create_time: Create time of the SQL Server instance.
        :param pulumi.Input[bool] force_upgrade: Indicate that the master instance upgrade or not. `true` for upgrading the master SQL Server instance to cluster type by force. Default is false. Note: this is not supported with `DUAL`(ha_type), `2017`(engine_version) master SQL Server instance, for it will cause ha_type of the master SQL Server instance change.
        :param pulumi.Input[str] master_instance_id: Indicates the master instance ID of recovery instances.
        :param pulumi.Input[int] memory: Memory size (in GB). Allowed value must be larger than `memory` that data source `tencentcloud_sqlserver_specinfos` provides.
        :param pulumi.Input[str] name: Name of the SQL Server instance.
        :param pulumi.Input[int] period: Purchase instance period in month. The value does not exceed 48.
        :param pulumi.Input[str] readonly_group_id: ID of the readonly group that this instance belongs to. When `readonly_group_type` set value `3`, it must be set with valid value.
        :param pulumi.Input[str] readonly_group_name: Required when `readonly_group_type`=2, the name of the newly created read-only group.
        :param pulumi.Input[int] readonly_group_type: Type of readonly group. Valid values: `1`, `3`. `1` for one auto-assigned readonly instance per one readonly group, `2` for creating new readonly group, `3` for all exist readonly instances stay in the exist readonly group. For now, only `1` and `3` are supported.
        :param pulumi.Input[int] readonly_groups_is_offline_delay: Required when `readonly_group_type`=2, whether the newly created read-only group has delay elimination enabled, 1-enabled, 0-disabled. When the delay between the read-only copy and the primary instance exceeds the threshold, it is automatically removed.
        :param pulumi.Input[int] readonly_groups_max_delay_time: Required when `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, the threshold for delayed elimination of newly created read-only groups.
        :param pulumi.Input[int] readonly_groups_min_in_group: When `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, it is required. After the newly created read-only group is delayed and removed, at least the number of read-only copies should be retained.
        :param pulumi.Input[str] ro_flag: Readonly flag. `RO` (read-only instance), `MASTER` (primary instance with read-only instances). If it is left empty, it refers to an instance which is not read-only and has no RO group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: Security group bound to the instance.
        :param pulumi.Input[int] status: Status of the SQL Server instance. 1 for applying, 2 for running, 3 for running with limit, 4 for isolated, 5 for recycling, 6 for recycled, 7 for running with task, 8 for off-line, 9 for expanding, 10 for migrating, 11 for readonly, 12 for rebooting.
        :param pulumi.Input[int] storage: Disk size (in GB). Allowed value must be a multiple of 10. The storage must be set with the limit of `storage_min` and `storage_max` which data source `tencentcloud_sqlserver_specinfos` provides.
        :param pulumi.Input[str] subnet_id: ID of subnet.
        :param pulumi.Input[Mapping[str, Any]] tags: The tags of the SQL Server.
        :param pulumi.Input[str] vip: IP for private access.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] voucher_ids: An array of voucher IDs, currently only one can be used for a single order.
        :param pulumi.Input[str] vpc_id: ID of VPC.
        :param pulumi.Input[int] vport: Port for private access.
        :param pulumi.Input[int] wait_switch: It has been deprecated from version 1.81.2. The way to execute the allocation. Supported values include: 0 - execute immediately, 1 - execute in maintenance window.
        """
        if auto_voucher is not None:
            pulumi.set(__self__, "auto_voucher", auto_voucher)
        if availability_zone is not None:
            pulumi.set(__self__, "availability_zone", availability_zone)
        if charge_type is not None:
            pulumi.set(__self__, "charge_type", charge_type)
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if force_upgrade is not None:
            pulumi.set(__self__, "force_upgrade", force_upgrade)
        if master_instance_id is not None:
            pulumi.set(__self__, "master_instance_id", master_instance_id)
        if memory is not None:
            pulumi.set(__self__, "memory", memory)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if period is not None:
            pulumi.set(__self__, "period", period)
        if readonly_group_id is not None:
            pulumi.set(__self__, "readonly_group_id", readonly_group_id)
        if readonly_group_name is not None:
            pulumi.set(__self__, "readonly_group_name", readonly_group_name)
        if readonly_group_type is not None:
            pulumi.set(__self__, "readonly_group_type", readonly_group_type)
        if readonly_groups_is_offline_delay is not None:
            pulumi.set(__self__, "readonly_groups_is_offline_delay", readonly_groups_is_offline_delay)
        if readonly_groups_max_delay_time is not None:
            pulumi.set(__self__, "readonly_groups_max_delay_time", readonly_groups_max_delay_time)
        if readonly_groups_min_in_group is not None:
            pulumi.set(__self__, "readonly_groups_min_in_group", readonly_groups_min_in_group)
        if ro_flag is not None:
            pulumi.set(__self__, "ro_flag", ro_flag)
        if security_groups is not None:
            pulumi.set(__self__, "security_groups", security_groups)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if storage is not None:
            pulumi.set(__self__, "storage", storage)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if vip is not None:
            pulumi.set(__self__, "vip", vip)
        if voucher_ids is not None:
            pulumi.set(__self__, "voucher_ids", voucher_ids)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)
        if vport is not None:
            pulumi.set(__self__, "vport", vport)
        if wait_switch is not None:
            warnings.warn("""It has been deprecated from version 1.81.2.""", DeprecationWarning)
            pulumi.log.warn("""wait_switch is deprecated: It has been deprecated from version 1.81.2.""")
        if wait_switch is not None:
            pulumi.set(__self__, "wait_switch", wait_switch)

    @property
    @pulumi.getter(name="autoVoucher")
    def auto_voucher(self) -> Optional[pulumi.Input[int]]:
        """
        Whether to use the voucher automatically; 1 for yes, 0 for no, the default is 0.
        """
        return pulumi.get(self, "auto_voucher")

    @auto_voucher.setter
    def auto_voucher(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "auto_voucher", value)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[pulumi.Input[str]]:
        """
        Availability zone.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter(name="chargeType")
    def charge_type(self) -> Optional[pulumi.Input[str]]:
        """
        Pay type of the SQL Server instance. Available values `PREPAID`, `POSTPAID_BY_HOUR`.
        """
        return pulumi.get(self, "charge_type")

    @charge_type.setter
    def charge_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "charge_type", value)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        Create time of the SQL Server instance.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter(name="forceUpgrade")
    def force_upgrade(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicate that the master instance upgrade or not. `true` for upgrading the master SQL Server instance to cluster type by force. Default is false. Note: this is not supported with `DUAL`(ha_type), `2017`(engine_version) master SQL Server instance, for it will cause ha_type of the master SQL Server instance change.
        """
        return pulumi.get(self, "force_upgrade")

    @force_upgrade.setter
    def force_upgrade(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "force_upgrade", value)

    @property
    @pulumi.getter(name="masterInstanceId")
    def master_instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the master instance ID of recovery instances.
        """
        return pulumi.get(self, "master_instance_id")

    @master_instance_id.setter
    def master_instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "master_instance_id", value)

    @property
    @pulumi.getter
    def memory(self) -> Optional[pulumi.Input[int]]:
        """
        Memory size (in GB). Allowed value must be larger than `memory` that data source `tencentcloud_sqlserver_specinfos` provides.
        """
        return pulumi.get(self, "memory")

    @memory.setter
    def memory(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "memory", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the SQL Server instance.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def period(self) -> Optional[pulumi.Input[int]]:
        """
        Purchase instance period in month. The value does not exceed 48.
        """
        return pulumi.get(self, "period")

    @period.setter
    def period(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "period", value)

    @property
    @pulumi.getter(name="readonlyGroupId")
    def readonly_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the readonly group that this instance belongs to. When `readonly_group_type` set value `3`, it must be set with valid value.
        """
        return pulumi.get(self, "readonly_group_id")

    @readonly_group_id.setter
    def readonly_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "readonly_group_id", value)

    @property
    @pulumi.getter(name="readonlyGroupName")
    def readonly_group_name(self) -> Optional[pulumi.Input[str]]:
        """
        Required when `readonly_group_type`=2, the name of the newly created read-only group.
        """
        return pulumi.get(self, "readonly_group_name")

    @readonly_group_name.setter
    def readonly_group_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "readonly_group_name", value)

    @property
    @pulumi.getter(name="readonlyGroupType")
    def readonly_group_type(self) -> Optional[pulumi.Input[int]]:
        """
        Type of readonly group. Valid values: `1`, `3`. `1` for one auto-assigned readonly instance per one readonly group, `2` for creating new readonly group, `3` for all exist readonly instances stay in the exist readonly group. For now, only `1` and `3` are supported.
        """
        return pulumi.get(self, "readonly_group_type")

    @readonly_group_type.setter
    def readonly_group_type(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "readonly_group_type", value)

    @property
    @pulumi.getter(name="readonlyGroupsIsOfflineDelay")
    def readonly_groups_is_offline_delay(self) -> Optional[pulumi.Input[int]]:
        """
        Required when `readonly_group_type`=2, whether the newly created read-only group has delay elimination enabled, 1-enabled, 0-disabled. When the delay between the read-only copy and the primary instance exceeds the threshold, it is automatically removed.
        """
        return pulumi.get(self, "readonly_groups_is_offline_delay")

    @readonly_groups_is_offline_delay.setter
    def readonly_groups_is_offline_delay(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "readonly_groups_is_offline_delay", value)

    @property
    @pulumi.getter(name="readonlyGroupsMaxDelayTime")
    def readonly_groups_max_delay_time(self) -> Optional[pulumi.Input[int]]:
        """
        Required when `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, the threshold for delayed elimination of newly created read-only groups.
        """
        return pulumi.get(self, "readonly_groups_max_delay_time")

    @readonly_groups_max_delay_time.setter
    def readonly_groups_max_delay_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "readonly_groups_max_delay_time", value)

    @property
    @pulumi.getter(name="readonlyGroupsMinInGroup")
    def readonly_groups_min_in_group(self) -> Optional[pulumi.Input[int]]:
        """
        When `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, it is required. After the newly created read-only group is delayed and removed, at least the number of read-only copies should be retained.
        """
        return pulumi.get(self, "readonly_groups_min_in_group")

    @readonly_groups_min_in_group.setter
    def readonly_groups_min_in_group(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "readonly_groups_min_in_group", value)

    @property
    @pulumi.getter(name="roFlag")
    def ro_flag(self) -> Optional[pulumi.Input[str]]:
        """
        Readonly flag. `RO` (read-only instance), `MASTER` (primary instance with read-only instances). If it is left empty, it refers to an instance which is not read-only and has no RO group.
        """
        return pulumi.get(self, "ro_flag")

    @ro_flag.setter
    def ro_flag(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ro_flag", value)

    @property
    @pulumi.getter(name="securityGroups")
    def security_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Security group bound to the instance.
        """
        return pulumi.get(self, "security_groups")

    @security_groups.setter
    def security_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_groups", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[int]]:
        """
        Status of the SQL Server instance. 1 for applying, 2 for running, 3 for running with limit, 4 for isolated, 5 for recycling, 6 for recycled, 7 for running with task, 8 for off-line, 9 for expanding, 10 for migrating, 11 for readonly, 12 for rebooting.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def storage(self) -> Optional[pulumi.Input[int]]:
        """
        Disk size (in GB). Allowed value must be a multiple of 10. The storage must be set with the limit of `storage_min` and `storage_max` which data source `tencentcloud_sqlserver_specinfos` provides.
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "storage", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of subnet.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        The tags of the SQL Server.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def vip(self) -> Optional[pulumi.Input[str]]:
        """
        IP for private access.
        """
        return pulumi.get(self, "vip")

    @vip.setter
    def vip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vip", value)

    @property
    @pulumi.getter(name="voucherIds")
    def voucher_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        An array of voucher IDs, currently only one can be used for a single order.
        """
        return pulumi.get(self, "voucher_ids")

    @voucher_ids.setter
    def voucher_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "voucher_ids", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of VPC.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_id", value)

    @property
    @pulumi.getter
    def vport(self) -> Optional[pulumi.Input[int]]:
        """
        Port for private access.
        """
        return pulumi.get(self, "vport")

    @vport.setter
    def vport(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "vport", value)

    @property
    @pulumi.getter(name="waitSwitch")
    def wait_switch(self) -> Optional[pulumi.Input[int]]:
        """
        It has been deprecated from version 1.81.2. The way to execute the allocation. Supported values include: 0 - execute immediately, 1 - execute in maintenance window.
        """
        return pulumi.get(self, "wait_switch")

    @wait_switch.setter
    def wait_switch(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "wait_switch", value)


class ReadonlyInstance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_voucher: Optional[pulumi.Input[int]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 charge_type: Optional[pulumi.Input[str]] = None,
                 force_upgrade: Optional[pulumi.Input[bool]] = None,
                 master_instance_id: Optional[pulumi.Input[str]] = None,
                 memory: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 readonly_group_id: Optional[pulumi.Input[str]] = None,
                 readonly_group_name: Optional[pulumi.Input[str]] = None,
                 readonly_group_type: Optional[pulumi.Input[int]] = None,
                 readonly_groups_is_offline_delay: Optional[pulumi.Input[int]] = None,
                 readonly_groups_max_delay_time: Optional[pulumi.Input[int]] = None,
                 readonly_groups_min_in_group: Optional[pulumi.Input[int]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 storage: Optional[pulumi.Input[int]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 voucher_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 wait_switch: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a SQL Server instance resource to create read-only database instances.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="sqlserver")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=zones.zones[4].name,
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            is_multicast=False)
        security_group = tencentcloud.security.Group("securityGroup", description="desc.")
        example_basic_instance = tencentcloud.sqlserver.BasicInstance("exampleBasicInstance",
            availability_zone=zones.zones[4].name,
            charge_type="POSTPAID_BY_HOUR",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            project_id=0,
            memory=4,
            storage=100,
            cpu=2,
            machine_type="CLOUD_PREMIUM",
            maintenance_week_sets=[
                1,
                2,
                3,
            ],
            maintenance_start_time="09:00",
            maintenance_time_span=3,
            security_groups=[security_group.id],
            tags={
                "test": "test",
            })
        example_readonly_instance = tencentcloud.sqlserver.ReadonlyInstance("exampleReadonlyInstance",
            availability_zone=zones.zones[4].name,
            charge_type="POSTPAID_BY_HOUR",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            memory=4,
            storage=20,
            master_instance_id=example_basic_instance.id,
            readonly_group_type=1,
            force_upgrade=True,
            tags={
                "test": "test",
            })
        ```

        ## Import

        SQL Server readonly instance can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Sqlserver/readonlyInstance:ReadonlyInstance example mssqlro-3cdq7kx5
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] auto_voucher: Whether to use the voucher automatically; 1 for yes, 0 for no, the default is 0.
        :param pulumi.Input[str] availability_zone: Availability zone.
        :param pulumi.Input[str] charge_type: Pay type of the SQL Server instance. Available values `PREPAID`, `POSTPAID_BY_HOUR`.
        :param pulumi.Input[bool] force_upgrade: Indicate that the master instance upgrade or not. `true` for upgrading the master SQL Server instance to cluster type by force. Default is false. Note: this is not supported with `DUAL`(ha_type), `2017`(engine_version) master SQL Server instance, for it will cause ha_type of the master SQL Server instance change.
        :param pulumi.Input[str] master_instance_id: Indicates the master instance ID of recovery instances.
        :param pulumi.Input[int] memory: Memory size (in GB). Allowed value must be larger than `memory` that data source `tencentcloud_sqlserver_specinfos` provides.
        :param pulumi.Input[str] name: Name of the SQL Server instance.
        :param pulumi.Input[int] period: Purchase instance period in month. The value does not exceed 48.
        :param pulumi.Input[str] readonly_group_id: ID of the readonly group that this instance belongs to. When `readonly_group_type` set value `3`, it must be set with valid value.
        :param pulumi.Input[str] readonly_group_name: Required when `readonly_group_type`=2, the name of the newly created read-only group.
        :param pulumi.Input[int] readonly_group_type: Type of readonly group. Valid values: `1`, `3`. `1` for one auto-assigned readonly instance per one readonly group, `2` for creating new readonly group, `3` for all exist readonly instances stay in the exist readonly group. For now, only `1` and `3` are supported.
        :param pulumi.Input[int] readonly_groups_is_offline_delay: Required when `readonly_group_type`=2, whether the newly created read-only group has delay elimination enabled, 1-enabled, 0-disabled. When the delay between the read-only copy and the primary instance exceeds the threshold, it is automatically removed.
        :param pulumi.Input[int] readonly_groups_max_delay_time: Required when `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, the threshold for delayed elimination of newly created read-only groups.
        :param pulumi.Input[int] readonly_groups_min_in_group: When `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, it is required. After the newly created read-only group is delayed and removed, at least the number of read-only copies should be retained.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: Security group bound to the instance.
        :param pulumi.Input[int] storage: Disk size (in GB). Allowed value must be a multiple of 10. The storage must be set with the limit of `storage_min` and `storage_max` which data source `tencentcloud_sqlserver_specinfos` provides.
        :param pulumi.Input[str] subnet_id: ID of subnet.
        :param pulumi.Input[Mapping[str, Any]] tags: The tags of the SQL Server.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] voucher_ids: An array of voucher IDs, currently only one can be used for a single order.
        :param pulumi.Input[str] vpc_id: ID of VPC.
        :param pulumi.Input[int] wait_switch: It has been deprecated from version 1.81.2. The way to execute the allocation. Supported values include: 0 - execute immediately, 1 - execute in maintenance window.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ReadonlyInstanceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a SQL Server instance resource to create read-only database instances.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="sqlserver")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=zones.zones[4].name,
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            is_multicast=False)
        security_group = tencentcloud.security.Group("securityGroup", description="desc.")
        example_basic_instance = tencentcloud.sqlserver.BasicInstance("exampleBasicInstance",
            availability_zone=zones.zones[4].name,
            charge_type="POSTPAID_BY_HOUR",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            project_id=0,
            memory=4,
            storage=100,
            cpu=2,
            machine_type="CLOUD_PREMIUM",
            maintenance_week_sets=[
                1,
                2,
                3,
            ],
            maintenance_start_time="09:00",
            maintenance_time_span=3,
            security_groups=[security_group.id],
            tags={
                "test": "test",
            })
        example_readonly_instance = tencentcloud.sqlserver.ReadonlyInstance("exampleReadonlyInstance",
            availability_zone=zones.zones[4].name,
            charge_type="POSTPAID_BY_HOUR",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            memory=4,
            storage=20,
            master_instance_id=example_basic_instance.id,
            readonly_group_type=1,
            force_upgrade=True,
            tags={
                "test": "test",
            })
        ```

        ## Import

        SQL Server readonly instance can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Sqlserver/readonlyInstance:ReadonlyInstance example mssqlro-3cdq7kx5
        ```

        :param str resource_name: The name of the resource.
        :param ReadonlyInstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ReadonlyInstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_voucher: Optional[pulumi.Input[int]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 charge_type: Optional[pulumi.Input[str]] = None,
                 force_upgrade: Optional[pulumi.Input[bool]] = None,
                 master_instance_id: Optional[pulumi.Input[str]] = None,
                 memory: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 readonly_group_id: Optional[pulumi.Input[str]] = None,
                 readonly_group_name: Optional[pulumi.Input[str]] = None,
                 readonly_group_type: Optional[pulumi.Input[int]] = None,
                 readonly_groups_is_offline_delay: Optional[pulumi.Input[int]] = None,
                 readonly_groups_max_delay_time: Optional[pulumi.Input[int]] = None,
                 readonly_groups_min_in_group: Optional[pulumi.Input[int]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 storage: Optional[pulumi.Input[int]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 voucher_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 wait_switch: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ReadonlyInstanceArgs.__new__(ReadonlyInstanceArgs)

            __props__.__dict__["auto_voucher"] = auto_voucher
            __props__.__dict__["availability_zone"] = availability_zone
            __props__.__dict__["charge_type"] = charge_type
            __props__.__dict__["force_upgrade"] = force_upgrade
            if master_instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'master_instance_id'")
            __props__.__dict__["master_instance_id"] = master_instance_id
            if memory is None and not opts.urn:
                raise TypeError("Missing required property 'memory'")
            __props__.__dict__["memory"] = memory
            __props__.__dict__["name"] = name
            __props__.__dict__["period"] = period
            __props__.__dict__["readonly_group_id"] = readonly_group_id
            __props__.__dict__["readonly_group_name"] = readonly_group_name
            if readonly_group_type is None and not opts.urn:
                raise TypeError("Missing required property 'readonly_group_type'")
            __props__.__dict__["readonly_group_type"] = readonly_group_type
            __props__.__dict__["readonly_groups_is_offline_delay"] = readonly_groups_is_offline_delay
            __props__.__dict__["readonly_groups_max_delay_time"] = readonly_groups_max_delay_time
            __props__.__dict__["readonly_groups_min_in_group"] = readonly_groups_min_in_group
            __props__.__dict__["security_groups"] = security_groups
            if storage is None and not opts.urn:
                raise TypeError("Missing required property 'storage'")
            __props__.__dict__["storage"] = storage
            __props__.__dict__["subnet_id"] = subnet_id
            __props__.__dict__["tags"] = tags
            __props__.__dict__["voucher_ids"] = voucher_ids
            __props__.__dict__["vpc_id"] = vpc_id
            if wait_switch is not None and not opts.urn:
                warnings.warn("""It has been deprecated from version 1.81.2.""", DeprecationWarning)
                pulumi.log.warn("""wait_switch is deprecated: It has been deprecated from version 1.81.2.""")
            __props__.__dict__["wait_switch"] = wait_switch
            __props__.__dict__["create_time"] = None
            __props__.__dict__["ro_flag"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["vip"] = None
            __props__.__dict__["vport"] = None
        super(ReadonlyInstance, __self__).__init__(
            'tencentcloud:Sqlserver/readonlyInstance:ReadonlyInstance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            auto_voucher: Optional[pulumi.Input[int]] = None,
            availability_zone: Optional[pulumi.Input[str]] = None,
            charge_type: Optional[pulumi.Input[str]] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            force_upgrade: Optional[pulumi.Input[bool]] = None,
            master_instance_id: Optional[pulumi.Input[str]] = None,
            memory: Optional[pulumi.Input[int]] = None,
            name: Optional[pulumi.Input[str]] = None,
            period: Optional[pulumi.Input[int]] = None,
            readonly_group_id: Optional[pulumi.Input[str]] = None,
            readonly_group_name: Optional[pulumi.Input[str]] = None,
            readonly_group_type: Optional[pulumi.Input[int]] = None,
            readonly_groups_is_offline_delay: Optional[pulumi.Input[int]] = None,
            readonly_groups_max_delay_time: Optional[pulumi.Input[int]] = None,
            readonly_groups_min_in_group: Optional[pulumi.Input[int]] = None,
            ro_flag: Optional[pulumi.Input[str]] = None,
            security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            status: Optional[pulumi.Input[int]] = None,
            storage: Optional[pulumi.Input[int]] = None,
            subnet_id: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            vip: Optional[pulumi.Input[str]] = None,
            voucher_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            vpc_id: Optional[pulumi.Input[str]] = None,
            vport: Optional[pulumi.Input[int]] = None,
            wait_switch: Optional[pulumi.Input[int]] = None) -> 'ReadonlyInstance':
        """
        Get an existing ReadonlyInstance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] auto_voucher: Whether to use the voucher automatically; 1 for yes, 0 for no, the default is 0.
        :param pulumi.Input[str] availability_zone: Availability zone.
        :param pulumi.Input[str] charge_type: Pay type of the SQL Server instance. Available values `PREPAID`, `POSTPAID_BY_HOUR`.
        :param pulumi.Input[str] create_time: Create time of the SQL Server instance.
        :param pulumi.Input[bool] force_upgrade: Indicate that the master instance upgrade or not. `true` for upgrading the master SQL Server instance to cluster type by force. Default is false. Note: this is not supported with `DUAL`(ha_type), `2017`(engine_version) master SQL Server instance, for it will cause ha_type of the master SQL Server instance change.
        :param pulumi.Input[str] master_instance_id: Indicates the master instance ID of recovery instances.
        :param pulumi.Input[int] memory: Memory size (in GB). Allowed value must be larger than `memory` that data source `tencentcloud_sqlserver_specinfos` provides.
        :param pulumi.Input[str] name: Name of the SQL Server instance.
        :param pulumi.Input[int] period: Purchase instance period in month. The value does not exceed 48.
        :param pulumi.Input[str] readonly_group_id: ID of the readonly group that this instance belongs to. When `readonly_group_type` set value `3`, it must be set with valid value.
        :param pulumi.Input[str] readonly_group_name: Required when `readonly_group_type`=2, the name of the newly created read-only group.
        :param pulumi.Input[int] readonly_group_type: Type of readonly group. Valid values: `1`, `3`. `1` for one auto-assigned readonly instance per one readonly group, `2` for creating new readonly group, `3` for all exist readonly instances stay in the exist readonly group. For now, only `1` and `3` are supported.
        :param pulumi.Input[int] readonly_groups_is_offline_delay: Required when `readonly_group_type`=2, whether the newly created read-only group has delay elimination enabled, 1-enabled, 0-disabled. When the delay between the read-only copy and the primary instance exceeds the threshold, it is automatically removed.
        :param pulumi.Input[int] readonly_groups_max_delay_time: Required when `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, the threshold for delayed elimination of newly created read-only groups.
        :param pulumi.Input[int] readonly_groups_min_in_group: When `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, it is required. After the newly created read-only group is delayed and removed, at least the number of read-only copies should be retained.
        :param pulumi.Input[str] ro_flag: Readonly flag. `RO` (read-only instance), `MASTER` (primary instance with read-only instances). If it is left empty, it refers to an instance which is not read-only and has no RO group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: Security group bound to the instance.
        :param pulumi.Input[int] status: Status of the SQL Server instance. 1 for applying, 2 for running, 3 for running with limit, 4 for isolated, 5 for recycling, 6 for recycled, 7 for running with task, 8 for off-line, 9 for expanding, 10 for migrating, 11 for readonly, 12 for rebooting.
        :param pulumi.Input[int] storage: Disk size (in GB). Allowed value must be a multiple of 10. The storage must be set with the limit of `storage_min` and `storage_max` which data source `tencentcloud_sqlserver_specinfos` provides.
        :param pulumi.Input[str] subnet_id: ID of subnet.
        :param pulumi.Input[Mapping[str, Any]] tags: The tags of the SQL Server.
        :param pulumi.Input[str] vip: IP for private access.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] voucher_ids: An array of voucher IDs, currently only one can be used for a single order.
        :param pulumi.Input[str] vpc_id: ID of VPC.
        :param pulumi.Input[int] vport: Port for private access.
        :param pulumi.Input[int] wait_switch: It has been deprecated from version 1.81.2. The way to execute the allocation. Supported values include: 0 - execute immediately, 1 - execute in maintenance window.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ReadonlyInstanceState.__new__(_ReadonlyInstanceState)

        __props__.__dict__["auto_voucher"] = auto_voucher
        __props__.__dict__["availability_zone"] = availability_zone
        __props__.__dict__["charge_type"] = charge_type
        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["force_upgrade"] = force_upgrade
        __props__.__dict__["master_instance_id"] = master_instance_id
        __props__.__dict__["memory"] = memory
        __props__.__dict__["name"] = name
        __props__.__dict__["period"] = period
        __props__.__dict__["readonly_group_id"] = readonly_group_id
        __props__.__dict__["readonly_group_name"] = readonly_group_name
        __props__.__dict__["readonly_group_type"] = readonly_group_type
        __props__.__dict__["readonly_groups_is_offline_delay"] = readonly_groups_is_offline_delay
        __props__.__dict__["readonly_groups_max_delay_time"] = readonly_groups_max_delay_time
        __props__.__dict__["readonly_groups_min_in_group"] = readonly_groups_min_in_group
        __props__.__dict__["ro_flag"] = ro_flag
        __props__.__dict__["security_groups"] = security_groups
        __props__.__dict__["status"] = status
        __props__.__dict__["storage"] = storage
        __props__.__dict__["subnet_id"] = subnet_id
        __props__.__dict__["tags"] = tags
        __props__.__dict__["vip"] = vip
        __props__.__dict__["voucher_ids"] = voucher_ids
        __props__.__dict__["vpc_id"] = vpc_id
        __props__.__dict__["vport"] = vport
        __props__.__dict__["wait_switch"] = wait_switch
        return ReadonlyInstance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="autoVoucher")
    def auto_voucher(self) -> pulumi.Output[Optional[int]]:
        """
        Whether to use the voucher automatically; 1 for yes, 0 for no, the default is 0.
        """
        return pulumi.get(self, "auto_voucher")

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> pulumi.Output[str]:
        """
        Availability zone.
        """
        return pulumi.get(self, "availability_zone")

    @property
    @pulumi.getter(name="chargeType")
    def charge_type(self) -> pulumi.Output[Optional[str]]:
        """
        Pay type of the SQL Server instance. Available values `PREPAID`, `POSTPAID_BY_HOUR`.
        """
        return pulumi.get(self, "charge_type")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        Create time of the SQL Server instance.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="forceUpgrade")
    def force_upgrade(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicate that the master instance upgrade or not. `true` for upgrading the master SQL Server instance to cluster type by force. Default is false. Note: this is not supported with `DUAL`(ha_type), `2017`(engine_version) master SQL Server instance, for it will cause ha_type of the master SQL Server instance change.
        """
        return pulumi.get(self, "force_upgrade")

    @property
    @pulumi.getter(name="masterInstanceId")
    def master_instance_id(self) -> pulumi.Output[str]:
        """
        Indicates the master instance ID of recovery instances.
        """
        return pulumi.get(self, "master_instance_id")

    @property
    @pulumi.getter
    def memory(self) -> pulumi.Output[int]:
        """
        Memory size (in GB). Allowed value must be larger than `memory` that data source `tencentcloud_sqlserver_specinfos` provides.
        """
        return pulumi.get(self, "memory")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the SQL Server instance.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def period(self) -> pulumi.Output[Optional[int]]:
        """
        Purchase instance period in month. The value does not exceed 48.
        """
        return pulumi.get(self, "period")

    @property
    @pulumi.getter(name="readonlyGroupId")
    def readonly_group_id(self) -> pulumi.Output[str]:
        """
        ID of the readonly group that this instance belongs to. When `readonly_group_type` set value `3`, it must be set with valid value.
        """
        return pulumi.get(self, "readonly_group_id")

    @property
    @pulumi.getter(name="readonlyGroupName")
    def readonly_group_name(self) -> pulumi.Output[str]:
        """
        Required when `readonly_group_type`=2, the name of the newly created read-only group.
        """
        return pulumi.get(self, "readonly_group_name")

    @property
    @pulumi.getter(name="readonlyGroupType")
    def readonly_group_type(self) -> pulumi.Output[int]:
        """
        Type of readonly group. Valid values: `1`, `3`. `1` for one auto-assigned readonly instance per one readonly group, `2` for creating new readonly group, `3` for all exist readonly instances stay in the exist readonly group. For now, only `1` and `3` are supported.
        """
        return pulumi.get(self, "readonly_group_type")

    @property
    @pulumi.getter(name="readonlyGroupsIsOfflineDelay")
    def readonly_groups_is_offline_delay(self) -> pulumi.Output[int]:
        """
        Required when `readonly_group_type`=2, whether the newly created read-only group has delay elimination enabled, 1-enabled, 0-disabled. When the delay between the read-only copy and the primary instance exceeds the threshold, it is automatically removed.
        """
        return pulumi.get(self, "readonly_groups_is_offline_delay")

    @property
    @pulumi.getter(name="readonlyGroupsMaxDelayTime")
    def readonly_groups_max_delay_time(self) -> pulumi.Output[int]:
        """
        Required when `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, the threshold for delayed elimination of newly created read-only groups.
        """
        return pulumi.get(self, "readonly_groups_max_delay_time")

    @property
    @pulumi.getter(name="readonlyGroupsMinInGroup")
    def readonly_groups_min_in_group(self) -> pulumi.Output[int]:
        """
        When `readonly_group_type`=2 and `readonly_groups_is_offline_delay`=1, it is required. After the newly created read-only group is delayed and removed, at least the number of read-only copies should be retained.
        """
        return pulumi.get(self, "readonly_groups_min_in_group")

    @property
    @pulumi.getter(name="roFlag")
    def ro_flag(self) -> pulumi.Output[str]:
        """
        Readonly flag. `RO` (read-only instance), `MASTER` (primary instance with read-only instances). If it is left empty, it refers to an instance which is not read-only and has no RO group.
        """
        return pulumi.get(self, "ro_flag")

    @property
    @pulumi.getter(name="securityGroups")
    def security_groups(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Security group bound to the instance.
        """
        return pulumi.get(self, "security_groups")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[int]:
        """
        Status of the SQL Server instance. 1 for applying, 2 for running, 3 for running with limit, 4 for isolated, 5 for recycling, 6 for recycled, 7 for running with task, 8 for off-line, 9 for expanding, 10 for migrating, 11 for readonly, 12 for rebooting.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Output[int]:
        """
        Disk size (in GB). Allowed value must be a multiple of 10. The storage must be set with the limit of `storage_min` and `storage_max` which data source `tencentcloud_sqlserver_specinfos` provides.
        """
        return pulumi.get(self, "storage")

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Output[Optional[str]]:
        """
        ID of subnet.
        """
        return pulumi.get(self, "subnet_id")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, Any]]]:
        """
        The tags of the SQL Server.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def vip(self) -> pulumi.Output[str]:
        """
        IP for private access.
        """
        return pulumi.get(self, "vip")

    @property
    @pulumi.getter(name="voucherIds")
    def voucher_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        An array of voucher IDs, currently only one can be used for a single order.
        """
        return pulumi.get(self, "voucher_ids")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> pulumi.Output[Optional[str]]:
        """
        ID of VPC.
        """
        return pulumi.get(self, "vpc_id")

    @property
    @pulumi.getter
    def vport(self) -> pulumi.Output[int]:
        """
        Port for private access.
        """
        return pulumi.get(self, "vport")

    @property
    @pulumi.getter(name="waitSwitch")
    def wait_switch(self) -> pulumi.Output[Optional[int]]:
        """
        It has been deprecated from version 1.81.2. The way to execute the allocation. Supported values include: 0 - execute immediately, 1 - execute in maintenance window.
        """
        return pulumi.get(self, "wait_switch")

