# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInvokerRecordsResult',
    'AwaitableGetInvokerRecordsResult',
    'get_invoker_records',
    'get_invoker_records_output',
]

@pulumi.output_type
class GetInvokerRecordsResult:
    """
    A collection of values returned by getInvokerRecords.
    """
    def __init__(__self__, id=None, invoker_ids=None, invoker_record_sets=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if invoker_ids and not isinstance(invoker_ids, list):
            raise TypeError("Expected argument 'invoker_ids' to be a list")
        pulumi.set(__self__, "invoker_ids", invoker_ids)
        if invoker_record_sets and not isinstance(invoker_record_sets, list):
            raise TypeError("Expected argument 'invoker_record_sets' to be a list")
        pulumi.set(__self__, "invoker_record_sets", invoker_record_sets)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="invokerIds")
    def invoker_ids(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "invoker_ids")

    @property
    @pulumi.getter(name="invokerRecordSets")
    def invoker_record_sets(self) -> Sequence['outputs.GetInvokerRecordsInvokerRecordSetResult']:
        """
        Execution history of an invoker.
        """
        return pulumi.get(self, "invoker_record_sets")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetInvokerRecordsResult(GetInvokerRecordsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInvokerRecordsResult(
            id=self.id,
            invoker_ids=self.invoker_ids,
            invoker_record_sets=self.invoker_record_sets,
            result_output_file=self.result_output_file)


def get_invoker_records(invoker_ids: Optional[Sequence[str]] = None,
                        result_output_file: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInvokerRecordsResult:
    """
    Use this data source to query detailed information of tat invoker_records

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    invoker_records = tencentcloud.Tat.get_invoker_records(invoker_ids=["ivk-cas4upyf"])
    ```


    :param Sequence[str] invoker_ids: List of invoker IDs. Up to 100 IDs are allowed.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['invokerIds'] = invoker_ids
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tat/getInvokerRecords:getInvokerRecords', __args__, opts=opts, typ=GetInvokerRecordsResult).value

    return AwaitableGetInvokerRecordsResult(
        id=__ret__.id,
        invoker_ids=__ret__.invoker_ids,
        invoker_record_sets=__ret__.invoker_record_sets,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_invoker_records)
def get_invoker_records_output(invoker_ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                               result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInvokerRecordsResult]:
    """
    Use this data source to query detailed information of tat invoker_records

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    invoker_records = tencentcloud.Tat.get_invoker_records(invoker_ids=["ivk-cas4upyf"])
    ```


    :param Sequence[str] invoker_ids: List of invoker IDs. Up to 100 IDs are allowed.
    :param str result_output_file: Used to save results.
    """
    ...
