# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'CommandTag',
    'InvokerScheduleSettings',
    'GetAgentAutomationAgentSetResult',
    'GetAgentFilterResult',
    'GetCommandCommandSetResult',
    'GetCommandCommandSetTagResult',
    'GetInvocationTaskFilterResult',
    'GetInvocationTaskInvocationTaskSetResult',
    'GetInvocationTaskInvocationTaskSetCommandDocumentResult',
    'GetInvocationTaskInvocationTaskSetTaskResultResult',
    'GetInvokerInvokerSetResult',
    'GetInvokerInvokerSetScheduleSettingResult',
    'GetInvokerRecordsInvokerRecordSetResult',
]

@pulumi.output_type
class CommandTag(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        """
        :param str key: Tag key.
        :param str value: Tag value.
        """
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        Tag key.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Tag value.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class InvokerScheduleSettings(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "invokeTime":
            suggest = "invoke_time"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in InvokerScheduleSettings. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        InvokerScheduleSettings.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        InvokerScheduleSettings.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 policy: str,
                 invoke_time: Optional[str] = None,
                 recurrence: Optional[str] = None):
        """
        :param str policy: Execution policy: `ONCE`: Execute once; `RECURRENCE`: Execute repeatedly.
        :param str invoke_time: The next execution time of the invoker. This field is required if Policy is ONCE.
        :param str recurrence: Trigger the crontab expression. This field is required if `Policy` is `RECURRENCE`. The crontab expression is parsed in UTC+8.
        """
        pulumi.set(__self__, "policy", policy)
        if invoke_time is not None:
            pulumi.set(__self__, "invoke_time", invoke_time)
        if recurrence is not None:
            pulumi.set(__self__, "recurrence", recurrence)

    @property
    @pulumi.getter
    def policy(self) -> str:
        """
        Execution policy: `ONCE`: Execute once; `RECURRENCE`: Execute repeatedly.
        """
        return pulumi.get(self, "policy")

    @property
    @pulumi.getter(name="invokeTime")
    def invoke_time(self) -> Optional[str]:
        """
        The next execution time of the invoker. This field is required if Policy is ONCE.
        """
        return pulumi.get(self, "invoke_time")

    @property
    @pulumi.getter
    def recurrence(self) -> Optional[str]:
        """
        Trigger the crontab expression. This field is required if `Policy` is `RECURRENCE`. The crontab expression is parsed in UTC+8.
        """
        return pulumi.get(self, "recurrence")


@pulumi.output_type
class GetAgentAutomationAgentSetResult(dict):
    def __init__(__self__, *,
                 agent_status: str,
                 environment: str,
                 instance_id: str,
                 last_heartbeat_time: str,
                 support_features: Sequence[str],
                 version: str):
        """
        :param str agent_status: Agent status.Ranges:&lt;li&gt; Online:Online&lt;li&gt; Offline:Offline.
        :param str environment: Environment for Agent.Ranges:&lt;li&gt; Linux:Linux instance&lt;li&gt; Windows:Windows instance.
        :param str instance_id: InstanceId.
        :param str last_heartbeat_time: Time of last heartbeat.
        :param Sequence[str] support_features: List of feature Agent support.
        :param str version: Agent version.
        """
        pulumi.set(__self__, "agent_status", agent_status)
        pulumi.set(__self__, "environment", environment)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "last_heartbeat_time", last_heartbeat_time)
        pulumi.set(__self__, "support_features", support_features)
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="agentStatus")
    def agent_status(self) -> str:
        """
        Agent status.Ranges:&lt;li&gt; Online:Online&lt;li&gt; Offline:Offline.
        """
        return pulumi.get(self, "agent_status")

    @property
    @pulumi.getter
    def environment(self) -> str:
        """
        Environment for Agent.Ranges:&lt;li&gt; Linux:Linux instance&lt;li&gt; Windows:Windows instance.
        """
        return pulumi.get(self, "environment")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        InstanceId.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="lastHeartbeatTime")
    def last_heartbeat_time(self) -> str:
        """
        Time of last heartbeat.
        """
        return pulumi.get(self, "last_heartbeat_time")

    @property
    @pulumi.getter(name="supportFeatures")
    def support_features(self) -> Sequence[str]:
        """
        List of feature Agent support.
        """
        return pulumi.get(self, "support_features")

    @property
    @pulumi.getter
    def version(self) -> str:
        """
        Agent version.
        """
        return pulumi.get(self, "version")


@pulumi.output_type
class GetAgentFilterResult(dict):
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str]):
        """
        :param str name: Field to be filtered.
        :param Sequence[str] values: Filter values of the field.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Field to be filtered.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        """
        Filter values of the field.
        """
        return pulumi.get(self, "values")


@pulumi.output_type
class GetCommandCommandSetResult(dict):
    def __init__(__self__, *,
                 command_id: str,
                 command_name: str,
                 command_type: str,
                 content: str,
                 created_by: str,
                 created_time: str,
                 default_parameters: str,
                 description: str,
                 enable_parameter: bool,
                 formatted_description: str,
                 output_cos_bucket_url: str,
                 output_cos_key_prefix: str,
                 tags: Sequence['outputs.GetCommandCommandSetTagResult'],
                 timeout: int,
                 updated_time: str,
                 username: str,
                 working_directory: str):
        """
        :param str command_id: Command ID.
        :param str command_name: Command name.
        :param str command_type: Command type, Value is `SHELL` or `POWERSHELL`.
        :param str content: command.
        :param str created_by: Command creator. `TAT` indicates a public command and `USER` indicates a personal command.
        :param str created_time: Command creation time.
        :param str default_parameters: Default custom parameter value.
        :param str description: Command description.
        :param bool enable_parameter: Whether to enable the custom parameter feature.
        :param str formatted_description: Formatted description of the command. This parameter is an empty string for user commands and contains values for public commands.
        :param str output_cos_bucket_url: The COS bucket URL for uploading logs.
        :param str output_cos_key_prefix: The COS bucket directory where the logs are saved.
        :param Sequence['GetCommandCommandSetTagArgs'] tags: Tags bound to the command. At most 10 tags are allowed.
        :param int timeout: Command timeout period.
        :param str updated_time: Command update time.
        :param str username: The user who executes the command on the instance.
        :param str working_directory: Command execution path.
        """
        pulumi.set(__self__, "command_id", command_id)
        pulumi.set(__self__, "command_name", command_name)
        pulumi.set(__self__, "command_type", command_type)
        pulumi.set(__self__, "content", content)
        pulumi.set(__self__, "created_by", created_by)
        pulumi.set(__self__, "created_time", created_time)
        pulumi.set(__self__, "default_parameters", default_parameters)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "enable_parameter", enable_parameter)
        pulumi.set(__self__, "formatted_description", formatted_description)
        pulumi.set(__self__, "output_cos_bucket_url", output_cos_bucket_url)
        pulumi.set(__self__, "output_cos_key_prefix", output_cos_key_prefix)
        pulumi.set(__self__, "tags", tags)
        pulumi.set(__self__, "timeout", timeout)
        pulumi.set(__self__, "updated_time", updated_time)
        pulumi.set(__self__, "username", username)
        pulumi.set(__self__, "working_directory", working_directory)

    @property
    @pulumi.getter(name="commandId")
    def command_id(self) -> str:
        """
        Command ID.
        """
        return pulumi.get(self, "command_id")

    @property
    @pulumi.getter(name="commandName")
    def command_name(self) -> str:
        """
        Command name.
        """
        return pulumi.get(self, "command_name")

    @property
    @pulumi.getter(name="commandType")
    def command_type(self) -> str:
        """
        Command type, Value is `SHELL` or `POWERSHELL`.
        """
        return pulumi.get(self, "command_type")

    @property
    @pulumi.getter
    def content(self) -> str:
        """
        command.
        """
        return pulumi.get(self, "content")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> str:
        """
        Command creator. `TAT` indicates a public command and `USER` indicates a personal command.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdTime")
    def created_time(self) -> str:
        """
        Command creation time.
        """
        return pulumi.get(self, "created_time")

    @property
    @pulumi.getter(name="defaultParameters")
    def default_parameters(self) -> str:
        """
        Default custom parameter value.
        """
        return pulumi.get(self, "default_parameters")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Command description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="enableParameter")
    def enable_parameter(self) -> bool:
        """
        Whether to enable the custom parameter feature.
        """
        return pulumi.get(self, "enable_parameter")

    @property
    @pulumi.getter(name="formattedDescription")
    def formatted_description(self) -> str:
        """
        Formatted description of the command. This parameter is an empty string for user commands and contains values for public commands.
        """
        return pulumi.get(self, "formatted_description")

    @property
    @pulumi.getter(name="outputCosBucketUrl")
    def output_cos_bucket_url(self) -> str:
        """
        The COS bucket URL for uploading logs.
        """
        return pulumi.get(self, "output_cos_bucket_url")

    @property
    @pulumi.getter(name="outputCosKeyPrefix")
    def output_cos_key_prefix(self) -> str:
        """
        The COS bucket directory where the logs are saved.
        """
        return pulumi.get(self, "output_cos_key_prefix")

    @property
    @pulumi.getter
    def tags(self) -> Sequence['outputs.GetCommandCommandSetTagResult']:
        """
        Tags bound to the command. At most 10 tags are allowed.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def timeout(self) -> int:
        """
        Command timeout period.
        """
        return pulumi.get(self, "timeout")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        """
        Command update time.
        """
        return pulumi.get(self, "updated_time")

    @property
    @pulumi.getter
    def username(self) -> str:
        """
        The user who executes the command on the instance.
        """
        return pulumi.get(self, "username")

    @property
    @pulumi.getter(name="workingDirectory")
    def working_directory(self) -> str:
        """
        Command execution path.
        """
        return pulumi.get(self, "working_directory")


@pulumi.output_type
class GetCommandCommandSetTagResult(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        """
        :param str key: Tag key.
        :param str value: Tag value.
        """
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        Tag key.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Tag value.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetInvocationTaskFilterResult(dict):
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str]):
        """
        :param str name: Field to be filtered.
        :param Sequence[str] values: Filter values of the field.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Field to be filtered.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        """
        Filter values of the field.
        """
        return pulumi.get(self, "values")


@pulumi.output_type
class GetInvocationTaskInvocationTaskSetResult(dict):
    def __init__(__self__, *,
                 command_documents: Sequence['outputs.GetInvocationTaskInvocationTaskSetCommandDocumentResult'],
                 command_id: str,
                 created_time: str,
                 end_time: str,
                 error_info: str,
                 instance_id: str,
                 invocation_id: str,
                 invocation_source: str,
                 invocation_task_id: str,
                 start_time: str,
                 task_results: Sequence['outputs.GetInvocationTaskInvocationTaskSetTaskResultResult'],
                 task_status: str,
                 updated_time: str):
        """
        :param Sequence['GetInvocationTaskInvocationTaskSetCommandDocumentArgs'] command_documents: Command details of the execution task.
        :param str command_id: Command ID.
        :param str created_time: Creation time.
        :param str end_time: End time of the execution task.
        :param str error_info: Error message displayed when the execution task fails.
        :param str instance_id: Instance ID.
        :param str invocation_id: Execution activity ID.
        :param str invocation_source: Invocation source.
        :param str invocation_task_id: Execution task ID.
        :param str start_time: Start time of the execution task.
        :param Sequence['GetInvocationTaskInvocationTaskSetTaskResultArgs'] task_results: Execution result.
        :param str task_status: Execution task status. Valid values:PENDING: PendingDELIVERING: DeliveringDELIVER_DELAYED: Delivery delayedDELIVER_FAILED: Delivery failedSTART_FAILED: Failed to start the commandRUNNING: RunningSUCCESS: SuccessFAILED: Failed to execute the command. The exit code is not 0 after execution.TIMEOUT: Command timed outTASK_TIMEOUT: Task timed outCANCELLING: CancelingCANCELLED: Canceled (canceled before execution)TERMINATED: Terminated (canceled during execution).
        :param str updated_time: Update time.
        """
        pulumi.set(__self__, "command_documents", command_documents)
        pulumi.set(__self__, "command_id", command_id)
        pulumi.set(__self__, "created_time", created_time)
        pulumi.set(__self__, "end_time", end_time)
        pulumi.set(__self__, "error_info", error_info)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "invocation_id", invocation_id)
        pulumi.set(__self__, "invocation_source", invocation_source)
        pulumi.set(__self__, "invocation_task_id", invocation_task_id)
        pulumi.set(__self__, "start_time", start_time)
        pulumi.set(__self__, "task_results", task_results)
        pulumi.set(__self__, "task_status", task_status)
        pulumi.set(__self__, "updated_time", updated_time)

    @property
    @pulumi.getter(name="commandDocuments")
    def command_documents(self) -> Sequence['outputs.GetInvocationTaskInvocationTaskSetCommandDocumentResult']:
        """
        Command details of the execution task.
        """
        return pulumi.get(self, "command_documents")

    @property
    @pulumi.getter(name="commandId")
    def command_id(self) -> str:
        """
        Command ID.
        """
        return pulumi.get(self, "command_id")

    @property
    @pulumi.getter(name="createdTime")
    def created_time(self) -> str:
        """
        Creation time.
        """
        return pulumi.get(self, "created_time")

    @property
    @pulumi.getter(name="endTime")
    def end_time(self) -> str:
        """
        End time of the execution task.
        """
        return pulumi.get(self, "end_time")

    @property
    @pulumi.getter(name="errorInfo")
    def error_info(self) -> str:
        """
        Error message displayed when the execution task fails.
        """
        return pulumi.get(self, "error_info")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="invocationId")
    def invocation_id(self) -> str:
        """
        Execution activity ID.
        """
        return pulumi.get(self, "invocation_id")

    @property
    @pulumi.getter(name="invocationSource")
    def invocation_source(self) -> str:
        """
        Invocation source.
        """
        return pulumi.get(self, "invocation_source")

    @property
    @pulumi.getter(name="invocationTaskId")
    def invocation_task_id(self) -> str:
        """
        Execution task ID.
        """
        return pulumi.get(self, "invocation_task_id")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> str:
        """
        Start time of the execution task.
        """
        return pulumi.get(self, "start_time")

    @property
    @pulumi.getter(name="taskResults")
    def task_results(self) -> Sequence['outputs.GetInvocationTaskInvocationTaskSetTaskResultResult']:
        """
        Execution result.
        """
        return pulumi.get(self, "task_results")

    @property
    @pulumi.getter(name="taskStatus")
    def task_status(self) -> str:
        """
        Execution task status. Valid values:PENDING: PendingDELIVERING: DeliveringDELIVER_DELAYED: Delivery delayedDELIVER_FAILED: Delivery failedSTART_FAILED: Failed to start the commandRUNNING: RunningSUCCESS: SuccessFAILED: Failed to execute the command. The exit code is not 0 after execution.TIMEOUT: Command timed outTASK_TIMEOUT: Task timed outCANCELLING: CancelingCANCELLED: Canceled (canceled before execution)TERMINATED: Terminated (canceled during execution).
        """
        return pulumi.get(self, "task_status")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        """
        Update time.
        """
        return pulumi.get(self, "updated_time")


@pulumi.output_type
class GetInvocationTaskInvocationTaskSetCommandDocumentResult(dict):
    def __init__(__self__, *,
                 command_type: str,
                 content: str,
                 output_cos_bucket_url: str,
                 output_cos_key_prefix: str,
                 timeout: int,
                 username: str,
                 working_directory: str):
        """
        :param str command_type: Command type.
        :param str content: Base64-encoded command.
        :param str output_cos_bucket_url: URL of the COS bucket to store the output.
        :param str output_cos_key_prefix: Prefix of the output file name.
        :param int timeout: Timeout period.
        :param str username: The user who executes the command.
        :param str working_directory: Execution path.
        """
        pulumi.set(__self__, "command_type", command_type)
        pulumi.set(__self__, "content", content)
        pulumi.set(__self__, "output_cos_bucket_url", output_cos_bucket_url)
        pulumi.set(__self__, "output_cos_key_prefix", output_cos_key_prefix)
        pulumi.set(__self__, "timeout", timeout)
        pulumi.set(__self__, "username", username)
        pulumi.set(__self__, "working_directory", working_directory)

    @property
    @pulumi.getter(name="commandType")
    def command_type(self) -> str:
        """
        Command type.
        """
        return pulumi.get(self, "command_type")

    @property
    @pulumi.getter
    def content(self) -> str:
        """
        Base64-encoded command.
        """
        return pulumi.get(self, "content")

    @property
    @pulumi.getter(name="outputCosBucketUrl")
    def output_cos_bucket_url(self) -> str:
        """
        URL of the COS bucket to store the output.
        """
        return pulumi.get(self, "output_cos_bucket_url")

    @property
    @pulumi.getter(name="outputCosKeyPrefix")
    def output_cos_key_prefix(self) -> str:
        """
        Prefix of the output file name.
        """
        return pulumi.get(self, "output_cos_key_prefix")

    @property
    @pulumi.getter
    def timeout(self) -> int:
        """
        Timeout period.
        """
        return pulumi.get(self, "timeout")

    @property
    @pulumi.getter
    def username(self) -> str:
        """
        The user who executes the command.
        """
        return pulumi.get(self, "username")

    @property
    @pulumi.getter(name="workingDirectory")
    def working_directory(self) -> str:
        """
        Execution path.
        """
        return pulumi.get(self, "working_directory")


@pulumi.output_type
class GetInvocationTaskInvocationTaskSetTaskResultResult(dict):
    def __init__(__self__, *,
                 dropped: int,
                 exec_end_time: str,
                 exec_start_time: str,
                 exit_code: int,
                 output: str,
                 output_upload_cos_error_info: str,
                 output_url: str):
        """
        :param int dropped: Dropped bytes of the command output.
        :param str exec_end_time: Time when the execution is ended.
        :param str exec_start_time: Time when the execution is started.
        :param int exit_code: ExitCode of the execution.
        :param str output: Base64-encoded command output. The maximum length is 24 KB.
        :param str output_upload_cos_error_info: Error message for uploading logs to COS.
        :param str output_url: COS URL of the logs.
        """
        pulumi.set(__self__, "dropped", dropped)
        pulumi.set(__self__, "exec_end_time", exec_end_time)
        pulumi.set(__self__, "exec_start_time", exec_start_time)
        pulumi.set(__self__, "exit_code", exit_code)
        pulumi.set(__self__, "output", output)
        pulumi.set(__self__, "output_upload_cos_error_info", output_upload_cos_error_info)
        pulumi.set(__self__, "output_url", output_url)

    @property
    @pulumi.getter
    def dropped(self) -> int:
        """
        Dropped bytes of the command output.
        """
        return pulumi.get(self, "dropped")

    @property
    @pulumi.getter(name="execEndTime")
    def exec_end_time(self) -> str:
        """
        Time when the execution is ended.
        """
        return pulumi.get(self, "exec_end_time")

    @property
    @pulumi.getter(name="execStartTime")
    def exec_start_time(self) -> str:
        """
        Time when the execution is started.
        """
        return pulumi.get(self, "exec_start_time")

    @property
    @pulumi.getter(name="exitCode")
    def exit_code(self) -> int:
        """
        ExitCode of the execution.
        """
        return pulumi.get(self, "exit_code")

    @property
    @pulumi.getter
    def output(self) -> str:
        """
        Base64-encoded command output. The maximum length is 24 KB.
        """
        return pulumi.get(self, "output")

    @property
    @pulumi.getter(name="outputUploadCosErrorInfo")
    def output_upload_cos_error_info(self) -> str:
        """
        Error message for uploading logs to COS.
        """
        return pulumi.get(self, "output_upload_cos_error_info")

    @property
    @pulumi.getter(name="outputUrl")
    def output_url(self) -> str:
        """
        COS URL of the logs.
        """
        return pulumi.get(self, "output_url")


@pulumi.output_type
class GetInvokerInvokerSetResult(dict):
    def __init__(__self__, *,
                 command_id: str,
                 created_time: str,
                 enable: bool,
                 instance_ids: Sequence[str],
                 invoker_id: str,
                 name: str,
                 parameters: str,
                 schedule_settings: Sequence['outputs.GetInvokerInvokerSetScheduleSettingResult'],
                 type: str,
                 updated_time: str,
                 username: str):
        """
        :param str command_id: Command ID.
        :param str created_time: Creation time.
        :param bool enable: Whether to enable the invoker.
        :param Sequence[str] instance_ids: Instance ID list.
        :param str invoker_id: Invoker ID.
        :param str name: Invoker name.
        :param str parameters: Custom parameters.
        :param Sequence['GetInvokerInvokerSetScheduleSettingArgs'] schedule_settings: Execution schedule of the invoker. This field is returned for recurring invokers.
        :param str type: Invoker type.
        :param str updated_time: Modification time.
        :param str username: Username.
        """
        pulumi.set(__self__, "command_id", command_id)
        pulumi.set(__self__, "created_time", created_time)
        pulumi.set(__self__, "enable", enable)
        pulumi.set(__self__, "instance_ids", instance_ids)
        pulumi.set(__self__, "invoker_id", invoker_id)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "parameters", parameters)
        pulumi.set(__self__, "schedule_settings", schedule_settings)
        pulumi.set(__self__, "type", type)
        pulumi.set(__self__, "updated_time", updated_time)
        pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="commandId")
    def command_id(self) -> str:
        """
        Command ID.
        """
        return pulumi.get(self, "command_id")

    @property
    @pulumi.getter(name="createdTime")
    def created_time(self) -> str:
        """
        Creation time.
        """
        return pulumi.get(self, "created_time")

    @property
    @pulumi.getter
    def enable(self) -> bool:
        """
        Whether to enable the invoker.
        """
        return pulumi.get(self, "enable")

    @property
    @pulumi.getter(name="instanceIds")
    def instance_ids(self) -> Sequence[str]:
        """
        Instance ID list.
        """
        return pulumi.get(self, "instance_ids")

    @property
    @pulumi.getter(name="invokerId")
    def invoker_id(self) -> str:
        """
        Invoker ID.
        """
        return pulumi.get(self, "invoker_id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Invoker name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def parameters(self) -> str:
        """
        Custom parameters.
        """
        return pulumi.get(self, "parameters")

    @property
    @pulumi.getter(name="scheduleSettings")
    def schedule_settings(self) -> Sequence['outputs.GetInvokerInvokerSetScheduleSettingResult']:
        """
        Execution schedule of the invoker. This field is returned for recurring invokers.
        """
        return pulumi.get(self, "schedule_settings")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Invoker type.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        """
        Modification time.
        """
        return pulumi.get(self, "updated_time")

    @property
    @pulumi.getter
    def username(self) -> str:
        """
        Username.
        """
        return pulumi.get(self, "username")


@pulumi.output_type
class GetInvokerInvokerSetScheduleSettingResult(dict):
    def __init__(__self__, *,
                 invoke_time: str,
                 policy: str,
                 recurrence: str):
        """
        :param str invoke_time: The next execution time of the invoker. This field is required if Policy is ONCE.
        :param str policy: Execution policy: `ONCE`: Execute once; `RECURRENCE`: Execute repeatedly.
        :param str recurrence: Trigger the crontab expression. This field is required if `Policy` is `RECURRENCE`. The crontab expression is parsed in UTC+8.
        """
        pulumi.set(__self__, "invoke_time", invoke_time)
        pulumi.set(__self__, "policy", policy)
        pulumi.set(__self__, "recurrence", recurrence)

    @property
    @pulumi.getter(name="invokeTime")
    def invoke_time(self) -> str:
        """
        The next execution time of the invoker. This field is required if Policy is ONCE.
        """
        return pulumi.get(self, "invoke_time")

    @property
    @pulumi.getter
    def policy(self) -> str:
        """
        Execution policy: `ONCE`: Execute once; `RECURRENCE`: Execute repeatedly.
        """
        return pulumi.get(self, "policy")

    @property
    @pulumi.getter
    def recurrence(self) -> str:
        """
        Trigger the crontab expression. This field is required if `Policy` is `RECURRENCE`. The crontab expression is parsed in UTC+8.
        """
        return pulumi.get(self, "recurrence")


@pulumi.output_type
class GetInvokerRecordsInvokerRecordSetResult(dict):
    def __init__(__self__, *,
                 invocation_id: str,
                 invoke_time: str,
                 invoker_id: str,
                 reason: str,
                 result: str):
        """
        :param str invocation_id: Command execution ID.
        :param str invoke_time: Execution time.
        :param str invoker_id: Invoker ID.
        :param str reason: Execution reason.
        :param str result: Trigger result.
        """
        pulumi.set(__self__, "invocation_id", invocation_id)
        pulumi.set(__self__, "invoke_time", invoke_time)
        pulumi.set(__self__, "invoker_id", invoker_id)
        pulumi.set(__self__, "reason", reason)
        pulumi.set(__self__, "result", result)

    @property
    @pulumi.getter(name="invocationId")
    def invocation_id(self) -> str:
        """
        Command execution ID.
        """
        return pulumi.get(self, "invocation_id")

    @property
    @pulumi.getter(name="invokeTime")
    def invoke_time(self) -> str:
        """
        Execution time.
        """
        return pulumi.get(self, "invoke_time")

    @property
    @pulumi.getter(name="invokerId")
    def invoker_id(self) -> str:
        """
        Invoker ID.
        """
        return pulumi.get(self, "invoker_id")

    @property
    @pulumi.getter
    def reason(self) -> str:
        """
        Execution reason.
        """
        return pulumi.get(self, "reason")

    @property
    @pulumi.getter
    def result(self) -> str:
        """
        Trigger result.
        """
        return pulumi.get(self, "result")


