# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetTopicResult',
    'AwaitableGetTopicResult',
    'get_topic',
    'get_topic_output',
]

@pulumi.output_type
class GetTopicResult:
    """
    A collection of values returned by getTopic.
    """
    def __init__(__self__, filters=None, id=None, is_tag_filter=None, limit=None, offset=None, result_output_file=None, topic_lists=None, topic_name=None, topic_name_lists=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if is_tag_filter and not isinstance(is_tag_filter, bool):
            raise TypeError("Expected argument 'is_tag_filter' to be a bool")
        pulumi.set(__self__, "is_tag_filter", is_tag_filter)
        if limit and not isinstance(limit, int):
            raise TypeError("Expected argument 'limit' to be a int")
        pulumi.set(__self__, "limit", limit)
        if offset and not isinstance(offset, int):
            raise TypeError("Expected argument 'offset' to be a int")
        pulumi.set(__self__, "offset", offset)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if topic_lists and not isinstance(topic_lists, list):
            raise TypeError("Expected argument 'topic_lists' to be a list")
        pulumi.set(__self__, "topic_lists", topic_lists)
        if topic_name and not isinstance(topic_name, str):
            raise TypeError("Expected argument 'topic_name' to be a str")
        pulumi.set(__self__, "topic_name", topic_name)
        if topic_name_lists and not isinstance(topic_name_lists, list):
            raise TypeError("Expected argument 'topic_name_lists' to be a list")
        pulumi.set(__self__, "topic_name_lists", topic_name_lists)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetTopicFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isTagFilter")
    def is_tag_filter(self) -> Optional[bool]:
        return pulumi.get(self, "is_tag_filter")

    @property
    @pulumi.getter
    def limit(self) -> Optional[int]:
        return pulumi.get(self, "limit")

    @property
    @pulumi.getter
    def offset(self) -> Optional[int]:
        return pulumi.get(self, "offset")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="topicLists")
    def topic_lists(self) -> Sequence['outputs.GetTopicTopicListResult']:
        """
        Topic list.
        """
        return pulumi.get(self, "topic_lists")

    @property
    @pulumi.getter(name="topicName")
    def topic_name(self) -> Optional[str]:
        """
        Topic name.
        """
        return pulumi.get(self, "topic_name")

    @property
    @pulumi.getter(name="topicNameLists")
    def topic_name_lists(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "topic_name_lists")


class AwaitableGetTopicResult(GetTopicResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTopicResult(
            filters=self.filters,
            id=self.id,
            is_tag_filter=self.is_tag_filter,
            limit=self.limit,
            offset=self.offset,
            result_output_file=self.result_output_file,
            topic_lists=self.topic_lists,
            topic_name=self.topic_name,
            topic_name_lists=self.topic_name_lists)


def get_topic(filters: Optional[Sequence[pulumi.InputType['GetTopicFilterArgs']]] = None,
              is_tag_filter: Optional[bool] = None,
              limit: Optional[int] = None,
              offset: Optional[int] = None,
              result_output_file: Optional[str] = None,
              topic_name: Optional[str] = None,
              topic_name_lists: Optional[Sequence[str]] = None,
              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTopicResult:
    """
    Use this data source to query detailed information of tcmq topic

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    topic = tencentcloud.Tcmq.get_topic(topic_name="topic_name")
    ```


    :param Sequence[pulumi.InputType['GetTopicFilterArgs']] filters: Filter. Currently, you can filter by tag. The tag name must be prefixed with `tag:`, such as `tag: owner`, `tag: environment`, or `tag: business`.
    :param bool is_tag_filter: For filtering by tag, this parameter must be set to `true`.
    :param int limit: Number of topics to be returned per page in case of paginated return. If this parameter is not passed in, 20 will be used by default. Maximum value: 50.
    :param int offset: Starting position of the list of topics to be returned on the current page in case of paginated return. If a value is entered, limit is required. If this parameter is left empty, 0 will be used by default.
    :param str result_output_file: Used to save results.
    :param str topic_name: Fuzzy search by TopicName.
    :param Sequence[str] topic_name_lists: Filter by CMQ topic name.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['isTagFilter'] = is_tag_filter
    __args__['limit'] = limit
    __args__['offset'] = offset
    __args__['resultOutputFile'] = result_output_file
    __args__['topicName'] = topic_name
    __args__['topicNameLists'] = topic_name_lists
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tcmq/getTopic:getTopic', __args__, opts=opts, typ=GetTopicResult).value

    return AwaitableGetTopicResult(
        filters=__ret__.filters,
        id=__ret__.id,
        is_tag_filter=__ret__.is_tag_filter,
        limit=__ret__.limit,
        offset=__ret__.offset,
        result_output_file=__ret__.result_output_file,
        topic_lists=__ret__.topic_lists,
        topic_name=__ret__.topic_name,
        topic_name_lists=__ret__.topic_name_lists)


@_utilities.lift_output_func(get_topic)
def get_topic_output(filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetTopicFilterArgs']]]]] = None,
                     is_tag_filter: Optional[pulumi.Input[Optional[bool]]] = None,
                     limit: Optional[pulumi.Input[Optional[int]]] = None,
                     offset: Optional[pulumi.Input[Optional[int]]] = None,
                     result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                     topic_name: Optional[pulumi.Input[Optional[str]]] = None,
                     topic_name_lists: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetTopicResult]:
    """
    Use this data source to query detailed information of tcmq topic

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    topic = tencentcloud.Tcmq.get_topic(topic_name="topic_name")
    ```


    :param Sequence[pulumi.InputType['GetTopicFilterArgs']] filters: Filter. Currently, you can filter by tag. The tag name must be prefixed with `tag:`, such as `tag: owner`, `tag: environment`, or `tag: business`.
    :param bool is_tag_filter: For filtering by tag, this parameter must be set to `true`.
    :param int limit: Number of topics to be returned per page in case of paginated return. If this parameter is not passed in, 20 will be used by default. Maximum value: 50.
    :param int offset: Starting position of the list of topics to be returned on the current page in case of paginated return. If a value is entered, limit is required. If this parameter is left empty, 0 will be used by default.
    :param str result_output_file: Used to save results.
    :param str topic_name: Fuzzy search by TopicName.
    :param Sequence[str] topic_name_lists: Filter by CMQ topic name.
    """
    ...
