# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetImagesResult',
    'AwaitableGetImagesResult',
    'get_images',
    'get_images_output',
]

@pulumi.output_type
class GetImagesResult:
    """
    A collection of values returned by getImages.
    """
    def __init__(__self__, digest=None, exact_match=None, id=None, image_info_lists=None, image_version=None, namespace_name=None, registry_id=None, repository_name=None, result_output_file=None):
        if digest and not isinstance(digest, str):
            raise TypeError("Expected argument 'digest' to be a str")
        pulumi.set(__self__, "digest", digest)
        if exact_match and not isinstance(exact_match, bool):
            raise TypeError("Expected argument 'exact_match' to be a bool")
        pulumi.set(__self__, "exact_match", exact_match)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if image_info_lists and not isinstance(image_info_lists, list):
            raise TypeError("Expected argument 'image_info_lists' to be a list")
        pulumi.set(__self__, "image_info_lists", image_info_lists)
        if image_version and not isinstance(image_version, str):
            raise TypeError("Expected argument 'image_version' to be a str")
        pulumi.set(__self__, "image_version", image_version)
        if namespace_name and not isinstance(namespace_name, str):
            raise TypeError("Expected argument 'namespace_name' to be a str")
        pulumi.set(__self__, "namespace_name", namespace_name)
        if registry_id and not isinstance(registry_id, str):
            raise TypeError("Expected argument 'registry_id' to be a str")
        pulumi.set(__self__, "registry_id", registry_id)
        if repository_name and not isinstance(repository_name, str):
            raise TypeError("Expected argument 'repository_name' to be a str")
        pulumi.set(__self__, "repository_name", repository_name)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def digest(self) -> Optional[str]:
        """
        hash value.
        """
        return pulumi.get(self, "digest")

    @property
    @pulumi.getter(name="exactMatch")
    def exact_match(self) -> Optional[bool]:
        return pulumi.get(self, "exact_match")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="imageInfoLists")
    def image_info_lists(self) -> Sequence['outputs.GetImagesImageInfoListResult']:
        """
        container image information list.
        """
        return pulumi.get(self, "image_info_lists")

    @property
    @pulumi.getter(name="imageVersion")
    def image_version(self) -> Optional[str]:
        """
        tag name.
        """
        return pulumi.get(self, "image_version")

    @property
    @pulumi.getter(name="namespaceName")
    def namespace_name(self) -> str:
        return pulumi.get(self, "namespace_name")

    @property
    @pulumi.getter(name="registryId")
    def registry_id(self) -> str:
        return pulumi.get(self, "registry_id")

    @property
    @pulumi.getter(name="repositoryName")
    def repository_name(self) -> str:
        return pulumi.get(self, "repository_name")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetImagesResult(GetImagesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetImagesResult(
            digest=self.digest,
            exact_match=self.exact_match,
            id=self.id,
            image_info_lists=self.image_info_lists,
            image_version=self.image_version,
            namespace_name=self.namespace_name,
            registry_id=self.registry_id,
            repository_name=self.repository_name,
            result_output_file=self.result_output_file)


def get_images(digest: Optional[str] = None,
               exact_match: Optional[bool] = None,
               image_version: Optional[str] = None,
               namespace_name: Optional[str] = None,
               registry_id: Optional[str] = None,
               repository_name: Optional[str] = None,
               result_output_file: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetImagesResult:
    """
    Use this data source to query detailed information of tcr images

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    images = tencentcloud.Tcr.get_images(digest="sha256:xxxxx",
        exact_match=False,
        image_version="v1",
        namespace_name="ns",
        registry_id="tcr-xxx",
        repository_name="repo")
    ```


    :param str digest: specify image digest for lookup.
    :param bool exact_match: specifies whether it is an exact match, true is an exact match, and not filled is a fuzzy match.
    :param str image_version: image version name, default is fuzzy match.
    :param str namespace_name: namespace name.
    :param str registry_id: instance id.
    :param str repository_name: repository name.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['digest'] = digest
    __args__['exactMatch'] = exact_match
    __args__['imageVersion'] = image_version
    __args__['namespaceName'] = namespace_name
    __args__['registryId'] = registry_id
    __args__['repositoryName'] = repository_name
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tcr/getImages:getImages', __args__, opts=opts, typ=GetImagesResult).value

    return AwaitableGetImagesResult(
        digest=__ret__.digest,
        exact_match=__ret__.exact_match,
        id=__ret__.id,
        image_info_lists=__ret__.image_info_lists,
        image_version=__ret__.image_version,
        namespace_name=__ret__.namespace_name,
        registry_id=__ret__.registry_id,
        repository_name=__ret__.repository_name,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_images)
def get_images_output(digest: Optional[pulumi.Input[Optional[str]]] = None,
                      exact_match: Optional[pulumi.Input[Optional[bool]]] = None,
                      image_version: Optional[pulumi.Input[Optional[str]]] = None,
                      namespace_name: Optional[pulumi.Input[str]] = None,
                      registry_id: Optional[pulumi.Input[str]] = None,
                      repository_name: Optional[pulumi.Input[str]] = None,
                      result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetImagesResult]:
    """
    Use this data source to query detailed information of tcr images

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    images = tencentcloud.Tcr.get_images(digest="sha256:xxxxx",
        exact_match=False,
        image_version="v1",
        namespace_name="ns",
        registry_id="tcr-xxx",
        repository_name="repo")
    ```


    :param str digest: specify image digest for lookup.
    :param bool exact_match: specifies whether it is an exact match, true is an exact match, and not filled is a fuzzy match.
    :param str image_version: image version name, default is fuzzy match.
    :param str namespace_name: namespace name.
    :param str registry_id: instance id.
    :param str repository_name: repository name.
    :param str result_output_file: Used to save results.
    """
    ...
