# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetRocketmqClusterResult',
    'AwaitableGetRocketmqClusterResult',
    'get_rocketmq_cluster',
    'get_rocketmq_cluster_output',
]

@pulumi.output_type
class GetRocketmqClusterResult:
    """
    A collection of values returned by getRocketmqCluster.
    """
    def __init__(__self__, cluster_id_lists=None, cluster_lists=None, id=None, id_keyword=None, name_keyword=None, result_output_file=None):
        if cluster_id_lists and not isinstance(cluster_id_lists, list):
            raise TypeError("Expected argument 'cluster_id_lists' to be a list")
        pulumi.set(__self__, "cluster_id_lists", cluster_id_lists)
        if cluster_lists and not isinstance(cluster_lists, list):
            raise TypeError("Expected argument 'cluster_lists' to be a list")
        pulumi.set(__self__, "cluster_lists", cluster_lists)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if id_keyword and not isinstance(id_keyword, str):
            raise TypeError("Expected argument 'id_keyword' to be a str")
        pulumi.set(__self__, "id_keyword", id_keyword)
        if name_keyword and not isinstance(name_keyword, str):
            raise TypeError("Expected argument 'name_keyword' to be a str")
        pulumi.set(__self__, "name_keyword", name_keyword)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="clusterIdLists")
    def cluster_id_lists(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "cluster_id_lists")

    @property
    @pulumi.getter(name="clusterLists")
    def cluster_lists(self) -> Sequence['outputs.GetRocketmqClusterClusterListResult']:
        """
        Cluster information.
        """
        return pulumi.get(self, "cluster_lists")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="idKeyword")
    def id_keyword(self) -> Optional[str]:
        return pulumi.get(self, "id_keyword")

    @property
    @pulumi.getter(name="nameKeyword")
    def name_keyword(self) -> Optional[str]:
        return pulumi.get(self, "name_keyword")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetRocketmqClusterResult(GetRocketmqClusterResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRocketmqClusterResult(
            cluster_id_lists=self.cluster_id_lists,
            cluster_lists=self.cluster_lists,
            id=self.id,
            id_keyword=self.id_keyword,
            name_keyword=self.name_keyword,
            result_output_file=self.result_output_file)


def get_rocketmq_cluster(cluster_id_lists: Optional[Sequence[str]] = None,
                         id_keyword: Optional[str] = None,
                         name_keyword: Optional[str] = None,
                         result_output_file: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRocketmqClusterResult:
    """
    Use this data source to query detailed information of tdmqRocketmq cluster

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    example_rocketmq_cluster = tencentcloud.Tdmq.get_rocketmq_cluster(name_keyword=example_tdmq / rocketmq_cluster_rocketmq_cluster["clusterName"])
    example_tdmq_rocketmq_cluster_rocketmq_cluster = tencentcloud.tdmq.RocketmqCluster("exampleTdmq/rocketmqClusterRocketmqCluster",
        cluster_name="tf_example",
        remark="remark.")
    ```


    :param Sequence[str] cluster_id_lists: Filter by cluster ID.
    :param str id_keyword: Search by cluster ID.
    :param str name_keyword: Search by cluster name.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['clusterIdLists'] = cluster_id_lists
    __args__['idKeyword'] = id_keyword
    __args__['nameKeyword'] = name_keyword
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tdmq/getRocketmqCluster:getRocketmqCluster', __args__, opts=opts, typ=GetRocketmqClusterResult).value

    return AwaitableGetRocketmqClusterResult(
        cluster_id_lists=__ret__.cluster_id_lists,
        cluster_lists=__ret__.cluster_lists,
        id=__ret__.id,
        id_keyword=__ret__.id_keyword,
        name_keyword=__ret__.name_keyword,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_rocketmq_cluster)
def get_rocketmq_cluster_output(cluster_id_lists: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                id_keyword: Optional[pulumi.Input[Optional[str]]] = None,
                                name_keyword: Optional[pulumi.Input[Optional[str]]] = None,
                                result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRocketmqClusterResult]:
    """
    Use this data source to query detailed information of tdmqRocketmq cluster

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    example_rocketmq_cluster = tencentcloud.Tdmq.get_rocketmq_cluster(name_keyword=example_tdmq / rocketmq_cluster_rocketmq_cluster["clusterName"])
    example_tdmq_rocketmq_cluster_rocketmq_cluster = tencentcloud.tdmq.RocketmqCluster("exampleTdmq/rocketmqClusterRocketmqCluster",
        cluster_name="tf_example",
        remark="remark.")
    ```


    :param Sequence[str] cluster_id_lists: Filter by cluster ID.
    :param str id_keyword: Search by cluster ID.
    :param str name_keyword: Search by cluster name.
    :param str result_output_file: Used to save results.
    """
    ...
