# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetNacosServerInterfacesResult',
    'AwaitableGetNacosServerInterfacesResult',
    'get_nacos_server_interfaces',
    'get_nacos_server_interfaces_output',
]

@pulumi.output_type
class GetNacosServerInterfacesResult:
    """
    A collection of values returned by getNacosServerInterfaces.
    """
    def __init__(__self__, contents=None, id=None, instance_id=None, result_output_file=None):
        if contents and not isinstance(contents, list):
            raise TypeError("Expected argument 'contents' to be a list")
        pulumi.set(__self__, "contents", contents)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def contents(self) -> Sequence['outputs.GetNacosServerInterfacesContentResult']:
        """
        interface list.
        """
        return pulumi.get(self, "contents")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[str]:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetNacosServerInterfacesResult(GetNacosServerInterfacesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNacosServerInterfacesResult(
            contents=self.contents,
            id=self.id,
            instance_id=self.instance_id,
            result_output_file=self.result_output_file)


def get_nacos_server_interfaces(instance_id: Optional[str] = None,
                                result_output_file: Optional[str] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNacosServerInterfacesResult:
    """
    Use this data source to query detailed information of tse nacos_server_interfaces

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    nacos_server_interfaces = tencentcloud.Tse.get_nacos_server_interfaces(instance_id="ins-xxxxxx")
    ```


    :param str instance_id: engine instance ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tse/getNacosServerInterfaces:getNacosServerInterfaces', __args__, opts=opts, typ=GetNacosServerInterfacesResult).value

    return AwaitableGetNacosServerInterfacesResult(
        contents=__ret__.contents,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_nacos_server_interfaces)
def get_nacos_server_interfaces_output(instance_id: Optional[pulumi.Input[Optional[str]]] = None,
                                       result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetNacosServerInterfacesResult]:
    """
    Use this data source to query detailed information of tse nacos_server_interfaces

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    nacos_server_interfaces = tencentcloud.Tse.get_nacos_server_interfaces(instance_id="ins-xxxxxx")
    ```


    :param str instance_id: engine instance ID.
    :param str result_output_file: Used to save results.
    """
    ...
