# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetZookeeperReplicasResult',
    'AwaitableGetZookeeperReplicasResult',
    'get_zookeeper_replicas',
    'get_zookeeper_replicas_output',
]

@pulumi.output_type
class GetZookeeperReplicasResult:
    """
    A collection of values returned by getZookeeperReplicas.
    """
    def __init__(__self__, id=None, instance_id=None, replicas=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if replicas and not isinstance(replicas, list):
            raise TypeError("Expected argument 'replicas' to be a list")
        pulumi.set(__self__, "replicas", replicas)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def replicas(self) -> Sequence['outputs.GetZookeeperReplicasReplicaResult']:
        """
        Engine instance replica information.
        """
        return pulumi.get(self, "replicas")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetZookeeperReplicasResult(GetZookeeperReplicasResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZookeeperReplicasResult(
            id=self.id,
            instance_id=self.instance_id,
            replicas=self.replicas,
            result_output_file=self.result_output_file)


def get_zookeeper_replicas(instance_id: Optional[str] = None,
                           result_output_file: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZookeeperReplicasResult:
    """
    Use this data source to query detailed information of tse zookeeper_replicas

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    zookeeper_replicas = tencentcloud.Tse.get_zookeeper_replicas(instance_id="ins-7eb7eea7")
    ```


    :param str instance_id: engine instance ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tse/getZookeeperReplicas:getZookeeperReplicas', __args__, opts=opts, typ=GetZookeeperReplicasResult).value

    return AwaitableGetZookeeperReplicasResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        replicas=__ret__.replicas,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_zookeeper_replicas)
def get_zookeeper_replicas_output(instance_id: Optional[pulumi.Input[str]] = None,
                                  result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetZookeeperReplicasResult]:
    """
    Use this data source to query detailed information of tse zookeeper_replicas

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    zookeeper_replicas = tencentcloud.Tse.get_zookeeper_replicas(instance_id="ins-7eb7eea7")
    ```


    :param str instance_id: engine instance ID.
    :param str result_output_file: Used to save results.
    """
    ...
