# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetApplicationAttributeResult',
    'AwaitableGetApplicationAttributeResult',
    'get_application_attribute',
    'get_application_attribute_output',
]

@pulumi.output_type
class GetApplicationAttributeResult:
    """
    A collection of values returned by getApplicationAttribute.
    """
    def __init__(__self__, application_id=None, id=None, result_output_file=None, results=None):
        if application_id and not isinstance(application_id, str):
            raise TypeError("Expected argument 'application_id' to be a str")
        pulumi.set(__self__, "application_id", application_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> str:
        return pulumi.get(self, "application_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetApplicationAttributeResultResult']:
        """
        application list other attribute.
        """
        return pulumi.get(self, "results")


class AwaitableGetApplicationAttributeResult(GetApplicationAttributeResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetApplicationAttributeResult(
            application_id=self.application_id,
            id=self.id,
            result_output_file=self.result_output_file,
            results=self.results)


def get_application_attribute(application_id: Optional[str] = None,
                              result_output_file: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetApplicationAttributeResult:
    """
    Use this data source to query detailed information of tsf application_attribute

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    application_attribute = tencentcloud.Tsf.get_application_attribute(application_id="application-a24x29xv")
    ```


    :param str application_id: application Id.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['applicationId'] = application_id
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tsf/getApplicationAttribute:getApplicationAttribute', __args__, opts=opts, typ=GetApplicationAttributeResult).value

    return AwaitableGetApplicationAttributeResult(
        application_id=__ret__.application_id,
        id=__ret__.id,
        result_output_file=__ret__.result_output_file,
        results=__ret__.results)


@_utilities.lift_output_func(get_application_attribute)
def get_application_attribute_output(application_id: Optional[pulumi.Input[str]] = None,
                                     result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetApplicationAttributeResult]:
    """
    Use this data source to query detailed information of tsf application_attribute

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    application_attribute = tencentcloud.Tsf.get_application_attribute(application_id="application-a24x29xv")
    ```


    :param str application_id: application Id.
    :param str result_output_file: Used to save results.
    """
    ...
