# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetGroupInstancesResult',
    'AwaitableGetGroupInstancesResult',
    'get_group_instances',
    'get_group_instances_output',
]

@pulumi.output_type
class GetGroupInstancesResult:
    """
    A collection of values returned by getGroupInstances.
    """
    def __init__(__self__, group_id=None, id=None, order_by=None, order_type=None, result_output_file=None, results=None, search_word=None):
        if group_id and not isinstance(group_id, str):
            raise TypeError("Expected argument 'group_id' to be a str")
        pulumi.set(__self__, "group_id", group_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if order_by and not isinstance(order_by, str):
            raise TypeError("Expected argument 'order_by' to be a str")
        pulumi.set(__self__, "order_by", order_by)
        if order_type and not isinstance(order_type, int):
            raise TypeError("Expected argument 'order_type' to be a int")
        pulumi.set(__self__, "order_type", order_type)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)
        if search_word and not isinstance(search_word, str):
            raise TypeError("Expected argument 'search_word' to be a str")
        pulumi.set(__self__, "search_word", search_word)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> str:
        """
        Group id.Note: This field may return null, which means no valid value was found.
        """
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="orderBy")
    def order_by(self) -> Optional[str]:
        return pulumi.get(self, "order_by")

    @property
    @pulumi.getter(name="orderType")
    def order_type(self) -> Optional[int]:
        return pulumi.get(self, "order_type")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetGroupInstancesResultResult']:
        """
        Machine information of the deployment group.Note: This field may return null, which means no valid value was found.
        """
        return pulumi.get(self, "results")

    @property
    @pulumi.getter(name="searchWord")
    def search_word(self) -> Optional[str]:
        return pulumi.get(self, "search_word")


class AwaitableGetGroupInstancesResult(GetGroupInstancesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetGroupInstancesResult(
            group_id=self.group_id,
            id=self.id,
            order_by=self.order_by,
            order_type=self.order_type,
            result_output_file=self.result_output_file,
            results=self.results,
            search_word=self.search_word)


def get_group_instances(group_id: Optional[str] = None,
                        order_by: Optional[str] = None,
                        order_type: Optional[int] = None,
                        result_output_file: Optional[str] = None,
                        search_word: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetGroupInstancesResult:
    """
    Use this data source to query detailed information of tsf group_instances

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    group_instances = tencentcloud.Tsf.get_group_instances(group_id="group-yrjkln9v",
        order_by="ASC",
        order_type=0,
        search_word="testing")
    ```


    :param str group_id: group id.
    :param str order_by: order term.
    :param int order_type: order type.
    :param str result_output_file: Used to save results.
    :param str search_word: search word.
    """
    __args__ = dict()
    __args__['groupId'] = group_id
    __args__['orderBy'] = order_by
    __args__['orderType'] = order_type
    __args__['resultOutputFile'] = result_output_file
    __args__['searchWord'] = search_word
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tsf/getGroupInstances:getGroupInstances', __args__, opts=opts, typ=GetGroupInstancesResult).value

    return AwaitableGetGroupInstancesResult(
        group_id=__ret__.group_id,
        id=__ret__.id,
        order_by=__ret__.order_by,
        order_type=__ret__.order_type,
        result_output_file=__ret__.result_output_file,
        results=__ret__.results,
        search_word=__ret__.search_word)


@_utilities.lift_output_func(get_group_instances)
def get_group_instances_output(group_id: Optional[pulumi.Input[str]] = None,
                               order_by: Optional[pulumi.Input[Optional[str]]] = None,
                               order_type: Optional[pulumi.Input[Optional[int]]] = None,
                               result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                               search_word: Optional[pulumi.Input[Optional[str]]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetGroupInstancesResult]:
    """
    Use this data source to query detailed information of tsf group_instances

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    group_instances = tencentcloud.Tsf.get_group_instances(group_id="group-yrjkln9v",
        order_by="ASC",
        order_type=0,
        search_word="testing")
    ```


    :param str group_id: group id.
    :param str order_by: order term.
    :param int order_type: order type.
    :param str result_output_file: Used to save results.
    :param str search_word: search word.
    """
    ...
