# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetGatewayFlowQosResult',
    'AwaitableGetGatewayFlowQosResult',
    'get_gateway_flow_qos',
    'get_gateway_flow_qos_output',
]

@pulumi.output_type
class GetGatewayFlowQosResult:
    """
    A collection of values returned by getGatewayFlowQos.
    """
    def __init__(__self__, gateway_id=None, gateway_qos_sets=None, id=None, ip_addresses=None, result_output_file=None):
        if gateway_id and not isinstance(gateway_id, str):
            raise TypeError("Expected argument 'gateway_id' to be a str")
        pulumi.set(__self__, "gateway_id", gateway_id)
        if gateway_qos_sets and not isinstance(gateway_qos_sets, list):
            raise TypeError("Expected argument 'gateway_qos_sets' to be a list")
        pulumi.set(__self__, "gateway_qos_sets", gateway_qos_sets)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ip_addresses and not isinstance(ip_addresses, list):
            raise TypeError("Expected argument 'ip_addresses' to be a list")
        pulumi.set(__self__, "ip_addresses", ip_addresses)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="gatewayId")
    def gateway_id(self) -> str:
        return pulumi.get(self, "gateway_id")

    @property
    @pulumi.getter(name="gatewayQosSets")
    def gateway_qos_sets(self) -> Sequence['outputs.GetGatewayFlowQosGatewayQosSetResult']:
        """
        instance detail list.
        """
        return pulumi.get(self, "gateway_qos_sets")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ipAddresses")
    def ip_addresses(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "ip_addresses")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetGatewayFlowQosResult(GetGatewayFlowQosResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetGatewayFlowQosResult(
            gateway_id=self.gateway_id,
            gateway_qos_sets=self.gateway_qos_sets,
            id=self.id,
            ip_addresses=self.ip_addresses,
            result_output_file=self.result_output_file)


def get_gateway_flow_qos(gateway_id: Optional[str] = None,
                         ip_addresses: Optional[Sequence[str]] = None,
                         result_output_file: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetGatewayFlowQosResult:
    """
    Use this data source to query detailed information of vpc gateway_flow_qos

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    gateway_flow_qos = tencentcloud.Vpc.get_gateway_flow_qos(gateway_id="vpngw-gt8bianl")
    ```


    :param str gateway_id: Network instance ID, the network instance types we currently support are:Private line gateway instance ID, in the form of `dcg-ltjahce6`;Nat gateway instance ID, in the form of `nat-ltjahce6`;VPN gateway instance ID, in the form of `vpn-ltjahce6`.
    :param Sequence[str] ip_addresses: Intranet IP of the cloud server with traffic limitation.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['gatewayId'] = gateway_id
    __args__['ipAddresses'] = ip_addresses
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Vpc/getGatewayFlowQos:getGatewayFlowQos', __args__, opts=opts, typ=GetGatewayFlowQosResult).value

    return AwaitableGetGatewayFlowQosResult(
        gateway_id=__ret__.gateway_id,
        gateway_qos_sets=__ret__.gateway_qos_sets,
        id=__ret__.id,
        ip_addresses=__ret__.ip_addresses,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_gateway_flow_qos)
def get_gateway_flow_qos_output(gateway_id: Optional[pulumi.Input[str]] = None,
                                ip_addresses: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetGatewayFlowQosResult]:
    """
    Use this data source to query detailed information of vpc gateway_flow_qos

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    gateway_flow_qos = tencentcloud.Vpc.get_gateway_flow_qos(gateway_id="vpngw-gt8bianl")
    ```


    :param str gateway_id: Network instance ID, the network instance types we currently support are:Private line gateway instance ID, in the form of `dcg-ltjahce6`;Nat gateway instance ID, in the form of `nat-ltjahce6`;VPN gateway instance ID, in the form of `vpn-ltjahce6`.
    :param Sequence[str] ip_addresses: Intranet IP of the cloud server with traffic limitation.
    :param str result_output_file: Used to save results.
    """
    ...
