# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetProductQuotaResult',
    'AwaitableGetProductQuotaResult',
    'get_product_quota',
    'get_product_quota_output',
]

@pulumi.output_type
class GetProductQuotaResult:
    """
    A collection of values returned by getProductQuota.
    """
    def __init__(__self__, id=None, product=None, product_quota_sets=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if product and not isinstance(product, str):
            raise TypeError("Expected argument 'product' to be a str")
        pulumi.set(__self__, "product", product)
        if product_quota_sets and not isinstance(product_quota_sets, list):
            raise TypeError("Expected argument 'product_quota_sets' to be a list")
        pulumi.set(__self__, "product_quota_sets", product_quota_sets)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def product(self) -> str:
        return pulumi.get(self, "product")

    @property
    @pulumi.getter(name="productQuotaSets")
    def product_quota_sets(self) -> Sequence['outputs.GetProductQuotaProductQuotaSetResult']:
        """
        ProductQuota Array.
        """
        return pulumi.get(self, "product_quota_sets")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetProductQuotaResult(GetProductQuotaResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProductQuotaResult(
            id=self.id,
            product=self.product,
            product_quota_sets=self.product_quota_sets,
            result_output_file=self.result_output_file)


def get_product_quota(product: Optional[str] = None,
                      result_output_file: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProductQuotaResult:
    """
    Use this data source to query detailed information of vpc product_quota

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    product_quota = tencentcloud.Vpc.get_product_quota(product="vpc")
    ```


    :param str product: The name of the network product to be queried. The products that can be queried are:vpc, ccn, vpn, dc, dfw, clb, eip.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['product'] = product
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Vpc/getProductQuota:getProductQuota', __args__, opts=opts, typ=GetProductQuotaResult).value

    return AwaitableGetProductQuotaResult(
        id=__ret__.id,
        product=__ret__.product,
        product_quota_sets=__ret__.product_quota_sets,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_product_quota)
def get_product_quota_output(product: Optional[pulumi.Input[str]] = None,
                             result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetProductQuotaResult]:
    """
    Use this data source to query detailed information of vpc product_quota

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    product_quota = tencentcloud.Vpc.get_product_quota(product="vpc")
    ```


    :param str product: The name of the network product to be queried. The products that can be queried are:vpc, ccn, vpn, dc, dfw, clb, eip.
    :param str result_output_file: Used to save results.
    """
    ...
