# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['NetworkAclQuintupleArgs', 'NetworkAclQuintuple']

@pulumi.input_type
class NetworkAclQuintupleArgs:
    def __init__(__self__, *,
                 network_acl_id: pulumi.Input[str],
                 network_acl_quintuple_set: pulumi.Input['NetworkAclQuintupleNetworkAclQuintupleSetArgs']):
        """
        The set of arguments for constructing a NetworkAclQuintuple resource.
        :param pulumi.Input[str] network_acl_id: Network ACL instance ID. For example:acl-12345678.
        :param pulumi.Input['NetworkAclQuintupleNetworkAclQuintupleSetArgs'] network_acl_quintuple_set: Network quintuple ACL rule set.
        """
        pulumi.set(__self__, "network_acl_id", network_acl_id)
        pulumi.set(__self__, "network_acl_quintuple_set", network_acl_quintuple_set)

    @property
    @pulumi.getter(name="networkAclId")
    def network_acl_id(self) -> pulumi.Input[str]:
        """
        Network ACL instance ID. For example:acl-12345678.
        """
        return pulumi.get(self, "network_acl_id")

    @network_acl_id.setter
    def network_acl_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_acl_id", value)

    @property
    @pulumi.getter(name="networkAclQuintupleSet")
    def network_acl_quintuple_set(self) -> pulumi.Input['NetworkAclQuintupleNetworkAclQuintupleSetArgs']:
        """
        Network quintuple ACL rule set.
        """
        return pulumi.get(self, "network_acl_quintuple_set")

    @network_acl_quintuple_set.setter
    def network_acl_quintuple_set(self, value: pulumi.Input['NetworkAclQuintupleNetworkAclQuintupleSetArgs']):
        pulumi.set(self, "network_acl_quintuple_set", value)


@pulumi.input_type
class _NetworkAclQuintupleState:
    def __init__(__self__, *,
                 network_acl_id: Optional[pulumi.Input[str]] = None,
                 network_acl_quintuple_set: Optional[pulumi.Input['NetworkAclQuintupleNetworkAclQuintupleSetArgs']] = None):
        """
        Input properties used for looking up and filtering NetworkAclQuintuple resources.
        :param pulumi.Input[str] network_acl_id: Network ACL instance ID. For example:acl-12345678.
        :param pulumi.Input['NetworkAclQuintupleNetworkAclQuintupleSetArgs'] network_acl_quintuple_set: Network quintuple ACL rule set.
        """
        if network_acl_id is not None:
            pulumi.set(__self__, "network_acl_id", network_acl_id)
        if network_acl_quintuple_set is not None:
            pulumi.set(__self__, "network_acl_quintuple_set", network_acl_quintuple_set)

    @property
    @pulumi.getter(name="networkAclId")
    def network_acl_id(self) -> Optional[pulumi.Input[str]]:
        """
        Network ACL instance ID. For example:acl-12345678.
        """
        return pulumi.get(self, "network_acl_id")

    @network_acl_id.setter
    def network_acl_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_acl_id", value)

    @property
    @pulumi.getter(name="networkAclQuintupleSet")
    def network_acl_quintuple_set(self) -> Optional[pulumi.Input['NetworkAclQuintupleNetworkAclQuintupleSetArgs']]:
        """
        Network quintuple ACL rule set.
        """
        return pulumi.get(self, "network_acl_quintuple_set")

    @network_acl_quintuple_set.setter
    def network_acl_quintuple_set(self, value: Optional[pulumi.Input['NetworkAclQuintupleNetworkAclQuintupleSetArgs']]):
        pulumi.set(self, "network_acl_quintuple_set", value)


class NetworkAclQuintuple(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 network_acl_id: Optional[pulumi.Input[str]] = None,
                 network_acl_quintuple_set: Optional[pulumi.Input[pulumi.InputType['NetworkAclQuintupleNetworkAclQuintupleSetArgs']]] = None,
                 __props__=None):
        """
        Create a NetworkAclQuintuple resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] network_acl_id: Network ACL instance ID. For example:acl-12345678.
        :param pulumi.Input[pulumi.InputType['NetworkAclQuintupleNetworkAclQuintupleSetArgs']] network_acl_quintuple_set: Network quintuple ACL rule set.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NetworkAclQuintupleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NetworkAclQuintuple resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NetworkAclQuintupleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NetworkAclQuintupleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 network_acl_id: Optional[pulumi.Input[str]] = None,
                 network_acl_quintuple_set: Optional[pulumi.Input[pulumi.InputType['NetworkAclQuintupleNetworkAclQuintupleSetArgs']]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NetworkAclQuintupleArgs.__new__(NetworkAclQuintupleArgs)

            if network_acl_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_acl_id'")
            __props__.__dict__["network_acl_id"] = network_acl_id
            if network_acl_quintuple_set is None and not opts.urn:
                raise TypeError("Missing required property 'network_acl_quintuple_set'")
            __props__.__dict__["network_acl_quintuple_set"] = network_acl_quintuple_set
        super(NetworkAclQuintuple, __self__).__init__(
            'tencentcloud:Vpc/networkAclQuintuple:NetworkAclQuintuple',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            network_acl_id: Optional[pulumi.Input[str]] = None,
            network_acl_quintuple_set: Optional[pulumi.Input[pulumi.InputType['NetworkAclQuintupleNetworkAclQuintupleSetArgs']]] = None) -> 'NetworkAclQuintuple':
        """
        Get an existing NetworkAclQuintuple resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] network_acl_id: Network ACL instance ID. For example:acl-12345678.
        :param pulumi.Input[pulumi.InputType['NetworkAclQuintupleNetworkAclQuintupleSetArgs']] network_acl_quintuple_set: Network quintuple ACL rule set.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NetworkAclQuintupleState.__new__(_NetworkAclQuintupleState)

        __props__.__dict__["network_acl_id"] = network_acl_id
        __props__.__dict__["network_acl_quintuple_set"] = network_acl_quintuple_set
        return NetworkAclQuintuple(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="networkAclId")
    def network_acl_id(self) -> pulumi.Output[str]:
        """
        Network ACL instance ID. For example:acl-12345678.
        """
        return pulumi.get(self, "network_acl_id")

    @property
    @pulumi.getter(name="networkAclQuintupleSet")
    def network_acl_quintuple_set(self) -> pulumi.Output['outputs.NetworkAclQuintupleNetworkAclQuintupleSet']:
        """
        Network quintuple ACL rule set.
        """
        return pulumi.get(self, "network_acl_quintuple_set")

